from module_constants import *
from ID_factions import *
from header_items import  *
from header_operations import *
from header_triggers import *

####################################################################################################################
#  Each item record contains the following fields:
#  1) Item id: used for referencing items in other files.
#     The prefix itm_ is automatically added before each item id.
#  2) Item name. Name of item as it'll appear in inventory window
#  3) List of meshes.  Each mesh record is a tuple containing the following fields:
#    3.1) Mesh name.
#    3.2) Modifier bits that this mesh matches.
#     Note that the first mesh record is the default.
#  4) Item flags. See header_items.py for a list of available flags.
#  5) Item capabilities. Used for which animations this item is used with. See header_items.py for a list of available flags.
#  6) Item value.
#  7) Item stats: Bitwise-or of various stats about the item such as:
#      weight, abundance, difficulty, head_armor, body_armor,leg_armor, etc...
#  8) Modifier bits: Modifiers that can be applied to this item.
#  9) [Optional] Triggers: List of simple triggers to be associated with the item.
#  10) [Optional] Factions: List of factions that item can be found as merchandise.
####################################################################################################################

# Some constants for ease of use.
imodbits_none = 0
imodbits_horse_basic = imodbit_swaybacked|imodbit_lame|imodbit_spirited|imodbit_heavy|imodbit_stubborn
imodbits_cloth  = imodbit_tattered | imodbit_ragged | imodbit_sturdy | imodbit_thick | imodbit_hardened
imodbits_armor  = imodbit_rusty | imodbit_battered | imodbit_crude | imodbit_thick | imodbit_reinforced |imodbit_lordly
imodbits_plate  = imodbit_cracked | imodbit_rusty | imodbit_battered | imodbit_crude | imodbit_thick | imodbit_reinforced |imodbit_lordly
imodbits_polearm = imodbit_cracked | imodbit_bent | imodbit_balanced
imodbits_shield  = imodbit_cracked | imodbit_battered |imodbit_thick | imodbit_reinforced
imodbits_sword   = imodbit_rusty | imodbit_chipped | imodbit_balanced |imodbit_tempered
imodbits_sword_high   = imodbit_rusty | imodbit_chipped | imodbit_balanced |imodbit_tempered|imodbit_masterwork
imodbits_axe   = imodbit_rusty | imodbit_chipped | imodbit_heavy
imodbits_mace   = imodbit_rusty | imodbit_chipped | imodbit_heavy
imodbits_pick   = imodbit_rusty | imodbit_chipped | imodbit_balanced | imodbit_heavy
imodbits_bow = imodbit_cracked | imodbit_bent | imodbit_strong |imodbit_masterwork
imodbits_crossbow = imodbit_cracked | imodbit_bent | imodbit_masterwork
imodbits_missile   = imodbit_bent | imodbit_large_bag
imodbits_thrown   = imodbit_bent | imodbit_heavy| imodbit_balanced| imodbit_large_bag
imodbits_thrown_minus_heavy = imodbit_bent | imodbit_balanced| imodbit_large_bag

imodbits_horse_good = imodbit_spirited|imodbit_heavy
imodbits_good   = imodbit_sturdy | imodbit_thick | imodbit_hardened | imodbit_reinforced
imodbits_bad    = imodbit_rusty | imodbit_chipped | imodbit_tattered | imodbit_ragged | imodbit_cracked | imodbit_bent
# Replace winged mace/spiked mace with: Flanged mace / Knobbed mace?
# Fauchard (majowski glaive) 
items = [
# item_name, mesh_name, item_properties, item_capabilities, slot_no, cost, bonus_flags, weapon_flags, scale, view_dir, pos_offset
 ["no_item","INVALID ITEM", [("invalid_item",0)], itp_type_one_handed_wpn|itp_primary|itp_secondary, itc_longsword, 3,weight(1.5)|spd_rtng(103)|weapon_length(90)|swing_damage(16,blunt)|thrust_damage(10,blunt),imodbits_none],

#************************************************************************************************
# ITEMS before this point are hardcoded into item_codes.h and their order should not be changed!
#************************************************************************************************


####################
## MM ITEMS Begin ##
####################
#Weapons

# Pistols
 # French
["french_cav_pistol", "Pistol", [("french_cav_pistol",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none, #patch1115 27/1 begin
 []],
#[(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_pistol)])]],
["french_officer_pistol", "Pistol", [("french_officer_pistol",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none,
 []],
#[(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_pistol)])]],
["french_pistol_1766", "Pistol", [("french_pistol_1766",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none,
 []],
#[(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_pistol)])]],
["french_pistol_1777", "Pistol", [("french_pistol_1777",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none,
 []],
#[(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_pistol)])]],

 # Russian
["russian_pistol", "Pistol", [("Russian_pistol",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none,
 []],
#[(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_pistol)])]],

 # British
["british_pistol", "Pistol", [("new_land_pattern_pistol",0)], itp_type_pistol|itp_merchandise|itp_primary|itp_cant_reload_while_moving_mounted ,itcf_shoot_pistol|itcf_reload_pistol|itcf_carry_pistol_front_left , 230 , weight(1.5)|difficulty(0)|spd_rtng(30) | shoot_speed(200) | thrust_damage(60 ,pierce)|max_ammo(1)|accuracy(25),imodbits_none, #patch1115 27/1 begin
 []],

 
# Carabines
# French
["french_mousquiton", "Cavalry Carbine", [("french_mousquiton",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],
["french_mousquiton_melee", "Cavalry Carbine", [("french_mousquiton",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(76)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],
["french_mousquiton_ai", "Cavalry Carbine", [("french_mousquiton",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],

["french_mousquiton_light", "Light Cavalry Carbine", [("french_mousquiton_light",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],
["french_mousquiton_light_melee", "Light Cavalry Carbine", [("french_mousquiton_light",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(76)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],
["french_mousquiton_light_ai", "Light Cavalry Carbine", [("french_mousquiton_light",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],

["french_dragoon_musket", "Cavalry Musket", [("french_dragoon_musket",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(25) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(72),imodbits_none,[]],
["french_dragoon_musket_melee", "Cavalry Musket", [("french_dragoon_musket",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(115)|swing_damage(20 , blunt) | thrust_damage(12,  blunt),imodbits_none ],#patch1115 48/1
["french_dragoon_musket_ai", "Cavalry Musket", [("french_dragoon_musket",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(25) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(72),imodbits_none,[]],

# Russian
["russian_dragoon_musket", "Cavalry Musket", [("Russian_dragoon_musket",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(25) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(72),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_carabine)])]],
["russian_dragoon_musket_melee", "Cavalry Musket", [("Russian_dragoon_musket",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(115)|swing_damage(20 , blunt) | thrust_damage(12,  blunt),imodbits_none ],
["russian_dragoon_musket_ai", "Cavalry Musket", [("Russian_dragoon_musket",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(25) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(72),imodbits_none,[]],

["russian_cavalry_stutzer_1803", "Short Carbine", [("Russian_cavalry_stutzer_1803",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving|itp_cant_reload_while_moving_mounted ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(29) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(40),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_carabine)])]],
["russian_gusarskiy_karabin", "Musketoon", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(18) | shoot_speed(180) | thrust_damage(70 ,pierce)|max_ammo(1)|accuracy(54),imodbits_none,
 [(ti_on_weapon_attack, [
  (this_or_next|multiplayer_is_server),
  (neg|game_in_multiplayer_mode),
  (store_trigger_param_1,":agent_id"),
  (eq,":agent_id",":agent_id"), # fix compiler bug warning.
  (copy_position,pos22,pos1),
  (position_move_y,pos22,110),
  (try_for_range,":unused",0,4), #4 extra bullets + 1 original = 5 bullets in one shot :D
    (copy_position,pos23,pos22),
    (store_random_in_range,":x_change",-15,16),
    (store_random_in_range,":z_change",-15,16),
    (position_rotate_x, pos23, ":x_change"),
    (position_rotate_z, pos23, ":z_change"),
    (set_fixed_point_multiplier,100),
    (store_random_in_range,":bullet_speed",12000,16000),
    (add_missile, ":agent_id", pos23, ":bullet_speed", "itm_cannon_canister_dummy", 0, "itm_canister_ammo", 0),
  (try_end),
  ])]],
["russian_gusarskiy_karabin_melee", "Musketoon", [("Russian_gusarskiy_karabin",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(58)|swing_damage(22 , blunt) | thrust_damage(12,  blunt),imodbits_none ],
["russian_gusarskiy_karabin_ai", "Musketoon", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(18) | shoot_speed(180) | thrust_damage(70 ,pierce)|max_ammo(1)|accuracy(54),imodbits_none,
 [(ti_on_weapon_attack, [
  (this_or_next|multiplayer_is_server),
  (neg|game_in_multiplayer_mode),
  (store_trigger_param_1,":agent_id"),
  (eq,":agent_id",":agent_id"), # fix compiler bug warning.
  (copy_position,pos22,pos1),
  (position_move_y,pos22,110),
  (try_for_range,":unused",0,4), #4 extra bullets + 1 original = 5 bullets in one shot :D
    (copy_position,pos23,pos22),
    (store_random_in_range,":x_change",-15,16),
    (store_random_in_range,":z_change",-15,16),
    (position_rotate_x, pos23, ":x_change"),
    (position_rotate_z, pos23, ":z_change"),
    (set_fixed_point_multiplier,100),
    (store_random_in_range,":bullet_speed",12000,16000),
    (add_missile, ":agent_id", pos23, ":bullet_speed", "itm_cannon_canister_dummy", 0, "itm_canister_ammo", 0),
  (try_end),
  ])]],

# British
["british_carbine", "Cavalry Carbine", [("paget_carabine",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],
["british_carbine_melee", "Cavalry Carbine", [("paget_carabine",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(50)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],
["british_carbine_ai", "Cavalry Carbine", [("paget_carabine",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_while_moving_mounted|itp_cant_reload_while_moving ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(27) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(65),imodbits_none,[]],

# Rifles
# Russian
["russian_rifle_1805", "Rifle", [("Russian_rifle_1805",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(18) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(87),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_rifle)])]],
["russian_rifle_1805_melee", "Rifle", [("Russian_rifle_1805",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket|itp_can_knock_down,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(74)|swing_damage(23 , blunt) | thrust_damage(22 ,  blunt),imodbits_none ],

# British
["british_baker_rifle", "Rifle", [("baker_rifle",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(18) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(87),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_rifle)])]],
["british_baker_rifle_melee", "Rifle", [("baker_rifle",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket|itp_can_knock_down,itc_musket_melee|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(85)|swing_damage(23 , blunt) | thrust_damage(22 ,  blunt),imodbits_none ],

#Cheat
["sniper_rifle", "Sniper Rifle", [("Russian_rifle_1805",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed ,itcf_shoot_musket|itcf_reload_pistol|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(300) | shoot_speed(250) | thrust_damage(300 ,pierce)|max_ammo(40)|accuracy(100),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_rifle)])]],
["blunderbluss", "Blunderbluss", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,
 [(ti_on_weapon_attack, [
  (this_or_next|multiplayer_is_server),
  (neg|game_in_multiplayer_mode),
  (store_trigger_param_1,":agent_id"),
  (eq,":agent_id",":agent_id"), # fix compiler bug warning.
  (copy_position,pos22,pos1),
  (position_move_y,pos22,110),
  (try_for_range,":unused",0,29), #29 extra bullets + 1 original = 20 bullets in one shot :D #mathishard
    (copy_position,pos23,pos22),
    (store_random_in_range,":x_change",-7,8),
    (store_random_in_range,":z_change",-10,11),
    (position_rotate_x, pos23, ":x_change"),
    (position_rotate_z, pos23, ":z_change"),
    (set_fixed_point_multiplier,100),
    (store_random_in_range,":bullet_speed",12000,19000),
    (add_missile, ":agent_id", pos23, ":bullet_speed", "itm_cannon_canister_dummy", 0, "itm_canister_ammo", 0),
  (try_end),
  ])]],
  
  ["sniper_rifle_ball", "Sniper Rifle", [("Russian_rifle_1805",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed ,itcf_shoot_musket|itcf_reload_pistol|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(300) | shoot_speed(250) | thrust_damage(300 ,pierce)|max_ammo(40)|accuracy(100),imodbits_none,
 [(ti_on_weapon_attack, [
  (this_or_next|multiplayer_is_server),
  (neg|game_in_multiplayer_mode),
  (store_trigger_param_1,":agent_id"),
  (eq,":agent_id",":agent_id"), # fix compiler bug warning.
  
   (set_fixed_point_multiplier, 100),
   (init_position,pos9), # pos9 holds new pos for cannonball
   (position_copy_origin,pos9,pos1),
   (position_get_rotation_around_x,":x_rot",pos1),
   (position_get_rotation_around_z,":z_rot",pos1),
   
   
   (val_add,":z_rot",90),
   (assign,":y_rot",":x_rot"),
   (try_begin),
     (gt,":y_rot",179),
     (val_sub,":y_rot",360),
   (try_end),
   (val_mul,":y_rot",-1),
   
   (position_rotate_z,pos9,":z_rot"),
   
   (assign,":init_vel",45), # 45 meters per 0.5 seconds = 90m/s
   (assign,":ammo_size","spr_mm_cannonball_code_only_12pd"),
   (assign,":flight_sound_id","snd_cannonball_loop"),
 
   (set_fixed_point_multiplier, 1000),
   # make rotation fixed point.
   (val_mul,":y_rot",1000),
   
   # x += Speed * Math.Cos(angle);
   (store_cos, ":cos_of_angle", ":y_rot"),
   (store_mul,":init_x_vel",":cos_of_angle",":init_vel"),
   (val_div,":init_x_vel",10),
   
   # z += speed * Math.Sin(angle);
   (store_sin, ":sin_of_angle", ":y_rot"),
   (store_mul,":init_z_vel",":sin_of_angle",":init_vel"),
   (val_div,":init_z_vel",10),
   (val_mul,":init_z_vel",-1),
   
   (set_fixed_point_multiplier, 100),
   (copy_position,pos49,pos9), # pos49 is prop pos.
   (call_script, "script_find_or_create_scene_prop_instance", ":ammo_size", 0, 0, 0),
   (assign,":ball_instance_id",reg0),

   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_in_use, 1),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_x_value, ":init_x_vel"),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_y_value, 0),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_z_value, ":init_z_vel"),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_time, 0),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_bounces, 0),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_user_agent, ":agent_id"),
   (scene_prop_set_slot,":ball_instance_id", scene_prop_slot_ammo_type, cannon_ammo_type_round),
   
   (call_script,"script_multiplayer_handle_prop_effect",":ball_instance_id",prop_effect_type_sound,":flight_sound_id",prop_effect_handle_start),
  ])]],


  # cannon dummy for canister
["cannon_ball_dummy", "{!}cannon_ball_dummy", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|custom_kill_info(1),itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(100)|accuracy(75),imodbits_none,
 []],
["cannon_canister_dummy", "{!}cannon_canister_dummy", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|custom_kill_info(2),itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(100)|accuracy(75),imodbits_none,
 []],
["cannon_explosion_dummy", "{!}cannon_ball_dummy", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|custom_kill_info(3),itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(100)|accuracy(75),imodbits_none,
 []],
["drown_dummy", "{!}cannon_ball_dummy", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|custom_kill_info(4),itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(100)|accuracy(75),imodbits_none,
 []],
["admin_kill_dummy", "{!}cannon_ball_dummy", [("Russian_gusarskiy_karabin",0)], itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|custom_kill_info(5),itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.0)|difficulty(0)|spd_rtng(150) | shoot_speed(200) | thrust_damage(300 ,pierce)|max_ammo(100)|accuracy(75),imodbits_none,
 []],

 
#Muskets
# French
["french_charleville", "Infantry Musket", [("french_charleville",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_musket),])]],
["french_charleville_melee", "Infantry Musket", [("french_charleville",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ],
["french_versailles", "Infantry Musket", [("french_versailles",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_musket),])]],
["french_versailles_melee", "Infantry Musket", [("french_versailles",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], #patch1115 fix 28/4

# British
["british_brown_bess", "Infantry Musket", [("brown_bess_musket",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
["british_brown_bess_melee", "Infantry Musket", [("brown_bess_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

# Russian
["russian_musket_1808", "Infantry Musket", [("Russian_musket_1808",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
# [(ti_on_weapon_attack, [(store_trigger_param_1,":user_agent"),(call_script, "script_server_fire_musket", ":user_agent", firearm_type_musket),])]],
["russian_musket_1808_melee", "Infantry Musket", [("Russian_musket_1808",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], #patch1115 fix 28/3

# Austrian
["austrian_musket", "Infantry Musket", [("austrian_musket",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
["austrian_musket_melee", "Infantry Musket", [("austrian_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], #patch1115 fix 28/2

# Prussian
["prussian_potsdam", "Infantry Musket", [("potsdam_musket",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
["prussian_potsdam_melee", "Infantry Musket", [("potsdam_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], #patch1115 fix 28/1

# Rhine
["prussian_musket_1806", "Infantry Musket", [("prussian_kuhfuss",0)], itp_cant_use_on_horseback|itp_type_crossbow |itp_merchandise|itp_primary|itp_two_handed|itp_cant_reload_on_horseback|itp_cant_reload_while_moving|itp_next_item_as_melee ,itcf_shoot_musket|itcf_carry_crossbow_back, 
683 , weight(3.5)|difficulty(0)|spd_rtng(23) | shoot_speed(250) | thrust_damage(100 ,pierce)|max_ammo(1)|accuracy(75),imodbits_none,[]],
["prussian_musket_1806_melee", "Infantry Musket", [("prussian_kuhfuss",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_crossbow_back,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 


 # Swords
# French
 ["french_art_off_sword","Artillery Officer Sword", [("Artillery_officer_sword",0),("Artillery_officer_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(92) | weapon_length(108)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["french_carabineer_sword","Heavy Cavalry Sword", [("Carabineer_sword",0),("Carabineer_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/4
 ["french_briquet_garde","Guard Sabre Briquet", [("Garde_briquet",0),("Guard_briquet_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(77)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["french_light_cav_sabre_garde","Light Cavalry Sabre", [("Garde_light_cav_sabre",0),("Garde_light_cav_sabre_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/9
 ["french_heavy_cav_sabre_garde","Heavy Cavalry Sabre", [("Guard_heavy_cavalry_sabre",0),("Guard_heavy_cavalry_sabre_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/8
 ["french_inf_off_sabre_garde","Imperial Guard Officer Sabre", [("Guard_infantry_officer_sabre",0),("Guard_infantry_officer_sabre_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(97)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["french_heavy_cav_off_sabre","Heavy Cavalry Sabre", [("Officer_heavy_cavalry_sword",0),("Officer_heavy_cavalry_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/5
 ["french_inf_off_sabre","Infantry Sabre", [("Infantry_officer_sword",0),("Infantry_officer_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(100)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["french_light_cav_off_sabre","Light Cavalry Sabre", [("Officer_light_cav_sabre",0),("Officer_light_cav_sabre_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/6
 ["french_light_inf_off_sabre","Light Infantry Sabre", [("Saber_voltigeur",0),("Saber_voltigeur_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(97)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["french_line_cav_sabre","Line Cavalry Sabre", [("Line_cav_ANXIII",0),("Line_cav_ANXIII_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn,
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/7
 ["french_briquet","Sabre Briquet", [("Sabre_briquet_french",0),("Sabre_briquet_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["french_light_cav_sabre","Light Cavalry Sabre", [("Sabre_cavalerie_legere",0),("Sabre_cavalerie_legere_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ],
 ["french_sappeur_sword","Sapper Sword", [("Sappeur_sword",0),("Sappeur_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(72)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],

# Russian
 ["russian_sabre_1798","Light Cavalry Sabre", [("Russian_sabre_1798",0),("Russian_sabre_1798_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/11
 ["russian_sabre_1809","Light Cavalry Sabre", [("Russian_sabre_1809",0),("Russian_sabre_1809_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/10
 ["russian_sword_1810","Dragoon Sword", [("Russian_sword_1810",0),("Russian_sword_1810_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(2.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/3
 ["russian_guard_sword_1799","Heavy Cavalry Sword", [("Russian_guard_sword_1799",0),("Russian_guard_sword_1799_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/1
 ["russian_briquet_1807","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_jaeger_bayonet","Sword Bayonet", [("Russian_jaeger_bayonet",0),("Kortik_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_jaeger_bayonet_jaeger","Sword Bayonet", [("Russian_jaeger_bayonet",0),("Kortik_jaeger_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_officer_sword","Officer Sword", [("Russian_officer_sword",0),("Russian_officer_sword_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(100)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["russian_officer_sword_jaeger","Officer Sword", [("Russian_officer_sword",0),("jaeger_officer_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(100)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["russian_peasant_axe", "Hand Axe", [("Russian_peasant_axe",0)], itp_type_one_handed_wpn|itp_merchandise| itp_primary|itp_secondary|itp_bonus_against_shield|itp_wooden_parry, itc_scimitar|itcf_carry_sword_left_hip,
87 , weight(1.5)|difficulty(9)|spd_rtng(90) | weapon_length(50)|swing_damage(33 , cut) | thrust_damage(0 ,  pierce),imodbits_axe ],#patch1115 56/2
 ["brokenbottle","Broken Vodka Bottle", [("Russian_vodka_bottle",0)], itp_type_thrown|itp_merchandise|itp_next_item_as_melee,itcf_throw_stone,
360, weight(1)|difficulty(0)|spd_rtng(90) | shoot_speed(16) | thrust_damage(33,cut)|max_ammo(1)|weapon_length(33),imodbits_none,
 [(ti_on_missile_hit, [(this_or_next|multiplayer_is_server),(neg|game_in_multiplayer_mode),(particle_system_burst, "psys_bottle_break", pos1, 10),(copy_position,pos56,pos1),(call_script,"script_multiplayer_server_play_sound_at_position","snd_glass_break"),])]],
 ["brokenbottle_melee", "Broken Vodka Bottle", [("Russian_vodka_bottle",0)], itp_type_one_handed_wpn|itp_primary|itp_no_parry, itc_dagger, 
210 , weight(1)|difficulty(0)|spd_rtng(95) | weapon_length(29)|swing_damage(22, blunt)| thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_kindjal","Cossack Knife", [("Russian_kindjal",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_secondary|itp_no_parry, itc_dagger|itcf_carry_dagger_front_left,
210 , weight(1)|difficulty(0)|spd_rtng(96) | weapon_length(45)|swing_damage(18 , cut) | thrust_damage(18 ,  pierce),imodbits_sword_high ],
 ["russian_guard_off_sword","Officer Sword", [("Russian_guard_off_sword",0),("Russian_guard_off_sword_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(100)|swing_damage(33 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["russian_sappeur_dagger","Short Sword", [("Russian_sappeur_dagger",0),("Sappeur_dagger_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(64)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_sappeur_dagger_invis","Short Sword", [("Russian_sappeur_dagger",0),("mm_invisible",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(64)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_peasant_knife","Knife", [("Russian_peasant_knife",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_secondary|itp_no_parry, itc_dagger|itcf_carry_dagger_front_left,
210 , weight(1)|difficulty(0)|spd_rtng(96) | weapon_length(27)|swing_damage(18 , cut) | thrust_damage(18 ,  pierce),imodbits_sword_high ],
 ["russian_peasant_serp","Sickle", [("Russian_peasant_serp",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_secondary|itp_no_parry, itc_dagger_no_stab|itcf_carry_dagger_front_left,
210 , weight(1)|difficulty(0)|spd_rtng(96) | weapon_length(35)|swing_damage(18 , cut) | thrust_damage(0 ,  pierce),imodbits_sword_high ],

# British
 ["british_highlander_officer_sword","Highlander Officer Sword", [("scottish_broadsword",0),("scottish_broadsword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(95)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 ["british_heavy_cav_sword","Heavy Cavalry Sword", [("1796_heavy_cavalry_sword",0),("1796_heavy_cavalry_sword_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(3.0)|difficulty(0)|spd_rtng(91) | weapon_length(111)|swing_damage(36 , cut) | thrust_damage(32 ,  pierce),imodbits_sword_high ],
 ["british_light_cav_sabre","Light Cavalry Sabre", [("1796_light_cavalry_saber",0),("1796_light_cavalry_saber_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn,
210 , weight(2.0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(33 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high ], #patch1115 fix 44/2
 ["british_baker_bayonet","Sword Bayonet", [("British_baker_bayonet",0),("British_baker_bayonet_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["british_musician_sword","Short Sword", [("British_musician_sword",0),("British_musician_sword_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["british_musician_sword_invis","Short Sword", [("British_musician_sword",0),("mm_invisible",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["british_officer_sword","Officer Sword", [("Russian_officer_sword",0),("British_officer_sword_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(1.5)|difficulty(0)|spd_rtng(95) | weapon_length(100)|swing_damage(32 , cut) | thrust_damage(29 ,  pierce),imodbits_sword_high ],
 
 
#Austrian
 ["austrian_infantry_briquet","Sword Bayonet", [("Austrian_infantry_briquet",0),("Austrian_infantry_briquet_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["austrian_infantry_briquet_black","Sword Bayonet", [("Austrian_infantry_briquet",0),("Austrian_infantry_briquet_black_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["austrian_jaeger_bayonet","Sword Bayonet", [("Austrian_jaeger_bayonet",0),("Austrian_jaeger_bayonet_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["austrian_jaeger_bayonet_invis","Sword Bayonet", [("Austrian_jaeger_bayonet",0),("mm_invisible",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],


# Prussia
 ["russian_briquet_1807_black","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_black_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_black_blackbelt","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_black_blackbelt_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_landwehr","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_landwehr_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(95) | weapon_length(63)|swing_damage(22 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["russian_peasant_axe_landwehr", "Hand Axe", [("Russian_peasant_axe",0),("Axe_landwehr_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise| itp_primary|itp_secondary|itp_bonus_against_shield|itp_wooden_parry, itc_scimitar|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn,
87 , weight(0)|difficulty(9)|spd_rtng(90) | weapon_length(50)|swing_damage(33 , cut) | thrust_damage(0 ,  pierce),imodbits_axe ],#patch1115 56/1

#training weapons
 ["training_officer_sword","Officer Training Sword", [("training_officer_sword",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_wooden_attack|itp_wooden_parry, itc_longsword|itcf_carry_sword_left_hip,
210 , weight(1.5)|difficulty(0)|spd_rtng(95)|weapon_length(100)|swing_damage(32, cut)|thrust_damage(29, pierce),imodbits_sword_high ],
 ["training_heavy_sword","Heavy Training Sword", [("training_heavy_sword",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_wooden_attack|itp_wooden_parry, itc_longsword|itcf_carry_sword_left_hip,
210 , weight(3.0)|difficulty(0)|spd_rtng(91)|weapon_length(111)|swing_damage(36, cut)|thrust_damage(32, pierce),imodbits_sword_high ],
["training_light_sabre","Light Training Sabre", [("training_light_sabre",0)], itp_type_one_handed_wpn|itp_merchandise|itp_primary|itp_wooden_attack|itp_wooden_parry, itc_longsword|itcf_carry_sword_left_hip,
210 , weight(2.0)|difficulty(0)|spd_rtng(93)|weapon_length(102)|swing_damage(33, cut)|thrust_damage(30, pierce),imodbits_sword_high ],
#end training weapons

# fake stuff for stupid bots
 ["french_briquet_garde_fake","Sabre Briquet", [("Garde_briquet",0),("Guard_briquet_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["french_briquet_fake","Sabre Briquet", [("Sabre_briquet_french",0),("Sabre_briquet_in_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_fake","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_black_fake","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_black_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_black_blackbelt_fake","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_black_blackbelt_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["russian_briquet_1807_landwehr_fake","Sabre Briquet", [("Russian_briquet_1807",0),("Tesak_landwehr_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 ["russian_peasant_axe_landwehr_fake", "Hand Axe", [("Russian_peasant_axe",0),("Axe_landwehr_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise| itp_primary|itp_secondary|itp_bonus_against_shield|itp_wooden_parry, itc_scimitar|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn,
87 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_axe ],
 ["austrian_infantry_briquet_fake","Sword Bayonet", [("Austrian_infantry_briquet",0),("Austrian_infantry_briquet_scabbard",ixmesh_carry)], itp_type_one_handed_wpn|itp_merchandise|itp_primary, itc_longsword|itcf_carry_sword_left_hip|itcf_show_holster_when_drawn, 
210 , weight(0)|difficulty(0)|spd_rtng(1) | weapon_length(1)|swing_damage(1 , cut) | thrust_damage(1 ,  pierce),imodbits_sword_high ],
 

# admin toy
["banhammer", "Banhammer", [("ban_hammer",0)], itp_crush_through|itp_type_polearm|itp_offset_lance|itp_can_knock_down| itp_primary|itp_two_handed|itp_wooden_parry, itc_nodachi,
 169 , weight(10)|difficulty(0)|spd_rtng(86) | weapon_length(170)|swing_damage(250 , blunt) | thrust_damage(250 ,  blunt),imodbits_polearm ],


# Instruments
 ["drumstick_right","Drum", [("drumstick_right",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_quiver_right_vertical, #patch1115 45/1 begin
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["flute","Flute", [("mm_fife",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_quiver_front_right, 
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["horn","Horn", [("horn",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_sword_left_hip, 
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["trumpet","Trumpet", [("trumpet",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_sword_left_hip, 
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["bugle","Bugle", [("bugle",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_sword_left_hip, 
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],
 ["bagpipe","Bagpipes", [("mm_invisible",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_no_pick_up_from_ground, itcf_carry_sword_left_hip, 
210 , weight(1.5)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(3 , cut) | thrust_damage(20 ,  pierce),imodbits_sword_high ],  #patch1115 45/1 end

 
 #Ammo
["bullets","Cartridges", [("cartridge_box_mesh",0),("bullet_projectile",ixmesh_flying_ammo),("cartridge_a",ixmesh_inventory)], itp_type_bolts|itp_merchandise|itp_default_ammo|itp_can_penetrate_shield, 0, 64,weight(2.0)|abundance(100)|weapon_length(1)|thrust_damage(1,pierce)|max_ammo(30),imodbits_missile,
 [(ti_on_missile_hit, [(copy_position,pos63,pos1),(store_trigger_param_2, ":collision_type"),(call_script, "script_mm_on_bullet_hit",":collision_type")])]],
["pistol_ammo","Pistol Cartridges", [("cartridge_box_mesh",0),("bullet_projectile",ixmesh_flying_ammo),("cartridge_a",ixmesh_inventory)], itp_type_bullets|itp_merchandise|itp_can_penetrate_shield, 0, 200,weight(1.0)|abundance(100)|weapon_length(1)|thrust_damage(1,pierce)|max_ammo(18),imodbits_missile,
 [(ti_on_missile_hit, [(copy_position,pos63,pos1),(store_trigger_param_2, ":collision_type"),(call_script, "script_mm_on_bullet_hit",":collision_type")])]],

#Only called in scripts 
["canister_ammo","Cartridges", [("cartridge_a",0),("bullet_projectile",ixmesh_flying_ammo)], itp_type_bolts|itp_merchandise|itp_can_penetrate_shield, 0, 64,weight(2.0)|abundance(100)|weapon_length(1)|thrust_damage(100,pierce)|max_ammo(1),imodbits_missile,
 [(ti_on_missile_hit, [(copy_position,pos63,pos1),(store_trigger_param_2, ":collision_type"),(call_script, "script_mm_on_bullet_hit",":collision_type")])]],
["shell_fragment","Shell Fragments", [("cartridge_a",0),("prtcl_dust_e",ixmesh_flying_ammo)], itp_type_bolts|itp_merchandise|itp_can_penetrate_shield, 0, 64,weight(2.0)|abundance(100)|weapon_length(3)|thrust_damage(500,pierce)|max_ammo(1),imodbits_missile,
 [(ti_on_missile_hit, [(copy_position,pos63,pos1),(store_trigger_param_2, ":collision_type"),(call_script, "script_mm_on_bullet_hit",":collision_type")])]],

 #Cheat
 ["explosive_bullets","Cartridges", [("rocket",0),("rocket",ixmesh_flying_ammo)], itp_type_bolts|itp_ignore_gravity|itp_ignore_friction|itp_can_penetrate_shield, 0, 64,weight(2.0)|abundance(100)|weapon_length(100)|thrust_damage(100,pierce)|max_ammo(120),imodbits_missile,
 [
  (ti_on_missile_hit,
  [
    (this_or_next|multiplayer_is_server),
    (neg|game_in_multiplayer_mode),
    (store_trigger_param_1, ":thrower_agent"),
    #pos1 - Missile hit position
    (copy_position,pos47,pos1),
    (call_script,"script_explosion_at_position",":thrower_agent",500,500), # Input: shooter_agent_no, max_damage points, range in cm
   ]),]],
 
# cannon ammo
["cannon_cartridge_round", "Round Shot", [("cannonball_cartridge",0)], itp_type_thrown |itp_merchandise,0,
 360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(1)|weapon_length(5),imodbits_none],
["cannon_cartridge_shell", "Shell (Explosive)", [("bomb_cartridge",0)], itp_type_thrown |itp_merchandise,0,
 360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(1)|weapon_length(5),imodbits_none],
["cannon_cartridge_canister", "Canister Shot", [("canister_cartridge",0)], itp_type_thrown |itp_merchandise,0,
 360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(1)|weapon_length(5),imodbits_none],
["cannon_cartridge_bomb", "Mortar Bomb", [("mortar_cartdridge",0)], itp_type_thrown |itp_merchandise,0,
 360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(1)|weapon_length(5),imodbits_none],
["rockets", "Rockets", [("rocket",0)], itp_type_thrown |itp_merchandise,0,
 360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(100)|weapon_length(5),imodbits_none],
 
 
 #Lances and other polearms
#French
["french_lance", "Lance", [("Lance_french",0)], itp_has_upper_stab|itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ],

#Prussian
["prussian_lance", "Lance", [("lance_prussia",0)], itp_has_upper_stab|itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ],

#Austrian
["austrian_lance", "Lance", [("lance_austria",0)],itp_has_upper_stab| itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ], 
 
#Rhine
["saxon_lance", "Lance", [("saxon_ulan_pike",0)],itp_has_upper_stab| itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ], 
 
#Russian
["russian_cossack_pike", "Lance", [("Russian_cossack_pike",0)], itp_has_upper_stab|itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ],
["russian_lancer_pike", "Lance", [("Russian_lancer_pike",0)], itp_has_upper_stab|itp_couchable|itp_type_polearm|itp_offset_lance|itp_no_parry| itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_is_pike|itp_no_blur, itc_lance,
 180 , weight(2.5)|difficulty(0)|spd_rtng(76) | weapon_length(185)|swing_damage(25 ,  pierce) | thrust_damage(30 ,  pierce),imodbits_polearm ],
["russian_opolcheniye_pike","Pike", [("Russian_opolcheniye_pike",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_is_pike|itp_no_blur, itc_spear,
 125 , weight(3.0)|difficulty(0)|spd_rtng(70) | weapon_length(188)|swing_damage(0 , blunt) | thrust_damage(30 ,  pierce),imodbits_polearm ],
["russian_peasant_kosa", "Scythe", [("Russian_peasant_kosa",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_is_pike|itp_no_blur, itc_staff,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(170)|swing_damage(20 , cut) | thrust_damage(20, pierce),imodbits_polearm ],
["russian_peasant_fork", "Wooden Fork", [("Russian_peasant_fork",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_is_pike|itp_no_blur, itc_spear,
 125 , weight(2.7)|difficulty(0)|spd_rtng(75) | weapon_length(145)|swing_damage(6 , blunt) | thrust_damage(25, pierce),imodbits_polearm ],
["russian_peasant_pitchfork", "Pitchfork", [("Russian_peasant_pitchfork",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed, itc_spear,
 125 , weight(2.7)|difficulty(0)|spd_rtng(75) | weapon_length(145)|swing_damage(6 , blunt) | thrust_damage(25, pierce),imodbits_polearm ],
["russian_peasant_sap", "Rake", [("Russian_peasant_sap",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_no_blur, itc_staff,
 125 , weight(2.7)|difficulty(0)|spd_rtng(75) | weapon_length(119)|swing_damage(18 , pierce) | thrust_damage(5, blunt),imodbits_polearm ],
["birch_trunk", "Birch Trunk", [("Birch_trunk",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_crush_through|itp_can_knock_down|itp_unbalanced|itp_no_blur, itc_parry_polearm|itc_cut_two_handed|itcf_thrust_polearm,
 125 , weight(10.0)|difficulty(0)|spd_rtng(67) | weapon_length(104)|swing_damage(30 , blunt) | thrust_damage(8, blunt),imodbits_polearm ], #patch1115 24/1
["russian_peasant_kosa2", "Scythe", [("Russian_peasant_kosa2",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_no_blur, itc_parry_polearm|itcf_overswing_polearm|itcf_slashright_polearm|itcf_slashleft_polearm,
 125 , weight(2.7)|difficulty(0)|spd_rtng(74) | weapon_length(115)|swing_damage(25 , cut) | thrust_damage(0, pierce),imodbits_polearm ],
["russian_peasant_club","Club", [("Russian_peasant_club",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_can_knock_down|itp_no_blur, itc_parry_polearm|itc_cut_two_handed|itcf_thrust_polearm,
 125 , weight(3.3)|difficulty(0)|spd_rtng(70) | weapon_length(90)|swing_damage(20 , blunt) | thrust_damage(5, blunt),imodbits_polearm ],
["russian_peasant_birch_club","Birch Club", [("Russian_peasant_birch_club",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_can_knock_down|itp_no_blur, itc_parry_polearm|itc_cut_two_handed|itcf_thrust_polearm,
 125 , weight(3.3)|difficulty(0)|spd_rtng(70) | weapon_length(90)|swing_damage(20 , blunt) | thrust_damage(5, blunt),imodbits_polearm ],
["russian_peasant_pike","Pike", [("Russian_peasant_pike",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_no_parry|itp_two_handed|itp_is_pike|itp_no_blur, itc_lance,
 125 , weight(3.0)|difficulty(0)|spd_rtng(70) | weapon_length(258)|swing_damage(0 , blunt) | thrust_damage(30 ,  pierce),imodbits_polearm ],
["russian_peasant_kuvalda", "Sledgehammer", [("Russian_peasant_kuvalda",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_no_blur, itc_parry_polearm|itc_cut_two_handed,
 125 , weight(2.7)|difficulty(0)|spd_rtng(75) | weapon_length(64)|swing_damage(30 , blunt) | thrust_damage(5, blunt),imodbits_polearm ],
["russian_peasant_2handed_axe", "Lumber Axe", [("Russian_peasant_2handed_axe",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_no_blur, itc_parry_polearm|itc_cut_two_handed,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(64)|swing_damage(35 , cut) | thrust_damage(0, pierce),imodbits_polearm ],
["russian_peasant_rogatina", "Hunting Spear", [("Russian_peasant_rogatina",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_is_pike|itp_no_blur, itc_spear,
 125 , weight(2.7)|difficulty(0)|spd_rtng(75) | weapon_length(159)|swing_damage(6 , blunt) | thrust_damage(25, pierce),imodbits_polearm ],
["sapper_axe_ship", "Axe", [("sapper_axe",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_bonus_against_shield, itc_cut_two_handed|itc_parry_polearm|itcf_carry_axe_back,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(73)|swing_damage(40 , cut) | thrust_damage(0, pierce),imodbits_polearm ],
["sapper_axe_rus_ship", "Axe", [("Russian_sappeur_axe",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_bonus_against_shield, itc_cut_two_handed|itc_parry_polearm|itcf_carry_axe_back,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(58)|swing_damage(40 , cut) | thrust_damage(0, pierce),imodbits_polearm ],

 #weapons for GF mode. #patch1115 60/12
["french_mousquiton_melee_gf", "Cavalry Carbine", [("french_mousquiton",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(76)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["french_mousquiton_light_melee_gf", "Light Cavalry Carbine", [("french_mousquiton_light",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(76)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["french_dragoon_musket_melee_gf", "Cavalry Musket", [("french_dragoon_musket",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(115)|swing_damage(20 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["russian_dragoon_musket_melee_gf", "Cavalry Musket", [("Russian_dragoon_musket",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(115)|swing_damage(20 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["russian_gusarskiy_karabin_melee_gf", "Musketoon", [("Russian_gusarskiy_karabin",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(58)|swing_damage(22 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["british_carbine_melee_gf", "Cavalry Carbine", [("paget_carabine",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(86) | weapon_length(50)|swing_damage(23 , blunt) | thrust_damage(12,  blunt),imodbits_none ],

["russian_rifle_1805_melee_gf", "Rifle", [("Russian_rifle_1805",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket|itp_can_knock_down,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(74)|swing_damage(23 , blunt) | thrust_damage(22 ,  blunt),imodbits_none ],

["british_baker_rifle_melee_gf", "Rifle", [("baker_rifle",0)], itp_has_upper_stab|itp_type_polearm |itp_primary|itp_no_blur|itp_offset_musket|itp_can_knock_down,itc_musket_melee|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(85)|swing_damage(23 , blunt) | thrust_damage(22 ,  blunt),imodbits_none ],

["french_charleville_melee_gf", "Infantry Musket", [("french_charleville",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ],

["french_versailles_melee_gf", "Infantry Musket", [("french_versailles",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

["british_brown_bess_melee_gf", "Infantry Musket", [("brown_bess_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

["russian_musket_1808_melee_gf", "Infantry Musket", [("Russian_musket_1808",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

["austrian_musket_melee_gf", "Infantry Musket", [("austrian_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

["prussian_potsdam_melee_gf", "Infantry Musket", [("potsdam_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 

["prussian_musket_1806_melee_gf", "Infantry Musket", [("prussian_kuhfuss",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm |itp_primary|itp_is_pike|itp_no_blur,itc_spear|itcf_carry_spear,
180 , weight(0)|difficulty(0)|spd_rtng(85) | weapon_length(138)|swing_damage(40 ,  pierce) | thrust_damage(45 ,  pierce),imodbits_none ], 
#end GF maps #patch1115 60/12
#training weapons
["training_musket", "Training Musket", [("training_musket",0)], itp_cant_use_on_horseback|itp_has_upper_stab|itp_type_polearm|itp_primary|itp_is_pike|itp_wooden_attack|itp_wooden_parry|itp_no_blur, itc_spear|itcf_carry_spear,
180, weight(0)|difficulty(0)|spd_rtng(85)|weapon_length(138)|swing_damage(40, pierce)|thrust_damage(45, pierce), imodbits_none ],
#end training weapons

# Flags
#French
["flag_france_45e","French Line Infantry Colour", [("france_colour_45e",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_84e","French Line Infantry Colour", [("france_colour_84e",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_vistula","Vistula Legion Colour", [("france_colour_vistula",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_grenadiers","French Guard Infantry Colour", [("france_colour_1ergarde",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_15","French Light Infantry Colour", [("france_colour_15eme",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_hussard","French Hussar Colour", [("france_colour_hussards",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_carab","French Carabinier Colour", [("france_colour_lanciers",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_cuirassier","French Cuirassier Colour", [("france_colour_cuirassiers",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_cheval","French Grenadiers a Cheval Colour", [("france_colour_gren_a_cheval",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_dragon","French Dragoon Colour", [("france_colour_dragons",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_france_lancier","French Lancer Colour", [("france_colour_lanciers",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
#Russian
["flag_russia_opolcheniye","Russian St Petersburg's Opolcheniye Flag", [("russian_colour_opolcheniye",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_pavlovsk_color","Russian Pavlovskiy Regimental Colour", [("russian_colour_pavlovsk_color",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_pavlovsk_white","Russian Pavlovskiy White Flag", [("russian_colour_pavlovsk_white",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_preobragenskiy_color","Russian Preobrazhenskiy Regimental Colour", [("russian_colour_preobragenskiy_color",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_preobragenskiy_white","Russian Preobrazhenskiy White Flag", [("russian_colour_preobragenskiy_white",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_simbirsk_color","Russian Simbirskiy Regimental Colour", [("russian_colour_simbirsk_color",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_simbirsk_white","Russian Simbirskiy White Flag", [("russian_colour_simbirsk_white",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["flag_russia_kyiv_dragoon","Russian Kyiv Dragoons Guidon", [("russian_colour_kyiv_dragoon",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
 #British
["britain_colour_33rd_regt","British 33rd Reg. Colour", [("britain_colour_33rd_regt",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_33rd_king","British 33rd King's Colour", [("britain_colour_33rd_king",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_42nd_regt","British 42nd Reg. Colour", [("britain_colour_42nd_regt",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_42nd_king","British 42nd King's Colour", [("britain_colour_42nd_king",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_2nd_regt","British 2nd Reg. Colour", [("britain_colour_2nd_king",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_2nd_king","British 2nd King's Colour", [("britain_colour_2nd_regt",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_51st_regt","British 51st Reg. Colour", [("britain_colour_51st_regt",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_51st_king","British 51st King's Colour", [("britain_colour_51st_king",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_kgl_regt","British KGL Reg. Colour", [("britain_colour_kgl_regt",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_kgl_king","British KGL King's Colour", [("britain_colour_kgl_king",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["britain_colour_blues","British Horse Guards Colour", [("britain_colour_blues",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
 #Prussian
["prussia_colour_infantry","Prussian Infantry Colour", [("flag_prussia_infantry",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["prussia_colour_infantry2","Prussian Infantry Colour", [("flag_prussia_infantry2",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["prussia_colour_guard","Prussian Guard Infantry Colour", [("flag_prussia_guard",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["prussia_colour_landwehr","Prussian Landwehr Colour", [("flag_prussia_landwehr",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["prussia_colour_hussard","Prussian Hussar Colour", [("flag_prussia_hussard",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
 #Austrian
["austria_colour_leibfahne","Austrian Leibfahne", [("austria_colour_leibfahne",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["austria_colour_ordinarfahne","Austrian Ordinarfahne", [("austria_colour_ordinarfahne",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["austria_colour_ordinarfahne_cav","Austrian Ordinarfahne", [("austria_colour_ordinarfahne_cav",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
 #Rhine
["bavarian_flag_national","Bavarian National Colour", [("bavarian_flag_national",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["bavarian_flag_regimental","Bavarian Reg. Colour", [("bavarian_flag_regimental",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["saxon_flag_infantry","Saxon Infantry Colour", [("saxon_infantry_flag",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["saxon_flag_uhlan","Saxon Uhlan Standard", [("saxon_ulan_standard",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["hessian_flag_infantry","Hessian Infantry Colour", [("hessen_infantry_flag",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["westphalian_flag_infantry","Westphalian Infantry Colour", [("west_gr_flag",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["baden_flag_dragoon","Baden Dragoon Standard", [("baden_dragoons_standard",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["westphalian_flag_cuirassier","Westphalian Cuirassier Standard", [("westphalian_cuirassier_standard",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["saxon_flag_garde","Saxon Garde du Corps Standard", [("standart_garde_du_corps",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(140)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["wurttemberg_flag_infantry","Wurttemberg Infantry Colour", [("wurttemberg_infantry_flag",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],
["wurttemberg_flag_infantry2","Wurttemberg Infantry Colour", [("wurttemberg_grenadiers_flag",0)],itp_type_two_handed_wpn|itp_two_handed|itp_wooden_parry|itp_primary, itc_parry_polearm,
 390 , weight(0.5)|difficulty(0)|spd_rtng(50) | weapon_length(320)|swing_damage(1 , cut) | thrust_damage(0 ,  pierce),imodbits_none ],

# Artillery tools
["cannon_lighter","Cannon Lighter", [("lighter",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_merchandise|itp_primary, itc_scimitar|itcf_carry_quiver_front_right, 
210 , weight(1.6)|difficulty(0)|spd_rtng(95) | weapon_length(58)|swing_damage(10 , blunt) | thrust_damage(0 ,  pierce),imodbits_sword_high ],
["ramrod", "Ramrod", [("ramrod",0)], itp_has_upper_stab|itp_type_polearm|itp_offset_lance|itp_merchandise| itp_primary|itp_wooden_parry, itc_spear|itcf_carry_spear,
 85 , weight(3.0)|difficulty(0)|spd_rtng(81) | weapon_length(135)|swing_damage(10 , blunt) | thrust_damage(12 ,  blunt),imodbits_polearm ],
["rocket_placement", "Rocket Launcher", [("rocket_launcher_folded",0)], itp_type_polearm|itp_offset_lance|itp_merchandise| itp_primary|itp_wooden_parry, itcf_carry_spear,
 85 , weight(15)|difficulty(0)|spd_rtng(81) | weapon_length(135)|swing_damage(10 , blunt) | thrust_damage(12 ,  blunt),imodbits_polearm ],
 
#Spyglass
["spyglass","Spyglass", [("spyglass",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary, 0, 
210 , weight(0)|difficulty(0)|spd_rtng(93) | weapon_length(102)|swing_damage(30 , cut) | thrust_damage(30 ,  pierce),imodbits_sword_high],

#Misc item: Keys
["key", "Key", [("key",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary, 0,
210 , weight(0)|difficulty(0)|spd_rtng(93)|weapon_length(102)|swing_damage(30, cut)|thrust_damage(30, pierce), imodbits_sword_high],
["key_gold", "Golden Key", [("key_gold",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary, 0,
210 , weight(0)|difficulty(0)|spd_rtng(93)|weapon_length(102)|swing_damage(30, cut)|thrust_damage(30, pierce), imodbits_sword_high],

#Misc item: drinking
["drinking_cup", "Cup", [("drinking_cup_carry",0), ("drinking_cup", ixmesh_carry)], itp_type_two_handed_wpn|itp_wooden_parry|itp_primary, 0,
 210, weight(1)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt), imodbits_sword_high ],
["drinking_tea_cup", "Tea Cup", [("drinking_tea_cup_carry",0), ("drinking_tea_cup", ixmesh_carry)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary, 0,
 210, weight(1)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt), imodbits_sword_high ],
["drinking_tea_cup_plate", "Tea Cup", [("drinking_tea_cup_plate_carry",0), ("drinking_tea_cup_plate", ixmesh_carry)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary, 0,
 210, weight(1.2)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt), imodbits_sword_high ],
#["drinking_tea_plate", "Tea Cup Plate Shield", [("drinking_tea_plate_carry",0), ("drinking_tea_plate", ixmesh_carry)], itp_type_shield|itp_wooden_parry, 0,
 # 210, weight(0.2)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt),imodbits_sword ],
["drinking_bottle", "Bottle", [("drinking_bottle_carry",0), ("drinking_bottle", ixmesh_carry)], itp_type_one_handed_wpn|itp_wooden_parry|itp_primary|itp_next_item_as_melee, 0,
 210, weight(1.2)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt), imodbits_sword_high ],
["drinking_bottle_melee", "Bottle", [("drinking_bottle_carry",0), ("drinking_bottle", ixmesh_carry)], itp_type_one_handed_wpn|itp_primary|itp_no_parry|itp_no_blur|itp_offset_musket, itc_dagger,
 210, weight(1.2)|difficulty(0)|spd_rtng(90)|weapon_length(32)|swing_damage(24, blunt)|thrust_damage(18, blunt), imodbits_sword_high ],

#Misc item: cane
["cane", "Drill Cane", [("drill_cane",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_wooden_attack|itp_merchandise|itp_primary|itp_next_item_as_melee, 0,
 210, weight(1.0)|difficulty(0)|spd_rtng(95)|weapon_length(90)|swing_damage(10, blunt)|thrust_damage(10, blunt), imodbits_sword_high ],
["cane_melee", "Drill Cane", [("drill_cane",0)], itp_type_one_handed_wpn|itp_wooden_parry|itp_wooden_attack|itp_merchandise|itp_primary, itc_longsword,
 210, weight(1.0)|difficulty(0)|spd_rtng(95)|weapon_length(90)|swing_damage(10, blunt)|thrust_damage(10, blunt), imodbits_sword_high ],

#Bandage # patch1115 surgeon
["bandages","Bandages", [("bandage",0)], itp_type_one_handed_wpn|itp_primary|itp_no_parry, itc_dagger_no_stab|itcf_carry_pistol_front_left, 
210 , weight(1.6)|difficulty(0)|spd_rtng(65) | weapon_length(25)|swing_damage(10 , blunt) | thrust_damage(0 ,  pierce),imodbits_sword_high ],


# Admin Toys
["grenade", "Holy Handgrenade", [("hhg",0)], itp_type_thrown|itp_primary ,itcf_throw_stone, 1 , weight(4)|difficulty(0)|spd_rtng(97) | shoot_speed(30) | thrust_damage(11 ,  blunt)|max_ammo(100)|weapon_length(8),imodbit_large_bag,
[
  (ti_on_weapon_attack, 
  [
    (copy_position,pos56,pos1),
    (call_script,"script_multiplayer_server_play_sound_at_position","snd_holy_call"),
  ]),
  (ti_on_missile_hit,
  [
    (store_trigger_param_1, ":thrower_agent"),
    #pos1 - Missile hit position
    (copy_position,pos47,pos1),
    (call_script,"script_explosion_at_position",":thrower_agent",500,500), # Input: shooter_agent_no, max_damage points, range in cm
   ]),
 ]],
 
#Sapper Items
["sapper_axe", "Sapper Axe", [("sapper_axe",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_bonus_against_shield, itc_cut_two_handed|itc_parry_polearm|itcf_carry_axe_back,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(100)|swing_damage(40 , cut) | thrust_damage(0, pierce),imodbits_polearm ],
["sapper_axe_rus", "Sapper Axe", [("Russian_sappeur_axe",0)], itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_bonus_against_shield, itc_cut_two_handed|itc_parry_polearm|itcf_carry_axe_back,
 125 , weight(2.7)|difficulty(0)|spd_rtng(70) | weapon_length(100)|swing_damage(40 , cut) | thrust_damage(0, pierce),imodbits_polearm ],
["construction_hammer", "Construction Hammer", [("sapper_hammer",0)], itp_type_one_handed_wpn|itp_no_parry|itp_merchandise|itp_primary, itc_scimitar|itcf_carry_quiver_right_vertical, 
 210 , weight(1.5)|difficulty(0)|spd_rtng(92) | weapon_length(120)|swing_damage(4 , blunt) | thrust_damage(0 ,  pierce),imodbits_sword_high ],
["shovel", "Spade", [("shovel",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed|itp_next_item_as_melee, itcf_carry_bow_back|itc_parry_polearm | itcf_thrust_onehanded_lance |itcf_thrust_onehanded_lance_horseback | itcf_thrust_polearm,
 125 , weight(2.5)|difficulty(0)|spd_rtng(75) | weapon_length(140)|swing_damage(6 , blunt) | thrust_damage(16, pierce),imodbits_polearm ],
["shovel_undig", "Spade", [("shovel",0)], itp_has_upper_stab|itp_type_polearm|itp_merchandise| itp_cant_use_on_horseback|itp_primary|itp_penalty_with_shield|itp_wooden_parry|itp_two_handed, itcf_carry_bow_back|itc_parry_polearm | itcf_thrust_onehanded_lance |itcf_thrust_onehanded_lance_horseback | itcf_thrust_polearm,
 125 , weight(2.5)|difficulty(0)|spd_rtng(75) | weapon_length(140)|swing_damage(6 , blunt) | thrust_damage(16, pierce),imodbits_polearm ],
["french_bomb", "Explosives", [("barreltriangulated",0)], itp_type_thrown |itp_merchandise,itcf_throw_stone,
360, weight(5)|difficulty(0)|spd_rtng(70) | shoot_speed(0) | thrust_damage(1,blunt)|max_ammo(1)|weapon_length(5),imodbits_none,[
 (ti_on_missile_hit,
 [
   (store_trigger_param_1, ":user_agent"),
   (call_script, "script_multiplayer_server_construct_prop", ":user_agent", "spr_mm_french_barrel_explosive")
 ])]],
 
 
#Uniforms
 #French
["french_voltigeur_body_officer", "French Voltigeur Uniform", [("french_voltigeur_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_voltigeur_body_ranker", "French Voltigeur Uniform", [("french_voltigeur_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_voltigeur_body_sarge", "French Voltigeur Uniform", [("french_voltigeur_body_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_45e_body_officer", "French Infantry Uniform", [("french_45e_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_45e_body_colours", "French Infantry Uniform", [("french_45e_body_flagcarrier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_45e_body_ranker", "French Infantry Uniform", [("french_45e_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_84e_body_officer", "French Infantry Uniform", [("french_84e_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_84e_body_ranker", "French Infantry Uniform", [("french_84e_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_84e_body_sarge", "French Infantry Uniform", [("french_84e_body_flagcarrier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_body_ranker", "French Dragoon Uniform", [("french_dragoon_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_body_officer", "French Dragoon Uniform", [("french_dragoon_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_general_body_boney", "Napoleon's Uniform", [("french_general_body_boney",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_grenadiers_a_cheval_body_colours", "French Horse Grenadier Uniform", [("french_grenadiers_a_cheval_body_flagman",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_grenadiers_a_cheval_body_ranker", "French Horse Grenadier Uniform", [("french_grenadiers_a_cheval_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_grenadiers_a_cheval_body_officer", "French Horse Grenadier Uniform", [("french_grenadiers_a_cheval_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_gap_body_colours", "French Grenadier Uniform", [("french_GRaP_body_flagman",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_gap_body_ranker", "French Grenadier Uniform", [("french_GRaP_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_gap_body_officer", "French Grenadier Uniform", [("french_GRaP_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_art_ranker_body", "French Artillery Uniform", [("french_art_ranker_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_art_ranker_body_alt", "French Artillery Uniform", [("french_art_ranker_body_alt",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_art_officer_body", "French Artillery Uniform", [("french_art_officer_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_vistula_body_ranker", "Vistula Legion Uniform", [("french_vistula_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_vistula_body_colours", "Vistula Legion Uniform", [("french_vistula_body_flagcarrier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_vistula_body_officer", "Vistula Legion Uniform", [("french_vistula_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_lancer_body_ranker", "French Guard Lancer Uniform", [("french_lancer_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_lancer_body_colours", "French Guard Lancer Uniform", [("french_lancer_flagcarrier_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_lancer_body_officer", "French Guard Lancer Uniform", [("french_lancer_officer_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_ranker", "French Cuirassier Uniform", [("fr_cuirassier_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_colours", "French Cuirassier Uniform", [("fr_cuirassier_body_porte_aigle",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_officer", "French Cuirassier Uniform", [("fr_cuirassier_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_ranker", "French Carabineer Uniform", [("fr_carabineer_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_colours", "French Carabineer Uniform", [("fr_carabineer_porte_aigle",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_officer", "French Carabineer Uniform", [("fr_carabineer_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_hussards_ranker", "French Hussar Uniform", [("french_hussards_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_hussards_nco", "French Hussar Uniform", [("french_hussards_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_hussards_officer", "French Hussar Uniform", [("french_hussards_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_hussards_trumpeter", "French Hussar Uniform", [("french_hussards_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_sapper", "French Sapper Uniform", [("french_sappeur",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_GRaP_body_drummer", "French Drummer Uniform", [("french_GRaP_body_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_GRaP_body_flautist", "French Flautist Uniform", [("french_GRaP_body_flautist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_voltigeur_body_hornist", "French Voltigeur Uniform", [("french_voltigeur_body_hornist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_45e_body_drummer", "French Drummer Uniform", [("french_45e_body_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_45e_body_flautist", "French Flautist Uniform", [("french_45e_body_flautist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_84e_body_drummer", "French Drummer Uniform", [("french_84e_body_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_84e_body_flautist", "French Flautist Uniform", [("french_84e_body_flautist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["fr_carabineer_trumpeter", "French Trumpeter Uniform", [("fr_carabineer_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["fr_cuirassier_body_trumpeter", "French Trumpeter Uniform", [("fr_cuirassier_body_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_body_trumpeter", "French Trumpeter Uniform", [("french_dragoon_body_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_lancer_trumpeter_body", "French Trumpeter Uniform", [("french_lancer_trumpeter_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_vistula_body_drummer", "Vistula Legion Uniform", [("french_vistula_body_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_vistula_body_flautist", "Vistula Legion Uniform", [("french_vistula_body_flautist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_body_sargent", "French Dragoon Uniform", [("french_dragoon_body_sargent",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_arty_train", "French Artillery Train Uniform", [("french_arty_train",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_grenadier_a_cheval_body_trumpeter", "French Trumpeter Uniform", [("french_grenadier_a_cheval_body_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_captain", "french_captain", [("french_captain",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_equipage_batallion", "french_equipage_batallion", [("french_equipage_batallion",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["french_surgeon", "Surgeon Outfit", [("french_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

 
 #British
["british_infantry_ranker", "British Infantry Uniform", [("british_infantry_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_infantry_sarge", "British Infantry Uniform", [("british_infantry_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_infantry_officer", "British Infantry Uniform", [("british_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_infantry_drum", "British Infantry Uniform", [("british_infantry_drum",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_infantry_flute", "British Infantry Uniform", [("british_infantry_flute",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_ranker", "KGL Infantry Uniform", [("british_kgl_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_sarge", "KGL Infantry Uniform", [("british_kgl_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_officer", "KGL Infantry Uniform", [("british_kgl_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_drum", "KGL Infantry Uniform", [("british_kgl_drum",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_flute", "KGL Infantry Uniform", [("british_kgl_flute",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_ranker", "British Highland Infantry Uniform", [("british_highland_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_sarge", "British Highland Infantry Uniform", [("british_highland_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_officer", "British Highland Infantry Uniform", [("british_highland_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_drummer", "British Highland Infantry Uniform", [("british_highland_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_piper", "British Highland Infantry Uniform", [("british_highland_piper",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_highland_piper_2", "British Highland Infantry Uniform", [("british_highland_piper_2",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_guard_ranker", "British Guard Infantry Uniform", [("british_guard_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_guard_sarge", "British Guard Infantry Uniform", [("british_guard_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_guard_officer", "British Guard Infantry Uniform", [("british_guard_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_guard_drum", "British Guard Infantry Uniform", [("british_guard_drum",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_guard_flute", "British Guard Infantry Uniform", [("british_guard_flute",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_ranker", "British Light Infantry Uniform", [("british_light_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_sarge", "British Light Infantry Uniform", [("british_light_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_officer", "British Light Infantry Uniform", [("british_light_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_bugler", "British Light Infantry Uniform", [("british_light_bugler",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_rifle_ranker", "British Rifleman Uniform", [("british_rifle_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_rifle_sarge", "British Rifleman Uniform", [("british_rifle_sarge",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_rifle_captain", "British Rifleman Uniform", [("british_rifle_captain",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_rifle_bugler", "British Rifleman Uniform", [("british_rifle_bugler",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_artillery_ranker", "British Artillery Uniform", [("british_artillery_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_artillery_officer", "British Artillery Uniform", [("british_artillery_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_artillery_train", "British Artillery Uniform", [("british_artillery_train",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_dragoon", "British Light Dragoon Uniform", [("british_light_dragoon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_light_dragoon_officer", "British Light Dragoon Uniform", [("british_light_dragoon_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_inniskilling_ranker", "British Dragoon Uniform", [("british_iniskilling_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_inniskilling_officer", "British Dragoon Uniform", [("british_iniskilling_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_blue_ranker", "British Horse Guard Uniform", [("british_blue_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_blue_officer", "British Horse Guard Uniform", [("british_blue_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_hussar_ranker", "British Horse Guard Uniform", [("KGL_hussar_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_hussar_officer", "British Horse Guard Uniform", [("KGL_hussar_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_kgl_hussar_trumpeter", "British Horse Guard Uniform", [("KGL_hussar_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_wellington", "British Wellington Uniform", [("wellington_coat",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_rocketeer", "British Rocketeer Uniform", [("british_rocketeer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_sapper", "British Sapper Uniform", [("british_sapper",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_captain", "British Captain Uniform", [("british_captain",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_royal_marine", "British Royal Marine Uniform", [("british_royal_marine",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["naked_female_body", "naked_female_body", [("0",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["naked_male_body", "naked_male_body", [("0",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["british_surgeon", "Surgeon Outfit", [("uk_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

 
 # Prussian
["prussian_infantry_ranker", "Prussian Infantry Uniform", [("prussian_8_infantry_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry_nco", "Prussian Infantry Uniform", [("prussian_8_infantry_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry_officer", "Prussian Infantry Uniform", [("prussian_8_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry_drum", "Prussian Infantry Uniform", [("prussian_8_infantry_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry_flute", "Prussian Infantry Uniform", [("prussian_8_infantry_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_dragoon_ranker", "Prussian Dragoon Uniform", [("prus_dragoon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_dragoon_nco", "Prussian Dragoon Uniform", [("prus_dragoon_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_dragoon_officer", "Prussian Dragoon Uniform", [("prus_dragoon_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_dragoon_trumpet", "Prussian Dragoon Uniform", [("prus_dragoon_trumpet",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_jaeger_ranker", "Prussian Jaeger Uniform", [("prussian_silesian_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_jaeger_ranker_alt", "Prussian Jaeger Uniform", [("prussian_silesian_ranker_variant",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_jaeger_nco", "Prussian Jaeger Uniform", [("prussian_silesian_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_jaeger_officer", "Prussian Jaeger Uniform", [("prussian_silesian_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_jaeger_hornist", "Prussian Jaeger Uniform", [("prussian_silesian_hornist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_guard_ranker", "Prussian Foot Guard Uniform", [("prussian_gzf_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_guard_nco", "Prussian Foot Guard Uniform", [("prussian_gzf_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_guard_officer", "Prussian Foot Guard Uniform", [("prussian_gzf_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_guard_drummer", "Prussian Foot Guard Uniform", [("prussian_gzf_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_guard_flute", "Prussian Foot Guard Uniform", [("prussian_gzf_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_arty_ranker", "Prussian Artillery Uniform", [("prussian_artillery_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_arty_train", "Prussian Artillery Uniform", [("prussian_artillery_train",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_arty_officer", "Prussian Artillery Uniform", [("prussian_artillery_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_hussar_ranker", "Prussian Hussar Uniform", [("prussian_hussar_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_hussar_nco", "Prussian Hussar Uniform", [("prussian_hussar_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_hussar_officer", "Prussian Hussar Uniform", [("prussian_hussar_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_hussar_officer_variant", "Prussian Hussar Uniform", [("prussian_hussar_officer_variant",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_hussar_trumpet", "Prussian Hussar Uniform", [("prussian_hussar_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry2_ranker", "Prussian Infantry Uniform", [("prussian_23_infantry_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry2_nco", "Prussian Infantry Uniform", [("prussian_23_infantry_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry2_officer", "Prussian Infantry Uniform", [("prussian_23_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry2_drum", "Prussian Infantry Uniform", [("prussian_23_infantry_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_infantry2_flute", "Prussian Infantry Uniform", [("prussian_23_infantry_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_ranker", "Prussian Landwehr Uniform", [("prussian_landwehr_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_ranker_alt", "Prussian Landwehr Uniform", [("prussian_landwehr_ranker_variant",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_nco", "Prussian Landwehr Uniform", [("prussian_landwehr_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_officer", "Prussian Landwehr Uniform", [("prussian_landwehr_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_drum", "Prussian Landwehr Uniform", [("prussian_landwehr_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_flute", "Prussian Landwehr Uniform", [("prussian_landwehr_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_cav_ranker", "Prussian Landwehr Uniform", [("prussian_landwehr_cavalry_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_cav_nco", "Prussian Landwehr Uniform", [("prussian_landwehr_cavalry_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_cav_officer", "Prussian Landwehr Uniform", [("prussian_landwehr_cavalry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_landwehr_cav_trumpet", "Prussian Landwehr Uniform", [("prussian_landwehr_cavalry_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_blucher", "Blucher's Uniform", [("blucher",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_cuirassier_ranker", "Prussian Cuirassier Uniform", [("prussian_cuirassier_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,  #patch1115 25/3 begin
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_cuirassier_nco", "Prussian Cuirassier Uniform", [("prussian_cuirassier_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_cuirassier_officer", "Prussian Cuirassier Uniform", [("prussian_cuirassier_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_cuirassier_trumpet", "Prussian Cuirassier Uniform", [("prussian_cuirassier_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ], #patch1115 25/3 end
["prussian_freikorps_ranker", "Prussian Freikorps Uniform", [("prussian_lutzov_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_freikorps_nco", "Prussian Freikorps Uniform", [("prussian_lutzov_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_freikorps_officer", "Prussian Freikorps Uniform", [("prussian_lutzov_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_freikorps_drum", "Prussian Freikorps Uniform", [("prussian_lutzov_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_freikorps_flute", "Prussian Freikorps Uniform", [("prussian_lutzov_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_pioneer", "Prussian Pioneer Uniform", [("prussian_pioneer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["prussian_surgeon", "Surgeon Outfit", [("prussia_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

 # Russian
["russian_infantry1", "Russian Infantry Uniform", [("rus_musketeer1",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_infantry_nco", "Russian Infantry Uniform", [("rus_musketeer_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_infantry_officer", "Russian Infantry Uniform", [("rus_musketeer_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_drummer", "Russian Infantry Uniform", [("rus_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_flautist", "Russian Infantry Uniform", [("rus_flautist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_hussar_officer", "Russian Hussar Uniform", [("rus_hussards_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_hussar_nco", "Russian Hussar Uniform", [("rus_hussards_sarg",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_hussar_ranker", "Russian Hussar Uniform", [("rus_hussards_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_hussar_trumpeter", "Russian Hussar Uniform", [("rus_hussards_trump",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_horse_guard", "Russian Chevalier-Garde Uniform", [("rus_chevalier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_horse_guard_nco", "Russian Chevalier-Garde Uniform", [("rus_chevalier_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_horse_guard_officer", "Russian Chevalier-Garde Uniform", [("rus_chevalier_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_horse_guard_trumpeter", "Russian Chevalier-Garde Uniform", [("rus_chevalier_trump",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_cossack_officer", "Russian Cossack Uniform", [("rus_cossack_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_cossack", "Russian Cossack Uniform", [("rus_cossack_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["Kutuzov", "Kutuzov Uniform", [("rus_kutuzov",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_militia_officer", "Russian Militia Officer Uniform", [("rus_militia_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_militia_ranker", "Russian Militia Uniform", [("rus_militia_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_guard_officer", "Russian Guard Infantry Uniform", [("rus_preobr_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_guard_nco", "Russian Guard Infantry Uniform", [("rus_preobr_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_guard_ranker", "Russian Guard Infantry Uniform", [("rus_preobr_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_guard_drummer", "Russian Guard Infantry Uniform", [("rus_preobr_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_guard_flautist", "Russian Guard Infantry Uniform", [("rus_flautist_preobr",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_jaeger_officer", "Russian Jaeger Uniform", [("rus_jaeger_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_jaeger_nco", "Russian Jaeger Uniform", [("rus_jaeger_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_jaeger_ranker", "Russian Jaeger Uniform", [("rus_jaeger",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_jaeger_musician", "Russian Jaeger Uniform", [("rus_jaeger_drum",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_gren_officer", "Russian Infantry Uniform", [("rus_pavlo_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_gren_nco", "Russian Infantry Uniform", [("rus_pavlo_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_gren_ranker", "Russian Infantry Uniform", [("rus_pavlo_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_arty_officer", "Russian Artillery Uniform", [("rus_arty_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_arty_nco", "Russian Artillery Uniform", [("rus_arty_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_arty_ranker", "Russian Artillery Uniform", [("rus_arty_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_dragoon_officer", "Russian Dragoon Uniform", [("rus_dragoon_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_dragoon_nco", "Russian Dragoon Uniform", [("rus_dragoon_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_dragoon_ranker", "Russian Dragoon Uniform", [("rus_dragoon_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_dragoon_trumpeter", "Russian Dragoon Uniform", [("rus_dragoon_trump",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["rus_partizan1", "Russian Great Coat", [("rus_partizan",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["rus_partizan2", "Russian Great Coat", [("rus_partizan1",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_uhlan_officer", "Russian Uhlan Uniform", [("rus_uhlan_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_uhlan_nco", "Russian Uhlan Uniform", [("rus_uhlan_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_uhlan_ranker", "Russian Uhlan Uniform", [("rus_uhlan_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_uhlan_trumpeter", "Russian Uhlan Uniform", [("rus_uhlan_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["rus_pioneer", "Russian Pioneer Uniform", [("rus_pioneer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["russian_surgeon", "Surgeon Outfit", [("russia_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

 
# Austrian
["austrian_infantry", "Austrian Infantry Uniform", [("austrian_infantry",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry_nco", "Austrian Infantry Uniform", [("austrian_infantry_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry_officer", "Austrian Infantry Uniform", [("austrian_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry_drummer", "Austrian Infantry Uniform", [("austrian_infantry_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry_fifer", "Austrian Infantry Uniform", [("austrian_infantry_musician",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry2", "Hungarian Infantry Uniform", [("austrian_infantry2",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry2_nco", "Hungarian Infantry Uniform", [("austrian_infantry2_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry2_officer", "Hungarian Infantry Uniform", [("austrian_infantry2_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry2_drummer", "Hungarian Infantry Uniform", [("austrian_infantry2_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_infantry2_fifer", "Hungarian Infantry Uniform", [("austrian_infantry2_musician",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier", "Hungarian Infantry Uniform", [("austrian_grenadier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier_alt", "Hungarian Infantry Uniform", [("austrian_grenadier_var1",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier_nco", "Hungarian Infantry Uniform", [("austrian_grenadier_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier_officer", "Hungarian Infantry Uniform", [("austrian_grenadier_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier_drummer", "Hungarian Infantry Uniform", [("austrian_grenadier_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenadier_fifer", "Hungarian Infantry Uniform", [("austrian_grenadier_musician",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenzer", "Austrian Grenzer Uniform", [("austrian_grenzer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenzer_nco", "Austrian Grenzer Uniform", [("austrian_grenzer_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenzer_officer", "Austrian Grenzer Uniform", [("austrian_grenzer_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenzer_drummer", "Austrian Grenzer Uniform", [("austrian_grenzer_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_grenzer_fifer", "Austrian Grenzer Uniform", [("austrian_grenzer_musician",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_jaeger", "Austrian Jaeger Uniform", [("austrian_jaeger",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_jaeger_nco", "Austrian Jaeger Uniform", [("austrian_jaeger_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_jaeger_officer", "Austrian Jaeger Uniform", [("austrian_jaeger_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_jaeger_hornist", "Austrian Jaeger Uniform", [("austrian_jaeger_hornist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_lightcav", "Austrian Chevau-leger Uniform", [("austrian_lightcav",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_lightcav_nco", "Austrian Chevau-leger Uniform", [("austrian_lightcav_flag_bearer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_lightcav_trumpet", "Austrian Chevau-leger Uniform", [("austrian_lightcav_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_lightcav_officer", "Austrian Chevau-leger Uniform", [("austrian_lightcav_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_dragoon", "Austrian Dragoon Uniform", [("austrian_dragoon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_dragoon_nco", "Austrian Dragoon Uniform", [("austrian_dragoon_flag_bearer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_dragoon_trumpet", "Austrian Dragoon Uniform", [("austrian_dragoon_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_dragoon_officer", "Austrian Dragoon Uniform", [("austrian_dragoon_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_uhlan", "Austrian Uhlan Uniform", [("austrian_uhlan",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_uhlan_nco", "Austrian Uhlan Uniform", [("austrian_uhlan_flag_bearer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_uhlan_trumpet", "Austrian Uhlan Uniform", [("austrian_uhlan_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_uhlan_officer", "Austrian Uhlan Uniform", [("austrian_uhlan_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_arty", "Austrian Artillery Uniform", [("austrian_arty",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_arty_train", "Austrian Artillery Uniform", [("austrian_arty_train",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_arty_officer", "Austrian Artillery Uniform", [("austrian_arty_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_pioneer", "Austrian Pioneer Uniform", [("austrian_pioneer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_hussar", "Austrian Hussar Uniform", [("austrian_hussar",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_hussar_nco", "Austrian Hussar Uniform", [("austrian_hussar_flag_bearer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_hussar_trumpet", "Austrian Hussar Uniform", [("austrian_hussar_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_hussar_officer", "Austrian Hussar Uniform", [("austrian_hussar_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_cuiraisser", "Austrian Cuirassier Uniform", [("austrian_cuirassier_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_cuiraisser_nco", "Austrian Cuirassier Uniform", [("austrian_cuirassier_flag_bearer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_cuiraisser_trumpet", "Austrian Cuirassier Uniform", [("austrian_cuirassier_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_cuiraisser_officer", "Austrian Cuirassier Uniform", [("austrian_cuirassier_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_schwarzenberg", "Schwarzenberg's Uniform", [("schwarzenberg",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["austrian_surgeon", "Surgeon Outfit", [("austria_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],


# Rhine
["bavarian_inf_ranker", "Bavarian Uniform", [("bavarian_inf_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_inf_flagcarrier", "Bavarian Uniform", [("bavarian_inf_flagcarrier",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_inf_officer", "Bavarian Uniform", [("bavarian_inf_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_inf_drummer", "Bavarian Uniform", [("bavarian_inf_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_inf_flutist", "Bavarian Uniform", [("bavarian_inf_flutist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_jaeger_ranker", "Bavarian Uniform", [("bavarian_jaeger_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_jaeger_nco", "Bavarian Uniform", [("bavarian_jaeger_body_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_jaeger_officer", "Bavarian Uniform", [("bavarian_jaeger_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_jaeger_hornist", "Bavarian Uniform", [("bavarian_jaeger_body_hornist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_artillery_ranker", "Bavarian Uniform", [("bavarian_artillery_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_artillery_train", "Bavarian Uniform", [("bavarian_artillery_train_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["bavarian_artillery_officer", "Bavarian Uniform", [("bavarian_artillery_officer_body",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_inf_ranker", "Saxon Uniform", [("saxon_infantry_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_inf_nco", "Saxon Uniform", [("saxon_infantry_body_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_inf_officer", "Saxon Uniform", [("saxon_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_inf_drummer", "Saxon Uniform", [("saxon_infantry_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_inf_fifer", "Saxon Uniform", [("saxon_inf_flutist",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_uhlan_ranker", "Saxon Uniform", [("saxon_ulan_private",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_uhlan_ranker_alt", "Saxon Uniform", [("saxon_ulan_private_2",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_uhlan_nco", "Saxon Uniform", [("saxon_ulan_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_uhlan_officer", "Saxon Uniform", [("saxon_ulan_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_uhlan_trumpet", "Saxon Uniform", [("saxon_ulan_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["hessian_inf_ranker", "Hessian Uniform", [("hessen_infantry_private",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["hessian_inf_nco", "Hessian Uniform", [("hessen_infantry_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["hessian_inf_officer", "Hessian Uniform", [("hessen_infantry_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["rhine_surgeon", "Surgeon Outfit", [("rhine_surgeon",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_guard_ranker", "Westphalian Uniform", [("west_gr_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_guard_nco", "Westphalian Uniform", [("west_gr_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_guard_officer", "Westphalian Uniform", [("west_gr_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_guard_drummer", "Westphalian Uniform", [("west_gr_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_guard_fifer", "Westphalian Uniform", [("west_gr_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_king", "Royal Outfit", [("saxonyking",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["nassau_jaeger_ranker", "Nassauer Uniform", [("nassau_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["nassau_jaeger_nco", "Nassauer Uniform", [("nassau_nco",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["nassau_jaeger_officer", "Nassauer Uniform", [("nassau_off",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["nassau_jaeger_trumpet", "Nassauer Uniform", [("nassau_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg_inf_ranker", "wurttemberg Uniform", [("wurttemberg_private",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg_inf_flagcarrier", "wurttemberg Uniform", [("wurttemberg_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg_inf_officer", "wurttemberg Uniform", [("wurttemberg_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg_inf_drummer", "wurttemberg Uniform", [("wurttemberg_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg_inf_flutist", "wurttemberg Uniform", [("wurttemberg_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg2_inf_ranker", "wurttemberg2 Uniform", [("wurttemberg_grenadier_private",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg2_inf_flagcarrier", "wurttemberg2 Uniform", [("wurttemberg_grenadier_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg2_inf_officer", "wurttemberg2 Uniform", [("wurttemberg_grandier_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg2_inf_drummer", "wurttemberg2 Uniform", [("wurttemberg_grenadier_drummer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["wurttemberg2_inf_flutist", "wurttemberg2 Uniform", [("wurttemberg_grenadier_fifer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["berg_pioneer", "berg_pioneer Uniform", [("berg_pioneer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_garde_ranker", "Saxon Cuirassier Uniform", [("garde_du_corps",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_garde_colours", "Saxon Cuirassier Uniform", [("garde_du_corps_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_garde_officer", "Saxon Cuirassier Uniform", [("garde_du_corps_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["saxon_garde_body_trumpeter", "Saxon Trumpeter Uniform", [("garde_du_corps_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_cuirassier_ranker", "Westphalian Cuirassier Uniform", [("westphalian_cuirassier_body_ranker",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_cuirassier_colours", "Westphalian Cuirassier Uniform", [("westphalian_cuirassier_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_cuirassier_officer", "Westphalian Cuirassier Uniform", [("westphalian_cuirassier_body_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(34)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["westphalian_cuirassier_body_trumpeter", "Westphalian Trumpeter Uniform", [("westphalian_cuirassier_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["baden_dragoon_ranker", "Austrian Chevau-leger Uniform", [("baden_dragoon_private",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["baden_dragoon_nco", "Austrian Chevau-leger Uniform", [("baden_dragoon_NCO",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["baden_dragoon_trumpet", "Austrian Chevau-leger Uniform", [("baden_dragoon_trumpeter",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["baden_dragoon_officer", "Austrian Chevau-leger Uniform", [("baden_dragoon_officer",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

#Civilian Shirts
["civil_shirt_1", "Civilian Shirt 1", [("civil_shirt_1",0)], itp_merchandise|itp_type_body_armor|itp_covers_legs|itp_civilian,0,
 100, weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
["civil_shirt_2", "Civilian Shirt 1", [("civil_shirt_2",0)], itp_merchandise|itp_type_body_armor|itp_covers_legs|itp_civilian,0,
 100, weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],

 # Character screen uniform
["character_uniform", "{!}Character Uniform Dummy", [("character_uniform",0)], itp_merchandise| itp_type_body_armor  |itp_covers_legs |itp_civilian,0,
 100 , weight(3)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(6)|difficulty(0) ,imodbits_cloth ],
 
#Hats
["rus_pavlovsk_ranker", "Pavlovsk Ranker Mitras Cap", [("rus_pavlovsk_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_kyiv_dragoons_all", "Russian Dragoon Helmet", [("rus_kyiv_dragoons_all",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_kyiv_dragoons_trumpeter", "Russian Dragoon Trumpeter Helmet", [("rus_kyiv_dragoons_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_drummer_shako", "Russian Infantry Shako", [("rus_drummer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_chevalier_hat", "Russian Chevalier-Garde Helmet", [("rus_chevalier_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_chevalier_hat_officer", "Russian Chevalier-Garde Helmet", [("rus_chevalier_hat_off",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_chevalier_hat_trumpeter", "Russian Chevalier-Garde Helmet", [("rus_chevalier_hat_trump",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_arty_shako_officer", "Russian Artillery Shako", [("rus_arty_captain_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_arty_shako_nco", "Russian Artillery Shako", [("rus_arty_sarge_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_arty_shako_ranker", "Russian Artillery Shako", [("rus_arty_ranker_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_cossack_hat_officer", "Cossack Hat", [("rus_cossacks_captain_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian |itp_doesnt_cover_hair ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_cossack_hat_nco", "Cossack Hat", [("rus_cossacks_sarge_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_cossack_hat_ranker", "Cossack Hat", [("rus_cossacks_ranker_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_hussar_shako_officer", "Russian Hussar Shako", [("rus_hussard_captain_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_hussar_shako_nco", "Russian Hussar Shako", [("rus_hussard_sarge_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_hussar_shako_ranker", "Russian Hussar Shako", [("rus_hussard_ranker_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_hussar_shako_trumpeter", "Russian Hussar Shako", [("rus_hussard_trumpeter_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_jaeger_shako_nco", "Russian Jaeger Shako", [("rus_jaeger_sarge_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_jaeger_shako_ranker", "Russian Jaeger Shako", [("rus_jaeger_ranker_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["kutuzov_hat", "Kutuzov Hat", [("rus_general",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_covers_beard  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_guard_shako_officer", "Russian Guard Infantry Shako", [("rus_preobr_captain_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian |itp_doesnt_cover_hair ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_guard_shako_nco", "Russian Guard Infantry Shako", [("rus_preobr_sarge_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_guard_shako_ranker", "Russian Guard Infantry Shako", [("rus_preobr_ranker_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_guard_shako_musician", "Russian Guard Infantry Shako", [("rus_preobr_musician_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_infantry_officer_shako", "Russian Infantry Shako", [("rus_captain_jaeger_musketeer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_infantry_shako_nco", "Russian Infantry Shako", [("rus_musketeer_sarge_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_pioneer_shako", "Russian Pioneer Shako", [("shako_rus_pioneer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_partisan_hat1", "Peasant's Cap", [("rus_random_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_partisan_hat2", "Peasant's Cap", [("rus_random_hat1",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_partisan_hat3", "Peasant's Cap", [("partizan_hat_1",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_partisan_hat4", "Peasant's Cap", [("partizan_hat_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_partisan_hat5", "Peasant's Cap", [("partizan_hat_3",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_uhlan_czapka_officer", "Russian Uhlan Czapka", [("czapka_officer_uhlan",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_uhlan_czapka_nco", "Russian Uhlan Czapka", [("czapka_nco_uhlan",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_uhlan_czapka_ranker", "Russian Uhlan Czapka", [("czapka_ranker_uhlan",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_uhlan_czapka_trumpeter", "Russian Uhlan Czapka", [("czapka_trump_uhlan",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],

  #French
["french_dragoon_helmet", "Dragoon Helmet", [("french_dragons_dlG_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_helmet_officer", "Dragoon Helmet", [("french_dragons_dlG_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_dragoon_helmet_trumpeter", "Dragoon Helmet", [("french_dragons_dlG_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_helmet", "Cuirassier Helmet", [("french_cuirassier_helmet_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_helmet_officer", "Cuirassier Helmet", [("french_cuirassier_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_cuirassier_helmet_trumpeter", "Cuirassier Helmet", [("french_cuirassier_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_attach_armature ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_helmet", "Carbinier Helmet", [("french_carabineer_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_helmet_officer", "Carbinier Helmet", [("french_carabineer_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_carabineer_helmet_trumpeter", "Carbinier Helmet", [("french_carabineer_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_hussar_shako_colours", "Hussar Shako", [("french_hussar_shako_colours",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_hussar_shako_ranker", "Hussar Shako", [("french_hussar_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_hussar_shako_trumpeter", "Hussar Shako", [("french_hussar_shako_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_inf_shako_45_ranker", "Infantry Shako", [("french_inf_shako_45_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_vistula_shako_colours", "Infantry Shako", [("french_vistula_shako_colours",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_vistula_shako_ranker", "Infantry Shako", [("french_vistula_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_vistula_shako_officer", "Infantry Shako", [("french_vistula_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_inf_shako_84_colours", "Infantry Shako", [("french_inf_shako_84_colours",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_inf_shako_84_ranker", "Infantry Shako", [("french_inf_shako_84_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_inf_shako_84_officer", "Infantry Shako", [("french_inf_shako_84_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],  
["french_voltigeur_shako_officer", "Voltigeur Shako", [("french_voltigeur_shako_captain",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_voltigeur_shako_ranker", "Voltigeur Shako", [("french_voltigeur_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_ldlg_czapka_officer", "Guard Lancer Czapka", [("french_LdlG_officer_czapka",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_ldlg_czapka_ranker", "Guard Lancer Czapka", [("french_LdlG_ranker_czapka",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_ldlg_czapka_trumpeter", "Guard Lancer Czapka", [("french_LdlG_trumpeter_czapka",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_artillery_bearskin_officer", "Artillery Bearskin", [("french_artillery_captain_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_artillery_bearskin_ranker", "Artillery Bearskin", [("french_artillery_ranker_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_gap_bearskin_officer", "Grenadiers a Pied Bearskin", [("french_GaP_officer_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_gap_bearskin_colours", "Grenadiers a Pied Bearskin", [("french_GaP_flagcarrier_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_gap_bearskin_ranker", "Grenadiers a Pied Bearskin", [("french_GaP_ranker_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_sapper_bearskin", "Sappeur Bearskin", [("french_sapper_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_inf_bicorne_45_officer", "Infantry Bicorne", [("french_inf_bicorne_45_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_hussar_bearskin_officer", "Hussar Bearskin", [("french_hussar_bearskin_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["french_artillery_train_shako", "Artillery Train Shako", [("french_artillery_train_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_nappy_hat", "Napoleon's Bicorne", [("french_nappy_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["grach_bearskin_ranker", "Grenadiers a Cheval Bearskin", [("grach_bearskin_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["grach_bearskin_officer", "Grenadiers a Cheval Bearskin", [("grach_bearskin_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["grach_bearskin_trumpeter", "Grenadiers a Cheval Bearskin", [("grach_bearskin_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_captain_hat", "french_captain_hat", [("french_captain_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_marine_hat", "french_marine_hat", [("french_marine_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_seaman_hat", "french_seaman_hat", [("french_seaman_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["french_seaman_hat_2", "french_seaman_hat_2", [("french_seaman_hat_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    

 #Austrian
["aus_arty_bicorn", "Artillery Bicorne", [("aus_arty_bicorn",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_arty_cap_bicorn", "Artillery Bicorne", [("aus_arty_cap_bicorn",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_arty_train_hat", "Artillery Train Hat", [("aus_arty_train_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_cavalry_helmet_officer", "Cavalry Helmet", [("aus_cavalry_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_cavalry_helmet_ranker", "Cavalry Helmet", [("aus_cavalry_helmet_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_cavalry_helmet_trumpeter", "Cavalry Helmet", [("aus_cavalry_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_uhlan_czapka", "Uhlan Czapka", [("aus_uhlan_czapka",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_uhlan_czapka_officer", "Uhlan Czapka", [("aus_uhlan_czapka_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_uhlan_czapka_trumpeter", "Uhlan Czapka", [("aus_uhlan_czapka_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_shwarzenberg_bicorn", "Schwarzenberg's Bicorne", [("aus_shwarzenberg_bicorn",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_grenadier_bearskin", "Grenadier Bearskin", [("aus_grenadier_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_tyrol_hat", "Tyrol Hat", [("aus_tyrol_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_tyrol_hat_officer", "Tyrol Hat", [("aus_tyrol_hat_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_pioneer_hat", "Pioneer Hat", [("aus_pioneer_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_grenadier_bearskin_officer", "Grenadier Bearskin", [("aus_grenadier_bearskin_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_grenzer_officer", "Grenz Shako", [("aus_grenzer_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_grenzer_ranker", "Grenz Shako", [("aus_grenzer_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_infantry_nco", "Infantry Shako", [("aus_infantry_nco",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_infantry_officer", "Infantry Shako", [("aus_infantry_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_infantry_ranker", "Infantry Shako", [("aus_infantry_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_hussard_shako_nco", "Hussar Shako", [("aus_hussard_shako_nco",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_hussard_shako_officer", "Hussar Shako", [("aus_hussard_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_hussard_shako_ranker", "Hussar Shako", [("aus_hussard_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_hussard_shako_trumpeter", "Hussar Shako", [("aus_hussard_shako_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["aus_surgeon_hat", "Surgeon Hat", [("austria_surgeon_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    

#British
["british_artillery_shako_officer", "Artillery Shako", [("british_artillery_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_artillery_shako_ranker", "Artillery Shako", [("british_artillery_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_rocket_tarleton", "Artillery Tarleton", [("british_rocket_tarleton",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_kgl_shako_officer", "KGL Shako", [("british_kgl_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_kgl_shako_ranker", "KGL Shako", [("british_kgl_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_light_shako_ranker", "Light Infantry Shako", [("british_light_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_light_shako_officer", "Light Infantry Shako", [("british_light_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_rifle_shako_officer", "Rifleman Shako", [("british_rifle_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_rifle_shako_ranker", "Rifleman Shako", [("british_rifle_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_rifle_beret", "Rifleman Beret", [("british_rifle_beret",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_rifle_beret_2", "Rifleman Beret", [("british_rifle_beret_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_highland_bonnet_ranker", "Highlander Bonnet", [("british_highland_bonnet_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_highland_bonnet_ensign", "Highlander Bonnet", [("british_highland_bonnet_ensign",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_highland_bonnet_officer", "Highlander Bonnet", [("british_highland_bonnet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_highland_bonnet_drummer", "Highlander Bonnet", [("british_highland_bonnet_drummer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_guard_shako_officer", "Guard Infantry Shako", [("british_guard_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_guard_shako_ranker", "Guard Infantry Shako", [("british_guard_shako_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["33_stovepipe", "Infantry Shako", [("33_stovepipe",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_lightdragoon_shako_ranker", "Light Dragoon Shako", [("british_23rd_lightdragoon_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_lightdragoon_shako_officer", "Light Dragoon Shako", [("british_23rd_lightdragoon_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_lightdragoon_shako_trumpeter", "Light Dragoon Shako", [("british_23rd_lightdragoon_shako_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_iniskilling_helmet_ranker", "Dragoon Helmet", [("british_iniskilling_helmet_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["british_iniskilling_helmet_officer", "Dragoon Helmet", [("british_iniskilling_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["british_iniskilling_helmet_trumpeter", "Dragoon Helmet", [("british_iniskilling_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair|itp_attach_armature  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["british_lifeguard_helmet_ranker", "Horse Guard Helmet", [("british_lifeguard_helmet_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_lifeguard_helmet_officer", "Horse Guard Helmet", [("british_lifeguard_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_lifeguard_helmet_trumpeter", "Horse Guard Helmet", [("british_lifeguard_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_kgl_hussar_bearskin", "KGL Hussar Helmet", [("KGL_hussar_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_kgl_hussar_officer_bearskin", "KGL Hussar Helmet", [("KGL_hussar_officer_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_kgl_hussar_bearskin_trumpeter", "KGL Hussar Helmet", [("KGL_hussar_bearskin_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_wellington_bicorne", "Wellington's Bicorne", [("british_wellington_bicorne",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_captain_hat", "british_captain_hat", [("british_captain_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_seaman_hat", "british_seaman_hat", [("british_seaman_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_seaman_hat_2", "british_seaman_hat_2", [("british_seaman_hat_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["royal_marine_beret", "royal_marine_beret", [("royal_marine_beret",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["royal_marine_hat", "royal_marine_hat", [("royal_marine_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["british_surgeon_bicorne", "Surgeon Bicorne", [("british_surgeon_bicorne",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    


#Prussian
["prussian_landwehr_hat", "Landwehr Hat", [("landwehr_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_landwehr_hat_2", "Landwehr Hat", [("landwehr_hat_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_landwehr_hat_3", "Landwehr Hat", [("landwehr_leather_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_shako", "Shako", [("prussian_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_shako_2", "Shako", [("prussian_shako_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_infantry_hat_officer", "Officer Cap", [("prussian_8th_officer_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_hussar_shako", "Hussar Shako", [("prussian_deadhussars_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_hussar_officer_shako", "Hussar Shako", [("prussian_hussar_officer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_blucher_hat", "Blucher's Cap", [("prussian_bluecher_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_arty_shako_officer", "Artillery Shako", [("prussian_arty_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_arty_shako_ranker", "Artillery Shako", [("prussian_arty_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_dragoon_shako_officer", "Dragoon Shako", [("prussian_dragoon_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_dragoon_shako_ranker", "Dragoon Shako", [("prussian_dragoon_ranker",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_guard_musician_shako", "Guard Infantry Shako", [("prussian_guard_musician_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_guard_colours_shako", "Guard Infantry Shako", [("prussian_guard_NCO_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_guard_officer_shako", "Guard Infantry Shako", [("prussian_guard_officer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_guard_ranker_shako", "Guard Infantry Shako", [("prussian_guard_ranker_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_inf_off_shako", "Infantry Shako", [("prussian_inf_off_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_jaeger_officer_shako", "Jaeger Shako", [("prussian_jaeger_officer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_landwehr_cav_shako", "Landwehr Shako", [("prussian_landwer_cav",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_landwehr_cav_shako_officer", "Landwehr Shako", [("prussian_landwer_cav_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_pioneer_shako", "Pioneer Shako", [("prussian_pioneer_shako",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_shako_colours", "Infantry Shako", [("prussian_shako_proper_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_shako_colours_2", "Infantry Shako", [("prussian_shako_style_2_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_cuirassier_helmet", "Cuirassier Helmet", [("prussian_cuirassier_helmet",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_cuirassier_helmet_trumpet", "Cuirassier Helmet", [("prussian_cuirassier_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(15)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["prussian_freikorps_officer_hat", "Freikorps Hat", [("lutzov_off_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    #patch1115 25/1
["prussian_infantry2_hat", "Infantry Cap", [("23_fourage_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    #patch1115 25/2

#Russian
["rus_opol_hat_ranker", "Opolocheniye Hat", [("rus_opol_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],
["rus_opol_hat_officer", "Opolocheniye Hat", [("rus_opol_captain_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],

#Rhine
["bavarian_helmet_other_ranks", "bavarian_helmet_other_ranks", [("bavarian_helmet_other_ranks",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_helmet_flagcarrier", "bavarian_helmet_flagcarrier", [("bavarian_helmet_flagcarrier",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_helmet_officer", "bavarian_helmet_officer", [("bavarian_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_jaeger_helmet_other_ranks", "Jaeger Helmet", [("bavarian_jaeger_helmet_other_ranks",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_jaeger_helmet_officer", "Jaeger Helmet", [("bavarian_jaeger_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_helmet_artillery", "Artillery Helmet", [("bavarian_helmet_artillery_other_ranks",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_helmet_train", "Artillery Helmet", [("bavarian_helmet_train_other_ranks",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["bavarian_helmet_artillery_officer", "Artillery Helmet", [("bavarian_helmet_artillery_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_inf_shako_ranker", "Infantry Shako", [("saxon_infantry_shako_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_inf_shako_nco", "Infantry Shako", [("saxon_infantry_shako_nco",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_inf_shako_officer", "Infantry Shako", [("saxon_infantry_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_uhlan_shako_ranker", "Cavalry Shako", [("saxon_ulan_shako_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_uhlan_shako_ranker_alt", "Cavalry Shako", [("saxon_ulan_shako_private_2",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_uhlan_shako_nco", "Cavalry Shako", [("saxon_ulan_shako_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_uhlan_shako_officer", "Cavalry Shako", [("saxon_ulan_shako_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_uhlan_shako_trumpeter", "Cavalry Shako", [("saxon_ulan_shako_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["hessian_inf_shako_ranker", "Infantry Shako", [("hessen_infantry_shako_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["hessian_inf_shako_nco", "Infantry Shako", [("hessen_infantry_shako_nco",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["hessian_inf_bicorne_officer", "Infantry Bicorne", [("hessen_infantry_officer_bicorn",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["rhine_surgeon_hat", "Surgeon Hat", [("rhine_surgeon_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_hat_ranker", "Bearskin", [("west_gr_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_hat_officer", "Bearskin", [("west_gr_off_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxonyking_hat", "Friedrich August Hat", [("saxonyking_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["nassau_jaeger_hat_ranker", "Bearskin", [("nassau_ranker_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["nassau_jaeger_hat_officer", "Bearskin", [("nassau_off_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg_helmet_other_ranks", "wurttemberg_helmet_other_ranks", [("wurttemberg_helmet_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg_helmet_flagcarrier", "wurttemberg_helmet_flagcarrier", [("wurttemberg_helmet_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg_helmet_officer", "wurttemberg_helmet_officer", [("wurttemberg_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg2_helmet_other_ranks", "wurttemberg_helmet_other_ranks", [("wurttemberg_helmet_grenadier",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg2_helmet_flagcarrier", "wurttemberg_helmet_flagcarrier", [("wurttemberg_helmet_grenadier_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["wurttemberg2_helmet_officer", "wurttemberg_helmet_officer", [("wurttemberg_helmet_grenadier_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["berg_pioneer_bearskin", "Bearskin", [("berg_pioneer_bearskin",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_helmet_other_ranks", "saxon_helmet_other_ranks", [("helmet_garde_du_corps",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_helmet_flagcarrier", "saxon_helmet_flagcarrier", [("helmet_garde_du_corps_nco",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_helmet_officer", "saxon_helmet_officer", [("helmet_garde_du_corps_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["saxon_helmet_trumpeter", "saxon_helmet_officer", [("helmet_garde_du_corps_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_helmet_other_ranks", "westphalian_helmet_other_ranks", [("westphalian_cuirassier_helmet_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_helmet_flagcarrier", "westphalian_helmet_flagcarrier", [("westphalian_cuirassier_helmet_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_helmet_officer", "westphalian_helmet_officer", [("westphalian_cuirassier_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["westphalian_helmet_trumpeter", "westphalian_helmet_officer", [("westphalian_cuirassier_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["badner_helmet_flagcarrier", "badner_helmet_flagcarrier", [("baden_dragoon_helmet_NCO",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["badner_helmet_officer", "badner_helmet_officer", [("baden_dragoon_helmet_officer",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["badner_helmet_ranker", "badner_helmet_officer", [("baden_dragoon_helmet_private",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    
["badner_helmet_trumpeter", "badner_helmet_officer", [("baden_dragoon_helmet_trumpeter",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],    

#Pirate
["pirate_hat", "Pirate Hat", [("pirate_hat",0)], itp_merchandise| itp_type_head_armor |itp_civilian|itp_doesnt_cover_hair  ,0, 4 , weight(0.5)|abundance(100)|head_armor(8)|body_armor(0)|leg_armor(0)|difficulty(0) ,imodbits_cloth ],


#Boots
 #French
 ["french_voltigeur_pants", "Voltigeur Pants", [("french_voltigeur_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_voltigeur_officer_pants", "Infantry Pants", [("french_voltigeur_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_dragoon_pants", "Cavalry Boots", [("french_dragoon_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_general_boots", "General's Boots", [("french_general_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_grenadiers_a_cheval_pants", "Cavalry Boots", [("french_grenadiers_a_cheval_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_vistula_pants", "Hessian Boots", [("french_vistula_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_lancer_pants", "Cavalry Pants", [("french_lancer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_lancer_officer_pants", "Cavalry Pants", [("french_lancer_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_hussards_ranker_pants", "Cavalry Pants", [("french_hussards_ranker_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_hussards_officer_pants", "Cavalry Pants", [("french_hussards_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_hussards_trumpeter_pants", "Cavalry Pants", [("french_hussards_trumpeter_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_sappeur_pants", "Hessian Boots", [("french_sappeur_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_art_ranker_pants", "Artillery Gaiters", [("french_art_ranker_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_GRaP_pants", "Grenadier Gaiters", [("french_GRaP_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["fr_arty_captain_bottefortes", "Artillery Boots", [("fr_arty_captain_bottefortes",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["fr_arty_train_bottefortes", "Artillery Boots", [("fr_arty_train_bottefortes",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["fr_officer_bottefortes", "Officer Boots", [("fr_officer_bottefortes",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_captain_pants", "Officer Boots", [("french_captain_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_basic_infantry_pants", "Infantry Boots", [("french_basic_infantry_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_captain_pants_blue", "Officer Boots", [("french_captain_pants_blue",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_equipage_batallion_pants", "Infantry Boots", [("french_equipage_batallion_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["french_sailor_pants", "Infantry Boots", [("french_sailor_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(4.5)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(36)|difficulty(0) ,imodbits_cloth ], #patch1115 23/1
 ["french_sailor_pants_female", "Infantry Boots", [("french_sailor_pants_fem",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(4.5)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(36)|difficulty(0) ,imodbits_cloth ], #patch1115 23/2
 ["french_surgeon_pants", "Surgeon Pants", [("french_surgeon_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 
 
 #Russian
 ["rus_infantry_pants1", "Infantry Gaiters", [("rus_musketeer_pants1",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_infantry_pants2", "Infantry Boots", [("rus_musketeer_pants2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_hussar_pants1", "Cavalry Gaiters", [("rus_hussar_pants1",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_hussar_pants2", "Cavalry Gaiters", [("rus_hussar_pants2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_hussar_pants_nco", "Hussar Hessians", [("rus_hussards_sarg_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_hussar_pants_officer", "Hussar Hessians", [("rus_hussards_off_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_horse_guard_pants", "Cavalry Boots", [("rus_chevalier_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_cossack_off_pants", "Cossack Pants", [("rus_cossack_off_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_kutuzov_pants", "General's Boots", [("rus_kutuzov_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_militia_off_pants", "Militia Boots", [("rus_militia_off_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_militia_ranker_pants", "Militia Boots", [("rus_militia_ranker_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_militia_ranker_pants1", "Militia Pants", [("rus_militia_ranker_pants1",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_jaeger_pants", "Jaeger Boots", [("rus_jaeger_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_arty_pants", "Artillery Boots", [("rus_arty_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_dragoon_pants1", "Cavalry Gaiters", [("rus_dragoon_pants1",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_dragoon_pants2", "Cavalry Gaiters", [("rus_dragoon_pants2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["rus_uhlan_pants", "Cavalry Pants", [("russian_uhlan_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],

 #Austrian
 ["austrian_infantry_pants", "Infantry Boots", [("austrian_infantry_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hungarian_pants", "Infantry Shoes", [("austrian_hungarian_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hungarian_pants_officer", "Infantry Boots", [("austrian_hungarian_officer_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["austrian_jaeger_pants", "Jaeger Boots", [("austrian_jaeger_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["austrian_jaeger_pants_officer", "Jaeger Boots", [("austrian_jaeger_officer_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hungarian_hussar_pants", "Hussar Hessians", [("austrian_hussard_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hungarian_uhlan_pants", "Hussar Hessians", [("austrian_uhlan_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["austrian_schwarzenberg_pants", "Schwarzenberg's Pants", [("schwarzenberg_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["austrian_officer_boots", "Infantry Boots", [("austrian_officer_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["austrian_cavalry_boots", "Cavalry Boots", [("austrian_cavalry_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 
 #British
 ["british_highland_kilt", "Kilt", [("british_highland_kilt",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_highland_kilt_2", "Kilt", [("british_highland_kilt_2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_highland_kilt_officer", "Kilt", [("british_highland_kilt_officer",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_rifle_captain_pants", "Rifleman Gaiters", [("british_rifle_captain_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_rifle_pants_green", "Rifleman Boots", [("british_rifle_pants_green",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_rifle_pants_grey", "Rifleman Boots", [("british_rifle_pants_grey",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_rifle_pants_rolled", "Rifleman Pants", [("british_rifle_pants_rolled",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_coldstream_pants", "Infantry Pants", [("british_coldstream_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_sapper_pants", "Sapper Pants", [("British_sappeur_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_wellington_pants", "Wellington's Pants", [("wellington_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_light_dragoon_pants", "Light Dragoon Pants", [("british_light_dragoon_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_rocketeer_pants", "Cavalry Pants", [("british_rocketeer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_cav_pants", "Cavalry Pants", [("british_cav_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_kgl_hussar_pants", "Cavalry Pants", [("KGL_hussar_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_kgl_hussar_officer_pants", "Cavalry Pants", [("KGL_hussar_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["british_captain_legs", "british_captain_legs", [("british_captain_legs",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["sailor_pants", "sailor_pants", [("sailor_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(4.25)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(36)|difficulty(0) ,imodbits_cloth ], #patch1115 23/3
 ["sailor_pants_female", "sailor_pants_female", [("sailor_pants_fem",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(4.25)|abundance(100)|head_armor(0)|body_armor(14)|leg_armor(36)|difficulty(0) ,imodbits_cloth ], #patch1115 23/4

 
 
 #Prussian
 ["prussian_infantry_pants", "Infantry Boots", [("prussian_infantry_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_jaeger_pants", "Infantry Boots", [("prussian_jaeger_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_landwehr_pants", "Landwehr Pants", [("prussian_landwehr_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_landwehr_pants2", "Landwehr Pants", [("prussian_landwehr_pants_2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_blucher_pants", "Blucher's Pants", [("blucher_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_cavalry_pants", "Cavalry Pants", [("prussian_cavalry_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_cavalry_pants2", "Cavalry Pants", [("prussian_cavalry_pants2",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_hussar_pants", "Cavalry Boots", [("prussian_hussar_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_hussar_pants_officer", "Cavalry Hessians", [("prussian_hussar_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["prussian_freikorps_pants", "Freikorps Pants", [("prussian_lutzov_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],

 #Rhine
 ["bavarian_infantry_pants", "Infantry Boots", [("bavarian_infantry_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["bavarian_pants_officer", "Infantry Boots", [("bavarian_officer_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["bavarian_artillery_pants", "Artillery Pants", [("bavarian_artillery_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["bavarian_artillery_pants_officer", "Artillery Boots", [("bavarian_artillery_officer_boots",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["saxon_uhlan_pants", "Cavalry Boots", [("saxon_ulan_other_rank_parade_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["saxon_uhlan_pants_alt", "Cavalry Boots", [("saxon_ulan_other_rank_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["saxon_uhlan_pants_officer", "Cavalry Boots", [("saxon_ulan_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hessian_infantry_pants", "Infantry Boots", [("hessen_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["hessian_infantry_pants_officer", "Infantry Boots", [("hessen_officer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["nassau_jaeger_pants", "Cavalry Boots", [("nassau_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["nassau_jaeger_pants_officer", "Cavalry Boots", [("nassau_off_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["wurttemberg_pants_all_ranks", "Infantry Boots", [("wurttemberg_pants_all_ranks",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["wurttemberg_pants_officer", "Infantry Boots", [("wurttemberg_pants_officer",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["wurttemberg_grenadier_pants", "Infantry Boots", [("wurttemberg_grenadier_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["berg_pioneer_pants", "Infantry Boots", [("berg_pioneer_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["garde_du_corps_pants_ranker", "Cavalry Boots", [("garde_du_corps_pants_ranker",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["garde_du_corps_pants", "Cavalry Boots", [("garde_du_corps_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 ["baden_dragoon_pants", "Cavalry Boots", [("baden_dragoon_pants",0)], itp_merchandise| itp_type_foot_armor  |itp_civilian | itp_attach_armature,0,
 10 , weight(1.25)|abundance(100)|head_armor(0)|body_armor(0)|leg_armor(30)|difficulty(0) ,imodbits_cloth ],
 
 
# Gloves
 ["officer_gloves","Officer Gloves", [("officer_gloves_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["drummer_gloves","Drummer Gloves", [("drummer_gloves_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["rus_chevgarde_gloves","Gloves", [("mm_invisible_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["fr_cuirassier_gloves", "Gloves", [("fr_cavalry_glove_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["fr_artillery_gloves", "Gloves", [("glove_black_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["br_cavalry_gloves", "Gloves", [("white_cavalry_glove_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["br_horseguard_gloves", "Gloves", [("hg_cavalry_glove_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["br_cavalry_gloves_short", "Gloves", [("white_cavalry_glove_short_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 ["br_horseguard_gloves_short", "Gloves", [("hg_cavalry_glove_short_L",0)], itp_merchandise|itp_type_hand_armor,0, 90, weight(0)|abundance(100)|body_armor(0)|difficulty(0),imodbits_cloth],
 
#Horses
 #French
 ["hussar_horse_french","Light Horse", [("french_hussards_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_french_trumpet","Light Horse", [("french_hussards_trumpeter_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lancer_horse_french","Light Horse", [("french_lancier_polonais_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lancer_horse_french_trumpet","Light Horse", [("french_lancier_polonais_horse_trumpeter",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["dragoon_horse_french","Medium Horse", [("french_dragoon_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/12
 ["dragoon_horse_french_trumpet","Medium Horse", [("french_dragoon_horse_trumpeter",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/11
 ["cuirassier_horse_french","Heavy Horse", [("french_cuirassier_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/13
 ["cuirassier_horse_french_officer","Heavy Horse", [("french_cuirassier_officer_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/14
 ["cuirassier_horse_french_trumpet","Heavy Horse", [("french_cuirassier_trumpeter_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/15
 ["carabineer_horse_french","Heavy Horse", [("french_carabineer_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/16
 ["carabineer_horse_french_officer","Heavy Horse", [("french_carabineer_officer_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/17
 ["carabineer_horse_french_trumpet","Heavy Horse", [("french_carabineer_trumpeter_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/18
 ["heavy_horse_french","Heavy Horse", [("french_grenadier_a_cheval_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/19
 ["heavy_horse_french_trumpet","Heavy Horse", [("french_grenadier_a_cheval_horse_trumpeter",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/20
 #British
 ["lightdragoon_horse_britain_1","Light Horse", [("british_ld_horse1",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lightdragoon_horse_britain_2","Light Horse", [("british_ld_horse2",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lightdragoon_horse_britain_3","Light Horse", [("british_ld_horse3",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lightdragoon_horse_britain_4","Light Horse", [("british_ld_horse4",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["kgl_horse_britain","Light Horse", [("british_kgl_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["heavydragoon_horse_britain","Heavy Horse", [("british_iniskilling_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/10
 ["heavy_horse_britain","Heavy Horse", [("british_rhg_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/9
 #Prussian
 ["lancer_horse_prussia_1","Light Horse", [("prussian_cuirassier_horse1",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lancer_horse_prussia_2","Light Horse", [("prussian_cuirassier_horse2",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_prussia_1","Light Horse", [("prussian_cuirassier_horse1",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_prussia_2","Light Horse", [("prussian_cuirassier_horse2",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["dragoon_horse_prussia_1","Medium Horse", [("prussian_dragoon_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/8
 ["dragoon_horse_prussia_2","Medium Horse", [("prussian_dragoon_horse_trumpeter",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/7
 ["heavy_horse_prussia_1","Heavy Horse", [("prussian_cuirassier_horse1",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/6
 ["heavy_horse_prussia_2","Heavy Horse", [("prussian_cuirassier_horse2",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/5
 #Russian
 ["cossack_horse_russia_1","Light Horse", [("russian_cossack_horse1",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["cossack_horse_russia_2","Light Horse", [("russian_cossack_horse2",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["cossack_horse_russia_3","Light Horse", [("russian_cossack_horse3",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["cossack_horse_russia_4","Light Horse", [("russian_cossack_horse4",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lancer_horse_russia","Light Horse", [("russian_lancer_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_russia","Light Horse", [("russian_hussar_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["dragoon_horse_russia","Medium Horse", [("russian_dragoon_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/4
 ["heavy_horse_russia","Heavy Horse", [("russian_chevalier_guard_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/3
 #Austrian
 ["lancer_horse_austria","Light Horse", [("austrian_lancer_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_austria","Light Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lightcav_horse_austria","Light Horse", [("austrian_lightcav_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["dragoon_horse_austria","Medium Horse", [("austrian_dragoon_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(40)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/2
 ["heavy_horse_austria","Heavy Horse", [("austrian_cuirassier_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/1
 #Rhine
 ["lancer_horse_rhine","Light Horse", [("saxon_ulan_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lancer_horse_rhine_officer","Light Horse", [("saxon_ulan_horse_white",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_rhine","Light Horse", [("nassau_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_rhine_officer","Light Horse", [("nassau_horse_off",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["lightcav_horse_rhine","Light Horse", [("baden_dragoon_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["cuirassier_horse_rhine","Heavy Horse", [("westphalian_cuirassier_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/13
 ["cuirassier_horse_rhine_officer","Heavy Horse", [("westphalian_cuirassier_horse_off",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/14
 ["garde_du_corps_horse_rhine","Heavy Horse", [("garde_du_corps_horse_rank",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/13
 ["garde_du_corps_horse_rhine_officer","Heavy Horse", [("garde_du_corps_horse_off",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(39)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion], #patch1115 fix 33/14

 #Placeholder horses
 ["lancer_horse_placeholder","Light Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["hussar_horse_placeholder","Light Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(3)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["dragoon_horse_placeholder","Medium Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(3)|horse_speed(40)|horse_maneuver(39)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion],
 ["heavy_horse_placeholder","Heavy Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(3)|horse_speed(38)|horse_maneuver(37)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion],

 #Cheat
 ["admin_horse","Admin Horse", [("austrian_hussard_horse",0)], itp_type_horse, 0, 600,abundance(100)|hit_points(100)|body_armor(500)|difficulty(0)|horse_speed(400)|horse_maneuver(100)|horse_charge(50)|horse_scale(120),imodbit_spirited],
 ["admin_lancer_horse","Light Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(0)|horse_speed(41)|horse_maneuver(41)|horse_charge(17)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["admin_hussar_horse","Light Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 400,abundance(70)|body_armor(6)|hit_points(80)|difficulty(0)|horse_speed(45)|horse_maneuver(50)|horse_charge(19)|horse_scale(104),imodbits_horse_basic|imodbit_champion],
 ["admin_dragoon_horse","Medium Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 500,abundance(90)|hit_points(100)|body_armor(8)|difficulty(0)|horse_speed(40)|horse_maneuver(39)|horse_charge(24)|horse_scale(106),imodbits_horse_basic|imodbit_champion],
 ["admin_heavy_horse","Heavy Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse, 0, 600,abundance(60)|hit_points(115)|body_armor(12)|difficulty(0)|horse_speed(38)|horse_maneuver(37)|horse_charge(32)|horse_scale(108),imodbits_horse_basic|imodbit_champion],

 #Artillery Horses
 #With cannon
 ["arty_horse_cannon_french","Artillery Horse", [("french_carabineer_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_cannon_british","Artillery Horse", [("british_iniskilling_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_cannon_russian","Artillery Horse", [("russian_dragoon_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_cannon_austrian","Artillery Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_cannon_prussian","Artillery Horse", [("prussian_cuirassier_horse1",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 #With howitzer
 ["arty_horse_howitzer_french","Artillery Horse", [("french_carabineer_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_howitzer_british","Artillery Horse", [("british_iniskilling_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_howitzer_russian","Artillery Horse", [("russian_dragoon_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_howitzer_austrian","Artillery Horse", [("austrian_hussard_horse",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 ["arty_horse_howitzer_prussian","Artillery Horse", [("prussian_cuirassier_horse1",0)], itp_merchandise|itp_type_horse|itp_is_carriage, 0, 600,abundance(60)|hit_points(200)|body_armor(10)|difficulty(1)|horse_speed(22)|horse_maneuver(10)|horse_charge(21)|horse_scale(116),imodbits_horse_basic|imodbit_champion],
 
####################
##  MM ITEMS End  ##
####################

["items_end", "Items End", [("empty_mesh",0)], 0, 0, 1, 0, 0],
]
