# -*- coding: cp1254 -*-
from header_common import *
from header_presentations import *
from header_mission_templates import *
from ID_meshes import *
from header_operations import *
from header_triggers import *
from header_items import *
from module_constants import *
import string

####################################################################################################################
#  Each presentation record contains the following fields:
#  1) Presentation id: used for referencing presentations in other files. The prefix prsnt_ is automatically added before each presentation id.
#  2) Presentation flags. See header_presentations.py for a list of available flags
#  3) Presentation background mesh: See module_meshes.py for a list of available background meshes
#  4) Triggers: Simple triggers that are associated with the presentation
####################################################################################################################

presentations = [
  
  ("game_start", 0, 0,
   [(ti_on_presentation_load,[(presentation_set_duration, 0)]),
   ]),
  ("game_escape", 0, 0,
   [(ti_on_presentation_load,[(presentation_set_duration, 0)]),
   ]),

  ("game_credits",prsntf_read_only,mesh_load_window,[
      (ti_on_presentation_load,
       [(assign, "$g_presentation_credits_obj_1", -1),
        (assign, "$g_presentation_credits_obj_2", -1),
        (assign, "$g_presentation_credits_obj_3", -1),
        (assign, "$g_presentation_credits_obj_4", -1),
        (assign, "$g_presentation_credits_obj_5", -1),
        (assign, "$g_presentation_credits_obj_6", -1),
        (assign, "$g_presentation_credits_obj_7", -1),
        (assign, "$g_presentation_credits_obj_8", -1),
        (assign, "$g_presentation_credits_obj_9", -1),
        (assign, "$g_presentation_credits_obj_10", -1),
        (assign, "$g_presentation_credits_obj_11", -1),
        (assign, "$g_presentation_credits_obj_12", -1),
        (assign, "$g_presentation_credits_obj_13", -1),
        #(assign, "$g_presentation_credits_obj_14", -1),
        (assign, "$g_presentation_credits_obj_15", -1),
        (assign, "$g_presentation_credits_obj_1_alpha", 0),
        (assign, "$g_presentation_credits_obj_2_alpha", 0),
        (assign, "$g_presentation_credits_obj_3_alpha", 0),
        (assign, "$g_presentation_credits_obj_4_alpha", 0),
        (assign, "$g_presentation_credits_obj_5_alpha", 0),
        (assign, "$g_presentation_credits_obj_6_alpha", 0),
        (assign, "$g_presentation_credits_obj_7_alpha", 0),
        (assign, "$g_presentation_credits_obj_8_alpha", 0),
        (assign, "$g_presentation_credits_obj_9_alpha", 0),
        (assign, "$g_presentation_credits_obj_10_alpha", 0),
        (assign, "$g_presentation_credits_obj_11_alpha", 0),
        (assign, "$g_presentation_credits_obj_12_alpha", 0),
        ]),
      (ti_on_presentation_run,
       [
        (store_trigger_param_1, ":cur_time"),
        (set_fixed_point_multiplier, 1000),
        (presentation_set_duration, 1000000),
        (try_begin),
          (this_or_next|key_clicked, key_space),
          (this_or_next|key_clicked, key_enter),
          (this_or_next|key_clicked, key_escape),
          (this_or_next|key_clicked, key_back_space),
          (this_or_next|key_clicked, key_left_mouse_button),
          (key_clicked, key_right_mouse_button),
          (presentation_set_duration, 0),
        (try_end),
        (try_begin),
          (lt, "$g_presentation_credits_obj_1", 0),
          (str_store_string, s1, "str_credits_1"),
          (create_text_overlay, "$g_presentation_credits_obj_1", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_1", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_1", 0),
          (position_set_x, pos1, 1200),
          (position_set_y, pos1, 1200),
          (overlay_set_size, "$g_presentation_credits_obj_1", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_1", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_1", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 3000),
          (eq, "$g_presentation_credits_obj_1_alpha", 0),
          (assign, "$g_presentation_credits_obj_1_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_1", 1000, 0x00),
        (else_try),
          (gt, ":cur_time", 4500),
          (lt, "$g_presentation_credits_obj_2", 0),
          (str_store_string, s1, "str_credits_2"),
          (create_text_overlay, "$g_presentation_credits_obj_2", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_2", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_2", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_2", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_2", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_2", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 7500),
          (eq, "$g_presentation_credits_obj_2_alpha", 0),
          (assign, "$g_presentation_credits_obj_2_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_2", 1000, 0x00),
        (else_try),
          (gt, ":cur_time", 9000),
          (lt, "$g_presentation_credits_obj_3", 0),
          (str_store_string, s1, "str_credits_3"),
          (create_text_overlay, "$g_presentation_credits_obj_3", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_3", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_3", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_3", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_3", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_3", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 13500),
          (eq, "$g_presentation_credits_obj_3_alpha", 0),
          (assign, "$g_presentation_credits_obj_3_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_3", 1000, 0),
        (else_try),
          (gt, ":cur_time", 15000),
          (lt, "$g_presentation_credits_obj_4", 0),
          (str_store_string, s1, "str_credits_4"),
          (create_text_overlay, "$g_presentation_credits_obj_4", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_4", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_4", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_4", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_4", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_4", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 17500),
          (eq, "$g_presentation_credits_obj_4_alpha", 0),
          (assign, "$g_presentation_credits_obj_4_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_4", 1000, 0),
        (else_try),
          (gt, ":cur_time", 19000),
          (lt, "$g_presentation_credits_obj_5", 0),
          (str_store_string, s1, "str_credits_5"),
          (create_text_overlay, "$g_presentation_credits_obj_5", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_5", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_5", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_5", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_5", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_5", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 21500),
          (eq, "$g_presentation_credits_obj_5_alpha", 0),
          (assign, "$g_presentation_credits_obj_5_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_5", 1000, 0),
        (else_try),
          (gt, ":cur_time", 23000),
          (lt, "$g_presentation_credits_obj_6", 0),
          (str_store_string, s1, "str_credits_6"),
          (create_text_overlay, "$g_presentation_credits_obj_6", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_6", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_6", 0),
          (position_set_x, pos1, 1800),
          (position_set_y, pos1, 1800),
          (overlay_set_size, "$g_presentation_credits_obj_6", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_6", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_6", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 26000),
          (eq, "$g_presentation_credits_obj_6_alpha", 0),
          (assign, "$g_presentation_credits_obj_6_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_6", 1000, 0),
        (else_try),
          (gt, ":cur_time", 27500),
          (lt, "$g_presentation_credits_obj_7", 0),
          (str_store_string, s1, "str_credits_7"),
          (create_text_overlay, "$g_presentation_credits_obj_7", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_7", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_7", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_7", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_7", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_7", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 30000),
          (eq, "$g_presentation_credits_obj_7_alpha", 0),
          (assign, "$g_presentation_credits_obj_7_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_7", 1000, 0),
        (else_try),
          (gt, ":cur_time", 31500),
          (lt, "$g_presentation_credits_obj_8", 0),
          (str_store_string, s1, "str_credits_8"),
          (create_text_overlay, "$g_presentation_credits_obj_8", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_8", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_8", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_8", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_8", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_8", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 35000),
          (eq, "$g_presentation_credits_obj_8_alpha", 0),
          (assign, "$g_presentation_credits_obj_8_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_8", 1000, 0),
        (else_try),
          (gt, ":cur_time", 36500),
          (lt, "$g_presentation_credits_obj_9", 0),
          (str_store_string, s1, "str_credits_9"),
          (create_text_overlay, "$g_presentation_credits_obj_9", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_9", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_9", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_9", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_9", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_9", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 40000),
          (eq, "$g_presentation_credits_obj_9_alpha", 0),
          (assign, "$g_presentation_credits_obj_9_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_9", 1000, 0),
        (else_try),
          (gt, ":cur_time", 41500),
          (lt, "$g_presentation_credits_obj_10", 0),
          (str_store_string, s1, "str_credits_10"),
          (create_text_overlay, "$g_presentation_credits_obj_10", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_10", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_10", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_10", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_10", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_10", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 44000),
          (eq, "$g_presentation_credits_obj_10_alpha", 0),
          (assign, "$g_presentation_credits_obj_10_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_10", 1000, 0),
        (else_try),
          (gt, ":cur_time", 45500),
          (lt, "$g_presentation_credits_obj_11", 0),
          (str_store_string, s1, "str_credits_11"),
          (create_text_overlay, "$g_presentation_credits_obj_11", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_11", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_11", 0),
          (position_set_x, pos1, 1750),
          (position_set_y, pos1, 1750),
          (overlay_set_size, "$g_presentation_credits_obj_11", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_11", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_11", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 47500),
          (eq, "$g_presentation_credits_obj_11_alpha", 0),
          (assign, "$g_presentation_credits_obj_11_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_11", 1000, 0),
        (else_try),
          (gt, ":cur_time", 52000),
          (lt, "$g_presentation_credits_obj_12", 0),
          (str_store_string, s1, "str_credits_13"),
          (create_text_overlay, "$g_presentation_credits_obj_12", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_12", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_12", 0),
          (position_set_x, pos1, 800),
          (position_set_y, pos1, 800),
          (overlay_set_size, "$g_presentation_credits_obj_12", pos1),
          (position_set_x, pos1, 280),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_12", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_12", 1000, 0xFF),
          
          (str_store_string, s1, "str_credits_14"),
          (create_text_overlay, "$g_presentation_credits_obj_13", s1, tf_center_justify|tf_double_space|tf_vertical_align_center),
          (overlay_set_color, "$g_presentation_credits_obj_13", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_13", 0),
          (position_set_x, pos1, 800),
          (position_set_y, pos1, 800),
          (overlay_set_size, "$g_presentation_credits_obj_13", pos1),
          (position_set_x, pos1, 720),
          (position_set_y, pos1, 375),
          (overlay_set_position, "$g_presentation_credits_obj_13", pos1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_13", 1000, 0xFF),
        (else_try),
          (gt, ":cur_time", 60000),
          (eq, "$g_presentation_credits_obj_12_alpha", 0),
          (assign, "$g_presentation_credits_obj_12_alpha", 1),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_12", 1000, 0),
          (overlay_animate_to_alpha, "$g_presentation_credits_obj_13", 1000, 0),
        (else_try),
          (gt, ":cur_time", 61500),
          (lt, "$g_presentation_credits_obj_15", 0),
          (str_store_string, s1, "str_credits_12"),
          (create_text_overlay, "$g_presentation_credits_obj_15", s1, tf_center_justify|tf_double_space),
          (overlay_set_color, "$g_presentation_credits_obj_15", 0),
          (overlay_set_alpha, "$g_presentation_credits_obj_15", 0xFF),
          (position_set_x, pos1, 1000),
          (position_set_y, pos1, 1000),
          (overlay_set_size, "$g_presentation_credits_obj_15", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, -4000), #-4800
          (overlay_set_position, "$g_presentation_credits_obj_15", pos1),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 760),
          (overlay_animate_to_position, "$g_presentation_credits_obj_15", 62000, pos1),
        (else_try),
          (gt, ":cur_time", 122000),
          (presentation_set_duration, 0),
        (try_end),
        ]),
      ]),

  ("game_profile_banner_selection", 0, mesh_load_window, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (str_store_string, s1, "str_profile_banner_selection_text"),
      (create_text_overlay, reg1, s1, tf_center_justify),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 600),
      (overlay_set_position, reg1, pos1),
      (overlay_set_text, reg1, s1),
      (create_button_overlay, "$g_presentation_obj_profile_banner_selection_1", "str_next_page", tf_center_justify),
      (position_set_x, pos1, 700),
      (position_set_y, pos1, 50),
      (overlay_set_position, "$g_presentation_obj_profile_banner_selection_1", pos1),

      (create_button_overlay, "$g_presentation_obj_profile_banner_selection_2", "str_use_default_banner", tf_center_justify),
      (position_set_x, pos1, 300),
      (position_set_y, pos1, 50),
      (overlay_set_position, "$g_presentation_obj_profile_banner_selection_2", pos1),

      (assign, ":x_pos", 200), #150
      (assign, ":y_pos", 575),
      (store_mul, ":starting_banner", 15, "$g_presentation_page_no"), #16
      (store_add, ":ending_banner", ":starting_banner", 15),  #16
      (store_add, "$g_presentation_banner_start", "$g_presentation_obj_profile_banner_selection_2", 1),
      (assign, ":num_valid_banners", 0),
      (try_for_range, ":cur_banner_mesh", banner_meshes_begin, banner_meshes_end_minus_one),
        (le, ":cur_banner_mesh", "mesh_banner_d14"), #We haven't made banners after this yet
        (assign, ":already_used", 0),
        (try_for_range, ":cur_faction", factions_begin, factions_end),
          (faction_slot_eq, ":cur_faction", slot_faction_banner, ":cur_banner_mesh"),
          (assign, ":already_used", 1),
        (try_end),
        (eq, ":already_used", 0),
        (val_add, ":num_valid_banners", 1),
        (gt, ":num_valid_banners", ":starting_banner"),
        (le, ":num_valid_banners", ":ending_banner"),
        #(lt, ":cur_banner_mesh", "mesh_banner_e08"), #We haven't made banners after this yet
        (create_image_button_overlay, reg1, ":cur_banner_mesh", ":cur_banner_mesh"),
        (position_set_x, pos1, ":x_pos"),
        (position_set_y, pos1, ":y_pos"),
        (overlay_set_position, reg1, pos1),
        (position_set_x, pos1, -100), #set to negative (mesh is used inveresed...)
        (position_set_y, pos1, 100),
        (overlay_set_size, reg1, pos1),
        (val_add, ":x_pos", 150), #100
        (ge, ":x_pos", 900),
        (assign, ":x_pos", 200),  #150
        (val_sub, ":y_pos", 150), #250
      (try_end),
      (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_event_state_change, [
      (store_trigger_param_1, ":object"),
      (try_begin),
        (eq, ":object", "$g_presentation_obj_profile_banner_selection_1"),
        (val_add, "$g_presentation_page_no", 1),
        (val_mod, "$g_presentation_page_no", 6), #8
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_profile_banner_selection"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_profile_banner_selection_2"),
        (profile_set_banner_id, -1),
        (presentation_set_duration, 0),
      (else_try),
        (store_sub, ":selected_banner", ":object", "$g_presentation_banner_start"),
        (store_mul, ":page_adder", 15, "$g_presentation_page_no"), #16
        (val_add, ":selected_banner", ":page_adder"),
        (assign, ":num_valid_banners", 0),
        (assign, ":end_cond", banner_meshes_end_minus_one),
        (try_for_range, ":cur_banner_mesh", banner_meshes_begin, ":end_cond"),
          (assign, ":already_used", 0),
          (try_for_range, ":cur_faction", factions_begin, factions_end),
            (faction_slot_eq, ":cur_faction", slot_faction_banner, ":cur_banner_mesh"),
            (assign, ":already_used", 1),
          (try_end),
          (eq, ":already_used", 0),
          (try_begin),
            (eq, ":selected_banner", ":num_valid_banners"),
            (store_sub, ":selected_banner_index", ":cur_banner_mesh", banner_meshes_begin),
            (profile_set_banner_id, ":selected_banner_index"),
            (assign, ":end_cond", 0), #break
          (try_end),
          (val_add, ":num_valid_banners", 1),
        (try_end),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("game_custom_battle_designer", prsntf_manual_end_only, mesh_cb_ui_main, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
     
     #Team 1 Faction Button
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_1"),
     (position_set_x,pos1,200),
     (position_set_y,pos1,700),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_1",pos1),
     
     #Team 2 Faction Button
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_2"),
     (position_set_x,pos1,780),
     (position_set_y,pos1,700),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_2",pos1),
     
     #Add factions to factions button
     (try_for_range,":faction_no",factions_begin,factions_end),
      (str_store_faction_name,s1,":faction_no"),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_1",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_2",s1),
     (try_end),
     
     #Set currently selected faction
     (store_sub, ":team_1_faction", "$g_quick_battle_team_1_faction", factions_begin),
     (overlay_set_val, "$g_presentation_obj_custom_battle_designer_1", ":team_1_faction"),
     (store_sub, ":team_2_faction", "$g_quick_battle_team_2_faction", factions_begin),
     (overlay_set_val, "$g_presentation_obj_custom_battle_designer_2", ":team_2_faction"),
     
     (assign,":cur_y",600),
     
     #Team 1 Unit 1
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_1"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_1",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_1",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_1", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_1",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_1",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",20),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_1_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_1_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 2
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_2"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_2",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_2",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_2", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_2",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_2",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",21),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_2_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_2_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 3
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_3"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_3",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_3",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_3", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_3",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_3",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",22),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_3_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_3_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 4
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_4"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_4",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_4",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_4", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_4",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_4",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",23),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_4_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_4_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 5
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_5"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_5",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_5",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_5", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_5",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_5",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",24),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_5_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_5_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 6
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_6"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_6",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_6",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_6", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_6",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_6",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",25),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_6_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_6_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 7
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_7"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_7",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_7",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_7", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_7",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_7",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",26),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_7_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_7_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 8
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_8"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_8",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_8",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_8", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_8",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_8",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",27),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_8_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_8_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 1 Unit 9
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_1_9"),
     (position_set_x,pos1,150),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_1_9",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_1_9",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_1_9", 1, 50),
     (position_set_x,pos1,350),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_9",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_1_9",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",28),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_1_9_counter","@{reg3}"),
     (position_set_x,pos1,420),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_1_9_counter",pos1),
     
     (assign,":cur_y",600),
     
     #Add team units to units buttons
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_1","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_2","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_3","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_4","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_5","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_6","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_7","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_8","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_9","str_no_troop"),
     (try_for_range_backwards,":troop_no",multiplayer_ai_troops_begin,multiplayer_ai_troops_end),
      (store_troop_faction,":faction_no",":troop_no"),
      (eq,":faction_no","$g_quick_battle_team_1_faction"),
      
      (troop_get_slot,":troop_class",":troop_no",slot_troop_class),
      (neq,":troop_class",multi_troop_class_mm_rocket),
      (neq,":troop_class",multi_troop_class_mm_artillery),
      
      (str_store_troop_name_plural,s1,":troop_no"),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_1",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_2",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_3",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_4",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_5",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_6",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_7",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_8",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_1_9",s1),
     (try_end),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",0),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_1",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",1),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_2",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",2),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_3",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",3),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_4",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",4),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_5",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",5),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_6",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",6),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_7",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",7),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_8",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",8),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_1_9",":selected_troop"),
     
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",20),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_1",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",21),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_2",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",22),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_3",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",23),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_4",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",24),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_5",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",25),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_6",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",26),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_7",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",27),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_8",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",28),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_1_9",":selected_troop"),
     
     #Team 2 Unit 1
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_1"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_1",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_1",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_1", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_1",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_1",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",30),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_1_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_1_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 2
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_2"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_2",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_2",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_2", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_2",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_2",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",31),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_2_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_2_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 3
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_3"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_3",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_3",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_3", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_3",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_3",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",32),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_3_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_3_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 4
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_4"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_4",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_4",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_4", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_4",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_4",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",33),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_4_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_4_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 5
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_5"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_5",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_5",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_5", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_5",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_5",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",34),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_5_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_5_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 6
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_6"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_6",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_6",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_6", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_6",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_6",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",35),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_6_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_6_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 7
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_7"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_7",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_7",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_7", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_7",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_7",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",36),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_7_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_7_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 8
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_8"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_8",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_8",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_8", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_8",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_8",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",37),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_8_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_8_counter",pos1),
     
     (val_sub,":cur_y",35),
     
     #Team 2 Unit 9
     (create_combo_button_overlay, "$g_presentation_obj_custom_battle_designer_unit_2_9"),
     (position_set_x,pos1,670),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_unit_2_9",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_unit_2_9",pos2),
     
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_slider_2_9", 1, 50),
     (position_set_x,pos1,870),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_9",pos1),
     (position_set_x,pos2,750),
     (position_set_y,pos2,1000),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_slider_2_9",pos2),
     
     (troop_get_slot,reg3,"trp_custom_battle_dummy",38),
     (create_text_overlay,"$g_presentation_obj_custom_battle_designer_slider_2_9_counter","@{reg3}"),
     (position_set_x,pos1,940),
     (position_set_y,pos1,":cur_y"),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_slider_2_9_counter",pos1),
     
     #Add team units to units buttons
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_1","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_2","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_3","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_4","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_5","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_6","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_7","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_8","str_no_troop"),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_9","str_no_troop"),
     (try_for_range_backwards,":troop_no",multiplayer_ai_troops_begin,multiplayer_ai_troops_end),
      (store_troop_faction,":faction_no",":troop_no"),
      (eq,":faction_no","$g_quick_battle_team_2_faction"),
      
      (troop_get_slot,":troop_class",":troop_no",slot_troop_class),
      (neq,":troop_class",multi_troop_class_mm_rocket),
      (neq,":troop_class",multi_troop_class_mm_artillery),
      
      (str_store_troop_name_plural,s1,":troop_no"),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_1",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_2",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_3",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_4",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_5",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_6",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_7",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_8",s1),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_unit_2_9",s1),
     (try_end),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",10),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_1",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",11),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_2",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",12),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_3",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",13),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_4",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",14),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_5",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",15),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_6",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",16),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_7",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",17),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_8",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",18),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_unit_2_9",":selected_troop"),
     
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",30),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_1",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",31),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_2",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",32),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_3",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",33),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_4",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",34),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_5",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",35),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_6",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",36),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_7",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",37),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_8",":selected_troop"),
     (troop_get_slot,":selected_troop","trp_custom_battle_dummy",38),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_slider_2_9",":selected_troop"),
     
     # Map select
     (create_combo_label_overlay, "$g_presentation_obj_custom_battle_designer_map_select",tf_center_justify),
     (position_set_x,pos1,240),
     (position_set_y,pos1,70),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_map_select",pos1),
     (try_for_range,":map",quick_battle_scenes_begin,quick_battle_scenes_end),
      (store_sub,":scene",":map",quick_battle_scenes_begin),
      (store_add,":string",quick_battle_scene_names_begin,":scene"),
      (overlay_add_item,"$g_presentation_obj_custom_battle_designer_map_select",":string"),
     (try_end),
     (store_sub,":scene","$g_quick_battle_map",quick_battle_scenes_begin),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_map_select",":scene"),
     
     (store_add,":picture",":scene",quick_battle_scene_images_begin),
     (create_mesh_overlay,reg0,":picture",tf_center_justify),
     (position_set_x,pos1,150),
     (position_set_y,pos1,130),
     (overlay_set_position,reg0,pos1),
     (position_set_x,pos2,500),
     (position_set_y,pos2,500),
     (overlay_set_size,reg0,pos2),
     
     # Map time
     (create_combo_label_overlay, "$g_presentation_obj_custom_battle_designer_day_time"),
     (position_set_x,pos1,750),
     (position_set_y,pos1,200),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_day_time",pos1),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_day_time","str_morning"), # 0
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_day_time","str_noon"), # 1
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_day_time","str_evening"), # 2
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_day_time","str_night"), # 3
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_day_time","$g_quick_battle_day_time_value"),
     
     (create_text_overlay,reg0,"str_timeofday"),
     (position_set_x,pos1,450),
     (position_set_y,pos1,205),
     (overlay_set_position,reg0,pos1),
     
     # Map fog
     (create_combo_label_overlay, "$g_presentation_obj_custom_battle_designer_fog"),
     (position_set_x,pos1,750),
     (position_set_y,pos1,150),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_fog",pos1),
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_fog","str_fog_none"), # 0
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_fog","str_fog_light"), # 1
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_fog","str_fog_medium"), # 2
     (overlay_add_item,"$g_presentation_obj_custom_battle_designer_fog","str_fog_thick"), # 3
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_fog","$g_quick_battle_fog_value"),
     
     (create_text_overlay,reg0,"str_fog_amount"),
     (position_set_x,pos1,450),
     (position_set_y,pos1,155),
     (overlay_set_position,reg0,pos1),
     
     # Map rain
     (create_slider_overlay, "$g_presentation_obj_custom_battle_designer_rain",0,200),
     (position_set_x,pos1,750),
     (position_set_y,pos1,100),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_rain",pos1),
     (overlay_set_val,"$g_presentation_obj_custom_battle_designer_rain","$g_quick_battle_rain_value"),
     
     (create_text_overlay,reg0,"str_rain_amount"),
     (position_set_x,pos1,450),
     (position_set_y,pos1,105),
     (overlay_set_position,reg0,pos1),
     
     (try_begin),
       (assign,":continue",0),
       (assign,":end_cond",10),
       (try_for_range,":value",0,":end_cond"),
         (neg|troop_slot_eq,"trp_custom_battle_dummy",":value",0),
         (assign,":continue",1),
         (assign,":end_cond",0), #Break
       (try_end),
       (eq,":continue",1),
       (assign,":end_cond",20),
       (try_for_range,":value",10,":end_cond"),
         (neg|troop_slot_eq,"trp_custom_battle_dummy",":value",0),
         (assign,":continue",2),
         (assign,":end_cond",0), #Break
       (try_end),
       (eq,":continue",2),
       (create_button_overlay,"$g_presentation_obj_custom_battle_designer_start","str_begin",tf_center_justify),
       (overlay_set_color,"$g_presentation_obj_custom_battle_designer_start",0x000000),
     (else_try),
       (create_text_overlay,"$g_presentation_obj_custom_battle_designer_start","str_begin",tf_center_justify),
       (overlay_set_color,"$g_presentation_obj_custom_battle_designer_start",0x333333),
     (try_end),
     (position_set_x,pos1,920),
     (position_set_y,pos1,30),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_start",pos1),
     (position_set_x,pos2,1500),
     (position_set_y,pos2,1500),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_start",pos2),
     
     (create_button_overlay,"$g_presentation_obj_custom_battle_designer_quit","str_back",tf_center_justify),
     (position_set_x,pos1,70),
     (position_set_y,pos1,30),
     (overlay_set_position,"$g_presentation_obj_custom_battle_designer_quit",pos1),
     (position_set_x,pos2,1500),
     (position_set_y,pos2,1500),
     (overlay_set_size,"$g_presentation_obj_custom_battle_designer_quit",pos2),
     
     (presentation_set_duration, 999999),
     ]),
     
     (ti_on_presentation_run,
      [
      (troop_get_slot,reg3,"trp_custom_battle_dummy",20),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_1_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",21),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_2_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",22),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_3_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",23),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_4_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",24),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_5_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",25),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_6_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",26),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_7_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",27),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_8_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",28),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_1_9_counter","@{reg3}"),
      
      (troop_get_slot,reg3,"trp_custom_battle_dummy",30),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_1_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",31),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_2_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",32),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_3_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",33),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_4_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",34),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_5_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",35),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_6_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",36),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_7_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",37),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_8_counter","@{reg3}"),
      (troop_get_slot,reg3,"trp_custom_battle_dummy",38),
      (overlay_set_text,"$g_presentation_obj_custom_battle_designer_slider_2_9_counter","@{reg3}"),
     ]),
     
    (ti_on_presentation_event_state_change,
     [
       (store_trigger_param_1, ":object"),
       (store_trigger_param_2, ":value"),
       
       (try_begin),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_1"),
         (store_add,":team_1_faction",":value",factions_begin),
         (assign, "$g_quick_battle_team_1_faction", ":team_1_faction"),
         (try_begin),
           (eq,":team_1_faction","fac_britain"),
           (assign,":base_troop_index",12),
         (else_try),
           (eq,":team_1_faction","fac_france"),
           (assign,":base_troop_index",13),
         (else_try),
           (eq,":team_1_faction","fac_prussia"),
           (assign,":base_troop_index",10),
         (else_try),
           (eq,":team_1_faction","fac_russia"),
           (assign,":base_troop_index",9),
         (else_try),
           (eq,":team_1_faction","fac_austria"),
           (assign,":base_troop_index",10),
         (else_try),
           (eq,":team_1_faction","fac_rhine"),
           (assign,":base_troop_index",10),
         (try_end),
         (try_for_range,":value2",0,10),
           (try_begin),
             (eq,":value2",0),
             (troop_set_slot,"trp_custom_battle_dummy",":value2",":base_troop_index"),
           (else_try),
             (troop_set_slot,"trp_custom_battle_dummy",":value2",0),
           (try_end),
         (try_end),
         (try_for_range,":value3",20,30),
           (troop_set_slot,"trp_custom_battle_dummy",":value3",20),
         (try_end),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_2"),
         (store_add,":team_2_faction",":value",factions_begin),
         (assign, "$g_quick_battle_team_2_faction", ":team_2_faction"),
         (try_begin),
           (eq,":team_2_faction","fac_britain"),
           (assign,":base_troop_index",12),
         (else_try),
           (eq,":team_2_faction","fac_france"),
           (assign,":base_troop_index",13),
         (else_try),
           (eq,":team_2_faction","fac_prussia"),
           (assign,":base_troop_index",10),
         (else_try),
           (eq,":team_2_faction","fac_russia"),
           (assign,":base_troop_index",9),
         (else_try),
           (eq,":team_2_faction","fac_austria"),
           (assign,":base_troop_index",10),
         (else_try),
           (eq,":team_1_faction","fac_rhine"),
           (assign,":base_troop_index",10),
         (try_end),
         (try_for_range,":value4",10,20),
           (try_begin),
             (eq,":value4",10),
             (troop_set_slot,"trp_custom_battle_dummy",":value4",":base_troop_index"),
           (else_try),
             (troop_set_slot,"trp_custom_battle_dummy",":value4",0),
           (try_end),
         (try_end),
         (try_for_range,":value5",30,40),
           (troop_set_slot,"trp_custom_battle_dummy",":value5",20),
         (try_end),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_1"),
         (troop_set_slot,"trp_custom_battle_dummy",0,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_2"),
         (troop_set_slot,"trp_custom_battle_dummy",1,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_3"),
         (troop_set_slot,"trp_custom_battle_dummy",2,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_4"),
         (troop_set_slot,"trp_custom_battle_dummy",3,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_5"),
         (troop_set_slot,"trp_custom_battle_dummy",4,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_6"),
         (troop_set_slot,"trp_custom_battle_dummy",5,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_7"),
         (troop_set_slot,"trp_custom_battle_dummy",6,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_8"),
         (troop_set_slot,"trp_custom_battle_dummy",7,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_1_9"),
         (troop_set_slot,"trp_custom_battle_dummy",8,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_1"),
         (troop_set_slot,"trp_custom_battle_dummy",10,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_2"),
         (troop_set_slot,"trp_custom_battle_dummy",11,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_3"),
         (troop_set_slot,"trp_custom_battle_dummy",12,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_4"),
         (troop_set_slot,"trp_custom_battle_dummy",13,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_5"),
         (troop_set_slot,"trp_custom_battle_dummy",14,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_6"),
         (troop_set_slot,"trp_custom_battle_dummy",15,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_7"),
         (troop_set_slot,"trp_custom_battle_dummy",16,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_8"),
         (troop_set_slot,"trp_custom_battle_dummy",17,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_unit_2_9"),
         (troop_set_slot,"trp_custom_battle_dummy",18,":value"),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_1"),
         (troop_set_slot,"trp_custom_battle_dummy",20,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_2"),
         (troop_set_slot,"trp_custom_battle_dummy",21,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_3"),
         (troop_set_slot,"trp_custom_battle_dummy",22,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_4"),
         (troop_set_slot,"trp_custom_battle_dummy",23,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_5"),
         (troop_set_slot,"trp_custom_battle_dummy",24,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_6"),
         (troop_set_slot,"trp_custom_battle_dummy",25,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_7"),
         (troop_set_slot,"trp_custom_battle_dummy",26,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_8"),
         (troop_set_slot,"trp_custom_battle_dummy",27,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_1_9"),
         (troop_set_slot,"trp_custom_battle_dummy",28,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_1"),
         (troop_set_slot,"trp_custom_battle_dummy",30,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_2"),
         (troop_set_slot,"trp_custom_battle_dummy",31,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_3"),
         (troop_set_slot,"trp_custom_battle_dummy",32,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_4"),
         (troop_set_slot,"trp_custom_battle_dummy",33,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_5"),
         (troop_set_slot,"trp_custom_battle_dummy",34,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_6"),
         (troop_set_slot,"trp_custom_battle_dummy",35,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_7"),
         (troop_set_slot,"trp_custom_battle_dummy",36,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_8"),
         (troop_set_slot,"trp_custom_battle_dummy",37,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_slider_2_9"),
         (troop_set_slot,"trp_custom_battle_dummy",38,":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_map_select"), 
         (store_add,"$g_quick_battle_map",":value",quick_battle_scenes_begin),
         (presentation_set_duration, 0),
         (start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_day_time"),
         (assign,"$g_quick_battle_day_time_value",":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_fog"),
         (assign,"$g_quick_battle_fog_value",":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_rain"),
         (assign,"$g_quick_battle_rain_value",":value"),
         #(presentation_set_duration, 0),
         #(start_presentation, "prsnt_game_custom_battle_designer"),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_start"),
       
         (assign,":continue",0),
         (assign,":end_cond",10),
         (try_for_range,":value5",0,":end_cond"),
           (neg|troop_slot_eq,"trp_custom_battle_dummy",":value5",0),
           (assign,":continue",1),
           (assign,":end_cond",0), #Break
         (try_end),
         (eq,":continue",1),
         (assign,":end_cond",20),
         (try_for_range,":value6",10,":end_cond"),
           (neg|troop_slot_eq,"trp_custom_battle_dummy",":value6",0),
           (assign,":continue",2),
           (assign,":end_cond",0), #Break
         (try_end),
         (eq,":continue",2),
       
         (assign, "$g_is_quick_battle", 1),
         
         (assign, ":current_scene","$g_quick_battle_map"),
         (modify_visitors_at_site, ":current_scene"),
         (call_script,"script_spawn_quick_battle_army"), # Needs to modify script to support new custom battles
         
         (set_jump_mission,"mt_quick_battle_battle"),
         (jump_to_menu, "mnu_custom_battle_end"),
         (jump_to_scene, ":current_scene"),
         (change_screen_mission),
         (presentation_set_duration, 0),
       (else_try),
         (eq, ":object", "$g_presentation_obj_custom_battle_designer_quit"),
         (presentation_set_duration, 0),
       (try_end),
     ]),
  ]),
  
  ("game_multiplayer_admin_panel", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (try_begin),
      
      
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_floodplain"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_floodplain_storm"),
        (assign, ":map_image", "mesh_scn_mp_floodplain_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_siege_of_toulon"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_siege_of_toulon_night"),
        (assign, ":map_image", "mesh_scn_mp_siege_of_toulon_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_hohenfels"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_hohenfels_night"),
        (assign, ":map_image", "mesh_scn_mp_fort_hohenfels_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_george"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_george_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_george_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_mackinaw"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_mackinaw_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_mackinaw_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_nylas"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_nylas_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_nylas_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_charge_to_the_rhine"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_charge_to_the_rhine_cloudy"),
        (assign, ":map_image", "mesh_scn_mp_charge_of_the_rhine_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_de_chartres"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_de_chartres_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_de_charte_select"),     
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_brochet"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_brochet_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_brochet_select"),     
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_bashir"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_bashir_morning"),
        (assign, ":map_image", "mesh_scn_mp_fort_bashir_select"),     
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_al_hafya"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_al_hafya_night"),
        (assign, ":map_image", "mesh_scn_mp_fort_al_hafya_select"),     
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_citadelle_napoleon"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_citadelle_napoleon_morning"),
        (assign, ":map_image", "mesh_scn_mp_citadell_napoleon_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_venice"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_venice_morning"),
        (assign, ":map_image", "mesh_scn_mp_venice_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_sjotofta"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_sjotofta_night"),
        (assign, ":map_image", "mesh_scn_mp_sjotofta_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_saints_isle"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_saints_isle_rain"),
        (assign, ":map_image", "mesh_scn_mp_saints_isle_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_russian_village_conq"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_russian_village_conq_night"),
        (assign, ":map_image", "mesh_scn_mp_russian_town_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_outlaws_den"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_outlaws_den_night"),
        (assign, ":map_image", "mesh_scn_mp_outlaws_den_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_russian_river_day"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_russian_river_cloudy"),
        (assign, ":map_image", "mesh_scn_mp_russian_river_select"),
      (else_try),
        (eq, "$g_multiplayer_selected_map", "scn_mp_theisland"),
        (assign, ":map_image", "mesh_scn_mp_the_island_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_forest_pallisade"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_forest_pallisade_fog"),
        (assign, ":map_image", "mesh_scn_mp_forest_pallaside_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_countryside"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_countryside_fog"),
        (assign, ":map_image", "mesh_scn_mp_countryside_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_dust"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_dust_morning"),
        (assign, ":map_image", "mesh_scn_mp_dust_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_beach"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_beach_morning"),
        (assign, ":map_image", "mesh_scn_mp_beach_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_bavarian_river"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_bavarian_river_cloudy"),
        (assign, ":map_image", "mesh_scn_mp_bavarian_river_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_arabian_village_conq"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_arabian_village_conq_morning"),
        (assign, ":map_image", "mesh_scn_mp_arabian_town_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_ambush"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_ambush_fog"),
        (assign, ":map_image", "mesh_scn_mp_ambush_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_avignon"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_avignon_morning"),
        (assign, ":map_image", "mesh_scn_mp_avignon_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_borodino"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_borodino_morn"),
        (assign, ":map_image", "mesh_scn_mp_bordino_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_columbia_hill_farm"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_columbia_farm_morning"),
        (assign, ":map_image", "mesh_scn_mp_columbia_farm_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_hungarian_plains"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_hungarian_plains_cloud"),
        (assign, ":map_image", "mesh_scn_mp_hungarian_plains_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_landshut"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_landshut_night"),
        (assign, ":map_image", "mesh_scn_mp_landshut_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_minden"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_minden_night"),
        (assign, ":map_image", "mesh_scn_mp_minden_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_oaksfield_day"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_oaksfield_storm"),
        (assign, ":map_image", "mesh_scn_mp_oaksfield_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_quatre_bras"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_quatre_bras_night"),
        (assign, ":map_image", "mesh_scn_mp_quatre_bras_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_roxburgh"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_roxburgh_raining"),
        (assign, ":map_image", "mesh_scn_mp_roxburgh_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_walloon_farm"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_walloon_farm_night"),
        (assign, ":map_image", "mesh_scn_mp_walloon_farm_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_slovenian_village"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_slovenian_village_raining"),
        (assign, ":map_image", "mesh_scn_mp_slovenian_village_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_arabian_harbour"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_arabian_harbour_night"),
        (assign, ":map_image", "mesh_scn_mp_arabian_harbour_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_arabian_village"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_arabian_village_morning"),
        (assign, ":map_image", "mesh_scn_mp_arabian_village_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_spanish_village"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_spanish_village_evening"),
        (assign, ":map_image", "mesh_scn_mp_spanish_village_select"),
      # (else_try),
        # (eq, "$g_multiplayer_selected_map", "scn_mp_berezina_crossing"),
        # (assign, ":map_image", "mesh_scn_mp_champs_elysees_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_champs_elysees"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_champs_elysees_rain"),
        (assign, ":map_image", "mesh_scn_mp_champs_elysees_select"),
      (else_try),
        (eq, "$g_multiplayer_selected_map", "scn_mp_european_city_summer"),
        (assign, ":map_image", "mesh_scn_mp_european_city_summer_select"),
      (else_try),
        (eq, "$g_multiplayer_selected_map", "scn_mp_european_city_winter"),
        (assign, ":map_image", "mesh_scn_mp_european_city_winter_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_beaver"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_beaver_morning"),
        (assign, ":map_image", "mesh_scn_mp_fort_beaver_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_lyon"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_lyon_night"),
        (assign, ":map_image", "mesh_scn_mp_fort_lyon_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_vincey"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_vincey_storm"),
        (assign, ":map_image", "mesh_scn_mp_fort_vincey_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_boyd"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_boyd_raining"),
        (assign, ":map_image", "mesh_scn_mp_fort_boyd_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_refleax"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_refleax_night"),
        (assign, ":map_image", "mesh_scn_mp_fort_refleax_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_fort_fleetwood"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_fort_fleetwood_storm"),
        (assign, ":map_image", "mesh_scn_mp_fort_fleetwood_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_french_farm"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_french_farm_storm"),
        (assign, ":map_image", "mesh_scn_mp_french_farm_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_german_village"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_german_village_rain"),
        (assign, ":map_image", "mesh_scn_mp_german_village_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_hougoumont"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_hougoumont_night"),
        (assign, ":map_image", "mesh_scn_mp_hougoumont_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_la_haye_sainte"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_la_haye_sainte_night"),
        (assign, ":map_image", "mesh_scn_mp_la_haye_sainte_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_river_crossing"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_river_crossing_morning"),
        (assign, ":map_image", "mesh_scn_mp_river_crossing_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_russian_village"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_russian_village_fog"),
        (assign, ":map_image", "mesh_scn_mp_russian_village_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_ardennes"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_ardennes_morning"),
        (assign, ":map_image", "mesh_scn_mp_ardennes_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_schemmerbach"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_schemmerbach_storm"),
        (assign, ":map_image", "mesh_scn_mp_schemmerbach_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_spanish_farm"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_spanish_farm_rain"),
        (assign, ":map_image", "mesh_scn_mp_spanish_farm_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_spanish_mountain_pass"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_spanish_mountain_pass_evening"),
        (assign, ":map_image", "mesh_scn_mp_spanish_mountain_pass_select"),
      (else_try),
        (eq, "$g_multiplayer_selected_map", "scn_mp_swamp"),
        (assign, ":map_image", "mesh_scn_mp_swamp_select"),
      (else_try),
        (this_or_next|eq, "$g_multiplayer_selected_map", "scn_mp_strangefields"),
        (eq, "$g_multiplayer_selected_map", "scn_mp_strangefields_storm"),
        (assign, ":map_image", "mesh_scn_mp_strangefields_select"),
      (else_try),
        (eq, "$g_multiplayer_selected_map", "scn_mp_testing_map"),
        (assign, ":map_image", "mesh_scn_mp_testing_map_select"),
      (else_try),
        (this_or_next|is_between,"$g_multiplayer_selected_map","scn_random_multi_plain_medium","scn_random_multi_steppe_medium"),
        (is_between,"$g_multiplayer_selected_map","scn_random_multi_forest_medium","scn_multiplayer_maps_end"),
        (assign, ":map_image", "mesh_scn_mp_random_plain_select"),
      (else_try),
        (is_between,"$g_multiplayer_selected_map","scn_random_multi_steppe_medium","scn_random_multi_snow_medium"),
        (assign, ":map_image", "mesh_scn_mp_random_steppe_select"),
      (else_try),
        (is_between,"$g_multiplayer_selected_map","scn_random_multi_snow_medium","scn_random_multi_desert_medium"),
        (assign, ":map_image", "mesh_scn_mp_random_snow_select"),
      (else_try),
        (is_between,"$g_multiplayer_selected_map","scn_random_multi_desert_medium","scn_random_multi_forest_medium"),
        (assign, ":map_image", "mesh_scn_mp_random_desert_select"),
      (else_try),
        (assign, ":map_image", "mesh_scn_mp_random_plain_select"),
      (try_end),
      
      (create_mesh_overlay, reg0, ":map_image"),
      (position_set_x, pos1, -1),
      (position_set_y, pos1, 550),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1002),
      (position_set_y, pos1, 1002),
      (overlay_set_size, reg0, pos1),

      (create_mesh_overlay, reg0, "mesh_mp_ui_host_main"),
      (position_set_x, pos1, -1),
      (position_set_y, pos1, -1),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1002),
      (position_set_y, pos1, 1002),
      (overlay_set_size, reg0, pos1),

      (assign, ":cur_y", 1240),
      (assign, ":cur_y_adder", 40),
      (assign, ":number_box_x", 530), #390

      (try_begin),
        # MM  20 more options
        (val_add, ":cur_y", ":cur_y_adder"),#added 3 more #patch1115 59/15
        (try_begin),
          (eq,"$g_bonuses_enabled",1),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
        (try_end),
        (try_begin),
          (eq,"$g_auto_kick",1),
          (val_add, ":cur_y", ":cur_y_adder"),
        (try_end),
        (try_begin),
          (eq,"$g_use_class_limits",1),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
          (val_add, ":cur_y", ":cur_y_adder"),
        (try_end),
        #MM end
        
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_king), # one less for him.
          (val_sub, ":cur_y", ":cur_y_adder"), 
        (try_end),
        
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_team_deathmatch),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_king),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        (val_add, ":cur_y", ":cur_y_adder"), #two more options for these modes (friendly fire options)
        (val_add, ":cur_y", ":cur_y_adder"),
        (val_add, ":cur_y", ":cur_y_adder"),#lets add another for when to turn ff on or off via time
        (val_add, ":cur_y", ":cur_y_adder"),
        (val_add, ":cur_y", ":cur_y_adder"),
        (val_add, ":cur_y", ":cur_y_adder"),
        (val_add, ":cur_y", ":cur_y_adder"),
        (val_add, ":cur_y", ":cur_y_adder"),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        (val_add, ":cur_y", ":cur_y_adder"), #one more option for these modes
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        (val_add, ":cur_y", ":cur_y_adder"), #one more option for these modes
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        (val_add, ":cur_y", ":cur_y_adder"), #2 more options for this mode
        (eq, "$g_no_rambo", 1),
        (val_add, ":cur_y", ":cur_y_adder"),
      (try_end),
      (assign, "$g_presentation_obj_admin_panel_3", -1),#hotfix
      (assign, "$g_presentation_obj_admin_panel_4", -1),
      (assign, "$g_presentation_obj_admin_panel_79", -1),
      (assign, "$g_presentation_obj_admin_panel_54", -1),
      (assign, "$g_presentation_obj_admin_panel_55", -1),
      (assign, "$g_presentation_obj_admin_panel_max_teamkills_before_kick", -1),

      #classlimiting vars
      (assign, "$g_presentation_obj_admin_panel_58", -1),
      (assign, "$g_presentation_obj_admin_panel_44", -1),
      (assign, "$g_presentation_obj_admin_panel_45", -1),
      (assign, "$g_presentation_obj_admin_panel_59", -1),
      (assign, "$g_presentation_obj_admin_panel_46", -1),
      (assign, "$g_presentation_obj_admin_panel_60", -1),
      (assign, "$g_presentation_obj_admin_panel_61", -1),
      (assign, "$g_presentation_obj_admin_panel_62", -1),
      (assign, "$g_presentation_obj_admin_panel_63", -1),
      (assign, "$g_presentation_obj_admin_panel_64", -1),
      (assign, "$g_presentation_obj_admin_panel_67", -1),
      (assign, "$g_presentation_obj_admin_panel_65", -1),
      (assign, "$g_presentation_obj_admin_panel_80", -1),
      (assign, "$g_presentation_obj_admin_panel_66", -1),
      (assign, "$g_presentation_obj_admin_panel_74", -1),
      (assign, "$g_presentation_obj_admin_panel_47", -1),
      (assign, "$g_presentation_obj_admin_panel_48", -1),
      (assign, "$g_presentation_obj_admin_panel_49", -1),
      (assign, "$g_presentation_obj_admin_panel_50", -1),
      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_admin_panel_container", s0, tf_scrollable),
      (position_set_x, pos1, 59),
      (position_set_y, pos1, 50),
      (overlay_set_position, "$g_presentation_obj_admin_panel_container", pos1),
      (position_set_x, pos1, 640),
      (position_set_y, pos1, 520),
      (overlay_set_area_size, "$g_presentation_obj_admin_panel_container", pos1),
      (set_container_overlay, "$g_presentation_obj_admin_panel_container"),

      (create_text_overlay, reg0, "str_server_name", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (str_store_server_name, s0),
      (try_begin),
        (eq, "$g_multiplayer_renaming_server_allowed", 1),
        (create_simple_text_box_overlay, "$g_presentation_obj_admin_panel_20"),
        (position_set_x, pos1, 390),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_20", pos1),
        (overlay_set_text, "$g_presentation_obj_admin_panel_20", s0),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_20", -1),
        (create_text_overlay, reg0, s0, 0),
        (position_set_x, pos1, 385),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
      (try_end),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_game_password", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_simple_text_box_overlay, "$g_presentation_obj_admin_panel_9"),
      (position_set_x, pos1, 390),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_9", pos1),
      (str_store_server_password, s0),
      (overlay_set_text, "$g_presentation_obj_admin_panel_9", s0),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_welcome_message", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_simple_text_box_overlay, "$g_presentation_obj_admin_panel_32"),
      (position_set_x, pos1, 390),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_32", pos1),
      (str_store_welcome_message, s0),
      (overlay_set_text, "$g_presentation_obj_admin_panel_32", s0),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_map", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (call_script, "script_multiplayer_fill_map_game_types", "$g_multiplayer_game_type"),
      (assign, ":num_maps", reg0),
      (assign, ":selected_index", 0),

      (try_begin),
        (gt, ":num_maps", 10),#WAS 14, now kh has arrows to select maps #patch1115 57/1
        (create_combo_label_overlay, "$g_presentation_obj_admin_panel_1"),
      #(try_end),
      #(try_begin),#some tests
      (else_try),
        (create_combo_button_overlay, "$g_presentation_obj_admin_panel_1"),
      (try_end),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_1", pos1),
      (try_begin),
        (gt, ":num_maps", 10),#WAS 14, now kh is in line with the rest #patch1115 57/2
        (position_set_x, pos1, 465),
      (else_try),
        (position_set_x, pos1, 490),
      (try_end),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_1", pos1),
      (troop_get_slot, ":first_map", "trp_multiplayer_data", multi_data_maps_for_game_type_begin),
      (assign, ":selected_map_available", 0),
      (try_for_range, ":i_map", 0, ":num_maps"),
        (store_add, ":map_slot", ":i_map", multi_data_maps_for_game_type_begin),
        (troop_get_slot, ":map_no", "trp_multiplayer_data", ":map_slot"),
        (try_begin),
          (eq, ":map_no", "$g_multiplayer_selected_map"),
          (multiplayer_get_my_player,":my_player"),
          (gt,":my_player",-1),
          (str_store_troop_name,s0,"trp_scene_name_dummy"),
        (else_try),
          (store_sub, ":string_index", ":map_no", multiplayer_scenes_begin),
          (val_add, ":string_index", multiplayer_scene_names_begin),
          (str_store_string, s0, ":string_index"),
        (try_end),
        (overlay_add_item, "$g_presentation_obj_admin_panel_1", s0),
        (try_begin),
          (eq, ":map_no", "$g_multiplayer_selected_map"),
          (assign, ":selected_index", ":i_map"),
          (assign, ":selected_map_available", 1),
        (try_end),
      (try_end),
      (overlay_set_val, "$g_presentation_obj_admin_panel_1", ":selected_index"),
   ###   
      (create_text_overlay, reg0, "str_map_menu", 0),#map selection 2
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      
      (create_button_overlay, "$g_presentation_obj_admin_panel_82", "str_choose_maps", 0),
      (position_set_x, pos1, 125),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_82", pos1),
###
      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (create_text_overlay, reg0, "str_num_custom_maps", 0),#patch1115 64/2
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_77", 0, 101),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_77", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_77", "$g_num_custom_maps"),

      (val_sub, ":cur_y", ":cur_y_adder"),#custom maps above

      (create_text_overlay, reg0, "str_game_type", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (try_begin),
        (eq, "$g_multiplayer_changing_game_type_allowed", 1),
        (create_combo_button_overlay, "$g_presentation_obj_admin_panel_10"),
        (position_set_x, pos1, 800),
        (position_set_y, pos1, 800),
        (overlay_set_size, "$g_presentation_obj_admin_panel_10", pos1),
        (position_set_x, pos1, 490),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_10", pos1),
        
        (assign,":add_scene_edit",0),
        (try_begin),
          (is_edit_mode_enabled),
          (multiplayer_is_server), # only for local host game.
          (assign,":add_scene_edit",1),
        (try_end),
        
        (try_for_range, ":i_game_type", 0, multiplayer_num_game_types),
          (this_or_next|neq,":i_game_type",multiplayer_game_type_scene_making),
          (eq,":add_scene_edit",1),
          
          (store_add, ":string_index", ":i_game_type", multiplayer_game_type_names_begin),
          (str_store_string, s0, ":string_index"),
          (overlay_add_item, "$g_presentation_obj_admin_panel_10", s0),
        (try_end),
        (overlay_set_val, "$g_presentation_obj_admin_panel_10", "$g_multiplayer_game_type"),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_10", -1),
        (store_add, ":string_index", "$g_multiplayer_game_type", multiplayer_game_type_names_begin),
        (str_store_string, s0, ":string_index"),
        (create_text_overlay, reg0, s0, 0),
        (position_set_x, pos1, 385),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
      (try_end),
      
      (val_sub, ":cur_y", ":cur_y_adder"),

      (assign, reg1, 1),
      (create_text_overlay, reg0, "str_team_reg1_faction", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_11"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_11", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_11", pos1),
      (call_script, "script_multiplayer_fill_available_factions_combo_button", "$g_presentation_obj_admin_panel_11", "$g_multiplayer_next_team_1_faction", "$g_multiplayer_next_team_2_faction"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (assign, reg1, 2),
      (create_text_overlay, reg0, "str_team_reg1_faction", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_12"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_12", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_12", pos1),
      (call_script, "script_multiplayer_fill_available_factions_combo_button", "$g_presentation_obj_admin_panel_12", "$g_multiplayer_next_team_2_faction", "$g_multiplayer_next_team_1_faction"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_commander), # cant have normal bots in this game mode.
      
        (assign, reg1, 1),
        (create_text_overlay, reg0, "str_number_of_bots_in_team_reg1", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_3", 0, "$g_multiplayer_max_num_bots"),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_3", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_3", "$g_multiplayer_num_bots_team_1"),

        (val_sub, ":cur_y", ":cur_y_adder"),

        (assign, reg1, 2),
        (create_text_overlay, reg0, "str_number_of_bots_in_team_reg1", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_4", 0, "$g_multiplayer_max_num_bots"),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_4", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_4", "$g_multiplayer_num_bots_team_2"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
      (try_end),
      
      # MM begin
      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        
        (create_text_overlay, reg0, "str_num_bots_per_squad", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_52", 0, 201),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_52", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_52", "$g_squad_size_limit"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
      
        (create_text_overlay, reg0, "str_scale_squad_size", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_53", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_53", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_53", "$g_scale_squad_size"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_max_num_bots", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_72", 50, 501),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_72", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_72", "$g_max_num_bots"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
      
        (create_text_overlay, reg0, "str_no_rambo", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_73", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_73", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_73", "$g_no_rambo"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (try_begin),
          (eq, "$g_no_rambo", 1),

          (create_text_overlay, reg0, "str_no_rambo_range", 0),
          (position_set_x, pos1, 0),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),

          (create_number_box_overlay, "$g_presentation_obj_admin_panel_79", 1, 101),
          (position_set_x, pos1, ":number_box_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, "$g_presentation_obj_admin_panel_79", pos1),
          (overlay_set_val, "$g_presentation_obj_admin_panel_79", "$g_no_rambo_range"),
        
          (val_sub, ":cur_y", ":cur_y_adder"),
        (else_try),
          (assign, "$g_presentation_obj_admin_panel_79", -1),
        (try_end),
        
        
        (create_text_overlay, reg0, "str_no_line_inf_spread", 0), #patch1115 63/4
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_76", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_76", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_76", "$g_no_line_inf_spread"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),#patch1115 63/4 end
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_52", -1),
        (assign, "$g_presentation_obj_admin_panel_53", -1),
        (assign, "$g_presentation_obj_admin_panel_72", -1),
        (assign, "$g_presentation_obj_admin_panel_73", -1),
        (assign, "$g_presentation_obj_admin_panel_76", -1),#patch1115 63/5
      (try_end),

      # Buildpoints begin
      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_commander), # buildpoints are useless in commander battle, there are no sappers.
        
        (create_text_overlay, reg0, "str_build_points_team_1", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_54", 0, 10000),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_54", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_54", "$g_team_1_max_build_points"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_build_points_team_2", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_55", 0, 10000),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_55", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_55", "$g_team_2_max_build_points"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
      (try_end),
        # Buildpoints end
      
      
      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_deathmatch),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_duel),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_scene_making),
        
        (create_text_overlay, reg0, "str_chk_auto_kick", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_auto_kick", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_auto_kick", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_auto_kick", "$g_auto_kick"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (try_begin),
          (eq,"$g_auto_kick",1),
          
          (create_text_overlay, reg0, "str_num_max_teamkills_before_kick", 0),
          (position_set_x, pos1, 0),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),

          (create_number_box_overlay, "$g_presentation_obj_admin_panel_max_teamkills_before_kick", 0, 25),
          (position_set_x, pos1, ":number_box_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, "$g_presentation_obj_admin_panel_max_teamkills_before_kick", pos1),
          (overlay_set_val, "$g_presentation_obj_admin_panel_max_teamkills_before_kick", "$g_max_teamkills_before_kick"),
          
          (val_sub, ":cur_y", ":cur_y_adder"),
        (else_try),
          (assign, "$g_presentation_obj_admin_panel_max_teamkills_before_kick", -1),
        (try_end),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_auto_kick", -1),
      (try_end),
      (create_text_overlay, reg0, "str_chk_auto_horse", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_auto_horse", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_auto_horse", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_auto_horse", "$g_auto_horse"),

      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_deathmatch),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_team_deathmatch),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_duel),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_scene_making),
        
        (create_text_overlay, reg0, "str_chk_auto_swap", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_auto_swap", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_auto_swap", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_auto_swap", "$g_auto_swap"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
        
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_auto_swap", -1),
      (try_end),
    
      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_deathmatch),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_duel),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_scene_making),
        
        (create_text_overlay, reg0, "str_auto_turn_on_FF", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_81", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_81", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_81", "$g_auto_FF"),

        (val_sub, ":cur_y", ":cur_y_adder"),

        (create_text_overlay, reg0, "str_allow_friendly_fire", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_5", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_5", pos1),
        (server_get_friendly_fire, ":server_friendly_fire"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_5", ":server_friendly_fire"),

        (val_sub, ":cur_y", ":cur_y_adder"),

        (create_text_overlay, reg0, "str_allow_melee_friendly_fire", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_36", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_36", pos1),
        (server_get_melee_friendly_fire, ":melee_friendly_fire"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_36", ":melee_friendly_fire"),

        (val_sub, ":cur_y", ":cur_y_adder"),

        (create_text_overlay, reg0, "str_friendly_fire_damage_self_ratio", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_37", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_37", pos1),
        (server_get_friendly_fire_damage_self_ratio, ":friendly_fire_damage_self_ratio"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_37", ":friendly_fire_damage_self_ratio"),

        (val_sub, ":cur_y", ":cur_y_adder"),

        (create_text_overlay, reg0, "str_friendly_fire_damage_friend_ratio", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_38", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_38", pos1),
        (server_get_friendly_fire_damage_friend_ratio, ":friendly_fire_damage_friend_ratio"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_38", ":friendly_fire_damage_friend_ratio"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),

      (else_try),
        (assign, "$g_presentation_obj_admin_panel_5", -1),
        (assign, "$g_presentation_obj_admin_panel_36", -1),
        (assign, "$g_presentation_obj_admin_panel_37", -1),
        (assign, "$g_presentation_obj_admin_panel_38", -1),
        (assign, "$g_presentation_obj_admin_panel_81", -1),
      (try_end),
      
      (create_text_overlay, reg0, "str_spectator_camera", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_19"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_19", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_19", pos1),
      (overlay_add_item, "$g_presentation_obj_admin_panel_19", "str_free"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_19", "str_stick_to_any_player"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_19", "str_stick_to_team_members"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_19", "str_stick_to_team_members_view"),
      (server_get_ghost_mode, ":server_ghost_mode"),
      (overlay_set_val, "$g_presentation_obj_admin_panel_19", ":server_ghost_mode"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_control_block_direction", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_15"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_15", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_15", pos1),
      (overlay_add_item, "$g_presentation_obj_admin_panel_15", "str_automatic"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_15", "str_by_mouse_movement"),
      (server_get_control_block_dir, ":server_control_block_dir"),
      (overlay_set_val, "$g_presentation_obj_admin_panel_15", ":server_control_block_dir"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_combat_speed", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_26"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_26", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_26", pos1),
      (overlay_add_item, "$g_presentation_obj_admin_panel_26", "str_combat_speed_0"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_26", "str_combat_speed_1"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_26", "str_combat_speed_2"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_26", "str_combat_speed_3"),
      (overlay_add_item, "$g_presentation_obj_admin_panel_26", "str_combat_speed_4"),
      (server_get_combat_speed, ":server_combat_speed"),
      (overlay_set_val, "$g_presentation_obj_admin_panel_26", ":server_combat_speed"),
      
      (val_sub, ":cur_y", ":cur_y_adder"),

      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_king),

        (create_text_overlay, reg0, "str_map_time_limit", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_7", multiplayer_game_max_minutes_min, multiplayer_game_max_minutes_max),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_7", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_7", "$g_multiplayer_game_max_minutes"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),
        
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_7", -1),
      (try_end),

      (try_begin),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),

        (create_text_overlay, reg0, "str_round_time_limit", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_16", multiplayer_round_max_seconds_min, multiplayer_round_max_seconds_max),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_16", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_16", "$g_multiplayer_round_max_seconds"),
      
        (val_sub, ":cur_y", ":cur_y_adder"),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_16", -1),
      (try_end),

      (try_begin),
        (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),

        (create_text_overlay, reg0, "str_players_take_control_of_a_bot_after_death", 0),
        (position_set_x, pos1, 30),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_check_box_overlay, "$g_presentation_obj_admin_panel_25", "mesh_checkbox_off", "mesh_checkbox_on"),
        (position_set_x, pos1, 7),
        (store_add, ":special_cur_y", ":cur_y", 7),
        (position_set_y, pos1, ":special_cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_25", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_25", "$g_multiplayer_player_respawn_as_bot"),
      
        (val_sub, ":cur_y", ":cur_y_adder"),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_25", -1),
      (try_end),

      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),

        (create_text_overlay, reg0, "str_defender_spawn_count_limit", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_combo_button_overlay, "$g_presentation_obj_admin_panel_27"),
        (position_set_x, pos1, 800),
        (position_set_y, pos1, 800),
        (overlay_set_size, "$g_presentation_obj_admin_panel_27", pos1),
        (position_set_x, pos1, 490),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_27", pos1),
        (assign, reg0, 10),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 9),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 8),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 7),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 6),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 5),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 4),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 3),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 2),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (assign, reg0, 1),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_reg0"),
        (overlay_add_item, "$g_presentation_obj_admin_panel_27", "str_unlimited"),

        (store_sub, ":value_to_set", 10, "$g_multiplayer_number_of_respawn_count"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_27", ":value_to_set"),
        
        (val_sub, ":cur_y", ":cur_y_adder"),      
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_27", -1),
      (try_end),

      (create_text_overlay, reg0, "str_team_points_limit", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_8", 1, multiplayer_game_max_points),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_8", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_8", "$g_multiplayer_game_max_points"),
      
      (val_sub, ":cur_y", ":cur_y_adder"),

      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),

        (create_text_overlay, reg0, "str_point_gained_from_flags", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_17", 25, 401),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_17", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_17", "$g_multiplayer_point_gained_from_flags"),
      
        (val_sub, ":cur_y", ":cur_y_adder"),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_17", -1),
      (try_end),
      
      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),

        (create_text_overlay, reg0, "str_point_gained_from_capturing_flag", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_18", 0, 11),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_18", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_18", "$g_multiplayer_point_gained_from_capturing_flag"),

        (val_sub, ":cur_y", ":cur_y_adder"),

      (else_try),
        (assign, "$g_presentation_obj_admin_panel_18", -1),
      (try_end),
      
      (create_text_overlay, reg0, "str_respawn_period", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_6", multiplayer_respawn_period_min, multiplayer_respawn_period_max),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_6", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_6", "$g_multiplayer_respawn_period"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (assign, "$g_presentation_obj_admin_panel_35", -1),
      

      (create_text_overlay, reg0, "str_make_kick_voteable", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_28", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_28", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_28", "$g_multiplayer_kick_voteable"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_make_ban_voteable", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_29", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_29", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_29", "$g_multiplayer_ban_voteable"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_make_maps_voteable", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_24", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_24", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_24", "$g_multiplayer_maps_voteable"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_make_factions_voteable", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_23", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_23", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_23", "$g_multiplayer_factions_voteable"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_bots_upper_limit_for_votes", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (assign, ":upper_limit", 51),
      (val_min, ":upper_limit", "$g_multiplayer_max_num_bots"),
      (create_number_box_overlay, "$g_presentation_obj_admin_panel_22", 0, ":upper_limit"),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_22", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_22", "$g_multiplayer_num_bots_voteable"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_valid_vote_ratio", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_30", 50, 101),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_30", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_30", "$g_multiplayer_valid_vote_ratio"),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_auto_team_balance_limit", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_combo_button_overlay, "$g_presentation_obj_admin_panel_31"),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_admin_panel_31", pos1),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_31", pos1),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_unlimited"),
      (assign, reg0, 6),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_reg0"),
      (assign, reg0, 5),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_reg0"),
      (assign, reg0, 4),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_reg0"),
      (assign, reg0, 3),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_reg0"),
      (assign, reg0, 2),
      (overlay_add_item, "$g_presentation_obj_admin_panel_31", "str_reg0"),
      (try_begin),
        (ge, "$g_multiplayer_auto_team_balance_limit", 1000),
        (overlay_set_val, "$g_presentation_obj_admin_panel_31", 0),
      (else_try),
        (store_sub, ":set_value", 7, "$g_multiplayer_auto_team_balance_limit"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_31", ":set_value"),
      (try_end),

      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_allow_player_banners", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_39", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_39", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_39", "$g_multiplayer_allow_player_banners"),

      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (create_text_overlay, reg0, "str_allow_multiple_firearms", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_56", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_56", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_56", "$g_allow_multiple_firearms"),

      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (create_text_overlay, reg0, "str_groupfight_mode", 0),#patch1115 60/10
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_75", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_75", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_75", "$g_groupfight_mode"),
      
      #G:comp_score:presentation start
      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (create_text_overlay, reg0, "str_competitive_score_mode", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_78", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_78", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_78", "$g_competitive_score_mode"),
      #G:comp_score:presentation end
      
      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (create_text_overlay, reg0, "str_enable_bonuses", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_57", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_57", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_57", "$g_bonuses_enabled"),
      
      (val_sub, ":cur_y", ":cur_y_adder"),
      
      (try_begin),
        (eq, "$g_bonuses_enabled", 1),

        (create_text_overlay, reg0, "str_bonus_strength", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_70", 1, 501),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_70", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_70", "$g_bonus_strength"),
      
        (val_sub, ":cur_y", ":cur_y_adder"),

        (create_text_overlay, reg0, "str_bonus_range", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_71", 1, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_71", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_71", "$g_bonus_range"),
      
        (val_sub, ":cur_y", ":cur_y_adder"),
      (else_try),
        (assign, "$g_presentation_obj_admin_panel_70", -1),
        (assign, "$g_presentation_obj_admin_panel_71", -1),
      (try_end),

      (create_text_overlay, reg0, "str_chance_of_falling_off_horse", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_68", 0, 101),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_68", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_68", "$g_chance_of_falling_off_horse"),
      
      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_damage_from_horse_dying", 0),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_number_box_overlay, "$g_presentation_obj_admin_panel_69", 0, 1001),
      (position_set_x, pos1, ":number_box_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_69", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_69", "$g_damage_from_horse_dying"),
      
      
      (val_sub, ":cur_y", ":cur_y_adder"),

      (create_text_overlay, reg0, "str_chk_class_limits", 0),
      (position_set_x, pos1, 30),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),

      (create_check_box_overlay, "$g_presentation_obj_admin_panel_43", "mesh_checkbox_off", "mesh_checkbox_on"),
      (position_set_x, pos1, 7),
      (store_add, ":special_cur_y", ":cur_y", 7),
      (position_set_y, pos1, ":special_cur_y"),
      (overlay_set_position, "$g_presentation_obj_admin_panel_43", pos1),
      (overlay_set_val, "$g_presentation_obj_admin_panel_43", "$g_use_class_limits"),
      
      (try_begin),
        (eq,"$g_use_class_limits",1),
      
        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_chk_class_limits_player_count", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_58", 0, 201),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_58", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_58", "$g_use_class_limits_player_count"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_grenadier", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_44", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_44", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_44", "$g_limit_grenadier"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_skirmisher", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_45", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_45", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_45", "$g_limit_skirmisher"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_rifle", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_59", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_59", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_59", "$g_limit_rifle"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_cavalry", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_46", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_46", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_46", "$g_limit_cavalry"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_lancer", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_60", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_60", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_60", "$g_limit_lancer"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_hussar", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_61", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_61", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_61", "$g_limit_hussar"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_dragoon", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_62", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_62", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_62", "$g_limit_dragoon"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_cuirassier", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_63", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_63", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_63", "$g_limit_cuirassier"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_heavycav", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_64", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_64", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_64", "$g_limit_heavycav"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_artillery", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_67", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_67", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_67", "$g_limit_artillery"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_rocket", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_65", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_65", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_65", "$g_limit_rocket"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_arty_train", 0),#patch1115 
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_80", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_80", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_80", "$g_limit_arty_train"),

        (val_sub, ":cur_y", ":cur_y_adder"), #patch1115 end
        
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (create_text_overlay, reg0, "str_limit_sapper_1", 0),
        (else_try),         
          (eq, "$g_groupfight_mode", 1),
          (create_text_overlay, reg0, "str_limit_sapper_2", 0),
        (else_try),
          (create_text_overlay, reg0, "str_limit_sapper", 0),
        (try_end),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_66", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_66", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_66", "$g_limit_sapper"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        (create_text_overlay, reg0, "str_limit_surgeon", 0),#patch1115 59/12
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_74", 0, 101),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_74", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_74", "$g_limit_surgeon"),

        (val_sub, ":cur_y", ":cur_y_adder"), #patch1115 59/12 end
        
        
        (create_text_overlay, reg0, "str_limit_musician", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_47", 0, 126),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_47", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_47", "$g_limit_musician"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_sergeant", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_48", 0, 126),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_48", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_48", "$g_limit_sergeant"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_officer", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_49", 0, 126),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_49", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_49", "$g_limit_officer"),

        (val_sub, ":cur_y", ":cur_y_adder"),
        
        
        (create_text_overlay, reg0, "str_limit_general", 0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),

        (create_number_box_overlay, "$g_presentation_obj_admin_panel_50", 0, 126),
        (position_set_x, pos1, ":number_box_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_panel_50", pos1),
        (overlay_set_val, "$g_presentation_obj_admin_panel_50", "$g_limit_general"),
        # MM end
      (try_end),
      

      (set_container_overlay, -1),

      (create_button_overlay, "$g_presentation_obj_admin_panel_13", "str_back", tf_center_justify),
      (position_set_x, pos1, 825),
      (position_set_y, pos1, 50),
      (overlay_set_position, "$g_presentation_obj_admin_panel_13", pos1),
      (position_set_x, pos1, 1500),
      (position_set_y, pos1, 1500),
      (overlay_set_size, "$g_presentation_obj_admin_panel_13", pos1),

      (create_button_overlay, "$g_presentation_obj_admin_panel_2", "str_start_map", tf_center_justify),
      (position_set_x, pos1, 825),
      (position_set_y, pos1, 90),
      (overlay_set_position, "$g_presentation_obj_admin_panel_2", pos1),
      (position_set_x, pos1, 1500),
      (position_set_y, pos1, 1500),
      (overlay_set_size, "$g_presentation_obj_admin_panel_2", pos1),

      # Vincenzo begin
	  (try_begin),
		  (neq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
	    (create_button_overlay, "$g_presentation_obj_admin_panel_51", "str_reset_map", tf_center_justify),
	    (position_set_x, pos1, 825),
	    (position_set_y, pos1, 130),
		  (overlay_set_position, "$g_presentation_obj_admin_panel_51", pos1),
		  (position_set_x, pos1, 1500),
		  (position_set_y, pos1, 1500),
		  (overlay_set_size, "$g_presentation_obj_admin_panel_51", pos1),
		(else_try), 
		  (assign, "$g_presentation_obj_admin_panel_51", -1),
		(try_end),
      # Vincenzo end
      
      (presentation_set_duration, 999999),

      (try_begin),
        (eq, ":selected_map_available", 0),
        (assign, "$g_multiplayer_selected_map", ":first_map"),
        (try_begin),
          (multiplayer_get_my_player,":my_player"),
          (gt,":my_player",-1),
          (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_request_map_name, "$g_multiplayer_selected_map"),
        (else_try),
          (presentation_set_duration, 0),
          (start_presentation, "prsnt_game_multiplayer_admin_panel"),
        (try_end),
      (try_end),
      ]),
    
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (store_trigger_param_2, ":value"),
      
      (try_begin),
        (eq, ":object", "$g_presentation_obj_admin_panel_1"),
        (store_add, ":slot_no", ":value", multi_data_maps_for_game_type_begin),
        (troop_get_slot, "$g_multiplayer_selected_map", "trp_multiplayer_data", ":slot_no"),
        (try_begin),
          (multiplayer_get_my_player,":my_player"),
          (gt,":my_player",-1),
          (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_request_map_name, "$g_multiplayer_selected_map"),
        (else_try),
          (presentation_set_duration, 0),
          (start_presentation, "prsnt_game_multiplayer_admin_panel"),
        (try_end),
      (else_try),#map selection 2
        (eq, ":object", "$g_presentation_obj_admin_panel_82"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_map_selection_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_2"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_start_map, "$g_multiplayer_selected_map", "$g_multiplayer_game_type"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_3"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_num_bots_in_team, 1, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_4"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_num_bots_in_team, 2, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_5"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_friendly_fire, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_6"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_respawn_period, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_7"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_game_max_minutes, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_8"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_game_max_points, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_9"),
        (multiplayer_send_string_to_server, multiplayer_event_admin_set_game_password, s0),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_10"),
        (neq, "$g_multiplayer_game_type", ":value"),
        (assign, "$g_multiplayer_game_type", ":value"),
        (call_script, "script_set_default_values_for_game_mode"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_11"),
        (store_sub,":num_factions_sub_1",factions_end,factions_begin),
        (val_sub,":num_factions_sub_1",1),
        (store_sub,":value",":num_factions_sub_1",":value"),
        (store_add, "$g_multiplayer_next_team_1_faction", ":value", factions_begin),
        
##        (try_begin),
##          (ge, "$g_multiplayer_next_team_1_faction", "$g_multiplayer_next_team_2_faction"),
##          (val_add, "$g_multiplayer_next_team_1_faction", 1),
##        (try_end),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_team_faction, 1, "$g_multiplayer_next_team_1_faction"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_12"),
        (store_sub,":num_factions_sub_1",factions_end,factions_begin),
        (val_sub,":num_factions_sub_1",1),
        (store_sub,":value",":num_factions_sub_1",":value"),
        (store_add, "$g_multiplayer_next_team_2_faction", ":value", factions_begin),
##        (try_begin),
##          (ge, "$g_multiplayer_next_team_2_faction", "$g_multiplayer_next_team_1_faction"),
##          (val_add, "$g_multiplayer_next_team_2_faction", 1),
##        (try_end),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_team_faction, 2, "$g_multiplayer_next_team_2_faction"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_13"),
        (presentation_set_duration, 0),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_15"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_control_block_dir, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_16"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_round_max_seconds, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_17"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_point_gained_from_flags, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_18"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_point_gained_from_capturing_flag, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_19"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_ghost_mode, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_20"),
        (multiplayer_send_string_to_server, multiplayer_event_admin_set_server_name, s0),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_22"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_num_bots_voteable, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_23"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_factions_voteable, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_24"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_maps_voteable, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_25"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_player_respawn_as_bot, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_26"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_combat_speed, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_27"),
        (store_sub, ":value_to_send", 10, ":value"), #opposite index of displayed list
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_respawn_count, ":value_to_send"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_28"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_kick_voteable, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_29"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_ban_voteable, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_30"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_valid_vote_ratio, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_31"),
        (try_begin),
          (eq, ":value", 0),
          (multiplayer_send_int_to_server, multiplayer_event_admin_set_auto_team_balance_limit, 1000),
        (else_try),
          (store_sub, ":value_to_send", 7, ":value"),
          (multiplayer_send_int_to_server, multiplayer_event_admin_set_auto_team_balance_limit, ":value_to_send"),
        (try_end),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_32"),
        (server_set_welcome_message, s0),
        (multiplayer_send_string_to_server, multiplayer_event_admin_set_welcome_message, s0),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_36"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_melee_friendly_fire, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_37"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_friendly_fire_damage_self_ratio, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_38"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_friendly_fire_damage_friend_ratio, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_39"),
        (multiplayer_send_int_to_server, multiplayer_event_admin_set_allow_player_banners, ":value"),
      # Vincenzo begin
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_auto_kick"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_auto_kick, ":value"),
        (assign,"$g_auto_kick", ":value"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_max_teamkills_before_kick"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_max_teamkills_before_kick, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_auto_horse"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_auto_horse, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_auto_swap"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_auto_swap, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_43"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_use_class_limits, ":value"),
        (assign,"$g_use_class_limits", ":value"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_44"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_grenadier, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_45"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_skirmisher, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_46"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_cavalry, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_47"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_musician, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_48"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_sergeant, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_49"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_officer, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_50"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_general, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_51"),
        (multiplayer_get_my_player,":my_player"),
        (gt,":my_player",-1), # only when server is actually running.
        (presentation_set_duration, 0),
        (multiplayer_send_message_to_server, multiplayer_event_reset_map),
      # Vincenzo end
      # Beaver begin
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_52"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_squad_size, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_53"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_scale_squad, ":value"),
      # Beaver end
      # buildpoints.
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_54"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_build_points_1, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_55"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_build_points_2, ":value"),
      # double gunning..
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_56"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_allow_multiple_firearms, ":value"),        
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_75"),#patch1115 60/11
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_groupfight_mode, ":value"),
      #G:comp_score:presentation start
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_78"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_competitive_score_mode, ":value"),
      #G:comp_score:presentation end
      # bonuses
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_57"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_enable_bonuses, ":value"),
        (assign,"$g_bonuses_enabled",":value"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_58"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_class_limit_player_count, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_59"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_rifle, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_60"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_lancer, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_61"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_hussar, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_62"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_dragoon, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_63"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_cuirassier, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_64"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_heavycav, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_65"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_rocket, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_66"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_sapper, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_67"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_artillery, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_68"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_fall_off_horse, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_69"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_horse_dying, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_70"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_bonus_strength, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_71"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_bonus_range, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_72"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_max_num_bots, ":value"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_73"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_no_rambo, ":value"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_74"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_surgeon, ":value"),#patch1115 59/13
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_76"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_line_inf_spread, ":value"),#patch1115 63/6
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_77"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_num_custom_maps, ":value"),#patch1115 64/3
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_79"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_no_rambo_range, ":value"),#patch1115 64/3
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_80"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_limit_arty_train, ":value"),#patch1115 59/13
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_panel_81"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_auto_ff, ":value"),#patch1115 59/13
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
      (try_begin),
        (eq,"$g_presentation_admin_panel_restart",1),
        (assign,"$g_presentation_admin_panel_restart",0),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
      (try_end),
     
      (try_begin),
        (key_clicked, key_escape),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_welcome_message", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_scene_making),
        (str_store_string, s0,"str_scene_making_welcome_message"),
      (else_try),
        (str_store_welcome_message, s0),
      (try_end),
      (try_begin),
        (neg|str_is_empty, s0),
        (eq, "$g_multiplayer_welcome_message_shown", 0),
        (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
        (position_set_x, pos1, 200),
        (position_set_y, pos1, 400),
        (overlay_set_position, reg0, pos1),
        (create_text_overlay, reg0, s0, tf_scrollable),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 230),
        (position_set_y, pos1, 425),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 540),
        (position_set_y, pos1, 150),
        (overlay_set_area_size, reg0, pos1),

        (presentation_set_duration, 999999),
      (else_try),
        (eq, "$g_multiplayer_show_server_rules", 1),
        (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
        (position_set_x, pos1, 200),
        (position_set_y, pos1, 400),
        (overlay_set_position, reg0, pos1),
        (try_begin),
          (neg|str_is_empty, s0),
          (str_clear, s3),
          (str_store_string, s2, s0),
          (str_store_string, s2, "str_s2_s3"),
          (str_store_string, s2, "str_s2_s3"),
        (else_try),
          (str_clear, s2),
        (try_end),
        (str_store_string, s3, "str_game_rules"),
        (str_store_string, s2, "str_s2_s3"),
        (assign, ":end_cond", 1000),
        (call_script, "script_game_multiplayer_get_game_type_mission_template", "$g_multiplayer_game_type"),
        (assign, ":cur_mt", reg0),
        
        (str_store_server_name, s0),
        (str_store_string, s3, "str_server_name_s0"),
        (str_store_string, s2, "str_s2_s3"),        

        (try_begin),                
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_deathmatch),
          (str_store_string, s0, "str_multi_game_type_1"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_team_deathmatch),
          (str_store_string, s0, "str_multi_game_type_2"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
          (str_store_string, s0, "str_multi_game_type_3"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
          (str_store_string, s0, "str_multi_game_type_5"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
          (str_store_string, s0, "str_multi_game_type_6"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
          (str_store_string, s0, "str_multi_game_type_7"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_duel),
          (str_store_string, s0, "str_multi_game_type_8"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (str_store_string, s0, "str_multi_game_type_9"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_king),
          (str_store_string, s0, "str_multi_game_type_10"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_royale),
          (str_store_string, s0, "str_multi_game_type_11"),
        (else_try),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_scene_making),
          (str_store_string, s0, "str_multi_game_type_12"),
        (try_end),
        (str_store_string, s3, "str_game_type_s0"),
        (str_store_string, s2, "str_s2_s3"),   
        
        (str_store_troop_name,s0,"trp_scene_name_dummy"),
        (str_store_string, s3, "str_map_name_s0"),
        (str_store_string, s2, "str_s2_s3"),
        
        (store_mission_timer_a, ":mission_timer"),
        (val_add, ":mission_timer", "$server_mission_timer_while_player_joined"),
        (assign, reg0, ":mission_timer"),       
        (store_mul, "$g_multiplayer_game_max_seconds", "$g_multiplayer_game_max_minutes", 60),
        (store_sub, ":remaining_seconds", "$g_multiplayer_game_max_seconds", ":mission_timer"),
        (store_div, reg0, ":remaining_seconds", 60),
        (store_mod, reg1, ":remaining_seconds", 60),
        (try_begin),
          (ge, reg0, 10),
          (ge, reg1, 10),          
          (str_clear, s0),
          (str_clear, s1),
        (else_try),  
          (ge, reg0, 10),
          (str_clear, s0),
          (str_store_string, s1, "@0"),
        (else_try),  
          (ge, reg1, 10),
          (str_store_string, s0, "@0"),
          (str_clear, s1),
        (else_try),  
          (str_store_string, s0, "@0"),
          (str_store_string, s1, "@0"),
        (try_end),
        (str_store_string, s3, "str_remaining_time_s0reg0_s1reg1"),
        
        (str_store_string, s2, "str_s2_s3"),

        (try_for_range, ":cur_option", 0, ":end_cond"),
          (assign, reg0, -12345), #magic number
          (call_script, "script_game_get_multiplayer_server_option_for_mission_template", ":cur_mt", ":cur_option"),
          (try_begin),
            (eq, reg0, -12345),
            (assign, ":end_cond", 0),
          (else_try),
            (call_script, "script_game_multiplayer_server_option_for_mission_template_to_string", ":cur_mt", ":cur_option", reg0),
            (str_store_string, s3, s0),
            (str_store_string, s2, "str_s2_s3"),
          (try_end),
        (try_end),        
        (create_text_overlay, reg0, s2, tf_scrollable),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 230),
        (position_set_y, pos1, 425),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 540),
        (position_set_y, pos1, 150),
        (overlay_set_area_size, reg0, pos1),

        (presentation_set_duration, 999999),
      (try_end),
      ]),

    (ti_on_presentation_run,
     [
       (str_store_welcome_message, s0),
       (try_begin),
         (neq, "$g_multiplayer_show_server_rules", 1),
         (this_or_next|str_is_empty, s0),
         (eq, "$g_multiplayer_welcome_message_shown", 1),
         (presentation_set_duration, 0),
         (neg|is_presentation_active, "prsnt_multiplayer_escape_menu"),
         (neg|is_presentation_active, "prsnt_multiplayer_team_select"),
         (start_presentation, "prsnt_multiplayer_team_select"),
       (else_try),
         (store_mission_timer_a, ":mission_timer"),
         (gt, ":mission_timer", 1),
         (this_or_next|key_clicked, key_escape),
         (this_or_next|key_clicked, key_space),
         (this_or_next|key_clicked, key_enter),
         (this_or_next|key_clicked, key_left_mouse_button),
         (key_clicked, key_right_mouse_button),
         (assign, "$g_multiplayer_welcome_message_shown", 1),
         (presentation_set_duration, 0),
         (neg|is_presentation_active, "prsnt_multiplayer_escape_menu"),
         (neg|is_presentation_active, "prsnt_multiplayer_team_select"),
         (try_begin),
           (eq, "$g_multiplayer_show_server_rules", 1),
           (assign, "$g_multiplayer_show_server_rules", 0),
           (start_presentation, "prsnt_multiplayer_escape_menu"),
         (else_try),
           (start_presentation, "prsnt_multiplayer_team_select"),
         (try_end),
       (try_end),
      ]),
    ]),

  ("multiplayer_team_select", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (multiplayer_get_my_player, ":my_player_no"),
      (try_begin),
        (neg|player_is_active,":my_player_no"),
        (presentation_set_duration, 0),
      (try_end),
      
      (player_is_active,":my_player_no"),
      (player_get_team_no,":my_team_no",":my_player_no"),
      #(player_get_troop_id,":cur_troop",":my_player_no"),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 180),
      (position_set_y, pos1, 230),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 2200),
      (overlay_set_size, reg0, pos1),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 520),
      (position_set_y, pos1, 230),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 2200),
      (overlay_set_size, reg0, pos1),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 350),
      (position_set_y, pos1, 65),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_team_select_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, 0),#90
      (overlay_set_position, "$g_presentation_obj_team_select_container", pos1),
      (position_set_x, pos1, 1150),
      (position_set_y, pos1, 650),#560
      (overlay_set_area_size, "$g_presentation_obj_team_select_container", pos1),
      (set_container_overlay, "$g_presentation_obj_team_select_container"),
      

      (try_begin),
        (eq, "$g_multiplayer_team_1_faction", "fac_britain"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_bri"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_france"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_fra"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_prussia"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_pru"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_russia"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_rus"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_austria"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_aus"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_rhine"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_rhi"),
      (try_end),

      (position_set_x, pos1, 325),
      (position_set_y, pos1, 550),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 100),
      (position_set_y, pos1, 100),
      (overlay_set_size, reg0, pos1),   

      (try_begin),
        (eq, "$g_multiplayer_team_2_faction", "$g_multiplayer_team_1_faction"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_reb"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_britain"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_bri"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_france"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_fra"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_prussia"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_pru"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_russia"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_rus"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_austria"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_aus"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_rhine"),
        (create_mesh_overlay, reg0, "mesh_ui_team_select_shield_rhi"),
      (try_end),

      (position_set_x, pos1, 665),
      (position_set_y, pos1, 550),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 100),
      (position_set_y, pos1, 100),
      (overlay_set_size, reg0, pos1),   
      
      (team_get_faction, ":faction_no", 0),
      (str_store_faction_name, s0, ":faction_no"),
      (store_sub,":faction_name_translated",":faction_no",factions_begin),
      (val_add,":faction_name_translated",faction_name_strings_begin),
      (str_store_string,s1,":faction_name_translated"),
      #(create_button_overlay, "$g_presentation_obj_team_select_1", s0, 0),
      (assign,":x_offset",298),
      (try_begin),
        (eq,":my_team_no",0),
        (create_button_overlay, "$g_presentation_obj_team_select_1", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1", 0xECEB82),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_1", 0x55FF50),
        (assign, "$g_multiplayer_team_select_1_available", 1),
        (create_text_overlay, "$g_presentation_obj_team_select_1_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1_1", 0xECEB82),
      (else_try),
        (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 0),
        (create_button_overlay, "$g_presentation_obj_team_select_1", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1", 0xFFFFFF),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_1", 0x55FF50),
        (assign, "$g_multiplayer_team_select_1_available", 1),
        (create_text_overlay, "$g_presentation_obj_team_select_1_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1_1", 0xFFFFFF),
      (else_try),
        (create_text_overlay, "$g_presentation_obj_team_select_1", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1", 0x888888),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_1", 0x888888),
        (assign, "$g_multiplayer_team_select_1_available", 0),
        (create_text_overlay, "$g_presentation_obj_team_select_1_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_1_1", 0x888888),
        (val_add,":x_offset",26),
      (try_end),
      (position_set_x, pos1, ":x_offset"),
      (position_set_y, pos1, 455),
      (overlay_set_position, "$g_presentation_obj_team_select_1", pos1),
      (position_set_x, pos1, 1600),
      (position_set_y, pos1, 1600),
      (overlay_set_size, "$g_presentation_obj_team_select_1", pos1),
      (position_set_x, pos1, 330),
      (position_set_y, pos1, 425),
      (overlay_set_position, "$g_presentation_obj_team_select_1_1", pos1),
      (position_set_x, pos1, 900),
      (position_set_y, pos1, 900),
      (overlay_set_size, "$g_presentation_obj_team_select_1_1", pos1),

      (team_get_faction, ":faction_no", 1),
      (str_store_faction_name, s0, ":faction_no"),
      (store_sub,":faction_name_translated",":faction_no",factions_begin),
      (val_add,":faction_name_translated",faction_name_strings_begin),
      (str_store_string,s1,":faction_name_translated"),
      #(create_button_overlay, "$g_presentation_obj_team_select_2", s0, 0),
      (assign,":x_offset",638),
      (try_begin),
        (eq,":my_team_no",1),
        (create_button_overlay, "$g_presentation_obj_team_select_2", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2", 0xECEB82),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_2", 0x55FF50),
        (assign, "$g_multiplayer_team_select_2_available", 1),
        (create_text_overlay, "$g_presentation_obj_team_select_2_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2_1", 0xECEB82),
      (else_try),
        (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 1),
        (create_button_overlay, "$g_presentation_obj_team_select_2", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2", 0xFFFFFF),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_2", 0x55FF50),
        (assign, "$g_multiplayer_team_select_2_available", 1),
        (create_text_overlay, "$g_presentation_obj_team_select_2_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2_1", 0xFFFFFF),
      (else_try),
        (create_text_overlay, "$g_presentation_obj_team_select_2", s0, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2", 0x888888),
        (overlay_set_hilight_color, "$g_presentation_obj_team_select_2", 0x888888),
        (assign, "$g_multiplayer_team_select_2_available", 0),
        (create_text_overlay, "$g_presentation_obj_team_select_2_1", s1, tf_center_justify),
        (overlay_set_color, "$g_presentation_obj_team_select_2_1", 0x888888),
        (val_add,":x_offset",26),
      (try_end),
      (position_set_x, pos1, ":x_offset"),
      (position_set_y, pos1, 455),
      (overlay_set_position, "$g_presentation_obj_team_select_2", pos1),
      (position_set_x, pos1, 1600),
      (position_set_y, pos1, 1600),
      (overlay_set_size, "$g_presentation_obj_team_select_2", pos1),
      (position_set_x, pos1, 670),
      (position_set_y, pos1, 425),
      (overlay_set_position, "$g_presentation_obj_team_select_2_1", pos1),
      (position_set_x, pos1, 900),
      (position_set_y, pos1, 900),
      (overlay_set_size, "$g_presentation_obj_team_select_2_1", pos1),
            
      (create_button_overlay, "$g_presentation_obj_team_select_3", "str_spectator", tf_center_justify),
      (overlay_set_color, "$g_presentation_obj_team_select_3", 0xFFFFFF),
      (overlay_set_hilight_color, "$g_presentation_obj_team_select_3", 0x55FF50),
      (position_set_x, pos1, 480),
      (position_set_y, pos1, 80),
      (overlay_set_position, "$g_presentation_obj_team_select_3", pos1),
      (position_set_x, pos1, 1400),
      (position_set_y, pos1, 1400),
      (overlay_set_size, "$g_presentation_obj_team_select_3", pos1),
            
      (create_button_overlay, "$g_presentation_obj_team_select_4", "str_auto_assign", tf_center_justify),
      (overlay_set_color, "$g_presentation_obj_team_select_4", 0xFFFFFF),
      (overlay_set_hilight_color, "$g_presentation_obj_team_select_4", 0x55FF50),
      (position_set_x, pos1, 480),
      (position_set_y, pos1, 130),
      (overlay_set_position, "$g_presentation_obj_team_select_4", pos1),
      (position_set_x, pos1, 1400),
      (position_set_y, pos1, 1400),
      (overlay_set_size, "$g_presentation_obj_team_select_4", pos1),

      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (position_set_x, pos1, 190),
      (position_set_y, pos1, 410),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 14000),
      (position_set_y, pos1, 200),
      (overlay_set_size, reg0, pos1),
      
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (position_set_x, pos1, 530),
      (position_set_y, pos1, 410),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 14000),
      (position_set_y, pos1, 200),
      (overlay_set_size, reg0, pos1),
      
      #Showing some stats
      (call_script,"script_get_playercounts_for_scoreboard"),
      #(assign,":total_player_count",reg50),
      (assign,":team1_total",reg51),
      (assign,":team1_alive",reg52),
      (assign,":team1_dead",reg53),
      (assign,":team2_total",reg54),
      (assign,":team2_alive",reg55),
      (assign,":team2_dead",reg56),
      (assign,":spectator_count",reg57),
      
      (assign,":sub_y",60),
      (assign,":cur_y",360),
      (assign,":cur_x_1",235),
      (assign,":cur_x_2",575),
      
      (assign,reg0,":team1_total"),
      (try_begin),
        (eq,":team1_total",1),
        (str_store_string,s0,"str_reg0_player_only"),
      (else_try),
        (str_store_string,s0,"str_reg0_players_only"),
      (try_end),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_1"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
      
      (assign,reg0,":team2_total"),
      (try_begin),
        (eq,":team2_total",1),
        (str_store_string,s0,"str_reg0_player_only"),
      (else_try),
        (str_store_string,s0,"str_reg0_players_only"),
      (try_end),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_2"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
      
      (val_sub,":cur_y",":sub_y"),
      
      (assign,reg0,":team1_alive"),
      (str_store_string,s0,"str_reg0_alive"),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_1"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
      
      (assign,reg0,":team2_alive"),
      (str_store_string,s0,"str_reg0_alive"),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_2"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
      
      (val_sub,":cur_y",":sub_y"),
      
      (assign,reg0,":team1_dead"),
      (str_store_string,s0,"str_reg0_dead"),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_1"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
      
      (assign,reg0,":team2_dead"),
      (str_store_string,s0,"str_reg0_dead"),
      (create_text_overlay, reg1, s0, 0),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x_2"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1300),
      (position_set_y, pos1, 1300),
      (overlay_set_size, reg1, pos1),
        
      (assign,reg0,":spectator_count"),
      (try_begin),
        (eq,":spectator_count",1),
        (str_store_string,s0,"str_reg0_spectator"),
      (else_try),
        (str_store_string,s0,"str_reg0_spectators"),
      (try_end),
      (create_text_overlay, reg1, s0, tf_center_justify),
      (overlay_set_color, reg1, 0xFFFFFF),
      (position_set_x, pos1, 490),
      (position_set_y, pos1, 55),
      (overlay_set_position, reg1, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg1, pos1),
      
      (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (multiplayer_get_my_player, ":my_player_no"),
      #(player_get_team_no,":my_team_no",":my_player_no"),
      #(player_get_troop_id,":cur_troop",":my_player_no"),
      (try_begin),
        (eq, "$g_waiting_for_confirmation_to_terminate", 0),
        (try_begin),
          (eq, ":object", "$g_presentation_obj_team_select_1"),
          (try_begin),
            (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 0),
            (try_begin),
              (player_get_team_no, ":my_team", ":my_player_no"),
              (neq, ":my_team", 0),
              (assign, "$g_confirmation_result", 0),
              (assign, "$g_waiting_for_confirmation_to_terminate", 1),
              (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
              (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
              (player_set_troop_id, ":my_player_no", -1),
              (multiplayer_send_int_to_server, multiplayer_event_change_team_no, 0),
              (store_mission_timer_a, ":player_last_team_select_time"),         
              (player_set_slot, ":my_player_no", slot_player_last_team_select_time, ":player_last_team_select_time"),
              (player_set_team_no, ":my_player_no", 0),
            (else_try),
              (presentation_set_duration, 0),
              (try_begin),
                (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
                (start_presentation, "prsnt_multiplayer_troop_select"),
              (else_try),
                (start_presentation, "prsnt_multiplayer_item_select"),
              (try_end),
            (try_end),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_team_select_2"),
          (try_begin),
            (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 1),
            (try_begin),
              (player_get_team_no, ":my_team", ":my_player_no"),
              (neq, ":my_team", 1),
              (assign, "$g_confirmation_result", 0),
              (assign, "$g_waiting_for_confirmation_to_terminate", 1),
              (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
              (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
              (player_set_troop_id, ":my_player_no", -1),
              (multiplayer_send_int_to_server, multiplayer_event_change_team_no, 1),
              (store_mission_timer_a, ":player_last_team_select_time"),         
              (player_set_slot, ":my_player_no", slot_player_last_team_select_time, ":player_last_team_select_time"),
              (player_set_team_no, ":my_player_no", 1),
            (else_try),
              (presentation_set_duration, 0),
              (try_begin),
                (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
                (start_presentation, "prsnt_multiplayer_troop_select"),
              (else_try),
                (start_presentation, "prsnt_multiplayer_item_select"),
              (try_end),
            (try_end),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_team_select_3"),
          (player_set_troop_id, ":my_player_no", -1),
          (multiplayer_send_int_to_server, multiplayer_event_change_team_no, multi_team_spectator),
          (player_set_team_no, ":my_player_no", multi_team_spectator),
          (presentation_set_duration, 0),
        (else_try),
          (eq, ":object", "$g_presentation_obj_team_select_4"),
          (try_begin),
            (player_get_team_no, ":my_team", ":my_player_no"),
            (call_script, "script_return_team_with_least_players", ":my_player_no"),
            (assign,":auto_team",reg0),
            (try_begin),
              (eq,":auto_team",-1), #Teams have equal players
              (try_begin),
                (is_between,":my_team",0,2), #Already have a team?
                (assign,":auto_team",":my_team"), #Assign me as that team
              (else_try),
                (store_random_in_range,":auto_team",0,2), #Else simply assign me to a random team
              (try_end),
            (try_end),
            (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", ":auto_team"),
            (try_begin),
              (neq, ":my_team", ":auto_team"),
              (assign, "$g_confirmation_result", 0),
              (assign, "$g_waiting_for_confirmation_to_terminate", 1),
              (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
              (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
              (player_set_troop_id, ":my_player_no", -1),
              (multiplayer_send_int_to_server, multiplayer_event_change_team_no, ":auto_team"),
              (store_mission_timer_a, ":player_last_team_select_time"),         
              (player_set_slot, ":my_player_no", slot_player_last_team_select_time, ":player_last_team_select_time"),
              (player_set_team_no, ":my_player_no", ":auto_team"),
            (else_try),
              (presentation_set_duration, 0),
              (try_begin),
                (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
                (start_presentation, "prsnt_multiplayer_troop_select"),
              (else_try),
                (start_presentation, "prsnt_multiplayer_item_select"),
              (try_end),
            (try_end),
          (try_end),
        (try_end),
      (try_end),
      ]),

    (ti_on_presentation_run,
     [
      (multiplayer_get_my_player, ":my_player_no"),
      (multiplayer_get_my_team, ":my_team"),
      #(team_get_faction,":my_faction_no",":my_team"),
      
      (assign, ":do_refresh", 0),
      (try_begin),
        (key_clicked, key_escape),
        (try_begin),
          (this_or_next|eq, "$g_waiting_for_confirmation_to_terminate", 1),
          (eq, ":my_team", multi_team_unassigned),
          (player_set_troop_id, ":my_player_no", -1),
          (multiplayer_send_int_to_server, multiplayer_event_change_team_no, multi_team_spectator),
          (player_set_team_no, ":my_player_no", multi_team_spectator),
          (assign,"$g_current_selected_rank",0),
          (assign,"$g_waiting_for_confirmation_to_terminate",0),
        (try_end),
        (presentation_set_duration, 0),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        #(display_message,"@Awaiting confirmation to change troop..."),
        (eq, "$g_confirmation_result", 1),
        #(display_message,"@Request accepted!"),
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (assign, "$g_confirmation_result", 0),
        (presentation_set_duration, 0),
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (start_presentation, "prsnt_multiplayer_troop_select"),
        (else_try),
        
          (assign,":faction_base_troop", -1),
          (team_get_faction,":my_faction",":my_team"),
          (try_begin),
            (eq,":my_faction","fac_britain"),
            (assign,":faction_base_troop", "trp_british_infantry"),
          (else_try),
            (eq,":my_faction","fac_france"),
            (assign,":faction_base_troop", "trp_french_infantry"),
          (else_try),
            (eq,":my_faction","fac_prussia"),
            (assign,":faction_base_troop", "trp_prussian_infantry"),
          (else_try),
            (eq,":my_faction","fac_russia"),
            (assign,":faction_base_troop", "trp_russian_infantry"),
          (else_try),
            (eq,":my_faction","fac_austria"),
            (assign,":faction_base_troop", "trp_austrian_infantry"),
          (else_try),
            (eq,":my_faction","fac_rhine"),
            (assign,":faction_base_troop", "trp_rhine_infantry_bavaria"),
          (try_end),
          (player_set_troop_id, ":my_player_no", ":faction_base_troop"),
          (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":faction_base_troop"),
          (assign,"$g_current_selected_rank",1),
          (try_begin),
            (gt,":faction_base_troop",-1),
            (troop_get_slot,":faction_base_troop_class",":faction_base_troop",slot_troop_class),
            (this_or_next|eq, ":faction_base_troop_class", multi_troop_class_mm_artillery),
            (eq, ":faction_base_troop_class", multi_troop_class_mm_rocket),
            (call_script, "script_random_item_selection", ":faction_base_troop",0, ":my_player_no"),  #patch1115 fix 17/22
          (else_try),
            (call_script, "script_random_item_selection", ":faction_base_troop",1, ":my_player_no"),  #patch1115 fix 17/21
          (try_end),
          (call_script, "script_multiplayer_send_item_selections"),
          (assign,"$g_original_selected_troop", ":faction_base_troop"),
          
          (start_presentation, "prsnt_multiplayer_item_select"),
        (try_end),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        (eq, "$g_confirmation_result", -1),

        #return troop and team back to the old state
        #(player_set_troop_id, ":my_player_no", "$g_confirmation_troop_backup"),
        #(player_set_team_no, ":my_player_no", "$g_confirmation_team_backup"), 
        #(assign, "$g_waiting_for_confirmation_to_terminate", 0),
        #(assign, "$g_confirmation_result", 0),
        (player_set_troop_id, ":my_player_no", -1),
        (multiplayer_send_int_to_server, multiplayer_event_change_team_no, multi_team_spectator),
        (player_set_team_no, ":my_player_no", multi_team_spectator),
        (assign,"$g_current_selected_rank",0),
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_team_select"),
      (else_try),
        (try_begin),
          (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 0),
          (try_begin),
            (eq, "$g_multiplayer_team_select_1_available", 0),
            (assign, ":do_refresh", 1),
          (try_end),
        (else_try),
         # not available
          (try_begin),
            (eq, "$g_multiplayer_team_select_1_available", 1),
            (assign, ":do_refresh", 1),
          (try_end),
        (try_end),
        (try_begin),
          (eq,":do_refresh",0),
          (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 1),
          (try_begin),
            (eq, "$g_multiplayer_team_select_2_available", 0),
            (assign, ":do_refresh", 1),
          (try_end),
        (else_try),
         # not available
          (try_begin),
            (eq, "$g_multiplayer_team_select_2_available", 1),
            (assign, ":do_refresh", 1),
          (try_end),
        (try_end),
        
        (try_begin),
          (eq, ":do_refresh", 1),
          (assign,"$g_should_do_refresh",1),
        (else_try),
          (store_mission_timer_a, ":current_time"),                            
          (store_sub, ":elapsed_time", ":current_time", "$g_last_refresh_at"),  #Even if no refresh due to team availiblity
          (ge, ":elapsed_time", 10),                                            #Still refresh every 10 sec to correct stats
          (assign,"$g_should_do_refresh",1),
        (try_end),
        
        (eq,"$g_should_do_refresh",1),
        
        (store_mission_timer_a, ":current_time"),
        (store_sub, ":elapsed_time", ":current_time", "$g_last_refresh_at"),
        (ge, ":elapsed_time", 1), # last refresh more then 1 seconds ago. 
        
        (assign,"$g_should_do_refresh",0),
        
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_team_select"),
        
        (store_mission_timer_a, "$g_last_refresh_at"),
      (try_end),
      ]),
    ]),
  
  ("multiplayer_troop_select", prsntf_manual_end_only, 0, [ #MM
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (assign,":continue",1),
      (try_begin),
        (neq, "$g_multiplayer_game_type", multiplayer_game_type_commander), #presentation only for commander mode
        (presentation_set_duration, 0),
        (assign,":continue",0),
      (try_end),
      (eq,":continue",1),
      
      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 450), #250
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750), #550 #1000
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 180),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 300),
      (position_set_y, pos1, 2000),
      (overlay_set_size, reg0, pos1),
      
      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_troop_select_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 370), #285
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_troop_select_container", pos1),
      (position_set_x, pos1, 405), #305 #405
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_troop_select_container", pos1),
      (set_container_overlay, "$g_presentation_obj_troop_select_container"),

      (assign, ":cur_y", 900),
      (assign, ":sub_y", 40),
      (assign, ":sub_y2", 15),

      (create_text_overlay, reg0, "str_choose_a_troop", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 100), #0
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, reg0, pos1),
      (val_sub, ":cur_y", ":sub_y"),
      (position_set_y, pos1, ":cur_y"),
      (position_set_x, pos1, 100),

      (multiplayer_get_my_player, ":my_player_no"),
      (player_get_team_no, ":my_team_no", ":my_player_no"),
      (team_get_faction, ":my_faction_no", ":my_team_no"),
      (try_for_range, ":i_multi", multi_data_troop_button_indices_begin, multi_data_troop_button_indices_end),
        (troop_set_slot, "trp_multiplayer_data", ":i_multi", -1),
      (try_end),
      (try_for_range, ":i_multi", multi_data_troop_display_indices_begin, multi_data_troop_display_indices_end),
        (troop_set_slot, "trp_multiplayer_data", ":i_multi", -1),
      (try_end),
      
      (player_get_slot,":selected_bot_type",":my_player_no",slot_player_bot_type_wanted),
      
      (assign, ":cur_troop_index", 0),
      (try_for_range, ":troop_no", multiplayer_ai_troops_begin, multiplayer_ai_troops_end),
        (store_troop_faction, ":troop_faction", ":troop_no"),
        (eq, ":troop_faction", ":my_faction_no"),
        (str_store_troop_name_plural, s1, ":troop_no"),
        #patch1115 52/1 start
        (try_begin),
          (eq,":selected_bot_type",":troop_no"),
          (assign, ":colour", 0xECEB82),
          (create_button_overlay, reg52, s1, 0),
        (else_try), 
          (call_script,"script_check_troop_availability",":troop_no",":my_player_no",0),
          (assign,":class_ok",reg3),
          (try_begin),
            (eq,":class_ok",1),
            (troop_set_slot,"trp_troop_check_dummy",":troop_no",1),
            (create_button_overlay, reg52, s1, 0),
            (assign,":colour",0xFFFFFF),
          (else_try),
            (troop_set_slot,"trp_troop_check_dummy",":troop_no",0),
            (create_text_overlay, reg52, s1, 0),
            (assign,":colour",0x888888),
          (try_end),
        (try_end),
        (overlay_set_color, reg52, ":colour"),
        (store_add, ":button_index_slot", ":cur_troop_index", multi_data_troop_button_indices_begin),
        (troop_set_slot, "trp_multiplayer_data", ":button_index_slot", reg52),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg52, pos1), #patch1115 52/1 end
        (val_sub, ":cur_y", ":sub_y2"),
        (position_set_y, pos1, ":cur_y"),
        
        (call_script, "script_get_num_players_of_troop_cb", ":troop_no", ":my_team_no"),
        (try_begin),
          (eq,reg0,1),
          (create_text_overlay, reg13, "str_reg0_player_only", 0),
        (else_try),
          (create_text_overlay, reg13, "str_reg0_players_only", 0),
        (try_end),
        (copy_position,pos3,pos1),
        (position_set_x, pos3, 110),
        (overlay_set_position, reg13, pos3),
        (position_set_x, pos3, 750),
        (position_set_y, pos3, 750),
        (overlay_set_size, reg13, pos3),
        (overlay_set_color, reg13, ":colour"),
        (val_sub, ":cur_y", ":sub_y"),
        (position_set_y, pos1, ":cur_y"),
        
        (store_mul,":troop_view",":troop_no", 2), #with weapons
        (create_mesh_overlay_with_tableau_material, reg1, -1, "tableau_game_party_window", ":troop_view"),
        (overlay_set_container_overlay, reg1, -1),
        (position_set_x, pos2, 150),
        (position_set_y, pos2, 200),
        (overlay_set_position, reg1, pos2),
        (position_set_x, pos2, 1200),
        (position_set_y, pos2, 1200),
        (overlay_set_size, reg1, pos2),
        (overlay_set_display, reg1, 0),
        (store_add, ":button_index_slot", ":cur_troop_index", multi_data_troop_display_indices_begin),
        (troop_set_slot, "trp_multiplayer_data", ":button_index_slot", reg1),
      
        (val_add, ":cur_troop_index", 1),
      (try_end),
          
      (presentation_set_duration, 999999),
      ]),
   
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (multiplayer_get_my_player, ":my_player_no"),
      (player_get_team_no, ":my_team_no", ":my_player_no"),
      (team_get_faction, ":my_faction_no", ":my_team_no"),
      (assign, ":selected_troop_no", -1),
      (assign, ":selected_troop_bot_type_wanted_no", -1),
      (assign, ":end_cond", multi_data_troop_button_indices_end),
      (try_for_range, ":i_button", multi_data_troop_button_indices_begin, ":end_cond"),
        (troop_slot_eq, "trp_multiplayer_data", ":i_button", ":object"),
        (store_sub, ":selected_troop_index", ":i_button", multi_data_troop_button_indices_begin),
        (assign, ":end_cond_2", multiplayer_ai_troops_end),
        (try_for_range, ":troop_no", multiplayer_ai_troops_begin, ":end_cond_2"),
          (store_troop_faction, ":troop_faction", ":troop_no"),
          (eq, ":troop_faction", ":my_faction_no"),
          (val_sub, ":selected_troop_index", 1),
          (lt, ":selected_troop_index", 0),
          (troop_get_slot,":selected_troop_no",":troop_no",slot_troop_officer_troop),
          (player_set_slot,":my_player_no",slot_player_bot_type_wanted,":troop_no"),
          (assign, ":selected_troop_bot_type_wanted_no", ":troop_no"),
          #(assign, ":selected_troop_no", ":troop_no"),
          (assign, ":end_cond_2", 0), #break
        (try_end),
        (try_begin),
          (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":selected_troop_bot_type_wanted_no"),
          
          (multiplayer_get_my_troop, ":troop_no"),
          
          # MM
          (neq, ":troop_no", ":selected_troop_no"),
          (player_set_troop_id, ":my_player_no", ":selected_troop_no"),
          
          (try_begin),
            (gt,":selected_troop_no",-1),
            (troop_get_slot,":selected_troop_class",":selected_troop_no",slot_troop_class),
            (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
            (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
            (call_script, "script_random_item_selection", ":selected_troop_no",0, ":my_player_no"),  #patch1115 fix 17/20
          (else_try),
            (call_script, "script_random_item_selection", ":selected_troop_no",1, ":my_player_no"),  #patch1115 fix 17/19
          (try_end),
          (call_script, "script_multiplayer_send_item_selections"),
          (assign, "$g_original_selected_troop", ":selected_troop_no"),
        (try_end),
        (presentation_set_duration, 0),
        #(assign, "$g_presentation_state", 0),
        
        #(call_script, "script_multiplayer_get_troop_class", ":selected_troop_no"),
        #(assign, ":selected_troop_rank", reg1),
        
        (assign, ":end_cond", 0), #break
      (try_end),
      ]),
    (ti_on_presentation_mouse_enter_leave,
      [
      (store_trigger_param_1, ":object"),
      (store_trigger_param_2, ":enter_leave"),
      
      (assign, ":end_cond", multi_data_troop_button_indices_end),
      (try_for_range, ":i_button", multi_data_troop_button_indices_begin, ":end_cond"),
        (troop_slot_eq, "trp_multiplayer_data", ":i_button", ":object"),
        (store_sub, ":selected_troop_index", ":i_button", multi_data_troop_button_indices_begin),
        (store_add, ":display_object_slot", ":selected_troop_index", multi_data_troop_display_indices_begin),
        (troop_get_slot,":display_object","trp_multiplayer_data",":display_object_slot"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display,":display_object",1),
        (else_try),
          (overlay_set_display,":display_object",0),
        (try_end),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
     (try_begin),        
        (key_clicked, key_escape),
        (multiplayer_get_my_player, ":my_player_no"),
        (is_between, ":my_player_no", 0, multiplayer_max_possible_player_id),
        (multiplayer_get_my_troop, ":my_troop"),
        (try_begin),
          (neg|is_between, ":my_troop", multiplayer_troops_begin, multiplayer_troops_end),
          (player_set_troop_id, ":my_player_no", -1),
          (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, -1),
          (multiplayer_send_int_to_server, multiplayer_event_change_team_no, multi_team_spectator),
          (player_set_team_no, ":my_player_no", multi_team_spectator),
        (try_end),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_item_select", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

        ##Little Pos Helper begin
        # (create_text_overlay, "$g_little_pos_helper", "@Pos: 00x,00y ^Size: 00x,00y"),
        # (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        # (init_position,pos22),
        # (position_set_x, pos22, 10),
        # (position_set_y, pos22, 700),
        # (overlay_set_position, "$g_little_pos_helper", pos22),
        # (assign,"$g_reposition_object",-1),
        # (try_for_range,":object",-1,100), #A hundred objects should suffice?
          # (troop_set_slot,"trp_x_pos",":object",0),
          # (troop_set_slot,"trp_y_pos",":object",0),
          # (troop_set_slot,"trp_x_size",":object",0),
          # (troop_set_slot,"trp_y_size",":object",0),
        # (try_end),
        ##Little Pos Helper end
        
      (multiplayer_get_my_player, ":my_player_no"),
      (player_is_active,":my_player_no"),
      (player_get_team_no,":my_team_no",":my_player_no"),
      (player_get_troop_id,":cur_troop",":my_player_no"),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 70),
      (position_set_y, pos1, 20),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 755),
      (position_set_y, pos1, 1035),
      (overlay_set_size, reg0, pos1),
      (troop_set_slot,"trp_x_pos",reg0,70),
      (troop_set_slot,"trp_y_pos",reg0,20),
      (troop_set_slot,"trp_x_size",reg0,755),
      (troop_set_slot,"trp_y_size",reg0,1035),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 540),
      (position_set_y, pos1, 85),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 580),
      (position_set_y, pos1, 1215),
      (overlay_set_size, reg0, pos1),
      (troop_set_slot,"trp_x_pos",reg0,540),
      (troop_set_slot,"trp_y_pos",reg0,85),
      (troop_set_slot,"trp_x_size",reg0,580),
      (troop_set_slot,"trp_y_size",reg0,1215),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 540),
      (position_set_y, pos1, 335),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 1825),
      (overlay_set_size, reg0, pos1),
      (troop_set_slot,"trp_x_pos",reg0,540),
      (troop_set_slot,"trp_y_pos",reg0,335),
      (troop_set_slot,"trp_x_size",reg0,285),
      (troop_set_slot,"trp_y_size",reg0,1825),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 715),
      (position_set_y, pos1, 335),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 1825),
      (overlay_set_size, reg0, pos1),
      (troop_set_slot,"trp_x_pos",reg0,715),
      (troop_set_slot,"trp_y_pos",reg0,335),
      (troop_set_slot,"trp_x_size",reg0,285),
      (troop_set_slot,"trp_y_size",reg0,1825),
      
      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 70),
      (position_set_y, pos1, 235),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 755),
      (position_set_y, pos1, 2125),
      (overlay_set_size, reg0, pos1),
      (troop_set_slot,"trp_x_pos",reg0,70),
      (troop_set_slot,"trp_y_pos",reg0,235),
      (troop_set_slot,"trp_x_size",reg0,755),
      (troop_set_slot,"trp_y_size",reg0,2325),
      
      #(str_clear, s0),
      #(create_text_overlay, "$g_presentation_obj_team_select_container", s0, tf_scrollable_style_2),
      #(position_set_x, pos1, 0),
      #(position_set_y, pos1, 0),#90
      #(overlay_set_position, "$g_presentation_obj_team_select_container", pos1),
      #(position_set_x, pos1, 1000),
      #(position_set_y, pos1, 750),#560
      #(overlay_set_area_size, "$g_presentation_obj_team_select_container", pos1),
      #(set_container_overlay, "$g_presentation_obj_team_select_container"),
      
      #(create_button_overlay, "$g_presentation_obj_select_done", "@Done", 0),
      (try_begin),
        (eq,":cur_troop",-1),
        (assign,"$g_current_selected_rank",0),
      (try_end),
      # (call_script, "script_multiplayer_get_troop_class", ":cur_troop"),
      # (assign, ":selected_troop_rank", reg1),
      (create_in_game_button_overlay, "$g_presentation_obj_select_done", "str_done", 0),
      (position_set_x, pos1, 820),
      (position_set_y, pos1, 40),
      (overlay_set_position, "$g_presentation_obj_select_done", pos1),
      (overlay_set_color,"$g_presentation_obj_select_done",0xFFFFFF),
      #(position_set_x, pos1, 800),
      #(position_set_y, pos1, 1500),
      #(overlay_set_size, "$g_presentation_obj_select_done", pos1),
      (troop_set_slot,"trp_x_pos","$g_presentation_obj_select_done",800),
      (troop_set_slot,"trp_y_pos","$g_presentation_obj_select_done",40),
      (troop_set_slot,"trp_x_size","$g_presentation_obj_select_done",1000),
      (troop_set_slot,"trp_y_size","$g_presentation_obj_select_done",1000),
      
      (create_in_game_button_overlay, "$g_presentation_obj_select_back", "str_back", 0),
      (position_set_x, pos1, 620),
      (position_set_y, pos1, 40),
      (overlay_set_position, "$g_presentation_obj_select_back", pos1),
      (overlay_set_color,"$g_presentation_obj_select_back",0xFFFFFF),
      #(position_set_x, pos1, 1500),
      #(position_set_y, pos1, 1500),
      #(overlay_set_size, "$g_presentation_obj_select_back", pos1),
      (troop_set_slot,"trp_x_pos","$g_presentation_obj_select_back",540),
      (troop_set_slot,"trp_y_pos","$g_presentation_obj_select_back",40),
      (troop_set_slot,"trp_x_size","$g_presentation_obj_select_back",1000),
      (troop_set_slot,"trp_y_size","$g_presentation_obj_select_back",1000),
      
      ### REGIMENT SELECT ###
      
      (try_begin),
        #(is_between,":my_team_no",0,2), #Player has selected a team - load regiment presentation
        
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0x000000),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 110),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 5500),
        (position_set_y, pos1, 1600),
        (overlay_set_size, reg0, pos1),
          
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0x000000),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 240),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 5500),
        (position_set_y, pos1, 1600),
        (overlay_set_size, reg0, pos1),
          
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0x000000),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 370),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 5500),
        (position_set_y, pos1, 1600),
        (overlay_set_size, reg0, pos1),
          
        (create_button_overlay, "$g_presentation_obj_select_infantry", "str_infantry", 0),
        (try_begin),
          (eq, "$g_multiplayer_select_presentation_unit_type", troop_select_type_infantry),
          (overlay_set_color,"$g_presentation_obj_select_infantry",0xECEB82),
        (else_try),
          (overlay_set_color,"$g_presentation_obj_select_infantry",0xFFFFFF),
        (try_end),
        (position_set_x, pos1, 125),
        (position_set_y, pos1, 660),
        (overlay_set_position, "$g_presentation_obj_select_infantry", pos1),
        #(position_set_x, pos1, 1500),
        #(position_set_y, pos1, 1500),
        #(overlay_set_size, "$g_presentation_obj_select_infantry", pos1),
        (troop_set_slot,"trp_x_pos","$g_presentation_obj_select_infantry",100),
        (troop_set_slot,"trp_y_pos","$g_presentation_obj_select_infantry",660),
        (troop_set_slot,"trp_x_size","$g_presentation_obj_select_infantry",1000),
        (troop_set_slot,"trp_y_size","$g_presentation_obj_select_infantry",1000),
        
        (create_button_overlay, "$g_presentation_obj_select_cavalry", "str_cavalry", 0),
        (try_begin),
          (eq, "$g_multiplayer_select_presentation_unit_type", troop_select_type_cavalry),
          (overlay_set_color,"$g_presentation_obj_select_cavalry",0xECEB82),
        (else_try),
          (overlay_set_color,"$g_presentation_obj_select_cavalry",0xFFFFFF),
        (try_end),
        (position_set_x, pos1, 255),
        (position_set_y, pos1, 660),
        (overlay_set_position, "$g_presentation_obj_select_cavalry", pos1),
        #(position_set_x, pos1, 1500),
        #(position_set_y, pos1, 1500),
        #(overlay_set_size, "$g_presentation_obj_select_cavalry", pos1),
        (troop_set_slot,"trp_x_pos","$g_presentation_obj_select_cavalry",250),
        (troop_set_slot,"trp_y_pos","$g_presentation_obj_select_cavalry",660),
        (troop_set_slot,"trp_x_size","$g_presentation_obj_select_cavalry",1000),
        (troop_set_slot,"trp_y_size","$g_presentation_obj_select_cavalry",1000),
        
        (create_button_overlay, "$g_presentation_obj_select_artillery", "str_specialists", 0),
        (try_begin),
          (eq, "$g_multiplayer_select_presentation_unit_type", troop_select_type_artillery),
          (overlay_set_color,"$g_presentation_obj_select_artillery",0xECEB82),
        (else_try),
          (overlay_set_color,"$g_presentation_obj_select_artillery",0xFFFFFF),
        (try_end),
        (position_set_x, pos1, 370),
        (position_set_y, pos1, 660),
        (overlay_set_position, "$g_presentation_obj_select_artillery", pos1),
        #(position_set_x, pos1, 1500),
        #(position_set_y, pos1, 1500),
        #(overlay_set_size, "$g_presentation_obj_select_artillery", pos1),
        (troop_set_slot,"trp_x_pos","$g_presentation_obj_select_artillery",400),
        (troop_set_slot,"trp_y_pos","$g_presentation_obj_select_artillery",660),
        (troop_set_slot,"trp_x_size","$g_presentation_obj_select_artillery",1000),
        (troop_set_slot,"trp_y_size","$g_presentation_obj_select_artillery",1000),
        
        (assign, ":cur_y", 605), #590
        (position_set_y, pos1, ":cur_y"),
        (position_set_x,pos1,98),
        
        (position_set_x, pos2, 900),
        (position_set_y, pos2, 900),
        (position_set_x, pos3, 750),
        (position_set_y, pos3, 750),

        (create_text_overlay, reg0, "str_choose_a_troop", 0),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_position, reg0, pos1),
        (overlay_set_size, reg0, pos2),
        (val_sub, ":cur_y", 28),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x,pos1,100),
        (troop_set_slot,"trp_x_pos",reg0,98), #Whatever this value + 2 for above
        (troop_set_slot,"trp_y_pos",reg0,590),
        (troop_set_slot,"trp_x_size",reg0,900),
        (troop_set_slot,"trp_y_size",reg0,900),

        (team_get_faction, ":my_faction_no", ":my_team_no"),
        (try_for_range, ":i_multi", multi_data_troop_button_indices_begin, multi_data_troop_button_indices_end),
          (troop_set_slot, "trp_multiplayer_data", ":i_multi", -1),
        (try_end),
        (try_for_range, ":i_multi", multi_data_troop_display_indices_begin, multi_data_troop_display_indices_end),
          (troop_set_slot, "trp_multiplayer_data", ":i_multi", -1),
        (try_end),

        (assign,":cur_troop_base",":cur_troop"),
        (assign,":end_cond",1),
        (try_for_range,":unused",0,":end_cond"),
          (gt,":cur_troop_base",-1),
          (store_troop_faction,":troop_fac",":cur_troop_base"),
          (try_begin),
            (neq,":my_faction_no",":troop_fac"),
            (val_sub,":cur_troop_base",1),
            (val_add,":end_cond",1),
          (else_try),
            (assign,":end_cond",0), #Break
          (try_end),
        (try_end),
        (assign, ":cur_troop_index", 0),
        (try_for_range, ":troop_no", multiplayer_troops_begin, multiplayer_troops_end),
          (store_troop_faction, ":troop_faction", ":troop_no"),
          (assign,":is_oth_rank",0),
          (try_begin),
            (gt,":troop_faction","fac_kingdoms_end"),
            (val_sub,":troop_faction",11),
            (assign,":is_oth_rank",1),
          (try_end),
          (eq, ":troop_faction", ":my_faction_no"),
          
          (call_script, "script_multiplayer_get_unit_type_for_select_presentation", ":troop_no"),
          (assign,":unit_type",reg0),
          (eq, "$g_multiplayer_select_presentation_unit_type",":unit_type"),
          
          (str_store_troop_name, s1, ":troop_no"),
          #(create_button_overlay, reg12, s1, 0),
          (try_begin),
            (eq,":troop_no",":cur_troop_base"),
            (troop_set_slot,"trp_troop_check_dummy",":troop_no",1),
            (try_begin),
              (eq,":is_oth_rank",0),
              (create_button_overlay, reg12, s1, 0),
              (assign,":colour",0xECEB82),
            (try_end),
          (else_try),
            (call_script,"script_check_troop_availability",":troop_no",":my_player_no",0),
            (assign,":class_ok",reg3),
            (try_begin),
              (eq,":class_ok",1),
              (troop_set_slot,"trp_troop_check_dummy",":troop_no",1),
              (try_begin),
                (eq,":is_oth_rank",0),
                (create_button_overlay, reg12, s1, 0),
                (assign,":colour",0xFFFFFF),
              (try_end),
            (else_try),
              (troop_set_slot,"trp_troop_check_dummy",":troop_no",0),
              (try_begin),
                (eq,":is_oth_rank",0),
                (create_text_overlay, reg12, s1, 0),
                (assign,":colour",0x888888),
              (try_end),
            (try_end),
          (try_end),
          (overlay_set_color, reg12, ":colour"),
          (overlay_set_hilight_color, reg12, 0x55FF50),
          
          (eq,":is_oth_rank",0), # Nothing created?
          
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg12, pos1),
          (overlay_set_size, reg12, pos2),
          
          (store_add, ":button_index_slot", ":cur_troop_index", multi_data_troop_button_indices_begin),
          (troop_set_slot, "trp_multiplayer_data", ":button_index_slot", reg12),
          
          (str_store_troop_name_plural, s7, ":troop_no"),
          #(overlay_set_tooltip, reg12, s7),
          (create_text_overlay, reg13, s7, 0),
          (store_sub,":y",":cur_y",20),
          (copy_position,pos4,pos1),
          (position_set_y, pos4, ":y"),
          (overlay_set_position, reg13, pos4),
          (overlay_set_size, reg13, pos3),
          (overlay_set_color, reg13, ":colour"),
          
          (call_script, "script_get_num_players_of_troop", ":troop_no", ":my_team_no"),
          (try_begin),
            (eq,reg0,1),
            (create_text_overlay, reg13, "str_reg0_player_only", 0),
          (else_try),
            (create_text_overlay, reg13, "str_reg0_players_only", 0),
          (try_end),
          (copy_position,pos5,pos4),
          (position_set_x, pos5, 300),
          (overlay_set_position, reg13, pos5),
          (overlay_set_size, reg13, pos3),
          (overlay_set_color, reg13, ":colour"),
          
          (create_mesh_overlay, reg0, "mesh_white_plane"),
          (overlay_set_color, reg0, 0xFFFFFF),
          (overlay_set_alpha, reg0, 0xD0),
          (store_add,":y",":cur_y",25),
          (position_set_y, pos4, ":y"),
          (overlay_set_position, reg0, pos4),
          (position_set_x, pos5, 14000),
          (position_set_y, pos5, 100),
          (overlay_set_size, reg0, pos5),
          
          (store_mul,":troop_view",":troop_no", 2), #with weapons
          (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
          (position_set_x, pos5, 480),
          (position_set_y, pos5, 350),
          (overlay_set_position, reg14, pos5),
          (position_set_x, pos5, 1000),
          (position_set_y, pos5, 1000),
          (overlay_set_size, reg14, pos5),
          (overlay_set_display, reg14, 0),
          (store_add, ":button_index_slot", ":cur_troop_index", multi_data_troop_display_indices_begin),
          (troop_set_slot, "trp_multiplayer_data", ":button_index_slot", reg14),
        
          (val_sub, ":cur_y", 50),
          (val_add, ":cur_troop_index", 1),
        (try_end),#try for range
      (try_end),
      
      
      ### RANK SELECT ###
      (assign,"$g_presentation_obj_rank_select_1",-1),
      (assign,"$g_presentation_obj_rank_select_2",-1),
      (assign,"$g_presentation_obj_rank_select_3",-1),
      (assign,"$g_presentation_obj_rank_select_4",-1),
      (assign,"$g_presentation_obj_rank_select_5",-1),
      
      (try_begin),
        (gt,":cur_troop",-1),

        (try_begin),
          (store_add,":troop_id","$g_original_selected_troop",1), #Checking for possible officer
          (store_troop_faction,":troop_faction_no",":troop_id"),
          (store_troop_faction,":my_faction_no","$g_original_selected_troop"),
          (store_add,":my_faction_no_plus_10",":my_faction_no",11),
          (eq,":troop_faction_no",":my_faction_no_plus_10"),
          
          (assign,":cur_y",185),
          
          (create_text_overlay, reg0, "str_choose_an_item", 0),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_y, pos1, ":cur_y"),
          (position_set_x, pos1, 98),
          (overlay_set_position, reg0, pos1),
          (overlay_set_size, reg0, pos2),
          (val_sub, ":cur_y", 28),
          (position_set_y, pos1, ":cur_y"),
          (position_set_x,pos1,100),
          
          (try_begin),
            (eq,"$g_original_selected_troop","trp_british_ship_marine"),#hotfix
            (create_button_overlay, "$g_presentation_obj_rank_select_1", "str_sail_brit", 0),
          (else_try),
            (eq,"$g_original_selected_troop","trp_french_ship_marine"),#hotfix
            (create_button_overlay, "$g_presentation_obj_rank_select_1", "str_sail_fren", 0),
          (else_try),
            (create_button_overlay, "$g_presentation_obj_rank_select_1", "str_ranker", 0),
          (try_end),
          (try_begin),
            (eq,"$g_current_selected_rank",1),
            (overlay_set_color, "$g_presentation_obj_rank_select_1", 0xECEB82),
          (else_try),
            (overlay_set_color, "$g_presentation_obj_rank_select_1", 0xFFFFFF),
          (try_end),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, "$g_presentation_obj_rank_select_1", pos1),  
          (overlay_set_size, "$g_presentation_obj_rank_select_1", pos2),
          (val_sub, ":cur_y", 25),
          (position_set_y, pos1, ":cur_y"),

          (store_mul,":troop_view","$g_original_selected_troop", 2), #with weapons
          (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
          (position_set_x, pos5, 480),
          (position_set_y, pos5, 350),
          (overlay_set_position, reg14, pos5),
          (position_set_x, pos5, 1000),
          (position_set_y, pos5, 1000),
          (overlay_set_size, reg14, pos5),
          (overlay_set_display, reg14, 0),
          (assign, "$g_rank_1_preview_display", reg14),
          
          (try_begin),
            ####
            # Moved this check up above not to print rank select presentation at all when only rankers are present
            ####
            #(store_add,":troop_id","$g_original_selected_troop",1), #Checking for possible officer
            #(store_troop_faction,":troop_faction_no",":troop_id"),
            #(store_troop_faction,":my_faction_no","$g_original_selected_troop"),
            #(store_add,":my_faction_no_plus_10",":my_faction_no",11),
            #(eq,":troop_faction_no",":my_faction_no_plus_10"),
            (str_store_troop_name_plural,s3,":troop_id"),
            (try_begin),
              (eq,"$g_current_selected_rank",2),
              (create_button_overlay, "$g_presentation_obj_rank_select_2", s3, 0),
              (overlay_set_color, "$g_presentation_obj_rank_select_2", 0xECEB82),
            (else_try),
              (call_script,"script_check_troop_availability",":troop_id",":my_player_no",0),
              (assign,":class_ok",reg3),
              (try_begin),
                (eq,":class_ok",1),
                (create_button_overlay, "$g_presentation_obj_rank_select_2", s3, 0),
                (overlay_set_color, "$g_presentation_obj_rank_select_2", 0xFFFFFF),
                (overlay_set_hilight_color, "$g_presentation_obj_rank_select_2", 0x55FF50),
              (else_try),
                (create_text_overlay, "$g_presentation_obj_rank_select_2", s3, 0),
                (overlay_set_color, "$g_presentation_obj_rank_select_2", 0x888888),
                (overlay_set_hilight_color, "$g_presentation_obj_rank_select_2", 0x888888),
              (try_end),
            (try_end),
            (position_set_y, pos1, ":cur_y"),
            (overlay_set_position, "$g_presentation_obj_rank_select_2", pos1),  
            (overlay_set_size, "$g_presentation_obj_rank_select_2", pos2),
            (val_sub, ":cur_y", 25),
            (position_set_y, pos1, ":cur_y"),

            (store_mul,":troop_view",":troop_id", 2), #with weapons
            (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
            (position_set_x, pos5, 480),
            (position_set_y, pos5, 350),
            (overlay_set_position, reg14, pos5),
            (position_set_x, pos5, 1000),
            (position_set_y, pos5, 1000),
            (overlay_set_size, reg14, pos5),
            (overlay_set_display, reg14, 0),
            (assign, "$g_rank_2_preview_display", reg14),
          
            (try_begin),
              (store_add,":troop_id","$g_original_selected_troop",2), #Checking for possible officer
              (store_troop_faction,":troop_faction_no",":troop_id"),
              (store_troop_faction,":my_faction_no","$g_original_selected_troop"),
              (store_add,":my_faction_no_plus_10",":my_faction_no",11),
              (eq,":troop_faction_no",":my_faction_no_plus_10"),
              (str_store_troop_name_plural,s3,":troop_id"),
              (try_begin),
                (eq,"$g_current_selected_rank",3),
                (create_button_overlay, "$g_presentation_obj_rank_select_3", s3, 0),
                (overlay_set_color, "$g_presentation_obj_rank_select_3", 0xECEB82),
              (else_try),
                (call_script,"script_check_troop_availability",":troop_id",":my_player_no",0),
                (assign,":class_ok",reg3),
                (try_begin),
                  (eq,":class_ok",1),
                  (create_button_overlay, "$g_presentation_obj_rank_select_3", s3, 0),
                  (overlay_set_color, "$g_presentation_obj_rank_select_3", 0xFFFFFF),
                  (overlay_set_hilight_color, "$g_presentation_obj_rank_select_3", 0x55FF50),
                (else_try),
                  (create_text_overlay, "$g_presentation_obj_rank_select_3", s3, 0),
                  (overlay_set_color, "$g_presentation_obj_rank_select_3", 0x888888),
                  (overlay_set_hilight_color, "$g_presentation_obj_rank_select_3", 0x888888),
                (try_end),
              (try_end),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, "$g_presentation_obj_rank_select_3", pos1),  
              (overlay_set_size, "$g_presentation_obj_rank_select_3", pos2),
              (val_sub, ":cur_y", 25),
              (position_set_y, pos1, ":cur_y"),

              (store_mul,":troop_view",":troop_id", 2), #with weapons
              (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
              (position_set_x, pos5, 480),
              (position_set_y, pos5, 350),
              (overlay_set_position, reg14, pos5),
              (position_set_x, pos5, 1000),
              (position_set_y, pos5, 1000),
              (overlay_set_size, reg14, pos5),
              (overlay_set_display, reg14, 0),
              (assign, "$g_rank_3_preview_display", reg14),
      
              (try_begin),
                (store_add,":troop_id","$g_original_selected_troop",3), #Checking for possible musicians
                (store_troop_faction,":troop_faction_no",":troop_id"),
                (store_troop_faction,":my_faction_no","$g_original_selected_troop"),
                (store_add,":my_faction_no_plus_10",":my_faction_no",11),
                (eq,":troop_faction_no",":my_faction_no_plus_10"),
                (str_store_troop_name_plural,s3,":troop_id"),

                #(create_button_overlay, "$g_presentation_obj_rank_select_4", s3, 0),
                (try_begin),
                  (eq,"$g_current_selected_rank",4),
                  (create_button_overlay, "$g_presentation_obj_rank_select_4", s3, 0),
                  (overlay_set_color, "$g_presentation_obj_rank_select_4", 0xECEB82),
                (else_try),
                  (call_script,"script_check_troop_availability",":troop_id",":my_player_no",0),
                  (assign,":class_ok",reg3),
                  (try_begin),
                    (eq,":class_ok",1),
                    (create_button_overlay, "$g_presentation_obj_rank_select_4", s3, 0),
                    (overlay_set_color, "$g_presentation_obj_rank_select_4", 0xFFFFFF),
                    (overlay_set_hilight_color, "$g_presentation_obj_rank_select_4", 0x55FF50),
                  (else_try),
                    (create_text_overlay, "$g_presentation_obj_rank_select_4", s3, 0),
                    (overlay_set_color, "$g_presentation_obj_rank_select_4", 0x888888),
                    (overlay_set_hilight_color, "$g_presentation_obj_rank_select_4", 0x888888),
                  (try_end),
                (try_end),
                (position_set_y, pos1, ":cur_y"),
                (overlay_set_position, "$g_presentation_obj_rank_select_4", pos1),  
                (overlay_set_size, "$g_presentation_obj_rank_select_4", pos2),
                (val_sub, ":cur_y", 25),
                (position_set_y, pos1, ":cur_y"),

                (store_mul,":troop_view",":troop_id", 2), #with weapons
                (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
                (position_set_x, pos5, 480),
                (position_set_y, pos5, 350),
                (overlay_set_position, reg14, pos5),
                (position_set_x, pos5, 1000),
                (position_set_y, pos5, 1000),
                (overlay_set_size, reg14, pos5),
                (overlay_set_display, reg14, 0),
                (assign, "$g_rank_4_preview_display", reg14),
          
                (try_begin),
                  (store_add,":troop_id","$g_original_selected_troop",4), #Checking for further possible musicians
                  (store_troop_faction,":troop_faction_no",":troop_id"),
                  (eq,":troop_faction_no",":my_faction_no_plus_10"),
                  (str_store_troop_name_plural,s3,":troop_id"),

                  #(create_button_overlay, "$g_presentation_obj_rank_select_5", s3, 0),
                  (try_begin),
                    (eq,"$g_current_selected_rank",5),
                    (create_button_overlay, "$g_presentation_obj_rank_select_5", s3, 0),
                    (overlay_set_color, "$g_presentation_obj_rank_select_5", 0xECEB82),
                  (else_try),
                    (call_script,"script_check_troop_availability",":troop_id",":my_player_no",0),
                    (assign,":class_ok",reg3),
                    (try_begin),
                      (eq,":class_ok",1),
                      (create_button_overlay, "$g_presentation_obj_rank_select_5", s3, 0),
                      (overlay_set_color, "$g_presentation_obj_rank_select_5", 0xFFFFFF),
                      (overlay_set_hilight_color, "$g_presentation_obj_rank_select_5", 0x55FF50),
                    (else_try),
                      (create_text_overlay, "$g_presentation_obj_rank_select_5", s3, 0),
                      (overlay_set_color, "$g_presentation_obj_rank_select_5", 0x888888),
                      (overlay_set_hilight_color, "$g_presentation_obj_rank_select_5", 0x888888),
                    (try_end),
                  (try_end),
                  (position_set_y, pos1, ":cur_y"),
                  (overlay_set_position, "$g_presentation_obj_rank_select_5", pos1),  
                  (overlay_set_size, "$g_presentation_obj_rank_select_5", pos2),
                  (val_sub, ":cur_y", 25),
                  (position_set_y, pos1, ":cur_y"),

                  (store_mul,":troop_view",":troop_id", 2), #with weapons
                  (create_mesh_overlay_with_tableau_material, reg14, -1, "tableau_game_party_window", ":troop_view"),
                  (position_set_x, pos5, 480),
                  (position_set_y, pos5, 350),
                  (overlay_set_position, reg14, pos5),
                  (position_set_x, pos5, 1000),
                  (position_set_y, pos5, 1000),
                  (overlay_set_size, reg14, pos5),
                  (overlay_set_display, reg14, 0),
                  (assign, "$g_rank_5_preview_display", reg14),
                (try_end),
              (try_end),
            (try_end),
          (try_end),
        (try_end),  
      (try_end),
      
      ### VISUAL STUFF ###
      (assign,"$g_presentation_obj_item_select",-1),
      
      (try_begin),
        (gt,":cur_troop",-1),
        (troop_get_slot,":selected_troop_rank",":cur_troop",slot_troop_rank),
        (try_begin),
          (this_or_next|eq, ":selected_troop_rank", mm_rank_general),
          (gt,"$g_current_selected_rank",0),
          
          (store_mul,":troop_view",":cur_troop", 2), #with weapons
          (create_mesh_overlay_with_tableau_material, reg0, -1, "tableau_game_party_window", ":troop_view"),
          (position_set_x, pos1, 655),
          (position_set_y, pos1, 350),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 1000),
          (position_set_y, pos1, 1000),
          (overlay_set_size, reg0, pos1),
          
          (create_text_overlay, reg0, "str_equipment", 0),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_x, pos1, 550),
          (position_set_y, pos1, 285),
          (overlay_set_position, reg0, pos1),
          (overlay_set_size, reg0, pos2),
          
          (assign,":cur_y",280),
          (position_set_x, pos1, 707),
          (assign,":cur_y2",270),
          (position_set_x, pos4, 590),
          (position_set_x, pos6, 400),
          (position_set_y, pos6, 400),
          (position_set_x, pos8, 710),
          
          (try_begin),
            (this_or_next|eq,":cur_troop","trp_russian_partizan"),
			      (this_or_next|eq,":cur_troop","trp_british_ship"),
			      (eq,":cur_troop","trp_french_ship"),
            (val_sub,":cur_y",35),
            (val_sub,":cur_y2",35),
            (create_mesh_overlay, reg0, "mesh_item_select_no_select"),
            (position_set_y, pos1, ":cur_y"),
            (position_set_y, pos4, ":cur_y2"),
            (overlay_set_position, reg0, pos4),
            (overlay_set_size, reg0, pos6),
            (create_text_overlay, reg0, "str_random", tf_center_justify),
            (overlay_set_color, reg0, 0x000000),
            (overlay_set_position, reg0, pos1),
            (overlay_set_size, reg0, pos2),
          (else_try),
#            (troop_get_inventory_capacity,":inv_cap",":cur_troop"),
            (assign,":item_index",0),
            (try_for_range, ":i_item", slot_player_selected_item_indices_begin, slot_player_selected_item_indices_end),
              (player_get_slot, ":item_id", ":my_player_no", ":i_item"),
#            (try_for_range, ":i_slot", 0, ":inv_cap"),
#              (troop_get_inventory_slot, ":item_id", ":cur_troop", ":i_slot"),
              (ge, ":item_id", 0),
              (item_get_slot, ":item_class", ":item_id", slot_item_multiplayer_item_class),
              (this_or_next|is_between,":item_class",multi_item_class_type_weapons_begin,multi_item_class_type_weapons_end),
              (is_between,":item_class",multi_item_class_type_horses_begin,multi_item_class_type_horses_end),
              (neq,":item_class",multi_item_class_type_bullet),
              (val_sub,":cur_y",35),
              (val_sub,":cur_y2",35),
              
              (try_begin), #Check for multiple versions of item type
                (eq,":item_index",0), #Only one selectable slot per troop
                (this_or_next|eq,":cur_troop","trp_russian_opol"), #Opolchenyie
                (this_or_next|eq,":cur_troop","trp_prussian_infantry_kurmark"), #landwehr #patch1115 49/1
                (this_or_next|is_between,":item_class",multi_item_class_type_horses_begin,multi_item_class_type_horses_end), #Arty horses
                (this_or_next|eq,":item_class",multi_item_class_type_flag), #Flags
                (eq,":item_class",multi_item_class_type_gun), #Guns
                (neq,":item_class",multi_item_class_type_horse), #Not normal horses
                (neq,":item_id","itm_french_officer_pistol"), #Not French officier pistols
                (neq,":item_id","itm_french_pistol_1766"),
                (assign,":continue",1),
                (try_begin),
                  (is_between,":item_class",multi_item_class_type_horses_begin,multi_item_class_type_horses_end), #If arty horse
                  (this_or_next|eq,"$g_spawn_with_artillery",0), #And no spawning with arty
                  (eq,"$g_spawn_with_artillery",3),              #Or only spawning with rockets
                  (assign,":continue",0), #Don't continue
                (try_end),
                (eq,":continue",1),
                (troop_get_inventory_capacity,":inv_cap",":cur_troop"),
                (try_for_range, ":i_slot", 0, ":inv_cap"),
                  (troop_get_inventory_slot, ":item_id2", ":cur_troop", ":i_slot"),
                  (ge, ":item_id2", 0),
                  #(neq, ":item_id2", ":item_id"),
                  (item_get_slot, ":item_class2", ":item_id2", slot_item_multiplayer_item_class),
                  (try_begin),
                    (eq,":item_class2", multi_item_class_type_horse_howitzer),
                    (assign,":item_class2",multi_item_class_type_horse_cannon),
                  (else_try),
                    (this_or_next|eq,":cur_troop","trp_prussian_infantry_kurmark"), #landwehr #patch1115 49/2
                    (eq,":cur_troop","trp_russian_opol"), #Opolchenyie
                    (eq,":item_class2", multi_item_class_type_lance),
                    (assign,":item_class2",multi_item_class_type_gun),
                  (try_end),
                  (assign,":item_class3",":item_class"),
                  (try_begin),
                    (eq,":item_class3", multi_item_class_type_horse_howitzer),
                    (assign,":item_class3",multi_item_class_type_horse_cannon),
                  (else_try),
                    (this_or_next|eq,":cur_troop","trp_prussian_infantry_kurmark"), #landwehr #patch1115 49/3
                    (eq,":cur_troop","trp_russian_opol"), #Opolchenyie
                    (eq,":item_class3", multi_item_class_type_lance),
                    (assign,":item_class3",multi_item_class_type_gun),
                  (try_end),
                  (eq,":item_class2", ":item_class3"),
                  (store_add,":slot_no",multi_data_item_button_indices_begin,":item_index"),
                  (troop_set_slot, "trp_multiplayer_data", ":slot_no", ":item_id2"),
                  (val_add,":item_index",1),
                (try_end),
                (gt,":item_index",1),
                #(troop_set_slot, "trp_multiplayer_data", multi_data_item_button_indices_begin, ":item_id"),
                (create_combo_label_overlay, "$g_presentation_obj_item_select"),
                (position_set_y, pos8, ":cur_y2"),
                (overlay_set_position, "$g_presentation_obj_item_select", pos8),
                (position_set_x, pos7, 1000),
                (position_set_y, pos7, 950),
                (overlay_set_size, "$g_presentation_obj_item_select", pos7),
                (assign, ":end_cond", ":item_index"),
                (try_for_range, ":i_button", 0, ":end_cond"),
                  (store_add, ":slot_no", ":i_button", multi_data_item_button_indices_begin),
                  (troop_get_slot, ":item_no", "trp_multiplayer_data", ":slot_no"),
                  (item_get_slot, ":item_no_class", ":item_no", slot_item_multiplayer_item_class),
                  (try_begin),
                    (eq,":item_no_class", multi_item_class_type_horse_howitzer),
                    (str_store_string,s3,"str_howitzer"),
                  (else_try),
                    (eq,":item_no_class",multi_item_class_type_horse_cannon),
                    (str_store_string,s3,"str_cannon"),
                  (else_try),
                    (str_store_item_name,s3,":item_no"),
                  (try_end),
                  (overlay_add_item,"$g_presentation_obj_item_select",s3),
                (try_end),
                (call_script,"script_get_item_class_cur_item",":item_class",":my_player_no"),
                (assign,":cur_item",reg0),
                (try_begin),
                  (ge,":cur_item",0),
                (else_try),
                  (assign,":cur_item",":item_id"),
                (try_end),
                (assign, ":end_cond", ":item_index"),
                (try_for_range, ":i_button", 0, ":end_cond"),
                  (store_add, ":slot_no", ":i_button", multi_data_item_button_indices_begin),
                  (troop_get_slot, ":item_no", "trp_multiplayer_data", ":slot_no"),
                  (eq,":item_no",":cur_item"),
                  (overlay_set_val,"$g_presentation_obj_item_select",":i_button"),
                  (assign,":end_cond",0), #Break
                (try_end),
              (else_try), #No item choice here
                (create_mesh_overlay, reg0, "mesh_item_select_no_select"),
                (position_set_y, pos1, ":cur_y"),
                (position_set_y, pos4, ":cur_y2"),
                (overlay_set_position, reg0, pos4),
                (overlay_set_size, reg0, pos6),
                (try_begin),
                  (this_or_next|eq,":cur_troop","trp_russian_cossack"),
                  (eq,":cur_troop","trp_prussian_infantry_kurmark"),
                  
                  (eq,":item_class",multi_item_class_type_sword),
                  (str_store_string, s8, "str_random"),
                (else_try),
                  (str_store_item_name,s8,":item_id"),
                (try_end),
                (create_text_overlay, reg0, s8, tf_center_justify),
                (overlay_set_color, reg0, 0x000000),
                (overlay_set_position, reg0, pos1),
                (overlay_set_size, reg0, pos2),
              (try_end),
            (try_end),
          (try_end),
        (try_end),
      (try_end),
      
      
      (store_mission_timer_a, "$g_last_refresh_at2"),
      (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (multiplayer_get_my_player, ":my_player_no"),
      (player_get_team_no,":my_team_no",":my_player_no"),
      (player_get_troop_id,":cur_troop",":my_player_no"),
      (try_begin),
        (eq, "$g_waiting_for_confirmation_to_terminate", 0),
        (try_begin),
          (eq,":object","$g_presentation_obj_select_done"),
          (gt,":cur_troop",-1),
          (troop_get_slot,":selected_troop_rank",":cur_troop",slot_troop_rank),
          (this_or_next|eq, ":selected_troop_rank", mm_rank_general),
          (gt,"$g_current_selected_rank",0),
          (player_get_team_no, ":my_team_no", ":my_player_no"),
          (presentation_set_duration, 0),
          (try_begin),
            (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
            (start_presentation,"prsnt_conquest_flag_select"),
          (else_try),
            (call_script,"script_multiplayer_client_show_respawncounter"),
          (try_end),
        (else_try),
          (eq,":object","$g_presentation_obj_select_back"),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_multiplayer_team_select"),
        (else_try),
          (eq,":object","$g_presentation_obj_select_infantry"),
          (assign, "$g_multiplayer_select_presentation_unit_type",troop_select_type_infantry),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_multiplayer_item_select"),
        (else_try),
          (eq,":object","$g_presentation_obj_select_cavalry"),
          (assign, "$g_multiplayer_select_presentation_unit_type",troop_select_type_cavalry),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_multiplayer_item_select"),
        (else_try),
          (eq,":object","$g_presentation_obj_select_artillery"),
          (assign, "$g_multiplayer_select_presentation_unit_type",troop_select_type_artillery),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_multiplayer_item_select"),
        (else_try),
          #Regiment Select
          (assign,":continue",0),
          (player_get_team_no, ":my_team_no", ":my_player_no"),
          (team_get_faction, ":my_faction_no", ":my_team_no"),
          (assign, ":selected_troop_no", -1),
          (assign, ":end_cond", multi_data_troop_button_indices_end),
          (try_for_range, ":i_button", multi_data_troop_button_indices_begin, ":end_cond"),
            (troop_slot_eq, "trp_multiplayer_data", ":i_button", ":object"),
            (store_sub, ":selected_troop_index", ":i_button", multi_data_troop_button_indices_begin),
            (assign, ":end_cond_2", multiplayer_troops_end),
            (try_for_range, ":troop_no", multiplayer_troops_begin, ":end_cond_2"),
              (store_troop_faction, ":troop_faction", ":troop_no"),
              (eq, ":troop_faction", ":my_faction_no"),
              
              (call_script, "script_multiplayer_get_unit_type_for_select_presentation", ":troop_no"),
              (assign,":unit_type",reg0),
              (eq, "$g_multiplayer_select_presentation_unit_type",":unit_type"),
              
              (val_sub, ":selected_troop_index", 1),
              (lt, ":selected_troop_index", 0),
              (assign, ":selected_troop_no", ":troop_no"),
              (assign, ":end_cond_2", 0), #break
            (try_end),
            (try_begin),
              (assign, "$g_confirmation_result", 0),
              (assign, "$g_waiting_for_confirmation_to_terminate", 1),
              (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
              (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
              (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
              (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
              (multiplayer_get_my_troop, ":troop_no"),
              (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":selected_troop_no"),
              # MM
              (neq, ":troop_no", ":selected_troop_no"),
              (player_set_troop_id, ":my_player_no", ":selected_troop_no"),
              (try_begin),
                (gt,":selected_troop_no",-1),
                (troop_get_slot,":selected_troop_class",":selected_troop_no",slot_troop_class),
                (this_or_next|eq,":selected_troop_class", multi_troop_class_mm_sapper),
                (this_or_next|eq,":selected_troop_class", multi_troop_class_mm_surgeon),#patch1115 59/16
                (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
                (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
                (call_script, "script_random_item_selection", ":selected_troop_no",0, ":my_player_no"),  #patch1115 fix 17/18
              (else_try),
                (call_script, "script_random_item_selection", ":selected_troop_no",1, ":my_player_no"),  #patch1115 fix 17/17
              (try_end),
              (call_script, "script_multiplayer_send_item_selections"),
              (assign, "$g_original_selected_troop", ":selected_troop_no"),
            (try_end),
            (presentation_set_duration, 0),
            #(assign, "$g_presentation_state", 0),

            (assign,"$g_current_selected_rank",1),
            
            (start_presentation, "prsnt_multiplayer_item_select"),
              
            (assign,":continue",1),
            (assign, ":end_cond", 0), #break
          (try_end), 
          (eq,":continue",1),
        (else_try),
          (try_begin),
            (eq,":object","$g_presentation_obj_rank_select_1"),
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
            (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
            (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
            (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
            (player_set_troop_id, ":my_player_no", "$g_original_selected_troop"),
            (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, "$g_original_selected_troop"), 
            (try_begin),
              (gt,"$g_original_selected_troop",-1),
              (troop_get_slot,":selected_troop_class","$g_original_selected_troop",slot_troop_class),
              (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
              (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
              (call_script, "script_random_item_selection", "$g_original_selected_troop",0, ":my_player_no"), #patch1115 fix 17/15
            (else_try),
              (call_script, "script_random_item_selection", "$g_original_selected_troop",1, ":my_player_no"),  #patch1115 fix 17/16
            (try_end),
            (call_script, "script_multiplayer_send_item_selections"),
            (assign,"$g_current_selected_rank",1),
          (else_try),
            (eq,":object","$g_presentation_obj_rank_select_2"),
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
            (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
            (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
            (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
            (store_add,":new_troop","$g_original_selected_troop",1),
            (player_set_troop_id, ":my_player_no", ":new_troop"),
            (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":new_troop"),
            (try_begin),
              (gt,":new_troop",-1),
              (troop_get_slot,":selected_troop_class",":new_troop",slot_troop_class),
              (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
              (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
              (call_script, "script_random_item_selection", ":new_troop",0, ":my_player_no"),  #patch1115 fix 17/14
            (else_try),
              (call_script, "script_random_item_selection", ":new_troop",1, ":my_player_no"),  #patch1115 fix 17/13
            (try_end),
            (call_script, "script_multiplayer_send_item_selections"),
            (assign,"$g_current_selected_rank",2),
          (else_try),
            (eq,":object","$g_presentation_obj_rank_select_3"),
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
            (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
            (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
            (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
            (store_add,":new_troop","$g_original_selected_troop",2),
            (player_set_troop_id, ":my_player_no", ":new_troop"),
            (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":new_troop"),
            (try_begin),
              (gt,":new_troop",-1),
              (troop_get_slot,":selected_troop_class",":new_troop",slot_troop_class),
              (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
              (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
              (call_script, "script_random_item_selection", ":new_troop",0, ":my_player_no"),  #patch1115 fix 17/12
            (else_try),
              (call_script, "script_random_item_selection", ":new_troop",1, ":my_player_no"),  #patch1115 fix 17/11
            (try_end),
            (call_script, "script_multiplayer_send_item_selections"),
            (assign,"$g_current_selected_rank",3),
          (else_try),
            (eq,":object","$g_presentation_obj_rank_select_4"),
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
            (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
            (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
            (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
            (store_add,":new_troop","$g_original_selected_troop",3),
            (player_set_troop_id, ":my_player_no", ":new_troop"),
            (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":new_troop"),
            (try_begin),
              (gt,":new_troop",-1),
              (troop_get_slot,":selected_troop_class",":new_troop",slot_troop_class),
              (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
              (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
              (call_script, "script_random_item_selection", ":new_troop",0, ":my_player_no"),  #patch1115 fix 17/10
            (else_try),
              (call_script, "script_random_item_selection", ":new_troop",1, ":my_player_no"),  #patch1115 fix 17/9
            (try_end),
            (call_script, "script_multiplayer_send_item_selections"),
            (assign,"$g_current_selected_rank",4),
          (else_try),
            (eq,":object","$g_presentation_obj_rank_select_5"),
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            (player_get_troop_id, "$g_confirmation_troop_backup", ":my_player_no"),
            (player_get_team_no, "$g_confirmation_team_backup", ":my_player_no"),
            (assign, "$g_confirmation_selected_rank_backup", "$g_current_selected_rank"),
            (assign, "$g_confirmation_original_troop_backup", "$g_original_selected_troop"),
            (store_add,":new_troop","$g_original_selected_troop",4),
            (player_set_troop_id, ":my_player_no", ":new_troop"),
            (multiplayer_send_int_to_server, multiplayer_event_change_troop_id, ":new_troop"),
            (try_begin),
              (gt,":new_troop",-1),
              (troop_get_slot,":selected_troop_class",":new_troop",slot_troop_class),
              (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
              (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
              (call_script, "script_random_item_selection", ":new_troop",0, ":my_player_no"),  #patch1115 fix 17/8
            (else_try),
              (call_script, "script_random_item_selection", ":new_troop",1, ":my_player_no"),  #patch1115 fix 17/7
            (try_end),
            (call_script, "script_multiplayer_send_item_selections"),
            (assign,"$g_current_selected_rank",5),
          (else_try),
            (eq,":object","$g_presentation_obj_item_select"),
            (store_trigger_param_2, ":value"),
            (store_add, ":slot_no", ":value", multi_data_item_button_indices_begin),
            (troop_get_slot, ":item_no", "trp_multiplayer_data", ":slot_no"),
            (ge,":item_no",0),
            (call_script,"script_quick_assign_item",":item_no",":my_player_no",":cur_troop"),
            (call_script, "script_multiplayer_send_item_selections"),
          (try_end),  
          (presentation_set_duration, 0),
          (start_presentation, "prsnt_multiplayer_item_select"),
        (try_end),
      (try_end),
      ]),

    (ti_on_presentation_mouse_enter_leave,
      [
      (store_trigger_param_1, ":object"),
      (store_trigger_param_2, ":enter_leave"),
      
      (try_begin),
        (eq,":enter_leave",0),
        (assign,"$g_reposition_object",":object"),
      (try_end),
      
      (assign, ":end_cond", multi_data_troop_button_indices_end),
      (try_for_range, ":i_button", multi_data_troop_button_indices_begin, ":end_cond"),
        (troop_slot_eq, "trp_multiplayer_data", ":i_button", ":object"),
        (store_sub, ":selected_troop_index", ":i_button", multi_data_troop_button_indices_begin),
        (store_add, ":display_object_slot", ":selected_troop_index", multi_data_troop_display_indices_begin),
        (troop_get_slot,":display_object","trp_multiplayer_data",":display_object_slot"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display,":display_object",1),
        (else_try),
          (overlay_set_display,":display_object",0),
        (try_end),
      (try_end),
      (try_begin),
        (eq, "$g_presentation_obj_rank_select_1", ":object"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display, "$g_rank_1_preview_display", 1),
        (else_try),
          (overlay_set_display,"$g_rank_1_preview_display",0),
        (try_end),
      (try_end),
      (try_begin),
        (eq, "$g_presentation_obj_rank_select_2", ":object"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display, "$g_rank_2_preview_display", 1),
        (else_try),
          (overlay_set_display,"$g_rank_2_preview_display",0),
        (try_end),
      (try_end),
      (try_begin),
        (eq, "$g_presentation_obj_rank_select_3", ":object"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display, "$g_rank_3_preview_display", 1),
        (else_try),
          (overlay_set_display,"$g_rank_3_preview_display",0),
        (try_end),
      (try_end),
      (try_begin),
        (eq, "$g_presentation_obj_rank_select_4", ":object"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display, "$g_rank_4_preview_display", 1),
        (else_try),
          (overlay_set_display,"$g_rank_4_preview_display",0),
        (try_end),
      (try_end),
      (try_begin),
        (eq, "$g_presentation_obj_rank_select_5", ":object"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display, "$g_rank_5_preview_display", 1),
        (else_try),
          (overlay_set_display,"$g_rank_5_preview_display",0),
        (try_end),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
      (set_fixed_point_multiplier, 1000),
      #(overlay_get_position, pos23, "$g_reposition_object"),
      #(position_get_x,":x_pos",pos23),
      #(position_get_y,":y_pos",pos23),
      (troop_get_slot,":x_pos","trp_x_pos","$g_reposition_object"),
      (troop_get_slot,":y_pos","trp_y_pos","$g_reposition_object"),
      (troop_get_slot,":x_size","trp_x_size","$g_reposition_object"),
      (troop_get_slot,":y_size","trp_y_size","$g_reposition_object"),
      # (assign,reg43,":x_pos"),
      # (assign,reg44,":y_pos"),
      # (assign,reg45,":x_size"),
      # (assign,reg46,":y_size"),
      # (overlay_set_text,"$g_little_pos_helper", "@Pos: {reg43}x,{reg44}y ^Size: {reg45}x,{reg46}y"),
      
      (assign,":update_position",0),
      (store_mission_timer_a, ":current_time"),
      (store_sub, ":elapsed_time", ":current_time", "$g_last_refresh_at2"),
      
      
      (try_begin),
        #(ge, ":elapsed_time", 1), # last update more then 1 seconds ago.
        (key_is_down,key_left_shift),
        (try_begin),
          (key_clicked,key_up),
          (try_begin),
            (key_is_down,key_left_control),
            (val_add,":y_size",50),
          (else_try),
            (val_add,":y_size",5),
          (try_end),
          (assign,":update_position",1),
        (else_try),
          (key_clicked,key_down),
          (try_begin),
            (key_is_down,key_left_control),
            (val_sub,":y_size",50),
          (else_try),
            (val_sub,":y_size",5),
          (try_end),
          (assign,":update_position",1),
        (else_try),
          (key_clicked,key_right),
          (try_begin),
            (key_is_down,key_left_control),
            (val_add,":x_size",50),
          (else_try),
            (val_add,":x_size",5),
          (try_end),
          (assign,":update_position",1),
        (else_try),
          (key_clicked,key_left),
          (try_begin),
            (key_is_down,key_left_control),
            (val_sub,":x_size",50),
          (else_try),
            (val_sub,":x_size",5),
          (try_end),
          (assign,":update_position",1),
        (try_end),
      (else_try),
        (key_clicked,key_up),
        (try_begin),
          (key_is_down,key_left_control),
          (val_add,":y_pos",50),
        (else_try),
          (val_add,":y_pos",5),
        (try_end),
        (assign,":update_position",1),
      (else_try),
        (key_clicked,key_down),
        (try_begin),
          (key_is_down,key_left_control),
          (val_sub,":y_pos",50),
        (else_try),
          (val_sub,":y_pos",5),
        (try_end),
        (assign,":update_position",1),
      (else_try),
        (key_clicked,key_right),
        (try_begin),
          (key_is_down,key_left_control),
          (val_add,":x_pos",50),
        (else_try),
          (val_add,":x_pos",5),
        (try_end),
        (assign,":update_position",1),
      (else_try),
        (key_clicked,key_left),
        (try_begin),
          (key_is_down,key_left_control),
          (val_sub,":x_pos",50),
        (else_try),
          (val_sub,":x_pos",5),
        (try_end),
        (assign,":update_position",1),
      (try_end),
      (try_begin),
        (eq,":update_position",1),
        (position_set_x,pos23,":x_pos"),
        (position_set_y,pos23,":y_pos"),
        (overlay_set_position,"$g_reposition_object",pos23),
        (position_set_x,pos23,":x_size"),
        (position_set_y,pos23,":y_size"),
        (overlay_set_size,"$g_reposition_object",pos23),
        (troop_set_slot,"trp_x_pos","$g_reposition_object",":x_pos"),
        (troop_set_slot,"trp_y_pos","$g_reposition_object",":y_pos"),
        (troop_set_slot,"trp_x_size","$g_reposition_object",":x_size"),
        (troop_set_slot,"trp_y_size","$g_reposition_object",":y_size"),
      (try_end),
      
      (multiplayer_get_my_player, ":my_player_no"),
      (multiplayer_get_my_team, ":my_team"),
      (team_get_faction,":my_faction_no",":my_team"),
      
      (assign, ":do_refresh", 0),
      (try_begin),
        (key_clicked, key_escape),
        (try_begin),
          (this_or_next|eq, "$g_waiting_for_confirmation_to_terminate", 1),
          (eq, ":my_team", multi_team_unassigned),
          (player_set_troop_id, ":my_player_no", -1),
          (multiplayer_send_int_to_server, multiplayer_event_change_team_no, multi_team_spectator),
          (player_set_team_no, ":my_player_no", multi_team_spectator),
          (assign,"$g_current_selected_rank",0),
          (assign,"$g_waiting_for_confirmation_to_terminate",0),
        (try_end),
        (presentation_set_duration, 0),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        #(display_message,"@Awaiting confirmation to change troop..."),
        (eq, "$g_confirmation_result", 1),
        #(display_message,"@Request accepted!"),
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (assign, "$g_confirmation_result", 0),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_item_select"),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        (eq, "$g_confirmation_result", -1),

        (player_set_troop_id, ":my_player_no", "$g_confirmation_troop_backup"),
        (assign, "$g_current_selected_rank", "$g_confirmation_selected_rank_backup"),
        (assign, "$g_original_selected_troop", "$g_confirmation_original_troop_backup"),
        
        (try_begin),
          (gt,"$g_confirmation_troop_backup",-1),
          (troop_get_slot,":selected_troop_class", "$g_confirmation_troop_backup", slot_troop_class),
          (this_or_next|eq,":selected_troop_class", multi_troop_class_mm_sapper),
          (this_or_next|eq,":selected_troop_class", multi_troop_class_mm_surgeon),
          (this_or_next|eq, ":selected_troop_class", multi_troop_class_mm_artillery),
          (eq, ":selected_troop_class", multi_troop_class_mm_rocket),
          
          (call_script, "script_random_item_selection", "$g_confirmation_troop_backup", 0, ":my_player_no"),
        (else_try),
          (call_script, "script_random_item_selection", "$g_confirmation_troop_backup", 1, ":my_player_no"),
        (try_end),
        
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_item_select"),
      (else_try),
        (ge, ":elapsed_time", 1), # last update more then 1 seconds ago.
        (store_mission_timer_a, "$g_last_refresh_at2"),
        (try_begin),
          (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 0),
          (try_begin),
            (eq, "$g_multiplayer_team_select_1_available", 0),
            (assign, ":do_refresh", 1),
          (try_end),
        (else_try),
         # not available
          (try_begin),
            (eq, "$g_multiplayer_team_select_1_available", 1),
            (assign, ":do_refresh", 1),
          (try_end),
        (try_end),
        (try_begin),
          (eq,":do_refresh",0),
          (call_script, "script_cf_multiplayer_team_is_available", ":my_player_no", 1),
          (try_begin),
            (eq, "$g_multiplayer_team_select_2_available", 0),
            (assign, ":do_refresh", 1),
          (try_end),
        (else_try),
         # not available
          (try_begin),
            (eq, "$g_multiplayer_team_select_2_available", 1),
            (assign, ":do_refresh", 1),
          (try_end),
        (try_end),
        (try_begin),
          (eq,":do_refresh",0),
          (player_is_active,":my_player_no"),
          (player_get_troop_id,":my_troop",":my_player_no"),
          (assign,":end_cond",multiplayer_troops_end),
          (try_for_range, ":troop_no", multiplayer_troops_begin, ":end_cond"),
            (neq,":troop_no",":my_troop"),
            (store_troop_faction, ":troop_faction", ":troop_no"),
            (try_begin),
              (gt,":troop_faction","fac_kingdoms_end"),
              (val_sub,":troop_faction",11),
            (try_end),
            (eq, ":troop_faction", ":my_faction_no"),
            (troop_get_slot,":troop_check","trp_troop_check_dummy",":troop_no"),
            (call_script,"script_check_troop_availability",":troop_no",":my_player_no",0),
            (assign,":class_ok",reg3),
            (try_begin),
              (eq,":class_ok",1),
              (eq,":troop_check",0),
              (assign,":do_refresh",1),
              (troop_set_slot,"trp_troop_check_dummy",":troop_no",1),
              (assign,":end_cond",0),
            (else_try),
              (eq,":class_ok",0),
              (eq,":troop_check",1),
              (assign,":do_refresh",1),
              (troop_set_slot,"trp_troop_check_dummy",":troop_no",0),
              (assign,":end_cond",0),
            (try_end),
          (try_end),
        (try_end),
        
        (try_begin),
          (eq, ":do_refresh", 1),
          (assign,"$g_should_do_refresh",1),
        (try_end),
        
        (eq,"$g_should_do_refresh",1),
        
        # (store_mission_timer_a, ":current_time"),
        # (store_sub, ":elapsed_time", ":current_time", "$g_last_refresh_at"),
        # (ge, ":elapsed_time", 1), # last refresh more then 1 seconds ago. 
        
        (assign,"$g_should_do_refresh",0),
        
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_item_select"),
        
        #(store_mission_timer_a, "$g_last_refresh_at"),
      (try_end),
      ]),
    ]),
    
  ("multiplayer_message_1", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (try_begin),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_round_result_in_battle_mode),
        (assign, ":winner_agent_team", "$g_multiplayer_message_value_1"),

        (try_begin),
          (eq, ":winner_agent_team", -1),
          (assign, ":text_font_color", 0xFFFFFFFF),

          (str_store_string, s0, "str_round_draw_no_one_remained"),
        (else_try),
          
          (assign,":sound_id",-1),
          (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
            (eq, ":winner_agent_team", 0),
            (assign,":sound_id","snd_win_tune_brit"),
            (assign, ":text_font_color", 0xFF33DD11),
          (else_try),
            (assign,":sound_id","snd_loose_tune_brit"),
            (assign, ":text_font_color", 0xFFFF4422),
          (try_end), #initializing ends
          (try_begin),
            (lt, "$my_team_at_start_of_round", 2),
            (try_begin),
              (eq, "$my_team_at_start_of_round", ":winner_agent_team"),
              (assign,":sound_id","snd_win_tune_brit"),
              (assign, ":text_font_color", 0xFF33DD11),
            (else_try),
              (assign,":sound_id","snd_loose_tune_brit"),
              (assign, ":text_font_color", 0xFFFF4422),
            (try_end),
          (try_end),

          (team_get_faction, ":faction_of_winner_team", ":winner_agent_team"),
          (str_store_faction_name, s1, ":faction_of_winner_team"),
          (str_store_string, s0, "str_s1_won_round"),
          
          (try_begin),
            (gt,":sound_id",-1),
            
            (store_sub,":fac_index",":faction_of_winner_team","fac_britain"),
            (val_add,":sound_id",":fac_index"),
            
            # play that damn sound ^.^
            (play_sound,":sound_id"),
          (try_end),
        (try_end),

        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (try_begin),
          (neq, ":winner_agent_team", -1),
          (position_set_x, pos1, 375), #375
        (else_try),
          (position_set_x, pos1, 400), #400
        (try_end),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 300),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_capture_the_flag_score),

        (agent_get_team, ":winner_agent_team", "$g_multiplayer_message_value_1"), #assign given agent's team to winner agent team.
        (team_get_faction, ":winner_agent_faction", ":winner_agent_team"),
        (str_store_faction_name, s1, ":winner_agent_faction"),

        (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
          (eq, ":winner_agent_team", 0),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end), #initializing ends
        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (assign, ":text_font_color", 0xFF33DD11),
              (play_sound, "snd_team_scored_a_point"),
            (else_try),
              (assign, ":text_font_color", 0xFFFF4422),
              (play_sound, "snd_enemy_scored_a_point"),
            (try_end),
          (try_end),
        (try_end),

        (str_store_string, s0, "str_s1_captured_flag"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 350),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_flag_returned_home),

        (try_begin),
          (ge, "$g_multiplayer_message_value_1", 0),
          (agent_get_team, ":returned_flag_agent_team", "$g_multiplayer_message_value_1"), 
          (team_get_faction, ":returned_flag_agent_faction", ":returned_flag_agent_team"),
          (str_store_faction_name, s1, ":returned_flag_agent_faction"),
          (str_store_string, s0, "str_s1_returned_flag"),
        (else_try),
          (val_add, "$g_multiplayer_message_value_1", 1),
          (val_mul, "$g_multiplayer_message_value_1", -1),
          (assign, ":returned_flag_agent_team", "$g_multiplayer_message_value_1"),
          (team_get_faction, ":returned_flag_agent_faction", ":returned_flag_agent_team"),
          (str_store_faction_name, s1, ":returned_flag_agent_faction"),
          (str_store_string, s0, "str_s1_auto_returned_flag"),
        (try_end),

        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (play_sound, "snd_flag_returned"),
          (try_end),
        (try_end),
        (assign, ":text_font_color", 0xFFFFFFFF),

        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 325),
        (position_set_y, pos1, 670),
        (position_set_x, pos1, 500), #new
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_capture_the_flag_stole),

        (agent_get_team, ":stolen_flag_agent_team", "$g_multiplayer_message_value_1"), 
        (team_get_faction, ":stolen_flag_agent_faction", ":stolen_flag_agent_team"),
        (str_store_faction_name, s1, ":stolen_flag_agent_faction"),

        (assign, ":text_font_color", 0xFFFFFFFF),

        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":stolen_flag_agent_team"),
              (play_sound, "snd_enemy_flag_taken"),
            (else_try),
              (play_sound, "snd_your_flag_taken"),
            (try_end),
          (try_end),
        (try_end),

        (str_store_string, s0, "str_s1_taken_flag"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 365),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_flag_captured),
      
        (store_div, ":winner_agent_team", "$g_multiplayer_message_value_1", 100),
        (store_mod, reg0, "$g_multiplayer_message_value_1", 100),
        (val_sub, ":winner_agent_team", 1),

        (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
          (eq, ":winner_agent_team", 0),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end), #initializing ends
        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (assign, ":text_font_color", 0xFF33DD11),
              (play_sound, "snd_team_scored_a_point"),
            (else_try),
              (assign, ":text_font_color", 0xFFFF4422),
              (play_sound, "snd_enemy_scored_a_point"),
            (try_end),
          (try_end),
        (try_end),

        (team_get_faction, ":winner_agent_faction", ":winner_agent_team"),
        (str_store_faction_name, s1, ":winner_agent_faction"),

        (call_script,"script_conquest_get_flag_name",reg0),
        (str_store_string, s0, "str_s1_captured_flag_reg0"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 345),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_flag_is_pulling),
      
        (store_div, ":winner_agent_team", "$g_multiplayer_message_value_1", 100),
        (store_mod, reg0, "$g_multiplayer_message_value_1", 100),
        (val_sub, ":winner_agent_team", 1),

        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (play_sound, "snd_enemy_flag_taken"),
            (else_try),
              (play_sound, "snd_your_flag_taken"),
            (try_end),
          (try_end),
        (try_end),

        (assign, ":text_font_color", 0xFFFFFFFF),

        (team_get_faction, ":winner_agent_faction", ":winner_agent_team"),
        (str_store_faction_name, s1, ":winner_agent_faction"),      

        (call_script,"script_conquest_get_flag_name",reg0),
        (str_store_string, s0, "str_s1_pulling_flag_reg0"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 345),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_flag_neutralized),      

        (store_div, ":winner_agent_team", "$g_multiplayer_message_value_1", 100),
        (store_mod, reg0, "$g_multiplayer_message_value_1", 100),
        (val_sub, ":winner_agent_team", 1),

        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (play_sound, "snd_flag_returned"),
          (try_end),
        (try_end),

        (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
          (eq, ":winner_agent_team", 0),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end), #initializing ends
        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (assign, ":text_font_color", 0xFF33DD11),
            (else_try),
              (assign, ":text_font_color", 0xFFFF4422),
            (try_end),
          (try_end),
        (try_end),

        (try_begin),
          (eq,":winner_agent_team",0),
          (assign,":loser_team",1),
        (else_try),
          (assign,":loser_team",0),
        (try_end),
        (team_get_faction, ":winner_agent_faction", ":loser_team"),
        (str_store_faction_name, s1, ":winner_agent_faction"),

        (call_script,"script_conquest_get_flag_name",reg0),
        (str_store_string, s0, "str_s1_neutralized_flag_reg0"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 345),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),     
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_round_result_in_siege_mode),      

        (assign, ":winner_agent_team", "$g_multiplayer_message_value_1"),

        (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
          (eq, ":winner_agent_team", 0),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end), #initializing ends
        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (assign, ":text_font_color", 0xFF33DD11),
            (else_try),
              (assign, ":text_font_color", 0xFFFF4422),
            (try_end),
          (try_end),
        (try_end),

        (try_begin),
          (eq, "$g_multiplayer_message_value_1", 0),
          (str_store_string, s0, "str_s1_defended_castle"),
        (else_try),
          (eq, "$g_multiplayer_message_value_1", 1),
          (str_store_string, s0, "str_s1_captured_castle"),
        (else_try),
          (str_store_string, s0, "str_round_draw"),
          (assign, ":text_font_color", 0xFFFFFFFF),
        (try_end),
      
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (try_begin),
          (neq, "$g_multiplayer_message_value_1", -1),
          (position_set_x, pos1, 325),
        (else_try),
          (position_set_x, pos1, 400),
        (try_end),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_attackers_won_the_round),

        (assign, ":winner_agent_team", "$g_multiplayer_message_value_1"),

        (try_begin), #for spectators initializing, we assume spectators are fan of team0 so coloring is applied as they are at team0.
          (eq, ":winner_agent_team", 0),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end), #initializing ends
        (multiplayer_get_my_player, ":my_player_no"),
        (try_begin),
          (ge, ":my_player_no", 0),
          (player_get_agent_id, ":my_player_agent", ":my_player_no"),
          (try_begin),
            (ge, ":my_player_agent", 0),
            (agent_get_team, ":my_player_team", ":my_player_agent"),
            (try_begin),
              (eq, ":my_player_team", ":winner_agent_team"),
              (assign, ":text_font_color", 0xFF33DD11),
            (else_try),
              (assign, ":text_font_color", 0xFFFF4422),
            (try_end),
          (try_end),
        (try_end),

        (try_begin),
          (eq, "$g_defender_team", 0),
          (team_get_faction, ":faction_of_winner_team", 1),
        (else_try),
          (team_get_faction, ":faction_of_winner_team", 0),
        (try_end),
        (str_store_faction_name, s1, ":faction_of_winner_team"),

        (str_store_string, s0, "str_s1_won_round"),
        (create_text_overlay, "$g_multiplayer_message_1", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_1", ":text_font_color"),
        (position_set_x, pos1, 350),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_1", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_1", pos1),
        (presentation_set_duration, 400),      
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
       ]),
     ]),

  ("multiplayer_message_2", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (try_begin),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_auto_team_balance_done),
        (assign, ":text_font_color", 0xFFFFFFFF),
        (str_store_string, s0, "str_auto_team_balance_done"),
        (create_text_overlay, "$g_multiplayer_message_2", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_2", ":text_font_color"),
        (position_set_x, pos1, 375),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, "$g_multiplayer_message_2", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_2", pos1),
        (presentation_set_duration, 300),
      (else_try),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_auto_team_balance_next),
        (assign, ":text_font_color", 0xFFFFFFFF),

        (try_begin),
          (neq, "$g_multiplayer_game_type", multiplayer_game_type_battle),
          (neq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
          (neq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (str_store_string, s0, "str_auto_team_balance_in_20_seconds"),
          (position_set_x, pos1, 375),
        (else_try),
          (str_store_string, s0, "str_auto_team_balance_next_round"),
          (position_set_x, pos1, 375),
        (try_end),
      
        (create_text_overlay, "$g_multiplayer_message_2", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_2", ":text_font_color"),
        (position_set_y, pos1, 670),
        (position_set_x, pos1, 500), #new
        (overlay_set_position, "$g_multiplayer_message_2", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_2", pos1),
        (presentation_set_duration, 300),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
       ]),
     ]),
      
  ("multiplayer_message_3", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),      
      (try_begin),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_poll_result),
      
        (assign, ":text_font_color", 0xFFFFFFFF),
        (try_begin),
          (eq, "$g_multiplayer_message_value_3", 1),
          (str_store_string, s0, "str_poll_result_yes"),
        (else_try),
          (str_store_string, s0, "str_poll_result_no"),
        (try_end),
        (create_text_overlay, "$g_multiplayer_message_3", s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, "$g_multiplayer_message_3", ":text_font_color"),
        (position_set_x, pos1, 380),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 475),
        (overlay_set_position, "$g_multiplayer_message_3", pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, "$g_multiplayer_message_3", pos1),
        (presentation_set_duration, 400),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [
       ]),
     ]),

  ("multiplayer_round_time_counter", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (assign, "$g_multiplayer_last_round_time_counter_value", -1),
      (str_clear, s0),
      (create_text_overlay, "$g_multiplayer_round_time_counter_overlay", s0, tf_left_align|tf_single_line|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_round_time_counter_overlay", 0xFFFFFF),
      (position_set_x, pos1, 900),
      (position_set_y, pos1, 690),
      (overlay_set_position, "$g_multiplayer_round_time_counter_overlay", pos1),
      (position_set_x, pos1, 2000),
      (position_set_y, pos1, 2000),
      (overlay_set_size, "$g_multiplayer_round_time_counter_overlay", pos1),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run,
     [(store_mission_timer_a, ":current_time"),
      (store_sub, ":seconds_past_in_round", ":current_time", "$g_round_start_time"),
      (store_sub, ":seconds_left_in_round", "$g_multiplayer_round_max_seconds", ":seconds_past_in_round"),
      (val_max, ":seconds_left_in_round", 0),
      (try_begin),
        (neq, "$g_multiplayer_last_round_time_counter_value", ":seconds_left_in_round"),
        (assign, "$g_multiplayer_last_round_time_counter_value", ":seconds_left_in_round"),
        (store_div, reg0, ":seconds_left_in_round", 60),
        (store_div, reg1, ":seconds_left_in_round", 10),
        (val_mod, reg1, 6),
        (assign, reg2, ":seconds_left_in_round"),
        (val_mod, reg2, 10),
        (str_store_string, s0, "str_reg0_dd_reg1reg2"),
        (overlay_set_text, "$g_multiplayer_round_time_counter_overlay", s0),
      (try_end),
      ]),
    ]),

  ("multiplayer_team_score_display", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (assign, "$g_multiplayer_team_1_last_displayed_score", -1),
      (assign, "$g_multiplayer_team_2_last_displayed_score", -1),
      (str_clear, s0),
      (create_text_overlay, "$g_multiplayer_team_1_score_display_overlay", s0, tf_left_align|tf_single_line|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_team_1_score_display_overlay", 0xFFFFFF),
      (position_set_x, pos1, 40),
      (position_set_y, pos1, 700),
      (overlay_set_position, "$g_multiplayer_team_1_score_display_overlay", pos1),
      (position_set_x, pos1, 1500),
      (position_set_y, pos1, 1500),
      (overlay_set_size, "$g_multiplayer_team_1_score_display_overlay", pos1),
      (create_text_overlay, "$g_multiplayer_team_2_score_display_overlay", s0, tf_left_align|tf_single_line|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_team_2_score_display_overlay", 0xFFFFFF),
      (position_set_x, pos1, 40),
      (position_set_y, pos1, 645),
      (overlay_set_position, "$g_multiplayer_team_2_score_display_overlay", pos1),
      (position_set_x, pos1, 1500),
      (position_set_y, pos1, 1500),
      (overlay_set_size, "$g_multiplayer_team_2_score_display_overlay", pos1),

      (try_begin),
        (eq, "$g_multiplayer_team_1_faction", "fac_russia"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_1"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_france"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_2"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_prussia"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_3"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_austria"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_4"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_rhine"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_5"),
      (else_try),
        (eq, "$g_multiplayer_team_1_faction", "fac_britain"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_6"),
      (try_end),

      (position_set_x, pos3, 25),
      (position_set_y, pos3, 715),
      (overlay_set_position, reg0, pos3),
      (position_set_x, pos1, 50),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1),      

      (try_begin),
        (eq, "$g_multiplayer_team_1_faction", "$g_multiplayer_team_2_faction"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_7"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_russia"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_1"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_france"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_2"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_prussia"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_3"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_austria"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_4"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_rhine"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_5"),
      (else_try),
        (eq, "$g_multiplayer_team_2_faction", "fac_britain"),
        (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_6"),
      (try_end),

      (position_set_x, pos3, 25),
      (position_set_y, pos3, 660),
      (overlay_set_position, reg0, pos3),
      (position_set_x, pos1, 50),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1),      

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (team_get_score, ":team_1_score", 0),
      (team_get_score, ":team_2_score", 1),
      (try_begin),
        (this_or_next|neq, ":team_1_score", "$g_multiplayer_team_1_last_displayed_score"),
        (neq, ":team_2_score", "$g_multiplayer_team_2_last_displayed_score"),
        (assign, "$g_multiplayer_team_1_last_displayed_score", ":team_1_score"),
        (assign, "$g_multiplayer_team_2_last_displayed_score", ":team_2_score"),
      
        (str_store_faction_name, s0, "$g_multiplayer_team_1_faction"),
        (assign, reg0, ":team_1_score"),
        (overlay_set_text, "$g_multiplayer_team_1_score_display_overlay", "str_reg0"),
        (str_store_faction_name, s0, "$g_multiplayer_team_2_faction"),
        (assign, reg0, ":team_2_score"),
        (overlay_set_text, "$g_multiplayer_team_2_score_display_overlay", "str_reg0"),

##        (str_store_faction_name, s0, "$g_multiplayer_team_1_faction"),
##        (assign, reg0, ":team_1_score"),
##        (overlay_set_text, "$g_multiplayer_team_1_score_display_overlay", "str_s0_dd_reg0"),
##        (str_store_faction_name, s0, "$g_multiplayer_team_2_faction"),
##        (assign, reg0, ":team_2_score"),
##        (overlay_set_text, "$g_multiplayer_team_2_score_display_overlay", "str_s0_dd_reg0"),
      (try_end),
      ]),
    ]),


  ("multiplayer_flag_projection_display", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, 
    [
      (set_fixed_point_multiplier, 1000),

      (store_sub, ":flag_mesh", "$g_multiplayer_team_1_faction", factions_begin),
      (val_add, ":flag_mesh", multiplayer_flag_projections_begin),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_1", ":flag_mesh"),
      (val_sub, ":flag_mesh", multiplayer_flag_projections_begin),
      (val_add, ":flag_mesh", multiplayer_flag_taken_projections_begin),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_2", ":flag_mesh"),
      
      (try_begin),
        (neq, "$g_multiplayer_team_1_faction", "$g_multiplayer_team_2_faction"),
        (store_sub, ":flag_mesh", "$g_multiplayer_team_2_faction", factions_begin),
        (val_add, ":flag_mesh", multiplayer_flag_projections_begin),
        (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_3", ":flag_mesh"),
        (val_sub, ":flag_mesh", multiplayer_flag_projections_begin),
        (val_add, ":flag_mesh", multiplayer_flag_taken_projections_begin),
        (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_4", ":flag_mesh"),
      (else_try),
        (assign, ":flag_mesh", "mesh_flag_project_rb"),
        (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_3", ":flag_mesh"),
        (assign, ":flag_mesh", "mesh_flag_project_rb_miss"),
        (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_4", ":flag_mesh"),      
      (try_end),
      
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_1", pos1),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_2", pos1),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_3", pos1),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_4", pos1),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 0),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_4", 0),
      (presentation_set_duration, 999999),
      ]),
      
    (ti_on_presentation_run, 
    [
      (set_fixed_point_multiplier, 1000),
      
      (scene_prop_get_instance, ":flag_red_id", "$team_1_flag_scene_prop", 0),      
      (team_get_slot, ":team_0_flag_situation", 0, slot_team_flag_situation),      
      (try_begin),
        (neq, ":team_0_flag_situation", 1),
        (prop_instance_get_position, pos1, ":flag_red_id"), #hold position of flag of team 1 (red flag) at pos1
      (else_try),
        (entry_point_get_position, pos1, multi_base_point_team_1), #moved from above to here after auto-set position      
      (try_end),            
      (position_move_z, pos1, 200, 1),
      
      (scene_prop_get_instance, ":flag_blue_id", "$team_2_flag_scene_prop", 0),      
      (team_get_slot, ":team_1_flag_situation", 1, slot_team_flag_situation),            
      (try_begin),
        (neq, ":team_1_flag_situation", 1),
        (prop_instance_get_position, pos2, ":flag_blue_id"), #hold position of flag of team 1 (red flag) at pos1
      (else_try),
        (entry_point_get_position, pos2, multi_base_point_team_2), #moved from above to here after auto-set position      
      (try_end),      
      (position_move_z, pos2, 200, 1),
            
      (position_get_screen_projection, pos3, pos1),
      (position_get_x, ":x_pos", pos3),
      (position_get_y, ":y_pos", pos3),
      (position_set_y, pos3, ":y_pos"),
      (try_begin),
        (is_between, ":x_pos", -100, 1100),
        (is_between, ":y_pos", -100, 850),

        (multiplayer_get_my_player, ":my_player_number"),
        (try_begin),
          (ge, ":my_player_number", 0),
          (player_get_team_no, ":my_player_team", ":my_player_number"),
        (else_try),
          (assign, ":my_player_team", multi_team_spectator),
        (try_end),

        (try_begin),
          (neq, ":my_player_team", 1), #if I am at team 0 or spectator
          (try_begin),
            (neq, ":team_0_flag_situation", 1), #if our flag is not stolen
            (overlay_set_position, "$g_presentation_obj_flag_projection_display_1", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
          (else_try), #if our flag is stolen
            (try_begin),
              (eq, ":my_player_team", 0), 
              (assign, ":our_base_entry_id", multi_base_point_team_1),
            (else_try), 
              (assign, ":our_base_entry_id", multi_base_point_team_2),
            (try_end),

            (entry_point_get_position, pos5, ":our_base_entry_id"), #moved from above to here after auto-set position
            (position_get_screen_projection, pos3, pos5),

            (overlay_set_position, "$g_presentation_obj_flag_projection_display_2", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
          (try_end),
        (else_try),
          (try_begin),
            (neq, ":team_0_flag_situation", 1),
            (overlay_set_position, "$g_presentation_obj_flag_projection_display_1", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
          (try_end),
        (try_end),      
      (else_try),
        (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
        (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
      (try_end),
      
      (position_get_screen_projection, pos3, pos2),
      (position_get_x, ":x_pos", pos3),
      (position_get_y, ":y_pos", pos3),
      (position_set_y, pos3, ":y_pos"),
      (try_begin),
        (is_between, ":x_pos", -100, 1100),
        (is_between, ":y_pos", -100, 850),

        (team_get_slot, ":team_1_flag_situation", 1, slot_team_flag_situation),

        (multiplayer_get_my_player, ":my_player_number"),
        (try_begin),
          (ge, ":my_player_number", 0),
          (player_get_team_no, ":my_player_team", ":my_player_number"),
        (else_try),
          (assign, ":my_player_team", multi_team_spectator),
        (try_end),

        (try_begin),
          (neq, ":my_player_team", 0), #if I am at team 0 or spectator
          (try_begin),
            (neq, ":team_1_flag_situation", 1), #if our flag is not stolen
            (overlay_set_position, "$g_presentation_obj_flag_projection_display_3", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_4", 0),
          (else_try), #if our flag is stolen      
            (try_begin),
              (eq, ":my_player_team", 0), 
              (assign, ":our_base_entry_id", multi_base_point_team_1),
            (else_try), 
              (assign, ":our_base_entry_id", multi_base_point_team_2),
            (try_end),

            (entry_point_get_position, pos5, ":our_base_entry_id"), #moved from above to here after auto-set position
            (position_get_screen_projection, pos3, pos5),
      
            (overlay_set_position, "$g_presentation_obj_flag_projection_display_4", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_4", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 0),
          (try_end),
        (else_try),
          (try_begin),
            (neq, ":team_1_flag_situation", 1),
            (overlay_set_position, "$g_presentation_obj_flag_projection_display_3", pos3),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 1),
            (overlay_set_display, "$g_presentation_obj_flag_projection_display_4", 0),
          (try_end),
        (try_end),
      (else_try),
        (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 0),
        (overlay_set_display, "$g_presentation_obj_flag_projection_display_4", 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_flag_projection_display_bt", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for search and destroy death mode flags.
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),

      (store_sub, ":flag_mesh", "$g_multiplayer_team_1_faction", factions_begin),
      (val_add, ":flag_mesh", multiplayer_flag_projections_begin),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_1", ":flag_mesh"),

      (try_begin),
        (neq, "$g_multiplayer_team_1_faction", "$g_multiplayer_team_2_faction"),
        (store_sub, ":flag_mesh", "$g_multiplayer_team_2_faction", factions_begin),
        (val_add, ":flag_mesh", multiplayer_flag_projections_begin),
      (else_try),
        (assign, ":flag_mesh", "mesh_flag_project_rb"),
      (try_end),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_3", ":flag_mesh"),

      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),

      (overlay_set_size, "$g_presentation_obj_flag_projection_display_1", pos1),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_3", pos1),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 0),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (try_begin),
        (eq, "$g_round_ended", 0),
        (set_fixed_point_multiplier, 1000),
        (scene_prop_get_instance, ":flag_1_id", "$team_1_flag_scene_prop", 0),
        (prop_instance_get_position, pos1, ":flag_1_id"), #hold position of flag of team 1 at pos1
        (position_move_z, pos1, 250, 1),
      
        (scene_prop_get_instance, ":flag_2_id", "$team_2_flag_scene_prop", 0),
        (prop_instance_get_position, pos2, ":flag_2_id"), #hold position of flag of team 2 at pos2
        (position_move_z, pos2, 250, 1),
      
        (position_get_screen_projection, pos3, pos1),
        (position_get_x, ":x_pos", pos3),
        (position_get_y, ":y_pos", pos3),
        (position_set_y, pos3, ":y_pos"),
        (try_begin),
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),

          (overlay_set_position, "$g_presentation_obj_flag_projection_display_1", pos3),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 1),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
        (try_end),
      
        (position_get_screen_projection, pos3, pos2),
        (position_get_x, ":x_pos", pos3),
        (position_get_y, ":y_pos", pos3),
        (position_set_y, pos3, ":y_pos"),
        (try_begin),
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),

          (overlay_set_position, "$g_presentation_obj_flag_projection_display_3", pos3),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 1),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_3", 0),
        (try_end),
      (else_try),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_destructible_targets_display", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for search and destroy death mode flags.
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),     

      (try_begin),
        (eq, "$g_defender_team", 0),
        (store_sub, ":flag_mesh", "$g_multiplayer_team_1_faction", factions_begin),
      (else_try),
        (store_sub, ":flag_mesh", "$g_multiplayer_team_2_faction", factions_begin),
      (try_end),
      
      (val_add, ":flag_mesh", multiplayer_flag_projections_begin),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_1", ":flag_mesh"),
      (create_mesh_overlay, "$g_presentation_obj_flag_projection_display_2", ":flag_mesh"),

      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),

      (overlay_set_size, "$g_presentation_obj_flag_projection_display_1", pos1),
      (overlay_set_size, "$g_presentation_obj_flag_projection_display_2", pos1),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
      (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (try_begin),
        (eq, "$g_round_ended", 0),
        (set_fixed_point_multiplier, 1000),
        (scene_prop_get_instance, ":target_1_id", "$g_destructible_target_1", 0),
        (prop_instance_get_position, pos1, ":target_1_id"), 
        (prop_instance_get_position, pos1, ":target_1_id"), 
        (position_move_z, pos1, 250, 1),
        (scene_prop_get_instance, ":target_2_id", "$g_destructible_target_2", 0),
        (prop_instance_get_position, pos2, ":target_2_id"), 
        (prop_instance_get_position, pos2, ":target_2_id"), 
        (position_move_z, pos2, 250, 1),
      
        (position_get_screen_projection, pos3, pos1),
        (position_get_x, ":x_pos", pos3),
        (position_get_y, ":y_pos", pos3),
        (position_set_y, pos3, ":y_pos"),
        (try_begin),
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),
      
          (prop_instance_get_starting_position, pos5, ":target_1_id"),
          (prop_instance_get_position, pos1, ":target_1_id"),
          (get_sq_distance_between_positions_in_meters, ":dist", pos5, pos1),
          (le, ":dist", 2), #this can be 0 or 1 too.

          (overlay_set_position, "$g_presentation_obj_flag_projection_display_1", pos3),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 1),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_1", 0),
        (try_end),
      
        (position_get_screen_projection, pos3, pos2),
        (position_get_x, ":x_pos", pos3),
        (position_get_y, ":y_pos", pos3),
        (position_set_y, pos3, ":y_pos"),
        (try_begin),
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),

          (prop_instance_get_starting_position, pos5, ":target_2_id"),
          (prop_instance_get_position, pos1, ":target_2_id"),
          (get_sq_distance_between_positions_in_meters, ":dist", pos5, pos1),
          (le, ":dist", 2), #this can be 0 or 1 too.

          (overlay_set_position, "$g_presentation_obj_flag_projection_display_2", pos3),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 1),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_flag_projection_display_2", 0),
        (try_end),
      (else_try),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_respawn_time_counter", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [      
      (set_fixed_point_multiplier, 1000),

      (assign, "$g_multiplayer_respawn_counter_overlay", -1),
      (assign, "$g_multiplayer_respawn_remained_overlay", -1),
      
      (assign, ":do_not_show_respawn_counter", 0),
      (try_begin),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_round_result_in_siege_mode),
        (this_or_next|eq, "$g_round_ended", 1),
        (eq, "$g_flag_is_not_ready", 1),
        (assign, ":do_not_show_respawn_counter", 1),
      (try_end),
      (eq, ":do_not_show_respawn_counter", 0),

      (assign, "$g_multiplayer_last_respawn_counter_value", -1),
      (str_clear, s0),
      (create_text_overlay, "$g_multiplayer_respawn_counter_overlay", s0, tf_center_justify|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_respawn_counter_overlay", 0xFFFFFF),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 600),
      (overlay_set_position, "$g_multiplayer_respawn_counter_overlay", pos1),
      (position_set_x, pos1, 2000),
      (position_set_y, pos1, 2000),
      (overlay_set_size, "$g_multiplayer_respawn_counter_overlay", pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_multiplayer_respawn_remained_overlay", s0, tf_center_justify|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_respawn_remained_overlay", 0xFFFFFF),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 570),
      (overlay_set_position, "$g_multiplayer_respawn_remained_overlay", pos1),
      (position_set_x, pos1, 1400),
      (position_set_y, pos1, 1400),
      (overlay_set_size, "$g_multiplayer_respawn_remained_overlay", pos1),

      #(store_mission_timer_a, "$g_multiplayer_respawn_start_time"),
      (presentation_set_duration, 999999),
      ]),
  
    (ti_on_presentation_run, [
      (ge, "$g_multiplayer_respawn_counter_overlay", 0),
      (multiplayer_get_my_player, ":my_player_no"),
      (try_begin),
        (ge, ":my_player_no", 0),
        (player_get_team_no, ":player_team", ":my_player_no"),
        (try_begin),
          (eq, ":player_team", multi_team_spectator),
          (presentation_set_duration, 0),
        (else_try),
          (player_get_agent_id,":player_agent",":my_player_no"),
          (agent_is_active,":player_agent"),
          (agent_is_alive,":player_agent"),
          (presentation_set_duration, 0),
        (else_try),
          (store_mission_timer_a, ":current_time"),
          (store_sub, ":seconds_past_in_respawn", ":current_time", "$g_multiplayer_respawn_start_time"),
          (try_begin),
            (eq, "$g_show_no_more_respawns_remained", 0),
            (assign, ":total_respawn_time", "$g_multiplayer_respawn_period"),
            (val_add,":total_respawn_time",1), # add one because server spawns you 1 sec late.
            (try_begin),
              # we have no agent yet, we never spawned, so we will insta spawn... unless siege defender it has more checks.
              (neg|agent_is_active,":player_agent"),
              (assign,":total_respawn_time",2),
            (try_end),
            
            (try_begin),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
              (eq, ":player_team", 0), # defenders
            
              (try_begin), 
                (agent_is_active,":player_agent"),
                (val_add, ":total_respawn_time", multiplayer_siege_mod_defender_team_extra_respawn_time),
              (else_try), #new added begin, to avoid siege-crack (rejoining of defenders when they die)
                (player_get_slot, ":player_last_team_select_time", ":my_player_no", slot_player_last_team_select_time),
                (store_mission_timer_a, ":current_time"),
                (store_sub, ":elapsed_time", ":current_time", ":player_last_team_select_time"),
                 
                (assign, ":player_team_respawn_period", "$g_multiplayer_respawn_period"), 
                (val_add, ":player_team_respawn_period", multiplayer_siege_mod_defender_team_extra_respawn_time), #new added for siege mod
                (lt, ":elapsed_time", ":player_team_respawn_period"),

                (store_sub, ":round_time", ":current_time", "$g_round_start_time"),
                (ge, ":round_time", multiplayer_new_agents_finish_spawning_time),
                 
                # count players..
                (assign, ":num_active_players_in_team_0", 0),
                (assign, ":num_active_players_in_team_1", 0),
                (assign, ":num_active_players", 0),
                (assign,":num_players",multiplayer_player_loops_end),
                (try_for_range, ":cur_player", "$g_player_loops_begin", ":num_players"),
                  (player_is_active, ":cur_player"),

                  (player_get_team_no, ":cur_player_team", ":cur_player"),
                  (try_begin),
                    (eq, ":cur_player_team", 0),
                    (val_add, ":num_active_players_in_team_0", 1),
                  (else_try),
                    (eq, ":cur_player_team", 1),
                    (val_add, ":num_active_players_in_team_1", 1),
                  (try_end),

                  (val_add, ":num_active_players", 1),
                   
                  (gt,":num_active_players",2),
                  (gt,":num_active_players_in_team_0", 0),
                  (gt,":num_active_players_in_team_1", 0),
                   
                  (assign,":num_players",0), # stop looping
                (try_end),
                 
                (gt, ":num_active_players", 2),
                (store_mul, ":multipication_of_num_active_players_in_teams", ":num_active_players_in_team_0", ":num_active_players_in_team_1"),
                (neq, ":multipication_of_num_active_players_in_teams", 0),

                (assign, ":total_respawn_time", "$g_multiplayer_respawn_period"),
                (val_add, ":total_respawn_time", multiplayer_siege_mod_defender_team_extra_respawn_time),
              (try_end),
            (try_end),
          (else_try),
            (assign, ":total_respawn_time", 6), # show no lives 6 seconds?
          (try_end),
          (store_sub, ":seconds_left_in_respawn", ":total_respawn_time", ":seconds_past_in_respawn"),
          (try_begin),
            (le, ":seconds_left_in_respawn", 0),
            (presentation_set_duration, 0),
          (else_try),
            (neq, "$g_multiplayer_last_respawn_counter_value", ":seconds_left_in_respawn"),
            (assign, "$g_multiplayer_last_respawn_counter_value", ":seconds_left_in_respawn"),
            (try_begin),
              (eq, "$g_show_no_more_respawns_remained", 0),
              (assign, reg0, ":seconds_left_in_respawn"),
              (str_store_string, s0, "str_respawning_in_reg0_seconds"),
              (try_begin),
                (gt, "$g_multiplayer_number_of_respawn_count", 0),
                (store_sub, reg0, "$g_multiplayer_number_of_respawn_count", "$g_my_spawn_count"),

               # (multiplayer_get_my_player, ":my_player_no"),
               # (player_get_team_no, ":my_player_team", ":my_player_no"),
                (eq, ":player_team", 0),
      
                (try_begin),
                  (gt, reg0, 1),
                  (str_store_string, s1, "str_reg0_respawns_remained"),
                (else_try),
                  (str_store_string, s1, "str_this_is_your_last_respawn"),
                (try_end),
              (else_try),
                (str_clear, s1),                
              (try_end),
            (else_try),
              (eq, "$g_show_no_more_respawns_remained", 1),
              ##(assign, "$g_informed_about_no_more_respawns_remained", 1),
              (str_store_string, s0, "str_no_more_respawns_remained_this_round"),
              (str_clear, s1),
              (str_store_string, s1, "str_wait_next_round"),
            (try_end),
            (overlay_set_text, "$g_multiplayer_respawn_counter_overlay", s0),
            (try_begin),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),
              (overlay_set_text, "$g_multiplayer_respawn_remained_overlay", s1),
            (try_end),
          (try_end),
        (try_end),
      (else_try),
        (presentation_set_duration, 0),
      (try_end),

      (try_begin),
        (eq, "$g_multiplayer_message_type", multiplayer_message_type_round_result_in_siege_mode),
        (this_or_next|eq, "$g_round_ended", 1),
        (eq, "$g_flag_is_not_ready", 1),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_stats_chart", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_score_b"),
      (position_set_x, pos1, 100),
      (position_set_y, pos1, 100),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),
      
      (try_begin),
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
        (call_script,"script_get_playercounts_for_scoreboard_cb"),
        (assign,":team1_total",reg51),
        (assign,":team1_alive",reg52),
        (assign,":team1_dead",-1), #Not interesting
        (assign,":team2_total",reg54),
        (assign,":team2_alive",reg55),
        (assign,":team2_dead",-1), #Not interesting
        (assign,":spectator_count",reg57),
      (else_try),
        (call_script,"script_get_playercounts_for_scoreboard"),
        #(assign,":total_player_count",reg50),
        (assign,":team1_total",reg51),
        (assign,":team1_alive",reg52),
        (assign,":team1_dead",reg53),
        (assign,":team2_total",reg54),
        (assign,":team2_alive",reg55),
        (assign,":team2_dead",reg56),
        (assign,":spectator_count",reg57),
      (try_end),
      
      (assign, ":team_1_rows",":team1_total"),
      (assign, ":team_2_rows",":team2_total"),
      (assign, ":spectator_rows",":spectator_count"),
      (assign,":num_players",multiplayer_player_loops_end),
      (try_for_range, ":player_no", 0, multiplayer_player_loops_end),
        (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
        (try_begin),
          (player_is_active, ":player_no"),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 1),
        (else_try),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
        (try_end),
      (try_end),
      (try_begin),
        (gt, "$g_multiplayer_num_bots_team_1", 0),
        (val_add, ":team_1_rows", 1),
      (try_end),
      (try_begin),
        (gt, "$g_multiplayer_num_bots_team_2", 0),
        (val_add, ":team_2_rows", 1),
      (try_end),

      (assign, ":total_rows", ":team_1_rows"),
      (val_max, ":total_rows", ":team_2_rows"),
      (val_add, ":total_rows", ":spectator_rows"),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_stats_chart_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 100),
      (position_set_y, pos1, 120),#120
      (overlay_set_position, "$g_presentation_obj_stats_chart_container", pos1),
      (position_set_x, pos1, 746),
      (position_set_y, pos1, 530),#530
      (overlay_set_area_size, "$g_presentation_obj_stats_chart_container", pos1),
      (set_container_overlay, "$g_presentation_obj_stats_chart_container"),

      (store_mul, ":y_needed", ":total_rows", 20),
      (val_add, ":y_needed", 100),
      (try_begin),
        (gt, ":spectator_rows", 0),
        (val_add, ":y_needed", 70),
      (try_end),

      (multiplayer_get_my_player, ":my_player_no"),       

      (try_begin),
        (gt, ":y_needed", 490),
        (assign, "$g_stats_chart_update_period", 8),
      (else_try),
        (assign, "$g_stats_chart_update_period", 1),
      (try_end),

      (try_begin), #counting number of flags each team has.
        (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
        (call_script, "script_get_headquarters_scores"),
        (assign, ":team_1_num_flags", reg0),
        (assign, ":team_2_num_flags", reg1),
      (try_end),

      #assuming only 2 teams in scene
      (try_for_range, ":i_team", 0, multi_team_spectator),
        
        # (assign,":num_players",multiplayer_player_loops_end),
        # (try_for_range, ":player_no", 0, ":num_players"),
          # (player_is_active, ":player_no"),
          # (player_get_team_no, ":team_no", ":player_no"),
          # (eq, ":team_no", ":i_team"),
          # (val_add, ":number_of_players", 1),
        # (try_end),
        
        # MM
        (assign, ":number_of_players", 0),
        (try_begin),
          (eq,":i_team",0),
          (assign,":number_of_players",":team1_total"),
          (assign,reg40,":team1_alive"),
          (assign,reg41,":team1_dead"),
        (else_try),
          (eq,":i_team",1),
          (assign,":number_of_players",":team2_total"),
          (assign,reg40,":team2_alive"),
          (assign,reg41,":team2_dead"),
        (try_end),
        # MM
        
        (assign, reg0, ":number_of_players"),
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (try_begin),
            (neq, ":number_of_players", 1),
            (str_store_string,s5,"str_reg0_players_only"),
            (assign,reg0,reg40), #Alive players
            (str_store_string,s6,"str_reg0_alive"),
            (str_store_string,s7,"@({s5},  {s6})"),
            (create_text_overlay, reg1, s7, 0),
          (else_try),
            (str_store_string,s5,"str_reg0_player_only"),
            (assign,reg0,reg40), #Alive players
            (str_store_string,s6,"str_reg0_alive"),
            (str_store_string,s7,"@({s5},  {s6})"),
            (create_text_overlay, reg1, s7, 0),
          (try_end),
        (else_try),
          (try_begin),
            (neq, ":number_of_players", 1),
            (create_text_overlay, reg1, "str_reg0_players", 0),
          (else_try),
            (create_text_overlay, reg1, "str_reg0_player", 0),
          (try_end),
        (try_end),

        (assign, ":cur_y", ":y_needed"),
        (team_get_faction, ":cur_faction", ":i_team"),
        (str_store_faction_name, s1, ":cur_faction"),
        (create_text_overlay, reg0, s1, 0),
        (try_begin),
          (eq, ":i_team", 0),
          (overlay_set_color, reg0, 0xFF0000),
          (overlay_set_color, reg1, 0xFF0000),
        (else_try),
          (overlay_set_color, reg0, 0x0099FF),
          (overlay_set_color, reg1, 0x0099FF),
        (try_end),
        (assign, ":distance_between_teams", 373),
        (store_mul, ":cur_x", ":distance_between_teams", ":i_team"),
        (val_add, ":cur_x", 42),
        (store_add, ":cur_x_add_15", ":cur_x", 15),
        (position_set_x, pos3, ":cur_x_add_15"),
        (position_set_y, pos3, ":cur_y"),
        (store_add, ":cur_x_add_35", ":cur_x", 38),
        (position_set_x, pos1, ":cur_x_add_35"),
        (position_set_y, pos1, ":cur_y"),
        (copy_position, pos2, pos1),
        (store_sub, ":cur_y_sub_10", ":cur_y", 14),
        (position_set_x, pos2, ":cur_x_add_35"),
        (position_set_y, pos2, ":cur_y_sub_10"),
        (overlay_set_position, reg0, pos1),
        (overlay_set_position, reg1, pos2),
        (position_set_x, pos1, 1000),
        (position_set_y, pos1, 1000),
        (position_set_x, pos2, 700),
        (position_set_y, pos2, 700),
        (overlay_set_size, reg0, pos1),
        (overlay_set_size, reg1, pos2),

        (team_get_faction, ":faction_of_team_1", 0),
        (team_get_faction, ":faction_of_team_2", 1),
          
        (try_begin),
          (eq, ":faction_of_team_1", ":faction_of_team_2"),
          (eq, ":i_team", 1),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_7"),
        (else_try),
          (eq, ":cur_faction", "fac_russia"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_1"),
        (else_try),
          (eq, ":cur_faction", "fac_france"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_2"),
        (else_try),
          (eq, ":cur_faction", "fac_prussia"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_3"),
        (else_try),
          (eq, ":cur_faction", "fac_austria"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_4"),
        (else_try),
          (eq, ":cur_faction", "fac_rhine"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_5"),
        (else_try),
          (eq, ":cur_faction", "fac_britain"),
          (create_mesh_overlay, reg0, "mesh_ui_kingdom_shield_6"),
        (try_end),
      
        (position_set_x, pos1, 100),
        (position_set_y, pos1, 100),
        (overlay_set_position, reg0, pos3),
        (position_set_x, pos1, 50),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1),      

        (team_get_score, reg0, ":i_team"),
        (create_text_overlay, reg0, "str_score_reg0", tf_right_align),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 325), #325
        (store_add, ":sub_cur_y", ":cur_y", 0),
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":sub_cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1200),
        (position_set_y, pos1, 1200),
        (overlay_set_size, reg0, pos1),      

        (try_begin), #counting number of flags each team has only at hq mod.
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
          (try_begin),
            (eq, ":i_team", 0),
            (assign, reg0, ":team_1_num_flags"),
          (else_try),
            (eq, ":i_team", 1),
            (assign, reg0, ":team_2_num_flags"),
          (try_end),
          (create_text_overlay, reg0, "str_flags_reg0", 0),
          (overlay_set_color, reg0, 0xFFFFFF),
          (store_add, ":sub_cur_x", ":cur_x", 258),
          (store_add, ":sub_cur_y", ":cur_y", -10),
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":sub_cur_y"),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 600),
          (position_set_y, pos1, 600),
          (overlay_set_size, reg0, pos1),      
        (try_end),

        (val_sub, ":cur_y", 60),
      
        (create_text_overlay, reg0, "str_player_name", 0),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),

        (try_begin), #at headquarters and capture the flag write score instead before kill count
          (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
          (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_king),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),      
          (create_text_overlay, reg0, "str_score", 0),
          (overlay_set_color, reg0, 0xFFFFFF),
          (store_add, ":sub_cur_x", ":cur_x", 138),
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
        (try_end),
      
        (create_text_overlay, reg0, "str_kills", tf_center_justify),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 206), #191
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),

        (create_text_overlay, reg0, "str_deaths", tf_center_justify),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 260), #232
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),
      
        (create_text_overlay, reg0, "str_ping", tf_center_justify),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 308), #291
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),
      
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_alpha, reg0, 0xD0),
        (store_add, ":sub_cur_x", ":cur_x", 0),
        (position_set_x, pos1, ":sub_cur_x"),
        (store_add, ":sub_cur_y", ":cur_y", -10),
        (position_set_y, pos1, ":sub_cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 16500),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1),

        (val_sub, ":cur_y", 35),
      
        (store_add, ":end_cond", ":num_players", 1),
        (try_for_range, ":unused", 0, ":end_cond"),
          (assign, ":max_score_plus_death", -2147483648),
          (assign, ":max_score_plus_death_player_no", -1),
          (try_for_range, ":player_no", 0, ":num_players"),            
            (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
            (troop_slot_eq, "trp_multiplayer_data", ":slot_index", 1),
            (player_get_team_no, ":player_team", ":player_no"),
            (eq, ":player_team", ":i_team"),

            (try_begin),
              (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),      
              (player_get_score, ":kill_count", ":player_no"), #get score in "capture the flag" or "headquarters"
            (else_try),
              (player_get_kill_count, ":kill_count", ":player_no"), #get kill count in "siege" or "battle" or "team deathmatch" or "deathmatch"
            (try_end),
      
            (player_get_death_count, ":death_count", ":player_no"), #get_death_count

            (store_mul, ":player_score_plus_death", ":kill_count", 1000),
            (val_sub, ":player_score_plus_death", ":death_count"),
      
            (this_or_next|gt, ":player_score_plus_death", ":max_score_plus_death"),
            (eq, ":player_score_plus_death", -2147483648),
      
            (assign, ":max_score_plus_death", ":player_score_plus_death"),
            (assign, ":max_score_plus_death_player_no", ":player_no"),
          (try_end),
          (try_begin),
            (ge, ":max_score_plus_death_player_no", 0),
            (store_add, ":slot_index", ":max_score_plus_death_player_no", multi_data_player_index_list_begin),
            (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
      
            (try_begin),
              (eq, ":my_player_no", ":max_score_plus_death_player_no"),
              (create_mesh_overlay, reg0, "mesh_white_plane"),
              (overlay_set_color, reg0, 0xFFFFFF),
              (overlay_set_alpha, reg0, 0x35),
              (store_add, ":sub_cur_x", ":cur_x", 0),
              (position_set_x, pos1, ":sub_cur_x"),
              (store_add, ":sub_cur_y", ":cur_y", 0),
              (position_set_y, pos1, ":sub_cur_y"),
              (overlay_set_position, reg0, pos1),
              (position_set_x, pos1, 16500),
              (position_set_y, pos1, 1000),
              (overlay_set_size, reg0, pos1),
            (try_end),
  
            (try_begin), #at headquarters and capture the flag write score instead dead label before kill count
              (this_or_next|eq, "$g_multiplayer_game_type", multiplayer_game_type_capture_the_flag),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),      

              (assign, ":font_color", 0xFFFFFF),
              (player_get_agent_id, ":max_score_plus_death_agent_id", ":max_score_plus_death_player_no"),
              (try_begin),
                (this_or_next|lt, ":max_score_plus_death_agent_id", 0),
                (neg|agent_is_alive, ":max_score_plus_death_agent_id"),
                (assign, ":font_color", 0xFF0000),
              (try_end),

              (player_get_score, reg0, ":max_score_plus_death_player_no"),
              (create_text_overlay, reg0, "str_reg0", tf_right_align),
              (overlay_set_color, reg0, ":font_color"),
              (position_set_x, pos1, 750),
              (position_set_y, pos1, 750),
              (overlay_set_size, reg0, pos1),      
              (store_add, ":sub_cur_x", ":cur_x", 165), #150
              (position_set_x, pos1, ":sub_cur_x"),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, reg0, pos1),
            (else_try),
              (assign, ":font_color", 0xFFFFFF),
              (player_get_agent_id, ":max_score_plus_death_agent_id", ":max_score_plus_death_player_no"),
              (try_begin),
                (this_or_next|lt, ":max_score_plus_death_agent_id", 0),
                (neg|agent_is_alive, ":max_score_plus_death_agent_id"),
                (assign, ":font_color", 0xFF0000),
                (create_text_overlay, reg0, "str_dead", 0),
                (overlay_set_color, reg0, ":font_color"),
                (position_set_x, pos1, 750),
                (position_set_y, pos1, 750),
                (overlay_set_size, reg0, pos1),
                (store_add, ":sub_cur_x", ":cur_x", 130),
                (position_set_x, pos1, ":sub_cur_x"),
                (position_set_y, pos1, ":cur_y"),
                (overlay_set_position, reg0, pos1),
              (try_end),
            (try_end),

            (str_store_player_username, s1, ":max_score_plus_death_player_no"),
            #(try_begin),
            #  (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
            #  (str_store_string,s1,"@{s1}'s Battalion"),
            #(try_end),
            (create_text_overlay, reg0, s1, 0),
            (overlay_set_color, reg0, ":font_color"),
            (position_set_x, pos1, 750),
            (position_set_y, pos1, 750),
            (overlay_set_size, reg0, pos1),
            (position_set_x, pos1, ":cur_x"),
            (position_set_y, pos1, ":cur_y"),
            (overlay_set_position, reg0, pos1),
            
            (try_begin),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
              (assign,":num_agents_in_group",0),
              (try_for_agents,":agent"),
                (agent_is_active,":agent"),
                (agent_is_human,":agent"),
                (agent_is_alive,":agent"),
                (agent_get_team,":team",":agent"),
                (eq,":team",":i_team"),
                (agent_get_group,":group",":agent"),
                (eq,":group", ":max_score_plus_death_player_no"),
                (val_add,":num_agents_in_group",1),
              (try_end),
              (assign,reg0,":num_agents_in_group"),
              (create_text_overlay, reg0, "str_reg0_alive", 0),
              (store_add, ":sub_cur_x", ":cur_x", 123), 
              (overlay_set_color, reg0, ":font_color"),
              (position_set_x, pos1, 750),
              (position_set_y, pos1, 750),
              (overlay_set_size, reg0, pos1),
              (position_set_x, pos1, ":sub_cur_x"),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, reg0, pos1),
            (try_end),
                
            (player_get_kill_count, reg0, ":max_score_plus_death_player_no"), #get_kill_count
            (create_text_overlay, reg0, "str_reg0", tf_right_align),
            (overlay_set_color, reg0, ":font_color"),
            (position_set_x, pos1, 750),
            (position_set_y, pos1, 750),
            (overlay_set_size, reg0, pos1),      
            (store_add, ":sub_cur_x", ":cur_x", 215), #200
            (position_set_x, pos1, ":sub_cur_x"),
            (position_set_y, pos1, ":cur_y"),
            (overlay_set_position, reg0, pos1),
      
            (player_get_death_count, reg0, ":max_score_plus_death_player_no"),
            (create_text_overlay, reg0, "str_reg0", tf_right_align),
            (overlay_set_color, reg0, ":font_color"),
            (position_set_x, pos1, 750),
            (position_set_y, pos1, 750),
            (overlay_set_size, reg0, pos1),      
            (store_add, ":sub_cur_x", ":cur_x", 265), #250
            (position_set_x, pos1, ":sub_cur_x"),
            (position_set_y, pos1, ":cur_y"),
            (overlay_set_position, reg0, pos1),
      
            (player_get_ping, reg0, ":max_score_plus_death_player_no"),
            (create_text_overlay, reg0, "str_reg0", tf_right_align),
            (overlay_set_color, reg0, ":font_color"),
            (position_set_x, pos1, 750),
            (position_set_y, pos1, 750),
            (overlay_set_size, reg0, pos1),
            (store_add, ":sub_cur_x", ":cur_x", 315), #300
            (position_set_x, pos1, ":sub_cur_x"),
            (position_set_y, pos1, ":cur_y"),
            (overlay_set_position, reg0, pos1),
            (val_sub, ":cur_y", 20),
          (else_try),
            (neq, "$g_multiplayer_game_type", multiplayer_game_type_commander), #Don't write bots seprate for commander mode
            (try_begin),
              (try_begin),
                (eq, ":i_team", 0),
                (assign, ":number_of_bots_in_cur_team", "$g_multiplayer_num_bots_team_1"),
              (else_try),
                (assign, ":number_of_bots_in_cur_team", "$g_multiplayer_num_bots_team_2"),
              (try_end),
             
              (team_get_bot_kill_count, reg0, ":i_team"),
              (team_get_bot_death_count, reg1, ":i_team"),
              (try_begin),
                (this_or_next|neq, reg0, 0),
                (this_or_next|neq, reg1, 0),
                (neq, ":number_of_bots_in_cur_team", 0),
                (assign, ":write_bot_informations_of_team", 1),
              (else_try),
                (assign, ":write_bot_informations_of_team", 0),
              (try_end),
      
              (eq, ":write_bot_informations_of_team", 1),

              (assign, ":number_of_alive_bots", 0),
              (try_for_agents, ":cur_agent"),
                (agent_is_active,":cur_agent"),
                (agent_is_non_player, ":cur_agent"),
                (agent_is_alive, ":cur_agent"),
                (agent_get_team, ":cur_agent_team", ":cur_agent"),
                (eq, ":cur_agent_team", ":i_team"),
                (val_add, ":number_of_alive_bots", 1),
              (try_end),
              (store_sub, ":number_of_dead_bots", ":number_of_bots_in_cur_team", ":number_of_alive_bots"),
              (try_begin),
                (eq, ":number_of_alive_bots", 0),
                (assign, ":font_color", 0xFF0000),
              (else_try),
                (assign, ":font_color", 0xD0D0D0),
              (try_end),

              (try_begin),
                (gt, ":number_of_dead_bots", 0),
                (try_begin),
                  (eq, ":number_of_bots_in_cur_team", 1),
                  (create_text_overlay, reg0, "str_dead", 0),
                  (store_add, ":sub_cur_x", ":cur_x", 130),
                (else_try),
                  (assign, reg0, ":number_of_dead_bots"),
                  (create_text_overlay, reg0, "str_reg0_dead", 0),
                  (store_add, ":sub_cur_x", ":cur_x", 123),
                (try_end),      
                (overlay_set_color, reg0, ":font_color"),
                (position_set_x, pos1, 750),
                (position_set_y, pos1, 750),
                (overlay_set_size, reg0, pos1),
                (position_set_x, pos1, ":sub_cur_x"),
                (position_set_y, pos1, ":cur_y"),
                (overlay_set_position, reg0, pos1),
              (try_end),

              (try_begin),
                (gt, ":number_of_bots_in_cur_team", 1),
                (assign, reg0, ":number_of_bots_in_cur_team"),
                (create_text_overlay, reg0, "str_bots_reg0_agents", 0),
              (else_try),
                (create_text_overlay, reg0, "str_bot_1_agent", 0),
              (try_end),
              (overlay_set_color, reg0, ":font_color"),
              (position_set_x, pos1, 750),
              (position_set_y, pos1, 750),
              (overlay_set_size, reg0, pos1),
              (position_set_x, pos1, ":cur_x"),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, reg0, pos1),
      
              (team_get_bot_kill_count, reg0, ":i_team"),
              (create_text_overlay, reg0, "str_reg0", tf_right_align),
              (overlay_set_color, reg0, ":font_color"),
              (position_set_x, pos1, 750),
              (position_set_y, pos1, 750),
              (overlay_set_size, reg0, pos1),
              (store_add, ":sub_cur_x", ":cur_x", 215), #200
              (position_set_x, pos1, ":sub_cur_x"),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, reg0, pos1),
      
              (team_get_bot_death_count, reg0, ":i_team"),
              (create_text_overlay, reg0, "str_reg0", tf_right_align),
              (overlay_set_color, reg0, ":font_color"),
              (position_set_x, pos1, 750),
              (position_set_y, pos1, 750),
              (overlay_set_size, reg0, pos1),
              (store_add, ":sub_cur_x", ":cur_x", 265), #250
              (position_set_x, pos1, ":sub_cur_x"),
              (position_set_y, pos1, ":cur_y"),
              (overlay_set_position, reg0, pos1),
              (val_sub, ":cur_y", 20),
            (try_end),
            (assign, ":end_cond", 0), #all players are written for this team, break
          (try_end),
        (try_end),

        (try_begin),
          (eq, ":i_team", 0),
          (assign, ":old_cur_y", ":cur_y"),
        (try_end),
      (try_end),

      (try_begin),
        (le, ":old_cur_y", ":cur_y"),
        (assign, ":cur_y", ":old_cur_y"),
      (try_end),

      (assign, ":cur_x", 42),

      #white line between playing players and spectators
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (store_add, ":sub_cur_x", ":cur_x", 0),
      (position_set_x, pos1, ":sub_cur_x"),
      (store_add, ":sub_cur_y", ":cur_y", 10),
      (position_set_y, pos1, ":sub_cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 36000),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1), 

      (try_begin),
        (gt, ":spectator_rows", 0),

        (assign, ":cur_x", 280),
        (val_sub, ":cur_y", 50),
        
        # MM
        (assign,reg43,":spectator_count"),
        
        #"spectators" text 
        (create_text_overlay, reg0, "str_spectators", 0),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1000),
        (position_set_y, pos1, 1000),
        (overlay_set_size, reg0, pos1),
        
        (create_text_overlay, reg0, "@( {reg43} )", tf_right_align),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 118), #200
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 800),
        (position_set_y, pos1, 800),
        (overlay_set_size, reg0, pos1),

        (create_text_overlay, reg0, "str_ping", tf_right_align),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 215), #200
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),

        #white line for spectators list
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_alpha, reg0, 0xD0),
        (store_add, ":sub_cur_x", ":cur_x", 0),
        (position_set_x, pos1, ":sub_cur_x"),
        (store_add, ":sub_cur_y", ":cur_y", -10),
        (position_set_y, pos1, ":sub_cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 12000),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1),

        (val_sub, ":cur_y", 30),

        (assign, ":font_color", 0xC0C0C0),

        (store_add, ":end_cond", ":num_players", 1),
        (try_for_range, ":player_no", 0, ":end_cond"),
          (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
          (troop_slot_eq, "trp_multiplayer_data", ":slot_index", 1),

          (player_get_team_no, ":player_team", ":player_no"),
          (eq, ":player_team", multi_team_spectator), #to not to allow dedicated server to pass below, dedicated servers have -1 for team_no not 2(multi_team_spectator).

          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 1),

          (try_begin),
            (eq, ":my_player_no", ":player_no"),
            (create_mesh_overlay, reg0, "mesh_white_plane"),
            (overlay_set_color, reg0, 0xFFFFFF),
            (overlay_set_alpha, reg0, 0x35),
            (store_add, ":sub_cur_x", ":cur_x", 0),
            (position_set_x, pos1, ":sub_cur_x"),
            (store_add, ":sub_cur_y", ":cur_y", 0),
            (position_set_y, pos1, ":sub_cur_y"),
            (overlay_set_position, reg0, pos1),
            (position_set_x, pos1, 12000),
            (position_set_y, pos1, 1000),
            (overlay_set_size, reg0, pos1),
          (try_end),

          (str_store_player_username, s1, ":player_no"),
          (create_text_overlay, reg0, s1, 0),
          (overlay_set_color, reg0, ":font_color"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (position_set_x, pos1, ":cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          
          (player_get_ping, reg0, ":player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, ":font_color"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 215), #200
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (val_sub, ":cur_y", 20),      
        (try_end),
      (try_end),

      (omit_key_once, key_mouse_scroll_up),
      (omit_key_once, key_mouse_scroll_down),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (this_or_next|key_clicked, key_mouse_scroll_up),
        (key_clicked, key_mouse_scroll_down),
        (omit_key_once, key_mouse_scroll_up),
        (omit_key_once, key_mouse_scroll_down),
      (try_end),
      (try_begin),
        (eq, "$g_multiplayer_stats_chart_opened_manually", 1),
        (neg|game_key_is_down, gk_leave),
        (assign, "$g_multiplayer_stats_chart_opened_manually", 0),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
      (try_end),
      (try_begin),
        (store_mul, ":update_period_time_limit", "$g_stats_chart_update_period", 1000),
        (gt, ":cur_time", ":update_period_time_limit"),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_stats_chart"),
      (try_end),
      ]),
    ]),

  #this score table is used in only deathmatch
  ("multiplayer_stats_chart_deathmatch", prsntf_read_only|prsntf_manual_end_only, 0, [ 
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_score_a"),
      (position_set_x, pos1, 295),
      (position_set_y, pos1, 115),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),
      
       (call_script,"script_get_playercounts_for_scoreboard"),
      # (assign,":total_player_count",reg50),
       (assign,":team1_total",reg51),
      # (assign,":team1_alive",reg52),
      # (assign,":team1_dead",reg53),
       (assign,":team2_total",reg54),
      # (assign,":team2_alive",reg55),
      # (assign,":team2_dead",reg56),
       (assign,":spectator_count",reg57),
      
       (store_add, ":team_total",":team1_total",":team2_total"),
      # (store_add, ":team_alive",":team1_alive",":team2_alive"),
      # (store_add, ":team_dead",":team1_dead",":team2_dead"),
      
      
      (assign, ":team_rows",":team_total"),
      (assign, ":spectator_rows",":spectator_count"),
      (assign,":num_players",multiplayer_player_loops_end),
      (try_for_range, ":player_no", 0, multiplayer_player_loops_end),
        (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
        (try_begin),
          (player_is_active, ":player_no"),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 1),
        (else_try),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
        (try_end),
      (try_end),
      (try_begin),
        (this_or_next|gt, "$g_multiplayer_num_bots_team_1", 0),
        (gt, "$g_multiplayer_num_bots_team_2", 0),
        (val_add, ":team_rows", 1),
      (try_end),

      (store_add, ":total_rows", ":team_rows", ":spectator_rows"),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_stats_chart_deathmatch_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 300),
      (position_set_y, pos1, 140),
      (overlay_set_position, "$g_presentation_obj_stats_chart_deathmatch_container", pos1),
      (position_set_x, pos1, 346),
      (position_set_y, pos1, 530),
      (overlay_set_area_size, "$g_presentation_obj_stats_chart_deathmatch_container", pos1),
      (set_container_overlay, "$g_presentation_obj_stats_chart_deathmatch_container"),

      (store_mul, ":y_needed", ":total_rows", 20),
      (val_add, ":y_needed", 80),
      (try_begin),
        (gt, ":spectator_rows", 0),
        (val_add, ":y_needed", 70),
      (try_end),

      (try_begin),
        (ge, ":total_rows", 17),
        (assign, "$g_stats_chart_update_period", 10),
      (else_try),
        (assign, "$g_stats_chart_update_period", 1),
      (try_end),

      (multiplayer_get_my_player, ":my_player_no"),
      
      
      

      #(assign, ":cur_y", ":y_needed"),
      # (try_begin),
        # (eq, ":i_team", 0),
        
      # (else_try),
        # (overlay_set_color, reg1, 0x0099FF),
      # (try_end),
      #(assign, ":cur_x", 42),
      #(store_mul, ":cur_x", ":distance_between_teams", ":i_team"),
      #(val_add, ":cur_x", 42),
      # (store_add, ":cur_x_add_35", ":cur_x", 37),
      # (store_sub, ":cur_y_sub_10", ":cur_y", 14),

      # MM
      
      

      #assuming only 2 teams in scene
      (assign, ":cur_y", ":y_needed"),
      (assign, ":cur_x", 42),
      
      
      # MM
      # (assign,reg0, ":team_total"),
      # (assign,reg40,":team_alive"),
      # (assign,reg41,":team_dead"),
      # (try_begin),
        # (neq, ":team_total", 1),
        # (create_text_overlay, reg1, "str_reg0_players", 0),
      # (else_try),
        # (create_text_overlay, reg1, "str_reg0_player", 0),
      # (try_end),
      # (overlay_set_color, reg1, 0xFFFFFF),
      # (store_sub,":cur_x_sub20",":cur_x",20),
      # (position_set_x, pos1, ":cur_x_sub20"),
      # (position_set_y, pos1, ":cur_y"),
      # (overlay_set_position, reg1, pos1),
      # (position_set_x, pos1, 800),
      # (position_set_y, pos1, 800),
      # (overlay_set_size, reg1, pos1),
      # MM
      
      
      (create_text_overlay, reg0, "str_player_name", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_text_overlay, reg0, "str_kills", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 179), #164
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_text_overlay, reg0, "str_deaths", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 233), #205
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_text_overlay, reg0, "str_ping", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 282), #264
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (store_add, ":sub_cur_x", ":cur_x", 0),
      (position_set_x, pos1, ":sub_cur_x"),
      (store_add, ":sub_cur_y", ":cur_y", -10),
      (position_set_y, pos1, ":sub_cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 15250),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1),

      (val_sub, ":cur_y", 35),
      
      (store_add, ":end_cond", ":num_players", 1),
      (try_for_range, ":unused", 0, ":end_cond"),
        (assign, ":max_score_plus_death", -2147483648),
        (assign, ":max_kills_player_no", -1),
        (try_for_range, ":player_no", 0, ":num_players"),
          (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
          (troop_slot_eq, "trp_multiplayer_data", ":slot_index", 1),
          (player_get_team_no, ":player_team", ":player_no"),
          (this_or_next|eq, ":player_team", 0),
          (eq, ":player_team", 1),

          (player_get_kill_count, ":kill_count", ":player_no"),
          (player_get_death_count, ":death_count", ":player_no"), #get_death_count
          (store_mul, ":player_score_plus_death", ":kill_count", 1000),
          (val_sub, ":player_score_plus_death", ":death_count"),
      
          (this_or_next|gt, ":player_score_plus_death", ":max_score_plus_death"),
          (eq, ":player_score_plus_death", -2147483648),
      
          (assign, ":max_score_plus_death", ":player_score_plus_death"),
          (assign, ":max_kills_player_no", ":player_no"),
        (try_end),
        (try_begin),
          (ge, ":max_kills_player_no", 0),
          (store_add, ":slot_index", ":max_kills_player_no", multi_data_player_index_list_begin),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
          (str_store_player_username, s1, ":max_kills_player_no"),
      
          (try_begin),
            (eq, ":my_player_no", ":max_kills_player_no"),
            (create_mesh_overlay, reg0, "mesh_white_plane"),
            (overlay_set_color, reg0, 0xFFFFFF),
            (overlay_set_alpha, reg0, 0x35),
            (store_add, ":sub_cur_x", ":cur_x", 0),
            (position_set_x, pos1, ":sub_cur_x"),
            (store_add, ":sub_cur_y", ":cur_y", 0),
            (position_set_y, pos1, ":sub_cur_y"),
            (overlay_set_position, reg0, pos1),
            (position_set_x, pos1, 16000),
            (position_set_y, pos1, 1000),
            (overlay_set_size, reg0, pos1),
          (try_end),

          (create_text_overlay, reg0, s1, 0),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (position_set_x, pos1, ":cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (player_get_kill_count, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),      
          (store_add, ":sub_cur_x", ":cur_x", 188), #173
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (player_get_death_count, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),      
          (store_add, ":sub_cur_x", ":cur_x", 238), #223
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (player_get_ping, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, 0xFFFFFF),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 288), #273
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (val_sub, ":cur_y", 20),
        (else_try),
          (store_add, ":number_of_bots", "$g_multiplayer_num_bots_team_1", "$g_multiplayer_num_bots_team_2"),
          (ge, ":number_of_bots", 1),

          (try_begin),
            (gt, ":number_of_bots", 1),
            (assign, reg0, ":number_of_bots"),
            (create_text_overlay, reg0, "str_bots_reg0_agents", 0),
          (else_try),
            (create_text_overlay, reg0, "str_bot_1_agent", 0),
          (try_end),
      
          (overlay_set_color, reg0, 0xD0D0D0),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (position_set_x, pos1, ":cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (team_get_bot_kill_count, reg0, 0),
          (assign, ":bot_kill_count", reg0),
          (team_get_bot_kill_count, reg0, 1),
          (val_add, ":bot_kill_count", reg0),
          (assign, reg0, ":bot_kill_count"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, 0xD0D0D0),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 188), #173
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (team_get_bot_death_count, reg0, 0),
          (assign, ":bot_death_count", reg0),
          (team_get_bot_death_count, reg0, 1),
          (val_add, ":bot_death_count", reg0),
          (assign, reg0, ":bot_death_count"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, 0xD0D0D0),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 238), #223
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (val_sub, ":cur_y", 20),

          (assign, ":end_cond", 0), #all players are written, break
        (else_try),
          (assign, ":end_cond", 0), #all players are written, break
        (try_end),
      (try_end),

      (assign, ":cur_x", 42),

      #white line between playing players and spectators
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (store_add, ":sub_cur_x", ":cur_x", 0),
      (position_set_x, pos1, ":sub_cur_x"),
      (store_add, ":sub_cur_y", ":cur_y", 10),
      (position_set_y, pos1, ":sub_cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 15250),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1), 

      (try_begin),
        (gt, ":spectator_rows", 0),

        (assign, ":cur_x", 75),
        (val_sub, ":cur_y", 50),
        
        # MM
        #(assign,reg43,":spectator_count"),
        
        #"spectators" text
        (create_text_overlay, reg0, "str_spectators", 0),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1000),
        (position_set_y, pos1, 1000),
        (overlay_set_size, reg0, pos1),

        (create_text_overlay, reg0, "str_ping", tf_center_justify),
        (overlay_set_color, reg0, 0xFFFFFF),
        (store_add, ":sub_cur_x", ":cur_x", 218), #200
        (position_set_x, pos1, ":sub_cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),
        (overlay_set_size, reg0, pos1),

        #white line for spectators list
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_alpha, reg0, 0xD0),
        (store_add, ":sub_cur_x", ":cur_x", 0),
        (position_set_x, pos1, ":sub_cur_x"),
        (store_add, ":sub_cur_y", ":cur_y", -10),
        (position_set_y, pos1, ":sub_cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 12000),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1), 

        (val_sub, ":cur_y", 30),

        (assign, ":font_color", 0xC0C0C0),
        
        (store_add, ":end_cond", ":num_players", 1),
        (try_for_range, ":player_no", 0, ":end_cond"),
          (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
          (troop_slot_eq, "trp_multiplayer_data", ":slot_index", 1),

          (player_get_team_no, ":player_team", ":player_no"),
          (eq, ":player_team", multi_team_spectator), #to not to allow dedicated server to pass below, dedicated servers have -1 for team_no not 2(multi_team_spectator).

          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 1),

          (try_begin),
            (eq, ":my_player_no", ":player_no"),
            (create_mesh_overlay, reg0, "mesh_white_plane"),
            (overlay_set_color, reg0, 0xFFFFFF),
            (overlay_set_alpha, reg0, 0x35),
            (store_add, ":sub_cur_x", ":cur_x", 0),
            (position_set_x, pos1, ":sub_cur_x"),
            (store_add, ":sub_cur_y", ":cur_y", 0),
            (position_set_y, pos1, ":sub_cur_y"),
            (overlay_set_position, reg0, pos1),
            (position_set_x, pos1, 12000), #16500
            (position_set_y, pos1, 1000),
            (overlay_set_size, reg0, pos1),
          (try_end),

          (str_store_player_username, s1, ":player_no"),
          (create_text_overlay, reg0, s1, 0),
          (overlay_set_color, reg0, ":font_color"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (position_set_x, pos1, ":cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          
          (player_get_ping, reg0, ":player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, ":font_color"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 215), #200
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (val_sub, ":cur_y", 20),      
        (try_end),
      (try_end),

      (omit_key_once, key_mouse_scroll_up),
      (omit_key_once, key_mouse_scroll_down),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (this_or_next|key_clicked, key_mouse_scroll_up),
        (key_clicked, key_mouse_scroll_down),
        (omit_key_once, key_mouse_scroll_up),
        (omit_key_once, key_mouse_scroll_down),
      (try_end),
      (try_begin),
        (eq, "$g_multiplayer_stats_chart_opened_manually", 1),
        (neg|game_key_is_down, gk_leave),
        (assign, "$g_multiplayer_stats_chart_opened_manually", 0),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
      (try_end),
      (try_begin),
        (store_mul, ":update_period_time_limit", "$g_stats_chart_update_period", 1000),
        (gt, ":cur_time", ":update_period_time_limit"),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_stats_chart_deathmatch"),
      (try_end),
      ]),
    ]),

  ("multiplayer_escape_menu", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 20),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1185),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_escape_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 30),
      (overlay_set_position, "$g_presentation_obj_escape_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 650),
      (overlay_set_area_size, "$g_presentation_obj_escape_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_escape_menu_container"),

      # Vincenzo begin
      (assign, ":cur_y", 600),
      # Vincenzo end

      (create_text_overlay, reg0, "str_choose_an_option", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (create_button_overlay, "$g_presentation_obj_escape_menu_1", "str_choose_faction", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_1", 0xFFFFFF),
      (multiplayer_get_my_team, ":my_team"),
      (assign, "$g_presentation_obj_escape_menu_2", -1),
      (assign, "$g_presentation_obj_escape_menu_3", -1),
      (assign, "$g_presentation_obj_escape_menu_6", -1),
      (assign, "$g_presentation_obj_escape_menu_7", -1),
      #(assign, "$g_presentation_obj_escape_menu_8", -1),#patch1115 61/6
      (assign, "$g_presentation_obj_escape_menu_9", -1),
      (assign, "$g_presentation_obj_escape_menu_10", -1),
      (assign, "$g_presentation_obj_escape_menu_11", -1),
      (assign, "$g_presentation_obj_escape_menu_12", -1),
      (assign, "$g_presentation_obj_escape_menu_13", -1),
      # Vincenzo begin
      (assign, "$g_presentation_obj_escape_menu_14", -1),
      (assign, "$g_presentation_obj_escape_menu_15", -1),
      (assign, "$g_presentation_obj_escape_menu_16", -1),
      (assign, "$g_presentation_obj_escape_menu_17", -1),
      #(assign, "$g_presentation_obj_escape_menu_18", -1),#patch1115 61/7
     # (assign, "$g_presentation_obj_escape_menu_19", -1),#patch1115 61/8
      (assign, "$g_presentation_obj_escape_menu_20", -1), #patch1115 46/9
	  (assign, "$g_presentation_obj_escape_menu_21", -1), #patch1115 58/8
      # Vincenzo end
      (try_begin),
        (multiplayer_get_my_team,":my_team"),
        (is_between, ":my_team", 0, multi_team_spectator),
        (create_button_overlay, "$g_presentation_obj_escape_menu_3", "str_choose_items", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_3", 0xFFFFFF),
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_headquarters),
          (create_button_overlay, "$g_presentation_obj_escape_menu_2", "str_choose_troop", 0),
          (overlay_set_color, "$g_presentation_obj_escape_menu_2", 0xFFFFFF),
        (try_end),
      (try_end),
      (create_button_overlay, "$g_presentation_obj_escape_menu_4", "str_options", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_4", 0xFFFFFF),
      (create_button_overlay, "$g_presentation_obj_escape_menu_5", "str_redefine_keys", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_5", 0xFFFFFF),

      (create_button_overlay, "$g_presentation_obj_escape_menu_13", "str_show_game_rules", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_13", 0xFFFFFF),

      (multiplayer_get_my_player, ":my_player_no"),
      (try_begin),
        (this_or_next|player_is_admin, ":my_player_no"), # Custom poll is enabled for admins
        (this_or_next|eq, "$g_multiplayer_maps_voteable", 1),
        (this_or_next|eq, "$g_multiplayer_factions_voteable", 1),
        (this_or_next|gt, "$g_multiplayer_num_bots_voteable", 0),
        (this_or_next|eq, "$g_multiplayer_kick_voteable", 1),
        (eq, "$g_multiplayer_ban_voteable", 1),
        (create_button_overlay, "$g_presentation_obj_escape_menu_6", "str_submit_a_poll", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_6", 0xFFFFFF),
        (assign, "$g_presentation_obj_escape_menu_6_available", 1),
        (try_begin),
          (ge, ":my_player_no", 0),
          # Vincenzo begin
          (neg|player_is_admin, ":my_player_no"),
          # Vincenzo end
          (player_get_slot, ":last_poll_time", ":my_player_no", slot_player_poll_disabled_until_time),
          (store_mission_timer_a, ":mission_timer"),
          (lt, ":mission_timer", ":last_poll_time"),
          (overlay_set_color, "$g_presentation_obj_escape_menu_6", 0x888888),
          (overlay_set_hilight_color, "$g_presentation_obj_escape_menu_6", 0x888888),
          (assign, "$g_presentation_obj_escape_menu_6_available", 0),
        (try_end),
      (try_end),

      (try_begin),
        (ge, ":my_player_no", 0),
        (player_is_admin, ":my_player_no"),
        (create_button_overlay, "$g_presentation_obj_escape_menu_7", "str_administrator_panel", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_7", 0xFFFFFF),
        #(create_button_overlay, "$g_presentation_obj_escape_menu_8", "str_kick_player", 0),#patch1115 61/3
        #(overlay_set_color, "$g_presentation_obj_escape_menu_8", 0xFFFFFF),
        (create_button_overlay, "$g_presentation_obj_escape_menu_9", "str_ban_player", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_9", 0xFFFFFF),
        # Vincenzo begin
        (create_button_overlay, "$g_presentation_obj_escape_menu_14", "str_ban_player_temp", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_14", 0xFFFFFF),
        (create_button_overlay, "$g_presentation_obj_escape_menu_15", "str_slay_player", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_15", 0xFFFFFF),
        (create_button_overlay, "$g_presentation_obj_escape_menu_16", "str_revive_player", 0),#patch1115 46/2 start
        (overlay_set_color, "$g_presentation_obj_escape_menu_16", 0xFFFFFF),
        (create_button_overlay, "$g_presentation_obj_escape_menu_17", "str_more_admin_tools", 0),#patch1115 61/2 start
        (overlay_set_color, "$g_presentation_obj_escape_menu_17", 0xFFFFFF),
        #(create_button_overlay, "$g_presentation_obj_escape_menu_17", "str_freeze_player", 0),
        #(overlay_set_color, "$g_presentation_obj_escape_menu_17", 0xFFFFFF),
        #(create_button_overlay, "$g_presentation_obj_escape_menu_18", "str_swap_player", 0),
        #(overlay_set_color, "$g_presentation_obj_escape_menu_18", 0xFFFFFF),
        #(create_button_overlay, "$g_presentation_obj_escape_menu_19", "str_spec_player", 0),
        #(overlay_set_color, "$g_presentation_obj_escape_menu_19", 0xFFFFFF),#patch1115 61/2 end
        (create_button_overlay, "$g_presentation_obj_escape_menu_20", "str_admin_cheats", 0), 
        (overlay_set_color, "$g_presentation_obj_escape_menu_20", 0xFFFFFF), #patch1115 46/2 end
        # Vincenzo end
      (try_end),

      (create_button_overlay, "$g_presentation_obj_escape_menu_11", "str_mute_player", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_11", 0xFFFFFF),
      (create_button_overlay, "$g_presentation_obj_escape_menu_21", "str_suicide_player", 0),#patch1115 58/1
      (overlay_set_color, "$g_presentation_obj_escape_menu_21", 0xFFFFFF),

      (try_begin),
        (assign, "$g_presentation_obj_escape_menu_12", -1),
        (assign, ":any_muted", 0),
        (assign,":play_end_cond",multiplayer_player_loops_end),
        (try_for_range, ":player_no", 0, ":play_end_cond"),
          (player_is_active, ":player_no"),
          (player_get_is_muted, ":is_muted", ":player_no"),
          (eq, ":is_muted", 1),
          (assign, ":any_muted", 1),
          (assign, ":play_end_cond",0),
        (try_end),
        (eq, ":any_muted", 1),
        (create_button_overlay, "$g_presentation_obj_escape_menu_12", "str_unmute_player", 0),
        (overlay_set_color, "$g_presentation_obj_escape_menu_12", 0xFFFFFF),
      (try_end),

      (create_button_overlay, "$g_presentation_obj_escape_menu_10", "str_quit", 0),
      (overlay_set_color, "$g_presentation_obj_escape_menu_10", 0xFFFFFF),

      (position_set_x, pos1, 130),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_1", pos1),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_2", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_2", pos1),
      (try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_3", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_3", pos1),
      (try_end),
      (val_sub, ":cur_y", escape_menu_item_height),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_4", pos1),
      (val_sub, ":cur_y", escape_menu_item_height),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_5", pos1),
      (val_sub, ":cur_y", escape_menu_item_height),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_13", pos1),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_6", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_6", pos1),
      (try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_7", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_7", pos1),
      (try_end),
      #(try_begin),
       # (ge, "$g_presentation_obj_escape_menu_8", 0),#patch1115 61/4
       # (val_sub, ":cur_y", escape_menu_item_height),
       # (position_set_y, pos1, ":cur_y"),
       # (overlay_set_position, "$g_presentation_obj_escape_menu_8", pos1),
      #(try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_9", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_9", pos1),
      (try_end),
      # Vincenzo begin
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_14", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_14", pos1),
      (try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_15", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_15", pos1),
      (try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_16", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_16", pos1),
      (try_end),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_17", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_17", pos1),
      (try_end),
      #(try_begin),#patch1115 61/5 start
      #  (ge, "$g_presentation_obj_escape_menu_18", 0),
      ##  (val_sub, ":cur_y", escape_menu_item_height),
       # (position_set_y, pos1, ":cur_y"),
      #  (overlay_set_position, "$g_presentation_obj_escape_menu_18", pos1),
      #(try_end),
      #(try_begin),
      #  (ge, "$g_presentation_obj_escape_menu_19", 0),
      #  (val_sub, ":cur_y", escape_menu_item_height),
      #  (position_set_y, pos1, ":cur_y"),
      #  (overlay_set_position, "$g_presentation_obj_escape_menu_19", pos1),
     # (try_end),#patch1115 61/5 end
      (try_begin),#PATCH1115 fix 46/1
        (ge, "$g_presentation_obj_escape_menu_20", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_20", pos1),
      (try_end),
      # Vincenzo end
      (val_sub, ":cur_y", escape_menu_item_height),#Patch1115 58/2 start
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_21", pos1),#Patch1115 58/2 end      
      (val_sub, ":cur_y", escape_menu_item_height),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_11", pos1),
      (try_begin),
        (ge, "$g_presentation_obj_escape_menu_12", 0),
        (val_sub, ":cur_y", escape_menu_item_height),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_escape_menu_12", pos1),
      (try_end),
      (val_sub, ":cur_y", escape_menu_item_height),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_escape_menu_10", pos1),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_begin),
        (eq, ":object", "$g_presentation_obj_escape_menu_1"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_team_select"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_2"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_conquest_flag_select"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_3"),
        (presentation_set_duration, 0),
        (try_begin),
          (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
          (start_presentation, "prsnt_multiplayer_troop_select"),
        (else_try),
          (start_presentation, "prsnt_multiplayer_item_select"),
        (try_end),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_4"),
        (presentation_set_duration, 0),
        (change_screen_options),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_5"),
        (presentation_set_duration, 0),
        (change_screen_controls),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_6"),
        (eq, "$g_presentation_obj_escape_menu_6_available", 1),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_poll_menu"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_7"),
        (presentation_set_duration, 0),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_request_map_name_no_open, "$g_multiplayer_selected_map"),
        (multiplayer_send_message_to_server, multiplayer_event_open_admin_panel),
      #(else_try),#patch1115 61/9
        #(eq, ":object", "$g_presentation_obj_escape_menu_8"),
        #(presentation_set_duration, 0),
        #(assign, "$g_multiplayer_players_list_action_type", players_list_action_kick), #admin kick
        #(start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_9"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_ban), #admin ban
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_10"),
        
        # MM stop da sounds
        (try_for_agents, ":cur_agent"),
          (agent_is_active,":cur_agent"),
          (agent_stop_sound,":cur_agent"),
        (try_end),
        # MM
        
        (presentation_set_duration, 0),
        (finish_mission, 0),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_11"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_mute), #mute player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_12"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_unmute), #unmute player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_13"),
        (presentation_set_duration, 0),
        (multiplayer_send_message_to_server, multiplayer_event_open_game_rules),
      # Vincenzo begin
      (else_try),#PATCH1115 58/3
        (eq, ":object", "$g_presentation_obj_escape_menu_21"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_confirm_suicide"),
        #(multiplayer_send_int_to_server, multiplayer_event_send_player_action, player_action_suicide),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_14"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_ban_temp), #admin temp ban
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_15"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_slay), #admin slay
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_16"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_revive), #admin revive
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_17"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_more_admin_tools"),
        #(assign, "$g_multiplayer_players_list_action_type", players_list_action_freeze), #admin freeze #patch1115 61/10 start
        #(start_presentation, "prsnt_multiplayer_show_players_list"),
     # (else_try),
       # (eq, ":object", "$g_presentation_obj_escape_menu_18"),
        #(presentation_set_duration, 0),
        #(assign, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
       # (start_presentation, "prsnt_multiplayer_show_players_list"),
     # (else_try),
       # (eq, ":object", "$g_presentation_obj_escape_menu_19"),
       # (presentation_set_duration, 0),
        #(assign, "$g_multiplayer_players_list_action_type", players_list_action_spec), #admin swap to Spectate
        #(start_presentation, "prsnt_multiplayer_show_players_list"), #patch1115 61/10 end
      (else_try),
        (eq, ":object", "$g_presentation_obj_escape_menu_20"),
        (presentation_set_duration, 0),
        (start_presentation, "prsnt_multiplayer_cheat_menu"),
      # Vincenzo end
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_poll_menu", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_poll_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_poll_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_poll_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_poll_menu_container"),

      (assign, "$g_presentation_obj_poll_menu_1", -1),
      (assign, "$g_presentation_obj_poll_menu_2", -1),
      (assign, "$g_presentation_obj_poll_menu_3", -1),
      (assign, "$g_presentation_obj_poll_menu_4", -1),
      (assign, "$g_presentation_obj_poll_menu_5", -1),
      (assign, "$g_presentation_obj_poll_menu_6", -1),#hotfix

      (assign, ":cur_y", 450),

      (create_text_overlay, reg0, "str_choose_a_poll_type", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (position_set_x, pos1, 60),

      (try_begin),
        (eq, "$g_multiplayer_maps_voteable", 1),
        (create_button_overlay, "$g_presentation_obj_poll_menu_1", "str_poll_for_changing_the_map", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_1", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_1", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (eq, "$g_multiplayer_factions_voteable", 1),
        (create_button_overlay, "$g_presentation_obj_poll_menu_4", "str_poll_for_changing_the_map_and_factions", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_4", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_4", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (gt, "$g_multiplayer_num_bots_voteable", 0),
        (create_button_overlay, "$g_presentation_obj_poll_menu_5", "str_poll_for_changing_number_of_bots", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_5", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_5", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (eq, "$g_multiplayer_kick_voteable", 1),
        (create_button_overlay, "$g_presentation_obj_poll_menu_2", "str_poll_for_kicking_a_player", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_2", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_2", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (eq, "$g_multiplayer_ban_voteable", 1),
        (create_button_overlay, "$g_presentation_obj_poll_menu_3", "str_poll_for_banning_a_player", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_3", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_3", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (multiplayer_get_my_player, ":my_player"),
        (player_is_active, ":my_player"),
        (player_is_admin, ":my_player"),
        
        (create_button_overlay, "$g_presentation_obj_poll_menu_6", "str_poll_for_custom_poll", 0),
        (overlay_set_color, "$g_presentation_obj_poll_menu_6", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_poll_menu_6", pos1),
      (try_end),

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_begin),
        (eq, ":object", "$g_presentation_obj_poll_menu_1"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_maps_list_action_type", 1), #poll map
        (start_presentation, "prsnt_multiplayer_show_maps_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_poll_menu_2"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_poll_kick), #poll kick
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_poll_menu_3"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_poll_ban), #poll ban
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_poll_menu_4"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_maps_list_action_type", 2), #poll map and factions
        (start_presentation, "prsnt_multiplayer_show_maps_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_poll_menu_5"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_number_of_bots_list_action_type", 1), #for team 1
        (start_presentation, "prsnt_multiplayer_show_number_of_bots_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_poll_menu_6"),
        (presentation_set_duration, 0),
        (assign, "$g_admin_chat_type", admin_chat_type_custom_poll),
        (start_presentation, "prsnt_multiplayer_admin_chat"),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_admin_chat", prsntf_manual_end_only, 0, [
  (ti_on_presentation_load, [
    (set_fixed_point_multiplier, 1000),
    
    (try_begin),
      (eq,"$g_admin_chat_type",admin_chat_type_everyone),
      (create_text_overlay, "$g_admin_chat_1", "str_admin_chat"),
    (else_try),
      (eq,"$g_admin_chat_type",admin_chat_type_inter),
      (create_text_overlay, "$g_admin_chat_1", "str_admin_chat_intern"),
    (else_try),
      (eq,"$g_admin_chat_type",admin_chat_type_custom_poll),
      (create_text_overlay, "$g_admin_chat_1", "str_admin_chat_custom_poll"),
    (try_end),
    
    (overlay_set_color, "$g_admin_chat_1", 0xFFFFFF),
    (position_set_x,pos1,200),
    (position_set_y,pos1,530),
    (overlay_set_position, "$g_admin_chat_1", pos1),
    (position_set_x,pos1,1000),
    (position_set_y,pos1,980),
    (overlay_set_size, "$g_admin_chat_1", pos1),
    (create_simple_text_box_overlay, "$g_admin_chat_2"),
    (position_set_x,pos1,200),
    (position_set_y,pos1,500),
    (overlay_set_position, "$g_admin_chat_2", pos1),
    (position_set_x,pos1,600),
    (position_set_y,pos1,1000),
    (overlay_set_size, "$g_admin_chat_2", pos1),
    (overlay_obtain_focus, "$g_admin_chat_2"),
    
    (str_clear, s0),
    (overlay_set_text, "$g_admin_chat_2", s0),
 
    (presentation_set_duration, 999999),
  ]),
  (ti_on_presentation_event_state_change, [
    (store_trigger_param_1,":object"),
    (try_begin),
      (eq,":object","$g_admin_chat_2"),
      (try_begin),
        (neg|key_clicked, key_escape),
        (neg|str_is_empty, s0),
        
        (try_begin),
          (eq,"$g_admin_chat_type",admin_chat_type_everyone),
          (multiplayer_send_string_to_server, multiplayer_event_send_admin_chat, s0),
        (else_try),
          (eq,"$g_admin_chat_type",admin_chat_type_inter),
          (multiplayer_send_string_to_server, multiplayer_event_send_inter_admin_chat, s0),
        (else_try),
          (eq,"$g_admin_chat_type",admin_chat_type_custom_poll),
          (multiplayer_send_string_to_server, multiplayer_event_start_new_custom_poll, s0),
        (try_end),
      (try_end),
      (presentation_set_duration, 0),
    (try_end),
  ]),
  (ti_on_presentation_run, [
    (store_trigger_param_1,":time"),
    (try_begin),
      (key_clicked, key_escape),
      (gt,":time",200),
      (presentation_set_duration, 0),
    (try_end),
  ]),]),
  
#custom_chat:presentation:
  ("multiplayer_custom_chat", prsntf_manual_end_only, 0, [
  (ti_on_presentation_load, [
    (set_fixed_point_multiplier, 1000),
    
    (create_simple_text_box_overlay, "$g_custom_chat"),
    (position_set_x,pos1,200),
    (position_set_y,pos1,500),
    (overlay_set_position, "$g_custom_chat", pos1),
    (position_set_x,pos1,600),
    (position_set_y,pos1,1000),
    (overlay_set_size, "$g_custom_chat", pos1),
    (overlay_obtain_focus, "$g_custom_chat"),
    
    (str_clear, s0),
    (overlay_set_text, "$g_custom_chat", s0),
 
    (presentation_set_duration, 999999),
  ]),
  (ti_on_presentation_event_state_change, [
    (store_trigger_param_1,":object"),
    (try_begin),
      (eq,":object","$g_custom_chat"),
      (try_begin),
        (neg|key_clicked, key_escape),
        (neg|str_is_empty, s0),        
          (multiplayer_send_string_to_server, multiplayer_event_send_custom_chat, s0),
      (try_end),
      (presentation_set_duration, 0),
    (try_end),
  ]),
  (ti_on_presentation_run, [
    (store_trigger_param_1,":time"),
    (try_begin),
      (key_clicked, key_escape),
      (gt,":time",200),
      (presentation_set_duration, 0),
    (try_end),
  ]),]),
  
   ("confirm_suicide", prsntf_manual_end_only, 0, [#patch1115 61/11
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 300),#80 200 is better 300
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 600),#move top down
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_admin_tool_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_admin_tool_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 400),# 500
      (overlay_set_area_size, "$g_presentation_obj_admin_tool_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_admin_tool_menu_container"),
      
      (assign, ":cur_y", 350),#450

      (create_text_overlay, reg0, "str_commit_suicide", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      #(val_sub, ":cur_y", escape_menu_item_height),
      (val_sub, ":cur_y", 100),
      
      (position_set_x, pos1, 60),
      
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_commit_suicide_1", "str_yes_wo_dot", 0),
        (overlay_set_color, "$g_presentation_obj_commit_suicide_1", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x, pos1, 40),
        (overlay_set_position, "$g_presentation_obj_commit_suicide_1", pos1),
        #(val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_commit_suicide_2", "str_no_wo_dot", 0),
        (overlay_set_color, "$g_presentation_obj_commit_suicide_2", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x, pos1, 220),
        (overlay_set_position, "$g_presentation_obj_commit_suicide_2", pos1),
        #(val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
     (try_begin),
        (eq, ":object", "$g_presentation_obj_commit_suicide_1"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_send_player_action, player_action_suicide),
     (else_try),
        (eq, ":object", "$g_presentation_obj_commit_suicide_2"),
        (presentation_set_duration, 0),
      (try_end),
    ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),#patch1115 
    
   ("multiplayer_more_admin_tools", prsntf_manual_end_only, 0, [#patch1115 61/11
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_admin_tool_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_admin_tool_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_admin_tool_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_admin_tool_menu_container"),
      
      (assign, ":cur_y", 450),

      (create_text_overlay, reg0, "str_choose_an_admin_tool", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (position_set_x, pos1, 60),
      
      (assign, "$g_presentation_obj_admin_tool_menu_1", -1),#hotfix
      (assign, "$g_presentation_obj_admin_tool_menu_2", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_3", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_4", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_5", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_6", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_7", -1),
      (assign, "$g_presentation_obj_admin_tool_menu_8", -1),
      
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_1", "str_kick_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_1", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_1", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_2", "str_freeze_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_2", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_2", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_3", "str_swap_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_3", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_3", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_4", "str_spec_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_4", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_4", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_5", "str_cheat_heal_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_5", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_5", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_6", "str_cheat_ammo_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_6", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_6", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_7", "str_cheat_beacon_player", 0),
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_7", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_7", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),      
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_admin_tool_menu_8", "str_spawn_player", 0),#patch1115 46/22
        (overlay_set_color, "$g_presentation_obj_admin_tool_menu_8", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_admin_tool_menu_8", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),   
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
     (try_begin),
      (eq, ":object", "$g_presentation_obj_admin_tool_menu_1"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_kick), #admin kick
        (start_presentation, "prsnt_multiplayer_show_players_list"),
     (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_2"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_freeze), #admin freeze
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_3"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_4"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_spec), #admin swap to Spectate
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_5"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_heal), # heal player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_6"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_ammo), # ammo player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_7"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_beacon), # Beacon player
        (start_presentation, "prsnt_multiplayer_show_players_list"),        
      (else_try),
        (eq, ":object", "$g_presentation_obj_admin_tool_menu_8"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_spawn), #admin respawn #patch1115 46/23
        (start_presentation, "prsnt_multiplayer_show_players_list"),   
      (try_end),
           ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),#patch1115 61/11 end
    
  ("game_multiplayer_map_selection_panel", prsntf_manual_end_only, 0, [  #MAP selection 2
  (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),
      
      (assign, "$g_presentation_obj_show_maps_list_menu_container", -1),#hotfix

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_show_maps_list_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_show_maps_list_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_show_maps_list_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_show_maps_list_menu_container"),

      (call_script, "script_multiplayer_fill_map_game_types", "$g_multiplayer_game_type"),
      (assign, ":num_maps", reg0),
      (store_mul, ":cur_y", ":num_maps", escape_menu_item_height),
      (val_add, ":cur_y", 10),

      (create_text_overlay, reg0, "str_choose_a_map", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (assign, ":overlay_id", -1),
      (try_for_range, ":i_map", 0, ":num_maps"),
        (store_add, ":map_slot", ":i_map", multi_data_maps_for_game_type_begin),
        (troop_get_slot, ":map_no", "trp_multiplayer_data", ":map_slot"),
        (store_sub, ":string_index", ":map_no", multiplayer_scenes_begin),
        (val_add, ":string_index", multiplayer_scene_names_begin),
        (str_store_string, s0, ":string_index"),
      
        (create_button_overlay, ":overlay_id", s0, 0),
        (overlay_set_color, ":overlay_id", 0xFFFFFF),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, ":overlay_id", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (store_add, "$g_show_maps_list_button_list_end_index", ":overlay_id", 1),
      (store_sub, "$g_show_maps_list_button_list_first_index", "$g_show_maps_list_button_list_end_index", ":num_maps"),

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_for_range, ":i_button", "$g_show_maps_list_button_list_first_index", "$g_show_maps_list_button_list_end_index"),
        (eq, ":object", ":i_button"),
        (call_script, "script_multiplayer_fill_map_game_types", "$g_multiplayer_game_type"),
        (store_sub, ":map_slot", ":object", "$g_show_maps_list_button_list_first_index"),
        (val_add, ":map_slot", multi_data_maps_for_game_type_begin),
        (troop_get_slot, ":scene_id", "trp_multiplayer_data", ":map_slot"),
        (presentation_set_duration, 0),
        
        (assign, "$g_show_maps_list_button_list_end_index", 0), #break;
        (start_presentation, "prsnt_game_multiplayer_admin_panel"),
        (assign, "$g_multiplayer_selected_map", ":scene_id"),
        (overlay_set_val, "$g_presentation_obj_admin_panel_1", "$g_multiplayer_selected_map"),
        (troop_get_slot, "$g_multiplayer_selected_map", "trp_multiplayer_data", ":map_slot"),
        (try_begin),
          (multiplayer_get_my_player,":my_player"),
          (gt,":my_player",-1),
          (multiplayer_send_2_int_to_server, multiplayer_event_admin_set_mod_variable, mod_variable_request_map_name, "$g_multiplayer_selected_map"),
        (try_end),
      (try_end),
      
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),
    
  ("multiplayer_cheat_menu", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_cheat_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_cheat_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_cheat_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_cheat_menu_container"),
      
      (assign, ":cur_y", 450),

      (create_text_overlay, reg0, "str_choose_a_cheat_type", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (position_set_x, pos1, 60),
      
      (assign, "$g_presentation_obj_cheat_menu_1", -1),#hotfix
      (assign, "$g_presentation_obj_cheat_menu_2", -1),
      (assign, "$g_presentation_obj_cheat_menu_3", -1),
      (assign, "$g_presentation_obj_cheat_menu_4", -1),
      (assign, "$g_presentation_obj_cheat_menu_5", -1),
      (assign, "$g_presentation_obj_cheat_menu_9", -1),
      (assign, "$g_presentation_obj_cheat_menu_10", -1),
      (assign, "$g_presentation_obj_cheat_menu_11", -1),
      (assign, "$g_presentation_obj_cheat_menu_12", -1),
      (assign, "$g_presentation_obj_cheat_menu_13", -1),
      
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_1", "str_cheat_spawn_hammer", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_1", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_1", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_2", "str_cheat_spawn_shotgun", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_2", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_2", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_3", "str_cheat_spawn_rocketlauncher", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_3", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_3", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_13", "str_cheat_spawn_balllauncher", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_13", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_13", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_4", "str_cheat_spawn_grenade", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_4", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_4", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_5", "str_cheat_spawn_horse", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_5", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_5", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_9", "str_cheat_tele_to_player", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_9", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_9", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_10", "str_cheat_tele_bring_player", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_10", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_10", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_11", "str_cheat_tele_wall", 0),
        (overlay_set_color, "$g_presentation_obj_cheat_menu_11", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_11", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (try_begin),
        (create_button_overlay, "$g_presentation_obj_cheat_menu_12", "str_cheat_god_mode", 0),#patch1115 54/2
        (overlay_set_color, "$g_presentation_obj_cheat_menu_12", 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_presentation_obj_cheat_menu_12", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),     

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_begin),
        (eq, ":object", "$g_presentation_obj_cheat_menu_1"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_hammer),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_2"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_shotgun),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_3"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_rocketlauncher),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_4"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_grenade),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_5"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_horse),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_9"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_tele_to), # tele to player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_10"),
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring), # bring player
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_11"),
        (presentation_set_duration, 0),
        (multiplayer_get_my_player, ":my_player_no"),
        (multiplayer_send_2_int_to_server, multiplayer_event_admin_cheat_teleport, cheat_tele_wall, ":my_player_no"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_12"),#patch1115 54/1
        (presentation_set_duration, 0),
        (assign, "$g_multiplayer_players_list_action_type", players_list_action_god), # god mode
        (start_presentation, "prsnt_multiplayer_show_players_list"),
      (else_try),
        (eq, ":object", "$g_presentation_obj_cheat_menu_13"),
        (presentation_set_duration, 0),
        (multiplayer_send_int_to_server, multiplayer_event_admin_cheat_spawn_item, cheat_item_balllauncher),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),
  
  
  ("multiplayer_show_players_list", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
      
      (assign,":start_number_for_players",1),
      (try_begin),
        (multiplayer_is_server),
        (assign,":start_number_for_players",0),
      (try_end),
	  
	    (try_for_range, ":player_no", ":start_number_for_players", multiplayer_player_loops_end),
        (player_is_active, ":player_no"),
	      (player_set_slot, ":player_no", slot_player_button_index, -1),
      (try_end),
	  
      (assign, "$g_multiplayer_players_list_for_all", -1),
      (try_begin),
        (str_clear, s3),

        (try_begin),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_mute), #mute player
          (str_store_string, s3, "str_mute_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_unmute), #unmute player
          (str_store_string, s3, "str_unmute_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_slay), #admin slay
          (str_store_string, s3, "str_slay_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_revive), #admin revive #patch1115 46/5
          (str_store_string, s3, "str_revive_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spawn), #admin respawn #patch1115 46/24
          (str_store_string, s3, "str_spawn_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_freeze), #admin freeze
          (str_store_string, s3, "str_freeze_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
          (str_store_string, s3, "str_swap_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_heal), #admin heal
          (str_store_string, s3, "str_cheat_heal_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spec), #admin swap to spectate
          (str_store_string, s3, "str_spec_all"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ammo), #admin refill ammo
          (str_store_string, s3, "str_cheat_ammo_all"),
        (try_end),
        
        (neg|str_is_empty, s3), # not empty
        
        (create_button_overlay, "$g_multiplayer_players_list_for_all", s3),
        (overlay_set_color, "$g_multiplayer_players_list_for_all", 0xFFFFFF),
        (position_set_x,pos1, 520),
        (position_set_y,pos1, 104),
        (overlay_set_position, "$g_multiplayer_players_list_for_all", pos1),
        (position_set_x, pos1, 1000),
        (position_set_y, pos1, 1000),
        (overlay_set_size, "$g_multiplayer_players_list_for_all", pos1),
      (try_end),
      
      (assign, "$g_multiplayer_players_list_force_autobalance", -1),
      (try_begin),
        (eq, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
        (str_store_string, s3, "str_forceautobalance_all"),
      
        (create_button_overlay, "$g_multiplayer_players_list_force_autobalance", s3),
        (overlay_set_color, "$g_multiplayer_players_list_force_autobalance", 0xFFFFFF),
        (position_set_x,pos1, 330),
        (position_set_y,pos1, 104),
        (overlay_set_position, "$g_multiplayer_players_list_force_autobalance", pos1),
        (position_set_x, pos1, 1000),
        (position_set_y, pos1, 1000),
        (overlay_set_size, "$g_multiplayer_players_list_force_autobalance", pos1),
      (try_end),
      
      (create_mesh_overlay, reg0, "mesh_mp_score_a"),
      (position_set_x, pos1, 295),
      (position_set_y, pos1, 84),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1040),
      (overlay_set_size, reg0, pos1),

      (assign, ":team_rows", 0),
      (assign, ":spectator_rows", 0),
      (multiplayer_get_my_player, ":my_player_no"),
      (assign,":num_players",multiplayer_player_loops_end),
      (try_for_players, ":player_no", "$g_ignore_server"),
        (player_is_active, ":player_no"),

        (assign, ":continue", 0),
        (try_begin),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_mute),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_unmute),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_slay),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_revive),#patch1115 46/3
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_spawn),#patch1115 46/25
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_freeze),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_heal),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_beacon),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_ammo),
          (neq, "$g_multiplayer_players_list_action_type", players_list_action_god), #patch1115 54/10
          
          (assign, ":continue", 1),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_mute),
          (neq, ":player_no", ":my_player_no"),
          (player_get_is_muted, ":is_muted", ":player_no"),
          (eq, ":is_muted", 0),
          (assign, ":continue", 1),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_unmute),
          (neq, ":player_no", ":my_player_no"),
          (player_get_is_muted, ":is_muted", ":player_no"),
          (eq, ":is_muted", 1),
          (assign, ":continue", 1),
        (else_try),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_slay),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_freeze),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_heal),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_beacon),
          (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_god),#patch1115 54/8
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ammo),
          
          (player_get_agent_id, ":this_player_agent_id", ":player_no"),
          (agent_is_active,":this_player_agent_id"),
          (agent_is_alive, ":this_player_agent_id"),
          (assign, ":continue", 1),
          
          (try_begin),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
            (eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
            (eq, ":player_no", ":my_player_no"),
            (assign, ":continue", 0),
          (try_end),
        (else_try),
           (eq, "$g_multiplayer_players_list_action_type", players_list_action_spawn),#patch1115 46/26          
           (player_get_agent_id, ":this_player_agent_id", ":player_no"),
           (this_or_next|neg|agent_is_active,":this_player_agent_id"),
           (neg|agent_is_alive, ":this_player_agent_id"),
           (player_get_team_no, ":player_team", ":player_no"),
           (lt, ":player_team", multi_team_spectator),
           (player_get_troop_id, ":player_troop", ":player_no"),
           (ge, ":player_troop", 0),
           (assign, ":continue", 1), #patch1115 46/26 end
        (else_try),
           (eq, "$g_multiplayer_players_list_action_type", players_list_action_revive),#patch1115 46/4 start
           (player_get_agent_id, ":this_player_agent_id", ":player_no"),
           (agent_is_active,":this_player_agent_id"),
           (neg|agent_is_alive, ":this_player_agent_id"),
           (player_get_team_no, ":player_team", ":player_no"),
           (lt, ":player_team", multi_team_spectator),
           (player_get_troop_id, ":player_troop", ":player_no"),
           (ge, ":player_troop", 0),
           (assign, ":continue", 1), #patch1115 46/4 end
        (try_end),
        (eq, ":continue", 1),
      
        (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
        (try_begin),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 1),
          (player_get_team_no, ":player_team", ":player_no"),
          (try_begin),
            (this_or_next|eq, ":player_team", 0),
            (eq, ":player_team", 1),
            (val_add, ":team_rows", 1),
          (else_try),
            (eq, ":player_team", multi_team_spectator),
            (val_add, ":spectator_rows", 1),
          (try_end),
        (else_try),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
        (try_end),
      (try_end),
      (try_begin),
        (this_or_next|gt, "$g_multiplayer_num_bots_team_1", 0),
        (gt, "$g_multiplayer_num_bots_team_2", 0),
        (val_add, ":team_rows", 1),
      (try_end),

      (store_add, ":total_rows", ":team_rows", ":spectator_rows"),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_stats_chart_deathmatch_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 300),
      (position_set_y, pos1, 140),
      (overlay_set_position, "$g_presentation_obj_stats_chart_deathmatch_container", pos1),
      (position_set_x, pos1, 346),
      (position_set_y, pos1, 530),
      (overlay_set_area_size, "$g_presentation_obj_stats_chart_deathmatch_container", pos1),
      (set_container_overlay, "$g_presentation_obj_stats_chart_deathmatch_container"),

      (store_mul, ":y_needed", ":total_rows", 20),
      (val_add, ":y_needed", 80),
      (try_begin),
        (gt, ":spectator_rows", 0),
        (val_add, ":y_needed", 70),
      (try_end),

      (try_begin),
        (ge, ":total_rows", 17),
        (assign, "$g_stats_chart_update_period", 10),
      (else_try),
        (assign, "$g_stats_chart_update_period", 1),
      (try_end),

      #assuming only 2 teams in scene
      (assign, ":cur_y", ":y_needed"),
      (assign, ":cur_x", 42),
      
      (create_text_overlay, reg0, "str_player_name", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, ":cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_text_overlay, reg0, "str_kills", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 179), #164
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_text_overlay, reg0, "str_deaths", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 233), #205
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),

      (create_text_overlay, reg0, "str_ping", tf_center_justify),
      (overlay_set_color, reg0, 0xFFFFFF),
      (store_add, ":sub_cur_x", ":cur_x", 282), #264
      (position_set_x, pos1, ":sub_cur_x"),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 750),
      (position_set_y, pos1, 750),
      (overlay_set_size, reg0, pos1),
      
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (store_add, ":sub_cur_x", ":cur_x", 0),
      (position_set_x, pos1, ":sub_cur_x"),
      (store_add, ":sub_cur_y", ":cur_y", -10),
      (position_set_y, pos1, ":sub_cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 15250),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1),

      (val_sub, ":cur_y", 35),

      (store_add, ":end_cond", ":num_players", 1),
      (try_for_range, ":unused", 0, ":end_cond"),
        (assign, ":max_score_plus_death", -2147483648),
        (assign, ":max_kills_player_no", -1),
        (try_for_range, ":player_no", ":start_number_for_players", ":num_players"),
          (player_is_active, ":player_no"),

          (assign, ":continue", 0),
          (try_begin),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_mute),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_unmute),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_slay),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_revive),#patch1115 46/6
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_spawn),#patch1115 46/27
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_freeze),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_heal),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_beacon),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_ammo),
            (neq, "$g_multiplayer_players_list_action_type", players_list_action_god), #patch1115 54/11
            
            (assign, ":continue", 1),
          (else_try),
            (eq, "$g_multiplayer_players_list_action_type", players_list_action_mute),
            (neq, ":player_no", ":my_player_no"),
            (player_get_is_muted, ":is_muted", ":player_no"),
            (eq, ":is_muted", 0),
            (assign, ":continue", 1),
          (else_try),
            (eq, "$g_multiplayer_players_list_action_type", players_list_action_unmute),
            (neq, ":player_no", ":my_player_no"),
            (player_get_is_muted, ":is_muted", ":player_no"),
            (eq, ":is_muted", 1),
            (assign, ":continue", 1),
          (else_try),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_slay),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_freeze),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_heal),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_beacon),
            (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_god),#patch1115 54/12
            (eq, "$g_multiplayer_players_list_action_type", players_list_action_ammo),
            
            (player_get_agent_id, ":this_player_agent_id", ":player_no"),
            (agent_is_active,":this_player_agent_id"),
            (agent_is_alive, ":this_player_agent_id"),
            (assign, ":continue", 1),
            (try_begin),
              (this_or_next|eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to),
              (eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring),
              (eq, ":player_no", ":my_player_no"),
              (assign, ":continue", 0),
            (try_end),           
         (else_try),
           (eq, "$g_multiplayer_players_list_action_type", players_list_action_spawn),#patch1115 46/27
           (player_get_team_no, ":player_team", ":player_no"),
           (lt, ":player_team", multi_team_spectator),
           (player_get_troop_id, ":player_troop", ":player_no"),
           (ge, ":player_troop", 0),
           (player_get_agent_id, ":this_player_agent_id", ":player_no"),
           (this_or_next|neg|agent_is_active,":this_player_agent_id"),
           (neg|agent_is_alive, ":this_player_agent_id"),
           (assign, ":continue", 1), #patch1115 46/27 end
         (else_try),         
           (eq, "$g_multiplayer_players_list_action_type", players_list_action_revive),#patch1115 46/7 start
           (player_get_agent_id, ":this_player_agent_id", ":player_no"),
           (agent_is_active,":this_player_agent_id"),
           (neg|agent_is_alive, ":this_player_agent_id"),
           (assign, ":continue", 1), #patch1115 46/7 end
         (try_end),
          (eq, ":continue", 1),
      
          (store_add, ":slot_index", ":player_no", multi_data_player_index_list_begin),
          (troop_slot_eq, "trp_multiplayer_data", ":slot_index", 1),

          (player_get_kill_count, ":kill_count", ":player_no"),
          (player_get_death_count, ":death_count", ":player_no"), #get_death_count
          (store_mul, ":player_score_plus_death", ":kill_count", 1000),
          (val_sub, ":player_score_plus_death", ":death_count"),
      
          (this_or_next|gt, ":player_score_plus_death", ":max_score_plus_death"),
          (eq, ":player_score_plus_death", -2147483648),
      
          (assign, ":max_score_plus_death", ":player_score_plus_death"),
          (assign, ":max_kills_player_no", ":player_no"),
        (try_end),
        (try_begin),
          (ge, ":max_kills_player_no", 0),
          (store_add, ":slot_index", ":max_kills_player_no", multi_data_player_index_list_begin),
          (troop_set_slot, "trp_multiplayer_data", ":slot_index", 0),
          (player_set_slot, ":max_kills_player_no", slot_player_button_index, -1),
          (str_store_player_username, s1, ":max_kills_player_no"),

          (player_get_team_no,":team_no",":max_kills_player_no"),
          (try_begin),
            (eq,":team_no",0),
            (assign,":colour",0x33DD11),
          (else_try),
            (eq,":team_no",1),
            (assign,":colour",0xFF4422),
          (else_try),
            (assign,":colour",0xFFFFFF),
          (try_end),
          
          (create_button_overlay, ":overlay_id", "str_player_name_s1", 0),
          (overlay_set_color, ":overlay_id", ":colour"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, ":overlay_id", pos1),
          (position_set_x, pos1, ":cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, ":overlay_id", pos1),
          (player_set_slot, ":max_kills_player_no", slot_player_button_index, ":overlay_id"),
      
          (player_get_kill_count, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, ":colour"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),      
          (store_add, ":sub_cur_x", ":cur_x", 188), #173
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (player_get_death_count, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, ":colour"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),      
          (store_add, ":sub_cur_x", ":cur_x", 238), #223
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
      
          (player_get_ping, reg0, ":max_kills_player_no"),
          (create_text_overlay, reg0, "str_reg0", tf_right_align),
          (overlay_set_color, reg0, ":colour"),
          (position_set_x, pos1, 750),
          (position_set_y, pos1, 750),
          (overlay_set_size, reg0, pos1),
          (store_add, ":sub_cur_x", ":cur_x", 288), #273
          (position_set_x, pos1, ":sub_cur_x"),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg0, pos1),
          (val_sub, ":cur_y", 20),
        (else_try),
          (assign, ":end_cond", 0), #all players are written, break
        (try_end),
      (try_end),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (assign,":num_players",multiplayer_player_loops_end),
      
      (try_begin), # For everyone! 
        (eq, "$g_multiplayer_players_list_for_all", ":object"), 
        (multiplayer_get_my_player, ":my_player_no"),
        
        (try_begin),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_mute), #mute player
          (try_for_range, ":player_no", 1, ":num_players"), #0 is server no need to write it
            (player_is_active, ":player_no"),
            (neq, ":player_no", ":my_player_no"),
            (player_set_is_muted, ":player_no", 1),
          (try_end),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_unmute), #unmute player
          (try_for_range, ":player_no", 1, ":num_players"), #0 is server no need to write it
            (player_is_active, ":player_no"),
            (neq, ":player_no", ":my_player_no"),
            (player_set_is_muted, ":player_no", 0),
          (try_end),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_slay), #admin slay
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_slay_player),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_revive), #admin revive
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_revive_player), #patch1115 46/7
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spawn), #admin respawn
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_spawn_player), #patch1115 46/28
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_freeze), #admin freeze
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_freeze_player),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_swap_player),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_heal), #admin heal
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_cheat_heal_player),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spec), #admin swap to spectate
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_spec_player),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ammo), #admin ammo player
          (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_cheat_ammo_player),
        (try_end),
        
        (presentation_set_duration, 0),
      (try_end),
      
      (try_begin), # For everyone! 
        (eq, "$g_multiplayer_players_list_force_autobalance", ":object"), 
        
        (multiplayer_send_2_int_to_server, multiplayer_event_player_list_action, player_list_all, player_list_admin_autobalance_player),
        
        (presentation_set_duration, 0),
      (try_end),
      
      (assign,":start_number_for_players",1),
      (try_begin),
        (multiplayer_is_server),
        (assign,":start_number_for_players",0),
      (try_end),
      
      (try_for_range, ":player_no", ":start_number_for_players", ":num_players"), #0 is server no need to write it
        (player_is_active, ":player_no"),
        (player_slot_eq, ":player_no", slot_player_button_index, ":object"),
        (try_begin),
          (is_between, "$g_multiplayer_players_list_action_type", players_list_action_poll_kick, players_list_action_poll_ban+1), #poll kick or poll ban
          (try_begin),
            (multiplayer_get_my_player, ":my_player_no"),
            (ge, ":my_player_no", 0),
            (multiplayer_send_2_int_to_server, multiplayer_event_start_new_poll, "$g_multiplayer_players_list_action_type", ":player_no"),
            (store_mission_timer_a, ":mission_timer"),
            (val_add, ":mission_timer", multiplayer_poll_disable_period),
            (player_set_slot, ":my_player_no", slot_player_poll_disabled_until_time, ":mission_timer"),
          (try_end),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_kick), #admin kick
          (multiplayer_send_int_to_server, multiplayer_event_admin_kick_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ban), #admin ban
          (multiplayer_send_int_to_server, multiplayer_event_admin_ban_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_mute), #mute player
          (player_set_is_muted, ":player_no", 1),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_unmute), #unmute player
          (player_set_is_muted, ":player_no", 0),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ban_temp), #admin temp ban
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_ban_player_temp, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_slay), #admin slay
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_slay_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_revive), #admin revive  #patch1115 46/8
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_revive_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spawn), #admin respawn  #patch1115 46/31
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_spawn_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_freeze), #admin freeze
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_freeze_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_swap), #admin swap
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_swap_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_heal), #admin heal
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_cheat_heal_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_beacon), #admin beacon
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_beacon_player, ":player_no"), 
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_to), #admin tele to player
          (multiplayer_send_2_int_to_server, multiplayer_event_admin_cheat_teleport, cheat_tele_to, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_tele_bring), #admin bring player
          (multiplayer_send_2_int_to_server, multiplayer_event_admin_cheat_teleport, cheat_tele_bring, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_spec), #admin swap to spectate
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_spec_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_ammo), #admin ammo player
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_cheat_ammo_player, ":player_no"),
        (else_try),
          (eq, "$g_multiplayer_players_list_action_type", players_list_action_god), #admin god
          (multiplayer_send_3_int_to_server, multiplayer_event_player_list_action, player_list_player, player_list_admin_god_mode, ":player_no"),#patch1115 54/3
        (try_end),
        (assign, ":num_players", 0), #break
        (presentation_set_duration, 0),
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),
# Vincenzo end

  ("multiplayer_show_maps_list", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_show_maps_list_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_show_maps_list_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_show_maps_list_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_show_maps_list_menu_container"),

      (call_script, "script_multiplayer_fill_map_game_types", "$g_multiplayer_game_type"),
      (assign, ":num_maps", reg0),
      (store_mul, ":cur_y", ":num_maps", escape_menu_item_height),
      (val_add, ":cur_y", 10),

      (create_text_overlay, reg0, "str_choose_a_map", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (assign, ":overlay_id", -1),
      (try_for_range, ":i_map", 0, ":num_maps"),
        (store_add, ":map_slot", ":i_map", multi_data_maps_for_game_type_begin),
        (troop_get_slot, ":map_no", "trp_multiplayer_data", ":map_slot"),
        (store_sub, ":string_index", ":map_no", multiplayer_scenes_begin),
        (val_add, ":string_index", multiplayer_scene_names_begin),
        (str_store_string, s0, ":string_index"),
      
        (create_button_overlay, ":overlay_id", s0, 0),
        (overlay_set_color, ":overlay_id", 0xFFFFFF),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, ":overlay_id", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (store_add, "$g_show_maps_list_button_list_end_index", ":overlay_id", 1),
      (store_sub, "$g_show_maps_list_button_list_first_index", "$g_show_maps_list_button_list_end_index", ":num_maps"),

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_for_range, ":i_button", "$g_show_maps_list_button_list_first_index", "$g_show_maps_list_button_list_end_index"),
        (eq, ":object", ":i_button"),
        (call_script, "script_multiplayer_fill_map_game_types", "$g_multiplayer_game_type"),
        (store_sub, ":map_slot", ":object", "$g_show_maps_list_button_list_first_index"),
        (val_add, ":map_slot", multi_data_maps_for_game_type_begin),
        (troop_get_slot, ":scene_id", "trp_multiplayer_data", ":map_slot"),
        (presentation_set_duration, 0),
        (try_begin),
          (eq, "$g_multiplayer_maps_list_action_type", 1), #vote for map
          (try_begin),
            (multiplayer_get_my_player, ":my_player_no"),
            (ge, ":my_player_no", 0),
            (multiplayer_send_2_int_to_server, multiplayer_event_start_new_poll, 0, ":scene_id"),
            (store_mission_timer_a, ":mission_timer"),
            (val_add, ":mission_timer", multiplayer_poll_disable_period),
            (player_set_slot, ":my_player_no", slot_player_poll_disabled_until_time, ":mission_timer"),
          (try_end),
        (else_try), #vote for map and factions
          (assign, "$g_multiplayer_factions_list_action_type", 1), #for team 1
          (assign, "$g_multiplayer_poll_for_map_and_faction_data_map", ":scene_id"),
          (start_presentation, "prsnt_multiplayer_show_factions_list"),
        (try_end),
        (assign, "$g_show_maps_list_button_list_end_index", 0), #break;
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_show_factions_list", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_show_factions_list_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_show_factions_list_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_show_factions_list_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_show_factions_list_menu_container"),

      (store_sub, ":num_factions", factions_end, factions_begin),
      (try_begin),
        (eq, "$g_multiplayer_factions_list_action_type", 2),
        (val_sub, ":num_factions", 1),
      (try_end),
      (store_mul, ":cur_y", ":num_factions", escape_menu_item_height),
      (val_add, ":cur_y", 10),

      (assign, reg0, "$g_multiplayer_factions_list_action_type"),
      (create_text_overlay, reg0, "str_choose_a_faction_for_team_reg0", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (assign, ":overlay_id", -1),
      (try_for_range, ":i_faction", factions_begin, factions_end),
        (this_or_next|eq, "$g_multiplayer_factions_list_action_type", 1),
        (neq, "$g_multiplayer_poll_for_map_and_faction_data_faction_1", ":i_faction"),
        (str_store_faction_name, s0, ":i_faction"),
        (create_button_overlay, ":overlay_id", s0, 0),
        (overlay_set_color, ":overlay_id", 0xFFFFFF),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, ":overlay_id", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (store_add, "$g_show_factions_list_button_list_end_index", ":overlay_id", 1),
      (store_sub, "$g_show_factions_list_button_list_first_index", "$g_show_factions_list_button_list_end_index", ":num_factions"),

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_for_range, ":i_button", "$g_show_factions_list_button_list_first_index", "$g_show_factions_list_button_list_end_index"),
        (eq, ":object", ":i_button"),
        (store_sub, ":faction_no", ":object", "$g_show_factions_list_button_list_first_index"),
        (val_add, ":faction_no", factions_begin),
        (presentation_set_duration, 0),
        (try_begin),
          (eq, "$g_multiplayer_factions_list_action_type", 2), #vote for second team
          (try_begin),
            (ge, ":faction_no", "$g_multiplayer_poll_for_map_and_faction_data_faction_1"),
            (val_add, ":faction_no", 1),
          (try_end),
          (try_begin),
            (multiplayer_get_my_player, ":my_player_no"),
            (ge, ":my_player_no", 0),
            (multiplayer_send_4_int_to_server, multiplayer_event_start_new_poll, 3, "$g_multiplayer_poll_for_map_and_faction_data_map", "$g_multiplayer_poll_for_map_and_faction_data_faction_1", ":faction_no"),
            (store_mission_timer_a, ":mission_timer"),
            (val_add, ":mission_timer", multiplayer_poll_disable_period),
            (player_set_slot, ":my_player_no", slot_player_poll_disabled_until_time, ":mission_timer"),
          (try_end),
        (else_try), #vote for first team
          (assign, "$g_multiplayer_factions_list_action_type", 2), #for team 2
          (assign, "$g_multiplayer_poll_for_map_and_faction_data_faction_1", ":faction_no"),
          (start_presentation, "prsnt_multiplayer_show_factions_list"),
        (try_end),
        (assign, "$g_show_factions_list_button_list_end_index", 0), #break;
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_show_number_of_bots_list", prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_show_number_of_bots_list_menu_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 285),
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_show_number_of_bots_list_menu_container", pos1),
      (position_set_x, pos1, 405),
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_show_number_of_bots_list_menu_container", pos1),
      (set_container_overlay, "$g_presentation_obj_show_number_of_bots_list_menu_container"),

      (assign, ":num_options", 0),
      (store_add, ":end_cond", "$g_multiplayer_num_bots_voteable", 1),
      (try_for_range, ":i_number", 0, ":end_cond"),
        (assign, ":i_number_mod_5", ":i_number"),
        (val_mod, ":i_number_mod_5", 5),
        (this_or_next|lt, ":i_number", 10),
        (eq, ":i_number_mod_5", 0),
        (val_add, ":num_options", 1),
      (try_end),

      (store_mul, ":cur_y", ":num_options", escape_menu_item_height),
      (val_add, ":cur_y", 10),

      (assign, reg0, "$g_multiplayer_number_of_bots_list_action_type"),
      (create_text_overlay, reg0, "str_choose_number_of_bots_for_team_reg0", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 0),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (val_sub, ":cur_y", escape_menu_item_height),

      (assign, ":overlay_id", -1),
      (try_for_range, ":i_number", 0, ":end_cond"),
        (assign, ":i_number_mod_5", ":i_number"),
        (val_mod, ":i_number_mod_5", 5),
        (this_or_next|lt, ":i_number", 10),
        (eq, ":i_number_mod_5", 0),
        (assign, reg0, ":i_number"),
        (str_store_string, s0, "str_reg0"),
        (create_button_overlay, ":overlay_id", s0, 0),
        (overlay_set_color, ":overlay_id", 0xFFFFFF),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, ":overlay_id", pos1),
        (val_sub, ":cur_y", escape_menu_item_height),
      (try_end),
      (store_add, "$g_show_number_of_bots_list_button_list_end_index", ":overlay_id", 1),
      (store_sub, "$g_show_number_of_bots_list_button_list_first_index", "$g_show_number_of_bots_list_button_list_end_index", ":num_options"),

      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
      (try_for_range, ":i_button", "$g_show_number_of_bots_list_button_list_first_index", "$g_show_number_of_bots_list_button_list_end_index"),
        (eq, ":object", ":i_button"),
        (store_sub, ":value_index", ":object", "$g_show_number_of_bots_list_button_list_first_index"),
        (try_begin),
          (lt, ":value_index", 10),
          (assign, ":used_value", ":value_index"),
        (else_try),
          (store_sub, ":used_value", ":value_index", 8),
          (val_mul, ":used_value", 5),
        (try_end),
        (presentation_set_duration, 0),
        (try_begin),
          (eq, "$g_multiplayer_number_of_bots_list_action_type", 2), #vote for second team
          (try_begin),
            (multiplayer_get_my_player, ":my_player_no"),
            (ge, ":my_player_no", 0),
            (multiplayer_send_3_int_to_server, multiplayer_event_start_new_poll, 4, "$g_multiplayer_poll_number_of_bots_team_1", ":used_value"),
            (store_mission_timer_a, ":mission_timer"),
            (val_add, ":mission_timer", multiplayer_poll_disable_period),
            (player_set_slot, ":my_player_no", slot_player_poll_disabled_until_time, ":mission_timer"),
          (try_end),
        (else_try), #vote for first team
          (assign, "$g_multiplayer_number_of_bots_list_action_type", 2), #for team 2
          (assign, "$g_multiplayer_poll_number_of_bots_team_1", ":used_value"),
          (start_presentation, "prsnt_multiplayer_show_number_of_bots_list"),
        (try_end),
        (assign, "$g_show_number_of_bots_list_button_list_end_index", 0), #break;
      (try_end),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (key_clicked, key_escape),
        (gt, ":cur_time", 200),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ("multiplayer_poll", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0x000000),
      (overlay_set_alpha, reg0, 0x44),
      (position_set_x, pos1, 50),
      (position_set_y, pos1, 50),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 37500),
      (position_set_y, pos1, 4500),
      (overlay_set_size, reg0, pos1),

      (try_begin),
        (eq, "$g_multiplayer_poll_to_show", 0),
        (store_sub, ":string_index", "$g_multiplayer_poll_value_to_show", multiplayer_scenes_begin),
        (val_add, ":string_index", multiplayer_scene_names_begin),
        (str_store_string, s0, ":string_index"),
        (create_text_overlay, reg0, "str_poll_change_map", tf_center_justify),
      (else_try),
        (eq, "$g_multiplayer_poll_to_show", 1),
        (str_store_player_username, s0, "$g_multiplayer_poll_value_to_show"),
        (create_text_overlay, reg0, "str_poll_kick_player", tf_center_justify),
      (else_try),
        (eq, "$g_multiplayer_poll_to_show", 2),
        (str_store_player_username, s0, "$g_multiplayer_poll_value_to_show"),
        (create_text_overlay, reg0, "str_poll_ban_player", tf_center_justify),
      (else_try),
        (eq, "$g_multiplayer_poll_to_show", 3),
        (store_sub, ":string_index", "$g_multiplayer_poll_value_to_show", multiplayer_scenes_begin),
        (val_add, ":string_index", multiplayer_scene_names_begin),
        (str_store_string, s0, ":string_index"),
        (str_store_faction_name, s1, "$g_multiplayer_poll_value_2_to_show"),
        (str_store_faction_name, s2, "$g_multiplayer_poll_value_3_to_show"),
        (create_text_overlay, reg0, "str_poll_change_map_with_faction", tf_center_justify|tf_scrollable_style_2),
      (else_try),
        (eq, "$g_multiplayer_poll_to_show", 4),
        (assign, reg0, "$g_multiplayer_poll_value_to_show"),
        (assign, reg1, "$g_multiplayer_poll_value_2_to_show"),
        (str_store_faction_name, s0, "$g_multiplayer_team_1_faction"),
        (str_store_faction_name, s1, "$g_multiplayer_team_2_faction"),
        (create_text_overlay, reg0, "str_poll_change_number_of_bots", tf_center_justify|tf_scrollable_style_2),
      (else_try),
        (eq, "$g_multiplayer_poll_to_show", 5), # custom poll
        (create_text_overlay, reg0, "str_poll_custom_poll", tf_center_justify|tf_scrollable_style_2),
      (try_end),
      (overlay_set_color, reg0, 0xFFFFFF),
      (try_begin),
        (neq, "$g_multiplayer_poll_to_show", 3),
        (neq, "$g_multiplayer_poll_to_show", 4),
        (neq, "$g_multiplayer_poll_to_show", 5), # custom poll
        (position_set_x, pos1, 400),
        (position_set_y, pos1, 100),
        (overlay_set_position, reg0, pos1),
      (else_try),
        (position_set_x, pos1, 50),
        (position_set_y, pos1, 70),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 750),
        (position_set_y, pos1, 60),
        (overlay_set_area_size, reg0, pos1),
      (try_end),

      (store_mission_timer_a, ":mission_timer"),
      (store_sub, "$g_multiplayer_poll_last_written_seconds_left", "$g_multiplayer_poll_client_end_time", ":mission_timer"),
      (assign, reg0, "$g_multiplayer_poll_last_written_seconds_left"),

      (create_text_overlay, "$g_presentation_obj_poll_1", "str_poll_time_left", tf_right_align|tf_single_line),
      (overlay_set_color, "$g_presentation_obj_poll_1", 0xFFFFFF),
      (position_set_x, pos1, 790),
      (position_set_y, pos1, 60),
      (overlay_set_position, "$g_presentation_obj_poll_1", pos1),

      (omit_key_once, key_1),
      (omit_key_once, key_2),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run,
     [(store_trigger_param_1, ":cur_time"),
      (try_begin),
        (this_or_next|key_clicked, key_escape),
        (key_clicked, key_2),
        (gt, ":cur_time", 500),
        (multiplayer_send_int_to_server, multiplayer_event_answer_to_poll, 0),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
      (else_try),
        (key_clicked, key_1),
        (gt, ":cur_time", 500),
        (multiplayer_send_int_to_server, multiplayer_event_answer_to_poll, 1),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
      (try_end),
      (store_mission_timer_a, ":mission_timer"),
      (store_sub, ":time_left", "$g_multiplayer_poll_client_end_time", ":mission_timer"),
      (try_begin),
        (neq, ":time_left", "$g_multiplayer_poll_last_written_seconds_left"),
        (try_begin),
          (lt, ":time_left", 0),
          (clear_omitted_keys),
          (presentation_set_duration, 0),
        (else_try),
          (assign, "$g_multiplayer_poll_last_written_seconds_left", ":time_left"),
          (assign, reg0, "$g_multiplayer_poll_last_written_seconds_left"),
          (overlay_set_text, "$g_presentation_obj_poll_1", "str_poll_time_left"),
        (try_end),
      (try_end),
      ]),
    ]),

  ("tutorial_show_mouse_movement",prsntf_read_only|prsntf_manual_end_only,0,[
      (ti_on_presentation_load,
       [
       (presentation_set_duration, 0),
        ]),
      (ti_on_presentation_run,
       [
          
       
        ]),
      ]),

  
  ("battle",0,0,[
      (ti_on_presentation_load,
       [(set_fixed_point_multiplier, 1000),
        (assign, "$g_formation_group0_selected", 0),
        (assign, "$g_formation_group1_selected", 0),
        (assign, "$g_formation_group2_selected", 0),
        (assign, "$g_formation_group3_selected", 0),
        (assign, "$g_formation_group4_selected", 0),
        (assign, "$g_formation_group5_selected", 0),
        (assign, "$g_formation_group6_selected", 0),
        (assign, "$g_formation_group7_selected", 0),
        (assign, "$g_formation_group8_selected", 0),
        (assign, "$g_presentation_obj_battle_but0", -1),
        (assign, "$g_presentation_obj_battle_but1", -1),
        (assign, "$g_presentation_obj_battle_but2", -1),
        (assign, "$g_presentation_obj_battle_but3", -1),
        (assign, "$g_presentation_obj_battle_but4", -1),
        (assign, "$g_presentation_obj_battle_but5", -1),
        (assign, "$g_presentation_obj_battle_but6", -1),
        (assign, "$g_presentation_obj_battle_but7", -1),
        (assign, "$g_presentation_obj_battle_but8", -1),
        (str_clear, s7),

        (try_for_agents, ":agent_no"),
          (agent_set_slot, ":agent_no", slot_agent_map_overlay_id, 0),
        (try_end),

        (get_player_agent_no, ":player_agent"),
        (agent_get_troop_id, ":player_troop_id", ":player_agent"),

        (position_set_y, pos1, 700),
        (create_text_overlay, reg1, "@Action", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, reg1, 0xFFAAAAAA),
        (position_set_x, pos1, 270),
        (overlay_set_position, reg1, pos1),
        (create_text_overlay, reg1, "@Mount", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, reg1, 0xFFAAAAAA),
        (position_set_x, pos1, 410),
        (overlay_set_position, reg1, pos1),
        (create_text_overlay, reg1, "@Attack Type", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, reg1, 0xFFAAAAAA),
        (position_set_x, pos1, 550),
        (overlay_set_position, reg1, pos1),

        (assign, "$group0_has_troops", 0),
        (assign, "$group1_has_troops", 0),
        (assign, "$group2_has_troops", 0),
        (assign, "$group3_has_troops", 0),
        (assign, "$group4_has_troops", 0),
        (assign, "$group5_has_troops", 0),
        (assign, "$group6_has_troops", 0),
        (assign, "$group7_has_troops", 0),
        (assign, "$group8_has_troops", 0),
        (party_get_num_companion_stacks, ":num_stacks", "p_main_party"),
        (assign, "$num_classes", 0),
        (try_for_range, ":troop_iterator", 0, ":num_stacks"),
          (party_stack_get_troop_id, ":cur_troop_id", "p_main_party", ":troop_iterator"),
          (troop_get_class, ":troop_class", ":cur_troop_id"),
          (neq, ":player_troop_id", ":cur_troop_id"),
          (try_begin),
            (eq, ":troop_class", 0),
            (try_begin),
              (neq, "$group0_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group0_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 1),
            (try_begin),
              (neq, "$group1_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group1_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 2),
            (try_begin),
              (neq, "$group2_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group2_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 3),
            (try_begin),
              (neq, "$group3_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group3_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 4),
            (try_begin),
              (neq, "$group4_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group4_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 5),
            (try_begin),
              (neq, "$group5_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group5_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 6),
            (try_begin),
              (neq, "$group6_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group6_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 7),
            (try_begin),
              (neq, "$group7_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group7_has_troops", 1),
          (else_try),
            (eq, ":troop_class", 8),
            (try_begin),
              (neq, "$group8_has_troops", 1),
              (val_add, "$num_classes", 1),
            (try_end),
            (assign, "$group8_has_troops", 1),
          (try_end),
        (try_end),

        (assign, ":stat_position_x", 0),
        (assign, ":stat_position_y", 653),
        (assign, ":stat_position_check_x", 20),
        (assign, ":stat_position_check_y", 662),
        (assign, ":stat_position_name_x", 50),
        (assign, ":stat_position_name_y", 660),
        (try_begin),
          (eq, "$group0_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but0", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but0", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but0", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but0", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but0", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check0", "mesh_checkbox_off", "mesh_checkbox_on"),
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check0", pos2),
          (val_add, ":stat_position_check_y", -40),

          (create_text_overlay, "$g_presentation_obj_battle_name0", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name0", pos3),
        
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but0_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but0_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but0_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group1_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but1", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but1", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but1", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but1", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but1", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check1", "mesh_checkbox_off", "mesh_checkbox_on"),
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check1", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name1", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name1", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but1_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but1_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but1_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group2_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but2", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but2", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but2", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but2", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but2", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check2", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check2", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name2", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name2", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but2_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but2_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but2_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group3_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but3", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but3", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but3", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but3", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but3", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check3", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check3", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name3", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name3", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but3_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but3_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but3_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group4_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but4", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but4", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but4", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but4", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but4", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check4", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check4", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name4", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name4", pos3),
          (val_add, ":stat_position_name_y", -40),
        
          (create_text_overlay, "$g_presentation_but4_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but4_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but4_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group5_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but5", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but5", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but5", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but5", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but5", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check5", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check5", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name5", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name5", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but5_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but5_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but5_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group6_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but6", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but6", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but6", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but6", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but6", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check6", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check6", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name6", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name6", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but6_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but6_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but6_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group7_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but7", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but7", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but7", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but7", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but7", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check7", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check7", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name7", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name7", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but7_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but7_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but7_weapon_usage", s7, tf_center_justify),
        (try_end),
        (try_begin),
          (eq, "$group8_has_troops", 1),
          (create_image_button_overlay, "$g_presentation_obj_battle_but8", "mesh_white_plane", "mesh_white_plane"),
          (position_set_x, pos1, ":stat_position_x"),
          (position_set_y, pos1, ":stat_position_y"),
          (overlay_set_position, "$g_presentation_obj_battle_but8", pos1),
          (val_add, ":stat_position_y", -40),

          (position_set_x, pos1, 32500),
          (position_set_y, pos1, 2000),
          (overlay_set_size, "$g_presentation_obj_battle_but8", pos1),
          (overlay_set_alpha, "$g_presentation_obj_battle_but8", 0),
          (overlay_set_color, "$g_presentation_obj_battle_but8", 0xFFFF00),

          (create_check_box_overlay, "$g_presentation_obj_battle_check8", "mesh_checkbox_off", "mesh_checkbox_on"),          
          (position_set_x, pos2, ":stat_position_check_x"),
          (position_set_y, pos2, ":stat_position_check_y"),
          (overlay_set_position, "$g_presentation_obj_battle_check8", pos2),
          (val_add, ":stat_position_check_y", -40),        

          (create_text_overlay, "$g_presentation_obj_battle_name8", s7, 0),
          (position_set_x, pos3, ":stat_position_name_x"),
          (position_set_y, pos3, ":stat_position_name_y"),
          (overlay_set_position, "$g_presentation_obj_battle_name8", pos3),
          (val_add, ":stat_position_name_y", -40),

          (create_text_overlay, "$g_presentation_but8_movement", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but8_riding", s7, tf_center_justify),
          (create_text_overlay, "$g_presentation_but8_weapon_usage", s7, tf_center_justify),
        (try_end),
        
        (get_player_agent_no, ":player_agent"),
        (agent_get_team, ":player_team", ":player_agent"),
        
        (call_script, "script_update_order_panel", ":player_team"),

        #(create_button_overlay, "$g_presentation_obj_battle_10", "@Hold This Position", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_11", "@Follow Me", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_12", "@Charge", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_13", "@Advance", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_14", "@Fall Back", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_15", "@Stand Closer", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_16", "@Spread Out", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_17", "@Stand Ground", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_18", "@Mount", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_19", "@Dismount", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_20", "@Use Any Weapon", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_21", "@Use Blunt Weapons", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_28", "@Hold Your Fire", tf_center_justify),
        #(create_button_overlay, "$g_presentation_obj_battle_29", "@Fire At Will", tf_center_justify),
        
        (assign, ":y_position_for_order_buttons", 640),
        (assign, ":addition_y_position", "$num_classes"),
        (val_mul, ":addition_y_position", -40),
        (val_add, ":y_position_for_order_buttons", ":addition_y_position"),

        (create_listbox_overlay, "$g_presentation_obj_battle_10", "str_space", 0),
        (create_listbox_overlay, "$g_presentation_obj_battle_11", "str_space", 0),
        (create_listbox_overlay, "$g_presentation_obj_battle_12", "str_space", 0),
        (create_listbox_overlay, "$g_presentation_obj_battle_13", "str_space", 0),
        
        (overlay_add_item, "$g_presentation_obj_battle_10", "@Stand Ground"),
        ##(overlay_add_item, "$g_presentation_obj_battle_10", "@Spread Out"),
        ##(overlay_add_item, "$g_presentation_obj_battle_10", "@Stand Closer"),
        ##(overlay_add_item, "$g_presentation_obj_battle_10", "@Fall Back"),
        ##(overlay_add_item, "$g_presentation_obj_battle_10", "@Advance"),
        (overlay_add_item, "$g_presentation_obj_battle_10", "@Charge"),
        (overlay_add_item, "$g_presentation_obj_battle_10", "@Follow Me"),
        (overlay_add_item, "$g_presentation_obj_battle_10", "@Hold This Position"),

        (create_button_overlay, "$g_presentation_obj_battle_14", "@Spread Out", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, "$g_presentation_obj_battle_14", 0xFFFFFFFF),
        (create_button_overlay, "$g_presentation_obj_battle_15", "@Stand Closer", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, "$g_presentation_obj_battle_15", 0xFFFFFFFF),
        (create_button_overlay, "$g_presentation_obj_battle_16", "@Fall Back", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, "$g_presentation_obj_battle_16", 0xFFFFFFFF),
        (create_button_overlay, "$g_presentation_obj_battle_17", "@Advance", tf_center_justify|tf_single_line|tf_with_outline),
        (overlay_set_color, "$g_presentation_obj_battle_17", 0xFFFFFFFF),
        
        (position_set_x, pos1, 600),
        (position_set_y, pos1, 600),
        (overlay_set_size, "$g_presentation_obj_battle_10", pos1),

        (val_add, ":y_position_for_order_buttons", -35),
        (position_set_x, pos1, 205),
        (position_set_y, pos1, ":y_position_for_order_buttons"),
        (val_add, ":y_position_for_order_buttons", 35),
        (overlay_set_position, "$g_presentation_obj_battle_10", pos1),
        (overlay_set_alpha, "$g_presentation_obj_battle_10", 0x60),
        (overlay_set_val, "$g_presentation_obj_battle_10", "$g_latest_order_1"),

        (val_add, ":y_position_for_order_buttons", -40), #new
        (position_set_x, pos1, 130), #new
        (position_set_y, pos1, ":y_position_for_order_buttons"), #new
        (val_add, ":y_position_for_order_buttons", 40), #new
        (overlay_set_position, "$g_presentation_obj_battle_14", pos1), #new
        #(overlay_set_alpha, "$g_presentation_obj_battle_14", 0x60), #new

        (val_add, ":y_position_for_order_buttons", -20), #new
        (position_set_x, pos1, 130), #new
        (position_set_y, pos1, ":y_position_for_order_buttons"), #new
        (val_add, ":y_position_for_order_buttons", 20), #new
        (overlay_set_position, "$g_presentation_obj_battle_15", pos1), #new
        #(overlay_set_alpha, "$g_presentation_obj_battle_15", 0x60), #new

        (val_add, ":y_position_for_order_buttons", -0), #new
        (position_set_x, pos1, 130), #new
        (position_set_y, pos1, ":y_position_for_order_buttons"), #new
        (val_add, ":y_position_for_order_buttons", 0), #new
        (overlay_set_position, "$g_presentation_obj_battle_16", pos1), #new
        #(overlay_set_alpha, "$g_presentation_obj_battle_16", 0x60), #new

        (val_add, ":y_position_for_order_buttons", 20), #new
        (position_set_x, pos1, 130), #new
        (position_set_y, pos1, ":y_position_for_order_buttons"), #new
        (val_add, ":y_position_for_order_buttons", -20), #new
        (overlay_set_position, "$g_presentation_obj_battle_17", pos1), #new
        #(overlay_set_alpha, "$g_presentation_obj_battle_17", 0x60), #new



        (overlay_add_item, "$g_presentation_obj_battle_11", "@Dismount"),
        (overlay_add_item, "$g_presentation_obj_battle_11", "@Mount"),
        
        (position_set_x, pos1, 600),
        (position_set_y, pos1, 600),
        (overlay_set_size, "$g_presentation_obj_battle_11", pos1),

        (position_set_x, pos1, 350),
        (position_set_y, pos1, ":y_position_for_order_buttons"),
        (overlay_set_position, "$g_presentation_obj_battle_11", pos1),

        (overlay_set_alpha, "$g_presentation_obj_battle_11", 0x60),
        (overlay_set_val, "$g_presentation_obj_battle_11", "$g_latest_order_2"),



        (overlay_add_item, "$g_presentation_obj_battle_12", "@Fire At Will"),
        (overlay_add_item, "$g_presentation_obj_battle_12", "@Hold Your Fire"),
        
        (position_set_x, pos1, 600),
        (position_set_y, pos1, 600),
        (overlay_set_size, "$g_presentation_obj_battle_12", pos1),

        (position_set_x, pos1, 495),
        (position_set_y, pos1, ":y_position_for_order_buttons"),
        (overlay_set_position, "$g_presentation_obj_battle_12", pos1),

        (overlay_set_alpha, "$g_presentation_obj_battle_12", 0x60),
        (overlay_set_val, "$g_presentation_obj_battle_12", "$g_latest_order_3"),



        (overlay_add_item, "$g_presentation_obj_battle_13", "@Use Blunt Weapons"),
        (overlay_add_item, "$g_presentation_obj_battle_13", "@Use Any Weapon"),
        
        (position_set_x, pos1, 600),
        (position_set_y, pos1, 600),
        (overlay_set_size, "$g_presentation_obj_battle_13", pos1),

        (val_add, ":y_position_for_order_buttons", -35),
        (position_set_x, pos1, 495),
        (position_set_y, pos1, ":y_position_for_order_buttons"),
        (val_add, ":y_position_for_order_buttons", 35),
        (overlay_set_position, "$g_presentation_obj_battle_13", pos1),

        (overlay_set_alpha, "$g_presentation_obj_battle_13", 0x60),
        (overlay_set_val, "$g_presentation_obj_battle_13", "$g_latest_order_4"),



        (create_text_overlay, "$g_presentation_obj_battle_22", "str_us_", 0),
        (create_text_overlay, "$g_presentation_obj_battle_23", "str_allies_", 0),
        (create_text_overlay, "$g_presentation_obj_battle_24", "str_enemies_", 0),
        (create_text_overlay, "$g_presentation_obj_battle_25", "@Ready", tf_center_justify),
        (create_text_overlay, "$g_presentation_obj_battle_26", "@Wounded", tf_center_justify),
        (create_text_overlay, "$g_presentation_obj_battle_28", "str_routed", tf_center_justify),
        (create_text_overlay, "$g_presentation_obj_battle_27", "@Dead", tf_center_justify),

        (create_text_overlay, "$g_battle_us_ready", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_us_wounded", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_us_routed", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_us_dead", s7, tf_center_justify),
        
        (create_text_overlay, "$g_battle_enemies_ready", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_enemies_wounded", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_enemies_routed", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_enemies_dead", s7, tf_center_justify),

        (create_text_overlay, "$g_battle_allies_ready", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_allies_wounded", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_allies_routed", s7, tf_center_justify),
        (create_text_overlay, "$g_battle_allies_dead", s7, tf_center_justify),


        (create_image_button_overlay, "$g_battle_report_plane", "mesh_white_plane", "mesh_white_plane"),
        (overlay_set_color, "$g_battle_report_plane", 0),
        (position_set_x, pos1, 15500),
        (position_set_y, pos1, 6000),
        (overlay_set_size, "$g_battle_report_plane", pos1),
        (position_set_x, pos1, 672),
        (position_set_y, pos1, 275),
        (overlay_set_position, "$g_battle_report_plane", pos1),
        (overlay_set_alpha, "$g_battle_report_plane", 0x44),
        (overlay_set_color, "$g_battle_report_plane", 0x1166BB),


        (position_set_x, pos1, 750),
        (position_set_y, pos1, 750),

        (overlay_set_size, "$g_presentation_obj_battle_14", pos1), #new
        (overlay_set_size, "$g_presentation_obj_battle_15", pos1), #new
        (overlay_set_size, "$g_presentation_obj_battle_16", pos1), #new
        (overlay_set_size, "$g_presentation_obj_battle_17", pos1), #new

        (overlay_set_size, "$g_presentation_obj_battle_22", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_23", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_24", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_25", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_26", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_27", pos1),
        (overlay_set_size, "$g_presentation_obj_battle_28", pos1),
        (overlay_set_size, "$g_battle_us_ready", pos1),
        (overlay_set_size, "$g_battle_us_wounded", pos1),
        (overlay_set_size, "$g_battle_us_routed", pos1),
        (overlay_set_size, "$g_battle_us_dead", pos1),
        (overlay_set_size, "$g_battle_enemies_ready", pos1),
        (overlay_set_size, "$g_battle_enemies_wounded", pos1),
        (overlay_set_size, "$g_battle_enemies_routed", pos1),
        (overlay_set_size, "$g_battle_enemies_dead", pos1),
        (overlay_set_size, "$g_battle_allies_ready", pos1),        
        (overlay_set_size, "$g_battle_allies_wounded", pos1),
        (overlay_set_size, "$g_battle_allies_routed", pos1),
        (overlay_set_size, "$g_battle_allies_dead", pos1),

        (assign, ":stat_position_x", 675),
        (assign, ":stat_position_y", 280),

        (val_add, ":stat_position_x", 70),
        (val_add, ":stat_position_y", 90),
        (position_set_x, pos1, ":stat_position_x"),
        (position_set_y, pos1, ":stat_position_y"),
        (overlay_set_position, "$g_presentation_obj_battle_25", pos1),
        (val_add, ":stat_position_x", 70),
        (position_set_x, pos1, ":stat_position_x"),
        (overlay_set_position, "$g_presentation_obj_battle_26", pos1),
        (val_add, ":stat_position_x", 70),
        (position_set_x, pos1, ":stat_position_x"),
        (overlay_set_position, "$g_presentation_obj_battle_28", pos1),
        (val_add, ":stat_position_x", 70),
        (position_set_x, pos1, ":stat_position_x"),
        (overlay_set_position, "$g_presentation_obj_battle_27", pos1),

        (val_add, ":stat_position_x", -280),
        (val_add, ":stat_position_y", -30),
        (position_set_x, pos1, ":stat_position_x"),
        (position_set_y, pos1, ":stat_position_y"),
        (overlay_set_position, "$g_presentation_obj_battle_22", pos1),
        (val_add, ":stat_position_y", -30),
        (position_set_y, pos1, ":stat_position_y"),
        (overlay_set_position, "$g_presentation_obj_battle_23", pos1),
        (val_add, ":stat_position_y", -30),
        (position_set_y, pos1, ":stat_position_y"),
        (overlay_set_position, "$g_presentation_obj_battle_24", pos1),

        (get_scene_boundaries, pos2, pos3),
        (position_transform_position_to_local, pos4, pos2, pos3),
        (set_fixed_point_multiplier, 1000),
        (position_get_x, ":map_width", pos4),
        (position_get_y, ":map_height", pos4),
        (set_fixed_point_multiplier, 1000),
        (store_div, ":map_ratio", ":map_height", 100),
        (store_div, ":map_ratio", ":map_width", ":map_ratio"),
        (try_begin),
          (gt, ":map_ratio", 100),
          (assign, "$g_battle_map_width", 300),
          (store_div, "$g_battle_map_scale", ":map_width", "$g_battle_map_width"),
          (store_div, "$g_battle_map_height", ":map_height", "$g_battle_map_scale"),
        (else_try),
          (assign, "$g_battle_map_height", 300),
          (store_div, "$g_battle_map_scale", ":map_height", "$g_battle_map_height"),
          (store_div, "$g_battle_map_width", ":map_width", "$g_battle_map_scale"),
        (try_end),
        
        (create_image_button_overlay, "$g_battle_map_plane", "mesh_white_plane", "mesh_white_plane"),
        (overlay_set_color, "$g_battle_map_plane", 0),
        (store_add, ":map_bordered_width", "$g_battle_map_width", 20),
        (store_add, ":map_bordered_height", "$g_battle_map_height", 20),
        (store_mul, ":map_scale_x", ":map_bordered_width", 50),
        (store_mul, ":map_scale_y", ":map_bordered_height", 50),
        (position_set_x, pos1, ":map_scale_x"),
        (position_set_y, pos1, ":map_scale_y"),
        (overlay_set_size, "$g_battle_map_plane", pos1),
        (store_sub, ":map_pos_x", 990, ":map_bordered_width"),
        (store_sub, ":map_pos_y", 740, ":map_bordered_height"),
        (position_set_x, pos1, ":map_pos_x"),
        (position_set_y, pos1, ":map_pos_y"),
        (overlay_set_position, "$g_battle_map_plane", pos1),
        (overlay_set_alpha, "$g_battle_map_plane", 0x44),

        (create_mesh_overlay, "$g_battle_map_infantry_order_flag", "mesh_flag_infantry"),
        (create_mesh_overlay, "$g_battle_map_archers_order_flag", "mesh_flag_archers"),
        (create_mesh_overlay, "$g_battle_map_cavalry_order_flag", "mesh_flag_cavalry"),
        (overlay_set_alpha, "$g_battle_map_infantry_order_flag", 0),
        (overlay_set_alpha, "$g_battle_map_archers_order_flag", 0),
        (overlay_set_alpha, "$g_battle_map_cavalry_order_flag", 0),

        (call_script, "script_update_order_panel_checked_classes"),
        (call_script, "script_update_order_panel_statistics_and_map"),

        (presentation_set_duration, 999999),
        ]),
      (ti_on_presentation_event_state_change,
       [(store_trigger_param_1, ":object"),
        (store_trigger_param_2, ":value"),
        (get_player_agent_no, ":player_agent"),
        (agent_get_team, ":player_team", ":player_agent"),

        (assign, ":update_listeners", 0),
        (try_begin),
          (eq, "$group0_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check0"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group0_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group1_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check1"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group1_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group2_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check2"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group2_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group3_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check3"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group3_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group4_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check4"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group4_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group5_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check5"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group5_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group6_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check6"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group6_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group7_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check7"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group7_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
        (else_try),
          (eq, "$group8_has_troops", 1),
          (eq, ":object", "$g_presentation_obj_battle_check8"),
          (assign, ":update_listeners", 1),
          (assign, "$g_formation_group8_selected", ":value"),
          (try_begin),
            (eq, ":value", 1),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0x44),
          (else_try),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),        
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but0"),
          (assign, ":update_listeners", 1),
        
          (assign, "$g_formation_group0_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check0", 1),

          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but1"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group1_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check1", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but2"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group2_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check2", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but3"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group3_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check3", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but4"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group4_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check4", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but5"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group5_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check5", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but6"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group6_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check6", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but7"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group7_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check7", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group8_has_troops", 1),
            (assign, "$g_formation_group8_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check8", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but8"),
          (assign, ":update_listeners", 1),

          (assign, "$g_formation_group8_selected", 1),
          (overlay_animate_to_alpha, "$g_presentation_obj_battle_but8", 250, 0x44),
          (overlay_set_val, "$g_presentation_obj_battle_check8", 1),

          (try_begin),
            (eq, "$group0_has_troops", 1),
            (assign, "$g_formation_group0_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check0", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but0", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group1_has_troops", 1),
            (assign, "$g_formation_group1_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check1", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but1", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group2_has_troops", 1),
            (assign, "$g_formation_group2_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check2", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but2", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group3_has_troops", 1),
            (assign, "$g_formation_group3_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check3", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but3", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group4_has_troops", 1),
            (assign, "$g_formation_group4_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check4", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but4", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group5_has_troops", 1),
            (assign, "$g_formation_group5_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check5", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but5", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group6_has_troops", 1),
            (assign, "$g_formation_group6_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check6", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but6", 250, 0),
          (try_end),
          (try_begin),
            (eq, "$group7_has_troops", 1),
            (assign, "$g_formation_group7_selected", 0),
            (overlay_set_val, "$g_presentation_obj_battle_check7", 0),
            (overlay_animate_to_alpha, "$g_presentation_obj_battle_but7", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_14"),
          (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_spread_out),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_15"),
          (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_stand_closer),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_16"),
          (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_fall_back),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_17"),
          (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_advance),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_10"),
          (try_begin),
            (eq, ":value", 3),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_hold),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_1", 3),
          (else_try),
            (eq, ":value", 2),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_follow),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_1", 2),
          (else_try),
            (eq, ":value", 1),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_charge),
            (call_script, "script_update_order_panel", ":player_team"),
##          (else_try),
##            (eq, ":value", 4),
##            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_advance),
##            (call_script, "script_update_order_panel", ":player_team"),
##          (else_try),
##            (eq, ":value", 3),
##            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_fall_back),
##            (call_script, "script_update_order_panel", ":player_team"),
##          (else_try),
##            (eq, ":value", 2),
##            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_stand_closer),
##            (call_script, "script_update_order_panel", ":player_team"),
##          (else_try),
##            (eq, ":value", 1),
##            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_spread_out),
##            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_1", 1),
          (else_try),
            (eq, ":value", 0),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_stand_ground),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_1", 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_11"),
          (try_begin),
            (eq, ":value", 1),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_mount),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_2", 1),
          (else_try),
            (eq, ":value", 0),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_dismount),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_2", 0),
          (try_end),        
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_12"),
          (try_begin),
            (eq, ":value", 1),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_fire_at_my_command),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_3", 1),
          (else_try),
            (eq, ":value", 0),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_fire_at_will),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_3", 0),
          (try_end),        
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_13"),
          (try_begin),
            (eq, ":value", 1),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_use_any_weapon),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_4", 1),
          (else_try),
            (eq, ":value", 0),
            (call_script, "script_team_give_order_from_order_panel", ":player_agent", mordr_use_blunt_weapons),
            (call_script, "script_update_order_panel", ":player_team"),
            (assign, "$g_latest_order_4", 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_battle_map_plane"),
          (get_scene_boundaries, pos2, pos3),
          (mouse_get_position, pos1),
          (set_fixed_point_multiplier, 1000),
          (position_get_x, ":mouse_x", pos1),
          (position_get_y, ":mouse_y", pos1),
          (store_sub, ":map_x", 980, "$g_battle_map_width"),
          (store_sub, ":map_y", 730, "$g_battle_map_height"),
          (val_sub, ":mouse_x", ":map_x"),
          (val_sub, ":mouse_y", ":map_y"),
          (val_clamp, ":mouse_x", 0, "$g_battle_map_width"),
          (val_clamp, ":mouse_y", 0, "$g_battle_map_height"),
          (val_mul, ":mouse_x", "$g_battle_map_scale"),
          (val_mul, ":mouse_y", "$g_battle_map_scale"),
          (set_fixed_point_multiplier, 1000),
          (position_set_x, pos1, ":mouse_x"),
          (position_set_y, pos1, ":mouse_y"),
          (position_transform_position_to_parent, pos3, pos2, pos1),
          (try_begin),
            (eq, "$g_formation_group0_selected", 1),
            (team_give_order, ":player_team", 0, mordr_hold),
            (team_set_order_position, ":player_team", 0, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group1_selected", 1),
            (team_give_order, ":player_team", 1, mordr_hold),
            (team_set_order_position, ":player_team", 1, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group2_selected", 1),
            (team_give_order, ":player_team", 2, mordr_hold),
            (team_set_order_position, ":player_team", 2, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group3_selected", 1),
            (team_give_order, ":player_team", 3, mordr_hold),
            (team_set_order_position, ":player_team", 3, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group4_selected", 1),
            (team_give_order, ":player_team", 4, mordr_hold),
            (team_set_order_position, ":player_team", 4, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group5_selected", 1),
            (team_give_order, ":player_team", 5, mordr_hold),
            (team_set_order_position, ":player_team", 5, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group6_selected", 1),
            (team_give_order, ":player_team", 6, mordr_hold),
            (team_set_order_position, ":player_team", 6, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group7_selected", 1),
            (team_give_order, ":player_team", 7, mordr_hold),
            (team_set_order_position, ":player_team", 7, pos3),
          (try_end),
          (try_begin),
            (eq, "$g_formation_group8_selected", 1),
            (team_give_order, ":player_team", 8, mordr_hold),
            (team_set_order_position, ":player_team", 8, pos3),
          (try_end),        
          (call_script, "script_update_order_flags_on_map"),
          (call_script, "script_update_order_panel", ":player_team"),
        (try_end),
        
        (try_begin),
          (eq, ":update_listeners", 1),
          (team_set_order_listener, ":player_team", -1),
          (try_begin),
            (this_or_next|eq, "$g_formation_group0_selected", 1),
            (eq, "$group0_has_troops", 0),
            (this_or_next|eq, "$g_formation_group1_selected", 1),
            (eq, "$group1_has_troops", 0),
            (this_or_next|eq, "$g_formation_group2_selected", 1),
            (eq, "$group2_has_troops", 0),
            (this_or_next|eq, "$g_formation_group3_selected", 1),
            (eq, "$group3_has_troops", 0),
            (this_or_next|eq, "$g_formation_group4_selected", 1),
            (eq, "$group4_has_troops", 0),
            (this_or_next|eq, "$g_formation_group5_selected", 1),
            (eq, "$group5_has_troops", 0),
            (this_or_next|eq, "$g_formation_group6_selected", 1),
            (eq, "$group6_has_troops", 0),
            (this_or_next|eq, "$g_formation_group7_selected", 1),
            (eq, "$group7_has_troops", 0),
            (this_or_next|eq, "$g_formation_group8_selected", 1),
            (eq, "$group8_has_troops", 0),
            (team_set_order_listener, ":player_team", grc_everyone),
          (else_try),
            (eq, "$g_formation_group0_selected", 1),
            (team_set_order_listener, ":player_team", 0, 1),
          (else_try),
            (eq, "$g_formation_group1_selected", 1),
            (team_set_order_listener, ":player_team", 1, 1),
          (else_try),
            (eq, "$g_formation_group2_selected", 1),
            (team_set_order_listener, ":player_team", 2, 1),
          (else_try),
            (eq, "$g_formation_group3_selected", 1),
            (team_set_order_listener, ":player_team", 3, 1),
          (else_try),
            (eq, "$g_formation_group4_selected", 1),
            (team_set_order_listener, ":player_team", 4, 1),
          (else_try),
            (eq, "$g_formation_group5_selected", 1),
            (team_set_order_listener, ":player_team", 5, 1),
          (else_try),
            (eq, "$g_formation_group6_selected", 1),
            (team_set_order_listener, ":player_team", 6, 1),
          (else_try),
            (eq, "$g_formation_group7_selected", 1),
            (team_set_order_listener, ":player_team", 7, 1),
          (else_try),
            (eq, "$g_formation_group8_selected", 1),
            (team_set_order_listener, ":player_team", 8, 1),
          (try_end),
        (try_end),
        ]),
      (ti_on_presentation_mouse_enter_leave,
       [(store_trigger_param_1, ":object"),
        (store_trigger_param_2, ":enter_leave"),
        (try_begin),
          (eq, ":object", "$g_presentation_obj_battle_but0"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but0_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but0_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but0_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name0", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but0_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but0_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but0_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name0", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but1"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but1_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but1_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but1_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name1", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but1_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but1_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but1_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name1", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but2"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but2_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but2_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but2_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name2", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but2_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but2_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but2_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name2", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but3"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but3_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but3_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but3_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name3", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but3_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but3_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but3_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name3", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but4"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but4_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but4_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but4_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name4", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but4_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but4_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but4_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name4", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but5"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but5_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but5_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but5_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name5", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but5_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but5_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but5_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name5", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but6"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but6_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but6_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but6_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name6", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but6_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but6_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but6_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name6", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but7"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but7_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but7_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but7_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name7", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but7_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but7_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but7_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name7", 250, 0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_battle_but8"),
          (try_begin),
            (eq, ":enter_leave", 0),
            (overlay_animate_to_color, "$g_presentation_but8_movement", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but8_riding", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_but8_weapon_usage", 250, 0xFFFFFF),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name8", 250, 0xFFFFFF),
          (else_try),
            (overlay_animate_to_color, "$g_presentation_but8_movement", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but8_riding", 250, 0),
            (overlay_animate_to_color, "$g_presentation_but8_weapon_usage", 250, 0),
            (overlay_animate_to_color, "$g_presentation_obj_battle_name8", 250, 0),
          (try_end),
        (try_end),
        ]),
      (ti_on_presentation_run,
       [(store_trigger_param_1, ":cur_time"),
        (try_begin),
          (this_or_next|game_key_clicked, gk_group0_hear),
          (this_or_next|game_key_clicked, gk_group1_hear),
          (this_or_next|game_key_clicked, gk_group2_hear),
          (this_or_next|game_key_clicked, gk_group3_hear),
          (this_or_next|game_key_clicked, gk_group4_hear),
          (this_or_next|game_key_clicked, gk_group5_hear),
          (this_or_next|game_key_clicked, gk_group6_hear),
          (this_or_next|game_key_clicked, gk_group7_hear),
          (this_or_next|game_key_clicked, gk_group8_hear),
          (this_or_next|game_key_clicked, gk_everyone_hear),
          (game_key_clicked, gk_reverse_order_group),
          (call_script, "script_update_order_panel_checked_classes"),
        (try_end),
        (try_begin),
          (this_or_next|game_key_clicked, gk_order_1),
          (this_or_next|game_key_clicked, gk_order_2),
          (this_or_next|game_key_clicked, gk_order_3),
          (this_or_next|game_key_clicked, gk_order_4),
          (this_or_next|game_key_clicked, gk_order_5),
          (game_key_clicked, gk_order_6),
          (get_player_agent_no, ":player_agent"),
          (agent_get_team, ":player_team", ":player_agent"),
          (call_script, "script_update_order_panel", ":player_team"),
        (try_end),
        (try_begin),
          (gt, ":cur_time", 200),
          (game_key_clicked, gk_view_orders),
          (try_for_agents, ":cur_agent"),
            (agent_is_active,":cur_agent"),
            (agent_set_slot, ":cur_agent", slot_agent_map_overlay_id, 0),
          (try_end),
          (presentation_set_duration, 0),
        (try_end),
        ]),
      ]),


    ("sliders",0,0,[
      (ti_on_presentation_load,
       [(set_fixed_point_multiplier, 1000),
        (create_slider_overlay, "$g_presentation_obj_sliders_1", 0, 100),
        (create_slider_overlay, "$g_presentation_obj_sliders_2", 0, 100),
        (create_slider_overlay, "$g_presentation_obj_sliders_3", 0, 100),
        (create_slider_overlay, "$g_presentation_obj_sliders_4", 0, 100),
        (assign, reg1, 25),
        (str_store_string, s1, "str_reg1"),
        (create_text_overlay, "$g_presentation_obj_sliders_5", s1),
        (create_text_overlay, "$g_presentation_obj_sliders_6", s1),
        (create_text_overlay, "$g_presentation_obj_sliders_7", s1),
        (create_text_overlay, "$g_presentation_obj_sliders_8", s1),
        (assign, "$g_presentation_obj_sliders_1_val", 25),
        (overlay_set_val, "$g_presentation_obj_sliders_1", 25),
        (assign, "$g_presentation_obj_sliders_2_val", 25),
        (overlay_set_val, "$g_presentation_obj_sliders_2", 25),
        (assign, "$g_presentation_obj_sliders_3_val", 25),
        (overlay_set_val, "$g_presentation_obj_sliders_3", 25),
        (assign, "$g_presentation_obj_sliders_4_val", 25),
        (overlay_set_val, "$g_presentation_obj_sliders_4", 25),
        (position_set_x, pos1, 600),
        (position_set_y, pos1, 200),
        (overlay_set_position, "$g_presentation_obj_sliders_1", pos1),
        (position_set_y, pos1, 300),
        (overlay_set_position, "$g_presentation_obj_sliders_2", pos1),
        (position_set_y, pos1, 400),
        (overlay_set_position, "$g_presentation_obj_sliders_3", pos1),
        (position_set_y, pos1, 500),
        (overlay_set_position, "$g_presentation_obj_sliders_4", pos1),
        (position_set_x, pos1, 800),
        (position_set_y, pos1, 200),
        (overlay_set_position, "$g_presentation_obj_sliders_5", pos1),
        (position_set_y, pos1, 300),
        (overlay_set_position, "$g_presentation_obj_sliders_6", pos1),
        (position_set_y, pos1, 400),
        (overlay_set_position, "$g_presentation_obj_sliders_7", pos1),
        (position_set_y, pos1, 500),
        (overlay_set_position, "$g_presentation_obj_sliders_8", pos1),
        (position_set_x, pos1, 500),
        (overlay_set_size, "$g_presentation_obj_sliders_3", pos1),
        ]),
      (ti_on_presentation_run,
       [
        ]),
      (ti_on_presentation_event_state_change,
       [(store_trigger_param_1, ":object"),
        (store_trigger_param_2, ":value"),
        (assign, ":val_changed", 0),
        (try_begin),
          (eq, ":object", "$g_presentation_obj_sliders_1"),
          (try_begin),
            (neq, "$g_presentation_obj_sliders_1_val", ":value"),
            (assign, "$g_presentation_obj_sliders_1_val", ":value"),
            (assign, ":val_changed", 1),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_sliders_2"),
          (try_begin),
            (neq, "$g_presentation_obj_sliders_2_val", ":value"),
            (assign, "$g_presentation_obj_sliders_2_val", ":value"),
            (assign, ":val_changed", 1),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_sliders_3"),
          (try_begin),
            (neq, "$g_presentation_obj_sliders_3_val", ":value"),
            (assign, "$g_presentation_obj_sliders_3_val", ":value"),
            (assign, ":val_changed", 1),
          (try_end),
        (else_try),
          (eq, ":object", "$g_presentation_obj_sliders_4"),
          (try_begin),
            (neq, "$g_presentation_obj_sliders_4_val", ":value"),
            (assign, "$g_presentation_obj_sliders_4_val", ":value"),
            (assign, ":val_changed", 1),
          (try_end),
        (try_end),
        (try_begin),
          (eq, ":val_changed", 1),
          (assign, ":sum_values", 0),
          (val_add, ":sum_values", "$g_presentation_obj_sliders_1_val"),
          (val_add, ":sum_values", "$g_presentation_obj_sliders_2_val"),
          (val_add, ":sum_values", "$g_presentation_obj_sliders_3_val"),
          (val_add, ":sum_values", "$g_presentation_obj_sliders_4_val"),
          (store_sub, ":difference", 100, ":sum_values"),
          (assign, ":obj_1_new_val", "$g_presentation_obj_sliders_1_val"),
          (assign, ":obj_2_new_val", "$g_presentation_obj_sliders_2_val"),
          (assign, ":obj_3_new_val", "$g_presentation_obj_sliders_3_val"),
          (assign, ":obj_4_new_val", "$g_presentation_obj_sliders_4_val"),
          (assign, ":adder", 1),
          (assign, ":between_1", 0),
          (assign, ":between_2", 100),
          (try_begin),
            (lt, ":difference", 0),
            (val_mul, ":difference", -1),
            (assign, ":adder", -1),
            (assign, ":between_1", 1),
            (assign, ":between_2", 101),
          (try_end),
          (store_sub, ":sum_non_changed_values", ":sum_values", ":value"),
          (val_add, ":sum_non_changed_values", 30),
          (try_for_range, ":unused", 0, ":difference"),
            (store_random_in_range, ":random_no", 0, ":sum_non_changed_values"),
            (try_begin),
              (neq, ":object", "$g_presentation_obj_sliders_1"),
              (val_sub, ":random_no", "$g_presentation_obj_sliders_1_val"),
              (val_sub, ":random_no", 10),
              (lt, ":random_no", 0),
              (is_between, ":obj_1_new_val", ":between_1", ":between_2"),
              (val_add, ":obj_1_new_val", ":adder"),
            (else_try),
              (neq, ":object", "$g_presentation_obj_sliders_2"),
              (val_sub, ":random_no", "$g_presentation_obj_sliders_2_val"),
              (val_sub, ":random_no", 10),
              (lt, ":random_no", 0),
              (is_between, ":obj_2_new_val", ":between_1", ":between_2"),
              (val_add, ":obj_2_new_val", ":adder"),
            (else_try),
              (neq, ":object", "$g_presentation_obj_sliders_3"),
              (val_sub, ":random_no", "$g_presentation_obj_sliders_3_val"),
              (val_sub, ":random_no", 10),
              (lt, ":random_no", 0),
              (is_between, ":obj_3_new_val", ":between_1", ":between_2"),
              (val_add, ":obj_3_new_val", ":adder"),
            (else_try),
              (is_between, ":obj_4_new_val", ":between_1", ":between_2"),
              (val_add, ":obj_4_new_val", ":adder"),
            (else_try),
              (val_add, ":difference", 1),
            (try_end),
          (try_end),
          (assign, "$g_presentation_obj_sliders_1_val", ":obj_1_new_val"),
          (assign, "$g_presentation_obj_sliders_2_val", ":obj_2_new_val"),
          (assign, "$g_presentation_obj_sliders_3_val", ":obj_3_new_val"),
          (assign, "$g_presentation_obj_sliders_4_val", ":obj_4_new_val"),
        (try_end),
        (overlay_set_val, "$g_presentation_obj_sliders_1", "$g_presentation_obj_sliders_1_val"),
        (overlay_set_val, "$g_presentation_obj_sliders_2", "$g_presentation_obj_sliders_2_val"),
        (overlay_set_val, "$g_presentation_obj_sliders_3", "$g_presentation_obj_sliders_3_val"),
        (overlay_set_val, "$g_presentation_obj_sliders_4", "$g_presentation_obj_sliders_4_val"),
        (assign, reg1, "$g_presentation_obj_sliders_1_val"),
        (str_store_string, s1, "str_reg1"),
        (overlay_set_text, "$g_presentation_obj_sliders_5", s1),
        (assign, reg1, "$g_presentation_obj_sliders_2_val"),
        (str_store_string, s1, "str_reg1"),
        (overlay_set_text, "$g_presentation_obj_sliders_6", s1),
        (assign, reg1, "$g_presentation_obj_sliders_3_val"),
        (str_store_string, s1, "str_reg1"),
        (overlay_set_text, "$g_presentation_obj_sliders_7", s1),
        (assign, reg1, "$g_presentation_obj_sliders_4_val"),
        (str_store_string, s1, "str_reg1"),
        (overlay_set_text, "$g_presentation_obj_sliders_8", s1),
        ]),
      ]),

  

  

  ("game_before_quit", 0, mesh_load_window,
   [
     (ti_on_presentation_load,
      [
        # (try_begin),
          # (is_trial_version),
          # (set_fixed_point_multiplier, 1000),
          # (create_mesh_overlay, reg0, "mesh_quit_adv"),
          # (position_set_x, pos1, -1),
          # (position_set_y, pos1, -1),
          # (overlay_set_position, reg0, pos1),
          # (position_set_x, pos1, 1002),
          # (position_set_y, pos1, 1002),
          # (overlay_set_size, reg0, pos1),
          # (assign, "$g_game_before_quit_state", 0),
          # (presentation_set_duration, 999999),
        # (try_end),
      ]),
     (ti_on_presentation_run,
       [
        # (store_trigger_param_1, ":cur_time"),
        # (gt, ":cur_time", 500),
        # (try_begin),
          # (this_or_next|key_clicked, key_space),
          # (this_or_next|key_clicked, key_enter),
          # (this_or_next|key_clicked, key_escape),
          # (this_or_next|key_clicked, key_back_space),
          # (this_or_next|key_clicked, key_left_mouse_button),
          # (key_clicked, key_right_mouse_button),
          # (try_begin),
            # (eq, "$g_game_before_quit_state", 0),
            # (val_add, "$g_game_before_quit_state", 1),
            # (create_mesh_overlay, reg0, "mesh_quit_adv_b"),
            # (position_set_x, pos1, -1),
            # (position_set_y, pos1, -1),
            # (overlay_set_position, reg0, pos1),
            # (position_set_x, pos1, 1002),
            # (position_set_y, pos1, 1002),
            # (overlay_set_size, reg0, pos1),
          # (else_try),
            # (presentation_set_duration, 0),
          # (try_end),
        # (try_end),
        ]),
     ]),

  ("multiplayer_duel_start_counter", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [      
      (set_fixed_point_multiplier, 1000),

      (assign, "$g_multiplayer_duel_start_counter_overlay", -1),
      (assign, "$g_multiplayer_last_duel_start_counter_value", -1),

      (str_clear, s0),
      (create_text_overlay, "$g_multiplayer_duel_start_counter_overlay", s0, tf_center_justify|tf_with_outline),
      (overlay_set_color, "$g_multiplayer_duel_start_counter_overlay", 0xFFFFFF),
      (position_set_x, pos1, 500),
      (position_set_y, pos1, 600),
      (overlay_set_position, "$g_multiplayer_duel_start_counter_overlay", pos1),
      (position_set_x, pos1, 2000),
      (position_set_y, pos1, 2000),
      (overlay_set_size, "$g_multiplayer_duel_start_counter_overlay", pos1),

      (presentation_set_duration, 999999),
      ]),
  
    (ti_on_presentation_run, [
      (ge, "$g_multiplayer_duel_start_counter_overlay", 0),
      (store_mission_timer_a, ":current_time"),
      (store_sub, ":seconds_past_in_duel_start", ":current_time", "$g_multiplayer_duel_start_time"),
      (store_sub, ":seconds_left_in_duel_start", 3, ":seconds_past_in_duel_start"),
      (try_begin),
        (le, ":seconds_left_in_duel_start", 0),
        (presentation_set_duration, 0),
      (else_try),
        (neq, "$g_multiplayer_last_duel_start_counter_value", ":seconds_left_in_duel_start"),
        (assign, "$g_multiplayer_last_duel_start_counter_value", ":seconds_left_in_duel_start"),
        (assign, reg0, ":seconds_left_in_duel_start"),
        (str_store_string, s0, "str_duel_starts_in_reg0_seconds"),
        (overlay_set_text, "$g_multiplayer_duel_start_counter_overlay", s0),
      (try_end),
      ]),
    ]),

  ("multiplayer_music", prsntf_manual_end_only, 0, [ #MM
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
      
      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 450), #250
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 700), #550 #1000
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),
      
      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_troop_select_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 370), #285
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_troop_select_container", pos1),
      (position_set_x, pos1, 355), #305 #405
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_troop_select_container", pos1),
      (set_container_overlay, "$g_presentation_obj_troop_select_container"),
          
      (multiplayer_get_my_player, ":my_player_no"),
      (gt, ":my_player_no", -1),
      (player_get_agent_id, ":player_agent", ":my_player_no"),
      (gt, ":player_agent", -1),
      (agent_get_team,":player_team",":player_agent"),
      (team_get_faction,":player_faction",":player_team"),
      
      
      (assign,":instrument",-1),
      (try_begin),
        (gt,"$g_used_piano_type",0),
        (assign,":instrument","$g_used_piano_type"),
        (assign,"$g_used_piano_type",-1),
      (else_try),  
        (agent_get_wielded_item,":instrument",":player_agent",0),
      (try_end),
	  
      (assign,":start_cond",0),
      (assign,":end_cond",0),
      (assign,":has_secondary",0),
      (try_begin),
        (eq,":instrument","itm_drumstick_right"),
        (try_begin),
          (eq,":player_faction","fac_britain"),
          (assign,":start_cond",drum_sounds_britain_begin),
          (assign,":end_cond",drum_sounds_britain_end),
          (assign,":track_strings_begin",drum_strings_britain_begin),
          (try_begin),
            (agent_get_troop_id,":troop_id",":player_agent"),
            (eq,":troop_id","trp_british_highlander_drum"),
            (assign,":start_cond",drum_sounds_highland_begin),
            (assign,":end_cond",drum_sounds_highland_end),
            (assign,":track_strings_begin",drum_strings_highland_begin),
          (try_end),
        (else_try),
          (this_or_next|eq,":player_faction","fac_rhine"),
          (eq,":player_faction","fac_france"),
          (assign,":start_cond",drum_sounds_france_begin),
          (assign,":end_cond",drum_sounds_france_end),
          (assign,":track_strings_begin",drum_strings_france_begin),
        (else_try),
          (eq,":player_faction","fac_prussia"),
          (assign,":start_cond",drum_sounds_prussia_begin),
          (assign,":end_cond",drum_sounds_prussia_end),
          (assign,":track_strings_begin",drum_strings_prussia_begin),
        (else_try),
          (eq,":player_faction","fac_russia"),
          (assign,":start_cond",drum_sounds_russia_begin),
          (assign,":end_cond",drum_sounds_russia_end),
          (assign,":track_strings_begin",drum_strings_russia_begin),
        (else_try),
          (eq,":player_faction","fac_austria"),
          (assign,":start_cond",drum_sounds_austria_begin),
          (assign,":end_cond",drum_sounds_austria_end),
          (assign,":track_strings_begin",drum_strings_austria_begin),
        (try_end),
        (assign,":has_secondary",1),
        (assign,":sec_string","str_music_calls"),
        (assign,":sec_start_cond",drum_sounds_calls_begin),
        (assign,":sec_end_cond",drum_sounds_calls_end),
        (assign,":sec_track_strings_begin",drum_strings_calls_begin),
      (else_try),
        (eq,":instrument","itm_flute"),
        (try_begin),
          (eq,":player_faction","fac_britain"),
          (assign,":start_cond",fife_sounds_britain_begin),
          (assign,":end_cond",fife_sounds_britain_end),
          (assign,":track_strings_begin",fife_strings_britain_begin),
        (else_try),
          (this_or_next|eq,":player_faction","fac_rhine"),
          (eq,":player_faction","fac_france"),
          (assign,":start_cond",fife_sounds_france_begin),
          (assign,":end_cond",fife_sounds_france_end),
          (assign,":track_strings_begin",fife_strings_france_begin),
        (else_try),
          (eq,":player_faction","fac_prussia"),
          (assign,":start_cond",fife_sounds_prussia_begin),
          (assign,":end_cond",fife_sounds_prussia_end),
          (assign,":track_strings_begin",fife_strings_prussia_begin),
        (else_try),
          (eq,":player_faction","fac_russia"),
          (assign,":start_cond",fife_sounds_russia_begin),
          (assign,":end_cond",fife_sounds_russia_end),
          (assign,":track_strings_begin",fife_strings_russia_begin),
        (else_try),
          (eq,":player_faction","fac_austria"),
          (assign,":start_cond",fife_sounds_austria_begin),
          (assign,":end_cond",fife_sounds_austria_end),
          (assign,":track_strings_begin",fife_strings_austria_begin),
        (try_end),
      (else_try),
        (is_between,":instrument","itm_horn","itm_bagpipe"),
        (try_begin),
          (eq,":player_faction","fac_britain"),
          (assign,":start_cond",bugle_sounds_britain_begin),
          (assign,":end_cond",bugle_sounds_britain_end),
          (assign,":track_strings_begin",bugle_strings_britain_begin),
        (else_try),
          (eq,":player_faction","fac_france"),
          (assign,":start_cond",bugle_sounds_france_begin),
          (assign,":end_cond",bugle_sounds_france_end),
          (assign,":track_strings_begin",bugle_strings_france_begin),
        (else_try),
          (eq,":player_faction","fac_prussia"),
          (assign,":start_cond",bugle_sounds_prussia_begin),
          (assign,":end_cond",bugle_sounds_prussia_end),
          (assign,":track_strings_begin",bugle_strings_prussia_begin),
        (else_try),
          (eq,":player_faction","fac_russia"),
          (assign,":start_cond",bugle_sounds_russia_begin),
          (assign,":end_cond",bugle_sounds_russia_end),
          (assign,":track_strings_begin",bugle_strings_russia_begin),
        (else_try),
          (eq,":player_faction","fac_austria"),
          (assign,":start_cond",bugle_sounds_austria_begin),
          (assign,":end_cond",bugle_sounds_austria_end),
          (assign,":track_strings_begin",bugle_strings_austria_begin),
        (else_try),
          (eq,":player_faction","fac_rhine"),
          (assign,":start_cond",bugle_sounds_france_begin),
          (store_add,":end_cond",bugle_sounds_france_end,1), #Adding first track from Prussia
          (assign,":track_strings_begin",bugle_strings_france_begin),
        (try_end),
        (assign,":has_secondary",1),
        (assign,":sec_string","str_music_calls"),
        (assign,":sec_start_cond",bugle_sounds_calls_begin),
        (assign,":sec_end_cond",bugle_sounds_calls_end),
        (assign,":sec_track_strings_begin",bugle_strings_calls_begin),
      (else_try),
        (eq,":instrument","itm_bagpipe"),
        (try_begin),
          (eq,":player_faction","fac_britain"),
          (assign,":start_cond",bagpipes_sounds_britain_begin),
          (assign,":end_cond",bagpipes_sounds_britain_end),
          (assign,":track_strings_begin",bagpipes_strings_britain_begin),
          (assign,":has_secondary",1),
          (assign,":sec_string","str_bagpipe_extras"),
          (assign,":sec_start_cond",bagpipes_sounds_extra_begin),
          (assign,":sec_end_cond",bagpipes_sounds_extra_end),
          (assign,":sec_track_strings_begin",bagpipes_strings_extra_begin),
        (try_end),
      (else_try),
        (eq,":instrument","spr_mm_piano"),
        (assign,":start_cond",piano_sounds_begin),
        (assign,":end_cond",piano_sounds_end),
        (assign,":track_strings_begin",piano_strings_begin),
      (else_try),
        (eq,":instrument","spr_mm_organ"),
        (assign,":start_cond",organ_sounds_begin),
        (assign,":end_cond",organ_sounds_end),
        (assign,":track_strings_begin",organ_strings_begin),
      (try_end),
      
      (assign,":failed",0),
      (try_begin),
        (this_or_next|eq,":start_cond",0),
        (eq,":end_cond",0),

        (assign,":failed",1),
        (presentation_set_duration, 0),
      (try_end),

      (eq,":failed",0),
      
      (assign, ":cur_y", 800),
      (assign, ":sub_y", 40),
        
      (create_text_overlay, reg0, "str_select_track", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 100), #0
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, reg0, pos1),
      (val_sub, ":cur_y", ":sub_y"),
      (position_set_y, pos1, ":cur_y"),
      (position_set_x, pos1, 100),
      
      (try_for_range, ":i_multi", 0, instrument_max_tracks),
        (troop_set_slot, "trp_track_select_dummy", ":i_multi", -1),
      (try_end),
      
      (assign, ":cur_track_index", 0),
      (try_for_range, ":unused", ":start_cond", ":end_cond"),

        (store_add,":track_string",":cur_track_index",":track_strings_begin"),
        (create_button_overlay, reg1, ":track_string", 0),
        (overlay_set_color, reg1, 0xFFFFFF),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg1, pos1),
        (val_sub, ":cur_y", ":sub_y"),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x, pos3, 1000),
        (position_set_y, pos3, 1000),
        (overlay_set_size,reg1, pos3),
          
        (troop_set_slot, "trp_track_select_dummy", ":cur_track_index", reg1),
        (val_add, ":cur_track_index", 1),
      (try_end),
      (try_begin),
        (eq,":has_secondary",1),
        
        (val_sub, ":cur_y", 20),
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 10000),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1),
        (val_sub, ":cur_y", 30),
        
        (create_text_overlay, reg0, ":sec_string", 0),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 100), #0
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 900),
        (position_set_y, pos1, 900),
        (overlay_set_size, reg0, pos1),
        
        (val_sub, ":cur_y", 10),
        (create_mesh_overlay, reg0, "mesh_white_plane"),
        (overlay_set_color, reg0, 0xFFFFFF),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 10000),
        (position_set_y, pos1, 50),
        (overlay_set_size, reg0, pos1),
        
        (val_sub, ":cur_y", ":sub_y"),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x, pos1, 100),
        
        (assign,":sec_track_index",0),
        (try_for_range, ":unused", ":sec_start_cond", ":sec_end_cond"),

          (store_add,":track_string",":sec_track_index",":sec_track_strings_begin"),
          (create_button_overlay, reg1, ":track_string", 0),
          (overlay_set_color, reg1, 0xFFFFFF),
          (position_set_y, pos1, ":cur_y"),
          (overlay_set_position, reg1, pos1),
          (val_sub, ":cur_y", ":sub_y"),
          (position_set_y, pos1, ":cur_y"),
          (position_set_x, pos3, 1000),
          (position_set_y, pos3, 1000),
          (overlay_set_size,reg1, pos3),
          
          (troop_set_slot, "trp_track_select_dummy", ":cur_track_index", reg1),
          (val_add, ":cur_track_index", 1),
          (val_add, ":sec_track_index", 1),
        (try_end),
      (try_end),
      
      (val_sub, ":cur_y", 20),
      (create_mesh_overlay, reg0, "mesh_white_plane"),
      (overlay_set_color, reg0, 0xFFFFFF),
      (overlay_set_alpha, reg0, 0xD0),
      (position_set_x, pos1, 100),
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 10000),
      (position_set_y, pos1, 50),
      (overlay_set_size, reg0, pos1),
      (val_sub, ":cur_y", 30),
        
      (create_check_box_overlay, "$g_music_presentation_play_together_button", "mesh_checkbox_off", "mesh_checkbox_on"),
      (overlay_set_val, "$g_music_presentation_play_together_button", "$g_play_music_together"),
      (position_set_x, pos1, 100), #0
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_music_presentation_play_together_button", pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, "$g_music_presentation_play_together_button", pos1),
      
      (create_text_overlay, reg0, "str_play_together", 0),
      (overlay_set_color, reg0, 0xFFFFFF),
      (position_set_x, pos1, 120), #0
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 1000),
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),
      
      (presentation_set_duration, 999999),
      ]),
   
    (ti_on_presentation_event_state_change, [
      (store_trigger_param_1, ":object"),
      (store_trigger_param_2, ":value"),
      
      (neq,"$g_waiting_for_confirmation_to_terminate",1),
      
      (try_begin),
        (eq,":object","$g_music_presentation_play_together_button"),
        (assign, "$g_play_music_together", ":value"),
        (start_presentation,"prsnt_multiplayer_music"),
        (multiplayer_send_3_int_to_server, multiplayer_event_send_player_action, player_action_music, music_type_toggle_together,":value"),
      (try_end),
      
      (assign, ":end_cond", instrument_max_tracks),
      (try_for_range, ":i_button", 0, ":end_cond"),
        (troop_slot_eq, "trp_track_select_dummy", ":i_button", ":object"),
        
        (multiplayer_send_3_int_to_server, multiplayer_event_send_player_action, player_action_music, music_type_start,":i_button"),
        
        (store_mission_timer_a,"$g_started_playing_music_at"),
       
        (assign, ":end_cond", 0), #break
      (try_end),
      
        #TEMP
        (presentation_set_duration, 0),
        #TEMP
        
      #(assign, "$g_waiting_for_confirmation_to_terminate", 1),
      ]),
    (ti_on_presentation_run, [
      (store_trigger_param_1,":cur_time"),
      (try_begin),
        (gt,":cur_time",200),
        (this_or_next|key_clicked, key_escape),
        (game_key_clicked, gk_defend), #gk_party_window
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
      #(else_try),
      #  (eq, "$g_waiting_for_confirmation_to_terminate", 1),
      #  (eq, "$g_confirmation_result", 1),
      #  (assign, "$g_waiting_for_confirmation_to_terminate", 0),
      #  (presentation_set_duration, 0),
      #  (store_mission_timer_a, "$g_music_started_at"),
      #(else_try),
      #  (eq, "$g_waiting_for_confirmation_to_terminate", 1),
      #  (eq, "$g_confirmation_result", -1),
      #  (assign, "$g_waiting_for_confirmation_to_terminate", 0),
      #  (presentation_set_duration, 0),
      #  (start_presentation,"prsnt_multiplayer_music"),
      (try_end),
      ]),
    ]),
  
  ("conquest_flag_select",0,0,[
      (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        
        # Create a container
        (str_clear, s0),
        (create_text_overlay, "$g_presentation_obj_flag_select_container", s0, tf_scrollable_style_2),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, 0),#90
        (overlay_set_position, "$g_presentation_obj_flag_select_container", pos1),
        (position_set_x, pos1, 1150),
        (position_set_y, pos1, 690),#560
        (overlay_set_area_size, "$g_presentation_obj_flag_select_container", pos1),
        (set_container_overlay, "$g_presentation_obj_flag_select_container"),
        
        
        (get_scene_boundaries, pos52, pos53),
        (position_transform_position_to_local, pos54, pos52, pos53),
        #(set_fixed_point_multiplier, 1000),
        (position_get_x, ":map_width", pos54),
        (position_get_y, ":map_height", pos54),
        #(set_fixed_point_multiplier, 1000),
        (store_div, ":map_ratio", ":map_height", 50),#100
        (store_div, ":map_ratio", ":map_width", ":map_ratio"),
        (try_begin),
          (gt, ":map_ratio", 100),
          (assign, "$g_battle_map_width", 600),#300
          (store_div, "$g_battle_map_scale", ":map_width", "$g_battle_map_width"),
          (store_div, "$g_battle_map_height", ":map_height", "$g_battle_map_scale"),
        (else_try),
          (assign, "$g_battle_map_height", 600),#300
          (store_div, "$g_battle_map_scale", ":map_height", "$g_battle_map_height"),
          (store_div, "$g_battle_map_width", ":map_width", "$g_battle_map_scale"),
        (try_end),
        
        (create_mesh_overlay, "$g_battle_map_plane", "mesh_white_plane"),
        (overlay_set_color, "$g_battle_map_plane", 0),
        (store_add, ":map_bordered_width", "$g_battle_map_width", 20),
        (store_add, ":map_bordered_height", "$g_battle_map_height", 20),
        (store_mul, ":map_scale_x", ":map_bordered_width", 50),
        (store_mul, ":map_scale_y", ":map_bordered_height", 50),
        (position_set_x, pos51, ":map_scale_x"),
        (position_set_y, pos51, ":map_scale_y"),
        (overlay_set_size, "$g_battle_map_plane", pos51),
        (store_sub, ":map_pos_x", 800, ":map_bordered_width"), #650
        (store_sub, ":map_pos_y", 690, ":map_bordered_height"), #540
        (position_set_x, pos51, ":map_pos_x"),
        (position_set_y, pos51, ":map_pos_y"),
        (overlay_set_position, "$g_battle_map_plane", pos51),
        (overlay_set_alpha, "$g_battle_map_plane", 0x44),
        
        (multiplayer_get_my_player,":my_player_no"),
        (player_get_team_no,":allied_team",":my_player_no"),
        (store_add,":player_team",":allied_team",1),        
        
        # Reset selected if you changed team.
        (try_begin),
          (neq,"$g_team_at_time_of_select",":player_team"),
          (assign,"$g_current_selected_flag",-1),
        (try_end),
        
        (try_begin),
          (gt,"$g_current_selected_flag",-1),
          (store_add,":cur_flag_slot",multi_data_flag_owner_begin,"$g_current_selected_flag"),
          (troop_get_slot,":current_owner","trp_multiplayer_data",":cur_flag_slot"),
          
          (neq,":current_owner",":player_team"),
          (assign,"$g_current_selected_flag",-1),
        (try_end),
        
        # Default select the first friendly flag if you dont have anything selected or just lost it...
        (try_begin),
          (eq,"$g_current_selected_flag",-1),
          
          (assign,":end_cond","$g_number_of_flags"),
          (try_for_range,":place_no",0,":end_cond"),
            (store_add,":cur_flag_slot",multi_data_flag_owner_begin,":place_no"),
            (troop_get_slot,":current_owner","trp_multiplayer_data",":cur_flag_slot"),
            
            (eq,":current_owner",":player_team"),
            (assign,"$g_current_selected_flag",":place_no"),
            
            (assign,":end_cond",0),
          (try_end),
        (try_end),
        
        (try_begin),
          (eq,":allied_team",0),
          (assign,":enemy_team",1),
        (else_try),
          (assign,":enemy_team",0),
        (try_end),
        (team_get_faction,":allied_faction",":allied_team"),
        (team_get_faction,":enemy_faction",":enemy_team"),
        
        (assign, ":allied_flag_mesh", 0),
        (try_begin),
          (eq,":allied_team",1),
          (eq, ":allied_faction", ":enemy_faction"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_reb"),
        (else_try),
          (eq, ":allied_faction", "fac_russia"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_rus"),
        (else_try),
          (eq, ":allied_faction", "fac_france"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_fra"),
        (else_try),
          (eq, ":allied_faction", "fac_prussia"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_pru"),
        (else_try),
          (eq, ":allied_faction", "fac_austria"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_aus"),
        (else_try),
          (eq, ":allied_faction", "fac_britain"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_bri"),
        (else_try),
          (eq, ":allied_faction", "fac_rhine"),
          (assign, ":allied_flag_mesh", "mesh_ui_team_select_shield_rhi"),
        (try_end),
      
        (assign, ":enemy_flag_mesh", 0),
        (try_begin),
          (eq,":enemy_team",1),
          (eq, ":allied_faction", ":enemy_faction"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_reb"),
        (else_try),
          (eq, ":enemy_faction", "fac_russia"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_rus"),
        (else_try),
          (eq, ":enemy_faction", "fac_france"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_fra"),
        (else_try),
          (eq, ":enemy_faction", "fac_prussia"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_pru"),
        (else_try),
          (eq, ":enemy_faction", "fac_austria"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_aus"),
        (else_try),
          (eq, ":enemy_faction", "fac_britain"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_bri"),
        (else_try),
          (eq, ":enemy_faction", "fac_rhine"),
          (assign, ":enemy_flag_mesh", "mesh_ui_team_select_shield_rhi"),
        (try_end),     
      
        (try_for_range, ":i_multi", 0, 30),
          (troop_set_slot, "trp_flag_select_dummy", ":i_multi", -1),
        (try_end),
        (assign, ":cur_flag_index", 0),
        
        (assign,":end_cond","$g_number_of_flags"),
        (try_for_range, ":place_no", 0, ":end_cond"),
          (store_add, ":cur_flag_slot", multi_data_flag_owner_begin, ":place_no"),
          (troop_get_slot, ":current_owner", "trp_multiplayer_data", ":cur_flag_slot"),

          (try_begin),
            (eq,":current_owner",0),  #Neutral Flag
            (create_image_button_overlay, reg41, "mesh_ui_team_select_shield_neu", "mesh_ui_team_select_shield_neu"),
          (else_try),
            (eq,":current_owner",":player_team"), #Allied Flag
            (create_image_button_overlay, reg41, ":allied_flag_mesh", ":allied_flag_mesh"),
          (else_try),
            (create_image_button_overlay, reg41, ":enemy_flag_mesh", ":enemy_flag_mesh"), #Enemy Flag
          (try_end),
          
          #(set_fixed_point_multiplier, 1000),
          (position_set_x, pos51, 50), #700
          (position_set_y, pos51, 50), #700
          (overlay_set_size, reg41, pos51),
          (overlay_set_alpha, reg41, 0x88),
         
          (try_begin),
          #  (eq, "$g_multiplayer_game_type", multiplayer_game_type_siege),  #Use different checks for siege to enable non-capture spawns
            #(ge,":place_no","$g_number_of_flags"),
          #  (scene_prop_get_instance, ":flag_id", "spr_mm_siege_spawn_code_only", ":place_no"), 
          #(else_try),
            (scene_prop_get_instance, ":flag_id", "spr_headquarters_pole_code_only", ":place_no"),
          (try_end),
          (prop_instance_get_position, pos51, ":flag_id"),
        
          #(set_fixed_point_multiplier, 1000),
          (position_transform_position_to_local, pos53, pos52, pos51),
          (position_get_x, ":flag_x_pos", pos53),
          (position_get_y, ":flag_y_pos", pos53),
          
          (assign,":map_scale","$g_battle_map_scale"),
#          (try_begin),
#            (gt,":map_scale",1000), #Bug "fix" #### IMPORTANT: Re enable this with proper values after test session
#            (val_sub,":map_scale",500),
#          (try_end),
          (val_div, ":flag_x_pos", ":map_scale"),
          (val_div, ":flag_y_pos", ":map_scale"),
          
          #(set_fixed_point_multiplier, 1000),
          (store_sub, ":map_x", 790, "$g_battle_map_width"), #640
          (store_sub, ":map_y", 680, "$g_battle_map_height"), #530
          
          (val_add, ":flag_x_pos", ":map_x"),
          (val_add, ":flag_y_pos", ":map_y"),
          
          (position_set_x, pos50, ":flag_x_pos"),
          (position_set_y, pos50, ":flag_y_pos"),
        
          (overlay_set_position, reg41, pos50),
          
          #(assign,reg43,":place_no"),
          (call_script,"script_conquest_get_flag_name",":place_no"),
          (create_button_overlay,reg42,s0,tf_center_justify),
          #(set_fixed_point_multiplier, 100),
          (val_add, ":flag_x_pos", 0),#-32
          (val_add, ":flag_y_pos", -44),
          (position_set_x, pos50, ":flag_x_pos"),
          (position_set_y, pos50, ":flag_y_pos"),
          #(set_fixed_point_multiplier, 1000),
          (overlay_set_position, reg42, pos50),
          (position_set_x, pos50, 1100),
          (position_set_y, pos50, 1100),
          (overlay_set_size,reg42, pos50),
          
          (try_begin),
            (eq,"$g_current_selected_flag",":place_no"),
            (overlay_set_color, reg42, 0xECEB82),
          (else_try),
            (overlay_set_color, reg42, 0xFFFFFF),
          (try_end),
          
          #(overlay_set_color, reg42, 0xFFFFFF),
          #(overlay_set_tooltip,reg41,"@Flag {reg43}"),
          (troop_set_slot, "trp_flag_select_dummy", ":cur_flag_index", reg41),
          
          (store_add,":cur_but_flag_index",":cur_flag_index",50),
          (troop_set_slot, "trp_flag_select_dummy", ":cur_but_flag_index", reg42),
          
          (val_add, ":cur_flag_index", 1),
        (try_end),
        
        (create_button_overlay, "$g_presentation_obj_flag_done", "str_done", 0),
        (try_begin),
          (gt,"$g_current_selected_flag",-1),
          (overlay_set_color, "$g_presentation_obj_flag_done", 0xFFFFFF),
          (overlay_set_hilight_color, "$g_presentation_obj_flag_done", 0x55FF50),
        (else_try),
          (overlay_set_color, "$g_presentation_obj_flag_done", 0x888888),
          (overlay_set_hilight_color, "$g_presentation_obj_flag_done", 0x888888),
        (try_end),
        (position_set_x, pos51, 450),
        (position_set_y, pos51, 80),
        (overlay_set_position, "$g_presentation_obj_flag_done", pos51),
        (position_set_x, pos51, 1500),
        (position_set_y, pos51, 1500),
        (overlay_set_size, "$g_presentation_obj_flag_done", pos51),
    
    
    
        # camera bits.
        (create_mesh_overlay, "$g_conquest_select_camera", "mesh_player_dot"),
        (position_set_x, pos1, 1500),
        (position_set_y, pos1, 1500),
        (overlay_set_size, "$g_conquest_select_camera", pos1),
        #(overlay_set_alpha, "$g_conquest_select_camera", 0x88),
        
        (mission_cam_get_position, pos51),
        (position_get_rotation_around_z, ":rot", pos51),
        (init_position, pos10),
        (position_rotate_z, pos10, ":rot"),
        (overlay_set_mesh_rotation, "$g_conquest_select_camera", pos10),

        (position_transform_position_to_local, pos53, pos52, pos51),
        (position_get_x, ":camera_x_pos", pos53),
        (position_get_y, ":camera_y_pos", pos53),
        
        (val_div, ":camera_x_pos", "$g_battle_map_scale"),
        (val_div, ":camera_y_pos", "$g_battle_map_scale"),
        (store_sub, ":map_x", 790, "$g_battle_map_width"), #640
        (store_sub, ":map_y", 680, "$g_battle_map_height"), #530
        
        (val_add, ":camera_x_pos", ":map_x"),
        (val_add, ":camera_y_pos", ":map_y"),
        
        (position_set_x, pos50, ":camera_x_pos"),
        (position_set_y, pos50, ":camera_y_pos"),
        (overlay_set_position, "$g_conquest_select_camera", pos50),
    
    
        (presentation_set_duration, 999999),
      ]),
      
      (ti_on_presentation_event_state_change,
      [
          (store_trigger_param_1,":object"),
          
          (try_begin),
            (eq,":object","$g_presentation_obj_flag_done"),
            
            (assign, "$g_confirmation_result", 0),
            (assign, "$g_waiting_for_confirmation_to_terminate", 1),
            
            (try_begin),
              (gt,"$g_current_selected_flag",-1),
              (multiplayer_send_int_to_server,multiplayer_event_set_spawn_flag,"$g_current_selected_flag"),
            (try_end),
          (else_try),
            (assign, ":end_cond", 30),
            (try_for_range, ":i_button", 0, ":end_cond"),
              (store_add,":i_button_text",":i_button",50),
              
              (this_or_next|troop_slot_eq, "trp_flag_select_dummy", ":i_button", ":object"),
              (troop_slot_eq, "trp_flag_select_dummy", ":i_button_text",":object"),
              
              #(assign,reg5,":i_button"),
              #(display_message,"@Flag selected: {reg5}"),
              #(troop_set_slot, "trp_flag_select_dummy", 222, ":i_button"),
              
              (multiplayer_get_my_player,":my_player_no"),
              (player_get_team_no,":allied_team",":my_player_no"),
              (store_add,":player_team",":allied_team",1),
              
              (store_add, ":cur_flag_slot", multi_data_flag_owner_begin, ":i_button"),
              (troop_get_slot, ":current_owner", "trp_multiplayer_data", ":cur_flag_slot"),
              
              (try_begin),
                (eq,":current_owner",":player_team"), #Allied Flag
              
                (assign,"$g_current_selected_flag",":i_button"),
                (assign,"$g_team_at_time_of_select",":player_team"),
                
                (presentation_set_duration, 0),
                (start_presentation, "prsnt_conquest_flag_select"),
              (else_try),
                (display_message,"str_invalid_flag_selection"),
              (try_end),
              
              (assign, ":end_cond", 0), #break
            (try_end),
          (try_end),
      ]),
      
      (ti_on_presentation_run, [
        (try_begin),
          (key_clicked, key_escape),
          (assign, "$g_waiting_for_confirmation_to_terminate", 0),
          (call_script,"script_multiplayer_client_show_respawncounter"),
          (presentation_set_duration, 0),
        (else_try),
          (eq, "$g_waiting_for_confirmation_to_terminate", 1),
          (eq, "$g_confirmation_result", 1),
          (assign, "$g_waiting_for_confirmation_to_terminate", 0),
          (call_script,"script_multiplayer_client_show_respawncounter"),
          (presentation_set_duration, 0),
        (else_try),
          (eq, "$g_waiting_for_confirmation_to_terminate", 1),
          (eq, "$g_confirmation_result", -1),
          (assign, "$g_waiting_for_confirmation_to_terminate", 0),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_conquest_flag_select"),
          
          (start_presentation, "prsnt_multiplayer_message_1"),
        (else_try), # do a update of cam pos.
          (set_fixed_point_multiplier, 1000),
         
          (get_scene_boundaries, pos72, pos73),
          (mission_cam_get_position, pos71),
          (position_get_rotation_around_z, ":rot", pos71),
          (init_position, pos70),
          (position_rotate_z, pos70, ":rot"),
          (overlay_set_mesh_rotation, "$g_conquest_select_camera", pos70),

          (position_transform_position_to_local, pos73, pos72, pos71),
          (position_get_x, ":camera_x_pos", pos73),
          (position_get_y, ":camera_y_pos", pos73),
          
          (val_div, ":camera_x_pos", "$g_battle_map_scale"),
          (val_div, ":camera_y_pos", "$g_battle_map_scale"),
          (store_sub, ":map_x", 790, "$g_battle_map_width"), #640
          (store_sub, ":map_y", 680, "$g_battle_map_height"), #530
          
          (val_add, ":camera_x_pos", ":map_x"),
          (val_add, ":camera_y_pos", ":map_y"),
          
          (init_position, pos70),
          (position_set_x, pos70, ":camera_x_pos"),
          (position_set_y, pos70, ":camera_y_pos"),
          (overlay_set_position, "$g_conquest_select_camera", pos70),
          
          (set_fixed_point_multiplier, 100),
        (try_end),
      ]),
  ]),
    
  ("message_conquest_round_ended", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
        (set_fixed_point_multiplier, 1000),
        
        (multiplayer_get_my_player,":my_player_no"),
        (player_get_team_no,":my_team_no",":my_player_no"),
        (team_get_score,":team_1_score", 0),
        (team_get_score,":team_2_score", 1),
        (try_begin),
          (le,":team_1_score",0),
          (assign,":winner_team",1),
        (else_try),
          (le,":team_2_score",0),
          (assign,":winner_team",0),
        (try_end),

        (assign,":sound_id",-1),
        (try_begin),
          (eq, ":winner_team", ":my_team_no"),
          (assign,":sound_id","snd_win_tune_brit"),
          (assign, ":text_font_color", 0xFF33DD11),
        (else_try),
          (assign,":sound_id","snd_loose_tune_brit"),
          (assign, ":text_font_color", 0xFFFF4422),
        (try_end),
                
        (team_get_faction, ":faction_of_winner_team", ":winner_team"),
        (str_store_faction_name, s1, ":faction_of_winner_team"),
        (str_store_string, s0, "str_s1_won_round"),
        
        (try_begin),
          (gt,":sound_id",-1),
          
          (store_sub,":fac_index",":faction_of_winner_team","fac_britain"),
          (val_add,":sound_id",":fac_index"),
          
          # play that damn sound ^.^
          (play_sound,":sound_id"),
        (try_end),

        (create_text_overlay, reg0, s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, reg0, ":text_font_color"),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 400),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 2000),
        (position_set_y, pos1, 2000),
        (overlay_set_size, reg0, pos1),
        (presentation_set_duration, 300),

      ]),
    (ti_on_presentation_run,
     [
       ]),
     ]),
 
  ("multiplayer_construct", prsntf_manual_end_only, 0, [ #MM
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
     
      (assign,"$g_prsnt_build_points_changed",0),
      
      (create_mesh_overlay, reg0, "mesh_mp_ingame_menu"),
      (position_set_x, pos1, 450), #250
      (position_set_y, pos1, 80),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 550), #1000
      (position_set_y, pos1, 1000),
      (overlay_set_size, reg0, pos1),

      (create_mesh_overlay, reg0, "mesh_mp_ui_welcome_panel"),
      (position_set_x, pos1, 200),
      (position_set_y, pos1, 330),
      (overlay_set_position, reg0, pos1),
      (position_set_x, pos1, 380),
      (position_set_y, pos1, 1400),
      (overlay_set_size, reg0, pos1),
      
      (str_clear, s0),
      (create_text_overlay, "$g_presentation_obj_troop_select_container", s0, tf_scrollable_style_2),
      (position_set_x, pos1, 370), #285
      (position_set_y, pos1, 125),
      (overlay_set_position, "$g_presentation_obj_troop_select_container", pos1),
      (position_set_x, pos1, 305), #405
      (position_set_y, pos1, 500),
      (overlay_set_area_size, "$g_presentation_obj_troop_select_container", pos1),
      (set_container_overlay, "$g_presentation_obj_troop_select_container"),

      (assign, ":cur_y", 800),
      (assign, ":sub_y", 50),

      (multiplayer_get_my_team,":my_team"),
      (assign,":my_team_allowed_explosive",1),
      (try_begin),
        (eq,":my_team",0),
        (assign,":my_team_build_points","$g_team_1_build_points"),
        (assign,":my_team_allowed_explosive","$g_explosives_available_team1"),
      (else_try),
        (eq,":my_team",1),
        (assign,":my_team_build_points","$g_team_2_build_points"),
        (assign,":my_team_allowed_explosive","$g_explosives_available_team2"),
      (try_end),
      (assign,reg6,":my_team_build_points"),  
      (assign,"$g_my_team_previous_build_points",":my_team_build_points"),  
      
      (create_text_overlay, "$g_presentation_obj_cur_build_points", "str_reg6_build_points", 0),
      (overlay_set_color, "$g_presentation_obj_cur_build_points", 0xFFFFFF),
      (position_set_x, pos1, 100), #0
      (position_set_y, pos1, ":cur_y"),
      (overlay_set_position, "$g_presentation_obj_cur_build_points", pos1),
      (position_set_x, pos1, 800),
      (position_set_y, pos1, 800),
      (overlay_set_size, "$g_presentation_obj_cur_build_points", pos1),
      (val_sub, ":cur_y", ":sub_y"),
      (position_set_y, pos1, ":cur_y"),
      (position_set_x, pos1, 100),

      (try_for_range, ":i_multi", construct_button_offset, construct_offset_end),
        (troop_set_slot, "trp_track_select_dummy", ":i_multi", -1),
      (try_end),

      (assign, ":cur_prop_index", 0),
      (try_for_range, ":prop_no", mm_construct_props_begin, mm_construct_props_end),
      
        (store_add,":cost_index",construct_costs_offset,":prop_no"),
        (val_sub,":cost_index",mm_construct_props_begin),
        (troop_get_slot,":prop_cost","trp_track_select_dummy",":cost_index"),
        (try_begin),
          (ge,":my_team_build_points",":prop_cost"),
          (assign,":cost_ok",1),
        (else_try),
          (assign,":cost_ok",0),
        (try_end),
        
        (try_begin),
          (eq,":prop_no","spr_crate_explosive"),
          
          (store_mission_timer_a, ":current_time"),
          (store_sub, ":seconds_past_in_round", ":current_time", "$g_round_start_time"),
          
          (this_or_next|eq,"$g_explosives_available_on_map",0),
          (this_or_next|eq,":my_team_allowed_explosive",0),
          (le, ":seconds_past_in_round", 33),
         
          (assign,":cost_ok",0),
        (try_end),
        
        (store_add,":string_no",":cur_prop_index",mm_construct_props_strings),
        (str_store_string, s1, ":string_no"),
        (try_begin),
          (eq,":cost_ok",1),
          (create_button_overlay, reg0, s1, 0),
          (overlay_set_color, reg0, 0xFFFFFF),
        (else_try),
          (create_text_overlay, reg0, s1, 0),
          (overlay_set_color, reg0, 0x888888),
        (try_end),
        (store_add, ":button_index_slot", ":cur_prop_index", construct_button_offset),
        (troop_set_slot, "trp_track_select_dummy", ":button_index_slot", reg0),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (val_sub, ":cur_y", ":sub_y"),
        (position_set_y, pos1, ":cur_y"),
        (position_set_x, pos3, 1000),
        (position_set_y, pos3, 1000),
        (overlay_set_size, reg0, pos3),
        
        (assign,reg7,":prop_cost"),
        (try_begin),
          (eq,":cost_ok",1),
          (create_text_overlay, reg0, "str_reg7_build_points_cost", 0),
          (overlay_set_color, reg0, 0x00F000),
        (else_try),
          (create_text_overlay, reg0, "str_reg7_build_points_cost", 0),
          (overlay_set_color, reg0, 0xF00000),
        (try_end),
        (copy_position,pos4,pos1),
        (position_get_y,":y",pos4),
        (val_add,":y",35),
        (position_set_y,pos4,":y"),
        (overlay_set_position, reg0, pos4),
        (position_set_x, pos3, 800),
        (position_set_y, pos3, 800),
        (overlay_set_size, reg0, pos3),
        
        (store_add,":mesh_no",":cur_prop_index",mm_construct_props_meshes),
        (create_mesh_overlay, reg1, ":mesh_no"),
        (overlay_set_container_overlay, reg1, -1),
        (position_set_x, pos2, 310),
        (position_set_y, pos2, 450),
        (overlay_set_position, reg1, pos2),
        (position_set_x, pos2, 225),
        (position_set_y, pos2, 225),
        (overlay_set_size, reg1, pos2),
        (overlay_set_display, reg1, 0),
        (store_add, ":button_index_slot", ":cur_prop_index", construct_display_offset),
        (troop_set_slot, "trp_track_select_dummy", ":button_index_slot", reg1),
      
        (val_add, ":cur_prop_index", 1),
      (try_end),
          
      (presentation_set_duration, 999999),
      ]),
   
    (ti_on_presentation_event_state_change,
     [(store_trigger_param_1, ":object"),
     
      (neq,"$g_waiting_for_confirmation_to_terminate",1),
      
      (multiplayer_get_my_team,":my_team"),
      (try_begin),
        (eq,":my_team",0),
        (assign,":my_team_build_points","$g_team_1_build_points"),
      (else_try),
        (eq,":my_team",1),
        (assign,":my_team_build_points","$g_team_2_build_points"),
      (try_end),
      
      (assign, ":selected_prop_no", -1),
      (assign, ":end_cond", construct_display_offset),
      (try_for_range, ":i_button", construct_button_offset, ":end_cond"),
        (troop_slot_eq, "trp_track_select_dummy", ":i_button", ":object"),
        (store_sub, ":selected_prop_index", ":i_button", construct_button_offset),
        (store_add,":selected_prop_no",mm_construct_props_begin,":selected_prop_index"),
        
        (is_between,":selected_prop_no",mm_construct_props_begin,mm_construct_props_end),
        
        (store_add,":cost_index",construct_costs_offset,":selected_prop_no"),
        (val_sub,":cost_index",mm_construct_props_begin),
        (troop_get_slot,":prop_cost","trp_track_select_dummy",":cost_index"),
        (try_begin),
          (ge,":my_team_build_points",":prop_cost"),
          (assign,":cost_ok",1),
        (else_try),
          (assign,":cost_ok",0),
        (try_end),
        (eq,":cost_ok",1),
        
        (multiplayer_send_int_to_server,multiplayer_event_player_build_prop,":selected_prop_no"),
          
        (assign, "$g_waiting_for_confirmation_to_terminate", 1),
        
        (assign, ":end_cond", 0), #break
      (try_end),
      ]),
    (ti_on_presentation_mouse_enter_leave,
      [
      (store_trigger_param_1, ":object"),
      (store_trigger_param_2, ":enter_leave"),
      
      (assign, ":end_cond", construct_display_offset),
      (try_for_range, ":i_button", construct_button_offset, ":end_cond"),
        (troop_slot_eq, "trp_track_select_dummy", ":i_button", ":object"),
        (store_sub, ":selected_prop_index", ":i_button", construct_button_offset),
        (store_add, ":display_object_slot", ":selected_prop_index", construct_display_offset),
        (troop_get_slot,":display_object","trp_track_select_dummy",":display_object_slot"),
        (try_begin),
          (eq,":enter_leave",0),
          (overlay_set_display,":display_object",1),
        (else_try),
          (overlay_set_display,":display_object",0),
        (try_end),
        (assign,":end_cond",0), #Break
      (try_end),
      ]),
    (ti_on_presentation_run, [
      (store_trigger_param_1,":cur_time"),
      (try_begin),
        (gt,":cur_time",200),
        (this_or_next|key_clicked, key_escape),
        (game_key_clicked, gk_defend), #gk_party_window
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        (eq, "$g_confirmation_result", 1),
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
      (else_try),
        (eq, "$g_waiting_for_confirmation_to_terminate", 1),
        (eq, "$g_confirmation_result", -1),
        (assign, "$g_waiting_for_confirmation_to_terminate", 0),
        (presentation_set_duration, 0),
        (start_presentation,"prsnt_multiplayer_construct"),
      (else_try),
        (eq,"$g_prsnt_build_points_changed",1),
        (multiplayer_get_my_team,":my_team"),
        (try_begin),
          (eq,":my_team",0),
          (assign,":my_team_build_points","$g_team_1_build_points"),
        (else_try),
          (eq,":my_team",1),
          (assign,":my_team_build_points","$g_team_2_build_points"),
        (try_end),
        (assign,":reset",0),
        (try_begin),
          (eq,":my_team_build_points","$g_my_team_previous_build_points"),
        (else_try),
          (ge,":my_team_build_points",6),
          (lt,"$g_my_team_previous_build_points",6),
          (assign,":reset",1),
        (else_try),
          (lt,":my_team_build_points",6),
          (ge,"$g_my_team_previous_build_points",6),
          (assign,":reset",1),
        (try_end),
        (try_begin),
          (eq,":reset",0),
          (assign,reg6,":my_team_build_points"),  
          (overlay_set_text,"$g_presentation_obj_cur_build_points","str_reg6_build_points"),
        (else_try),
          (eq,":reset",1),
          (presentation_set_duration, 0),
          (start_presentation,"prsnt_multiplayer_construct"),
        (try_end),
        (assign,"$g_prsnt_build_points_changed",0),
      (try_end),
      ]),
    ]),
    
  ("display_server_notice", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
        (set_fixed_point_multiplier, 1000),
        
        (try_begin),
          (eq, "$g_presentation_server_notice_colour", colour_white),
          (assign, ":text_font_colour", 0xFFFFFFFF),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_red),
          (assign, ":text_font_colour", 0xFFFF4422),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_green),
          (assign, ":text_font_colour", 0xFF33DD11),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_blue),
          (assign, ":text_font_colour", 0xFF3333FF),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_yellow),
          (assign, ":text_font_colour", 0xFFDDCC11),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_purple),
          (assign, ":text_font_colour", 0x7D007D),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_pink),
          (assign, ":text_font_colour", 0xFFEEBBCC),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_magenta),
          (assign, ":text_font_colour", 0xFF00FF),
        (else_try),
          (eq, "$g_presentation_server_notice_colour", colour_invisible),
          (assign, ":text_font_colour", 0x00000000),
        (try_end),
        
        (create_text_overlay, reg0, s60, tf_center_justify|tf_with_outline),
        (overlay_set_color, reg0, ":text_font_colour"),
        (position_set_x, pos1, 380),
        (position_set_x, pos1, 500), #new
        (position_set_y, pos1, 670),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1500),
        (position_set_y, pos1, 1500),
        (overlay_set_size, reg0, pos1),
        (presentation_set_duration, 400),

      ]),
    (ti_on_presentation_run,
     [
       ]),
     ]),
     
     
  ("multiplayer_cannon_crosshair", prsntf_read_only|prsntf_manual_end_only, 0, [ #MM
    (ti_on_presentation_load,
     [(set_fixed_point_multiplier, 1000),
          
      (assign,"$g_close_crosshair",0),
     
      (create_mesh_overlay,reg0,"mesh_white_plane"),
      (overlay_set_color,reg0,0xFFFFFF),
      (overlay_set_alpha,reg0,0xD6),
      (position_set_x,pos1,500),
      (position_set_y,pos1,335),
      (overlay_set_position,reg0,pos1),
      (position_set_x,pos1,80),
      (position_set_y,pos1,2000),
      (overlay_set_size,reg0,pos1),
      
      (create_mesh_overlay,reg0,"mesh_white_plane"),
      (overlay_set_color,reg0,0xFFFFFF),
      (overlay_set_alpha,reg0,0xD6),
      (position_set_x,pos1,480),
      (position_set_y,pos1,375),
      (overlay_set_position,reg0,pos1),
      (position_set_x,pos1,2000),
      (position_set_y,pos1,80),
      (overlay_set_size,reg0,pos1),
      
      (create_mesh_overlay,reg0,"mesh_white_plane"),
      (overlay_set_color,reg0,0xFFFFFF),
      (overlay_set_alpha,reg0,0xD6),
      (position_set_x,pos1,485),
      (position_set_y,pos1,360),
      (overlay_set_position,reg0,pos1),
      (position_set_x,pos1,1500),
      (position_set_y,pos1,90),
      (overlay_set_size,reg0,pos1),
      
      (create_mesh_overlay,reg0,"mesh_white_plane"),
      (overlay_set_color,reg0,0xFFFFFF),
      (overlay_set_alpha,reg0,0xD6),
      (position_set_x,pos1,490),
      (position_set_y,pos1,345),
      (overlay_set_position,reg0,pos1),
      (position_set_x,pos1,1000),
      (position_set_y,pos1,80),
      (overlay_set_size,reg0,pos1),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      #(store_trigger_param_1,":cur_time"),
      
      (eq,"$g_close_crosshair",1),
      (presentation_set_duration, 0),
      ]),
    ]),
    
  ("spyglass_dummy", prsntf_read_only|prsntf_manual_end_only, 0,
   [
    (ti_on_presentation_load,
      [
          (call_script,"script_client_get_my_agent"),
          (assign,":agent_id",reg0),
          (agent_is_active,":agent_id"),
          (agent_is_alive,":agent_id"),
          (agent_set_visibility, ":agent_id", 0),
          (set_fixed_point_multiplier,100),
          (set_zoom_amount,165),
          
          (create_mesh_overlay, reg0, "mesh_mm_spyglass_ui"),
          (position_set_x, pos1, 50), #-1
          (position_set_y, pos1, 40), #-1
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 101), #-1
          (position_set_y, pos1, 100), #-1
          (overlay_set_size, reg0, pos1),
          
          (try_begin),
            (game_in_multiplayer_mode),
            (multiplayer_send_2_int_to_server,multiplayer_event_send_player_action,player_action_spyglass,spyglass_type_start),
          (else_try),
            (call_script, "script_multiplayer_server_agent_use_spyglass", ":agent_id", spyglass_type_start),
          (try_end),
          (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_run,
      [ 
          (call_script,"script_client_get_my_agent"),
          (assign,":agent_id",reg0),
          (agent_is_active,":agent_id"),
          (assign,":continue",0),
          (try_begin),
            (neg|game_key_is_down,gk_defend), 
            (assign,":continue",1),
          (else_try),
            (agent_get_wielded_item,":item_id",":agent_id",0),
            (neq,":item_id","itm_spyglass"),
            (assign,":continue",1),
          (try_end),
          (eq,":continue",1),
          (set_fixed_point_multiplier,100),
          (set_zoom_amount,0),
          (agent_set_visibility, ":agent_id", 1),
          (try_begin),
            (game_in_multiplayer_mode),
            (multiplayer_send_2_int_to_server,multiplayer_event_send_player_action,player_action_spyglass,spyglass_type_stop),
          (else_try),
            (call_script, "script_multiplayer_server_agent_use_spyglass", ":agent_id", spyglass_type_stop),
          (try_end),
          (presentation_set_duration, 0),
      ]),

     ]),

  ("drinking", prsntf_read_only|prsntf_manual_end_only, 0,
   [
    (ti_on_presentation_load,
      [
          (call_script, "script_client_get_my_agent"),
          (assign, ":agent_id", reg0),
          (agent_is_active,":agent_id"),
          (agent_is_alive,":agent_id"),
          (try_begin),
            (game_in_multiplayer_mode),
            (multiplayer_send_2_int_to_server, multiplayer_event_send_player_action, player_action_misc_item_drinking, drinking_type_start),
          (else_try),
            (call_script, "script_multiplayer_agent_drinking", ":agent_id", drinking_type_start),
          (try_end),
          (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_run,
      [
          (call_script, "script_client_get_my_agent"),
          (assign, ":agent_id", reg0),
          (agent_is_active, ":agent_id"),
          (assign, ":stop_drinking", 0),
          (try_begin),
            (neg|game_key_is_down, gk_defend),
            (assign, ":stop_drinking", 1),
          (else_try),
            (agent_get_wielded_item, ":item_id", ":agent_id", 0),
            (call_script, "script_multiplayer_agent_drinking_get_animation", ":item_id"),
            #reg0 = animation_id or -1 if the item can not be used for drinking
            (lt, reg0, 0),
            (assign, ":stop_drinking", 1),
          (try_end),
          (eq, ":stop_drinking", 1),
          (try_begin),
            (game_in_multiplayer_mode),
            (multiplayer_send_2_int_to_server, multiplayer_event_send_player_action, player_action_misc_item_drinking, drinking_type_stop),
          (else_try),
            (call_script, "script_multiplayer_agent_drinking", ":agent_id", drinking_type_stop),
          (try_end),
          (presentation_set_duration, 0),
      ]),

     ]),
     
  ("multiplayer_bonus_icons", prsntf_read_only|prsntf_manual_end_only, 0,
   [
    (ti_on_presentation_load,
      [
      
        (store_mission_timer_a, "$g_bonus_icons_time_since_last_update"),
        (val_sub,"$g_bonus_icons_time_since_last_update",10),
      
        (set_fixed_point_multiplier,1000),
        
        (assign,":cur_y",300),
        (assign,":cur_x",40),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_damage", "mesh_bonus_icon_melee"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_damage", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_damage", 0),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_accuracy", "mesh_bonus_icon_accuracy"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_accuracy", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_accuracy", 0),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_speed", "mesh_bonus_icon_speed"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_speed", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_speed", 0),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_reload_speed", "mesh_bonus_icon_reload"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_reload_speed", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_reload_speed", 0),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_use_speed", "mesh_bonus_icon_artillery"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_use_speed", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_use_speed", 0),
        
        (create_mesh_overlay, "$g_bonus_icons_overlay_general", "mesh_bonus_icon_commander"),
        (position_set_x, pos1, ":cur_x"),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, "$g_bonus_icons_overlay_general", pos1),
        (overlay_set_display, "$g_bonus_icons_overlay_general", 0),
        
        (presentation_set_duration, 999999),
        (set_fixed_point_multiplier,100),
      
      ]),

    (ti_on_presentation_run,
      [ 
      
      (try_begin),
        (eq, "$g_bonuses_enabled", 0),
        (presentation_set_duration, 0),
      (else_try),
        (eq, "$g_bonuses_enabled", 1),
        
        (store_mission_timer_a, ":cur_time"),
        (val_sub,":cur_time","$g_bonus_icons_time_since_last_update"),
        (ge,":cur_time", 2), #Update every 2 sec 
        
        (assign,":show_damage",0),
        (assign,":show_accuracy",0),
        (assign,":show_speed",0),
        (assign,":show_reload_speed",0),
        (assign,":show_use_speed",0),
        (assign,":show_general",0),
        (try_begin),            
          (multiplayer_get_my_player,":my_player"),
          (player_is_active,":my_player"),
          (player_get_agent_id,":my_agent",":my_player"),
          (agent_is_active,":my_agent"),
          (agent_is_alive, ":my_agent"),
          
          (agent_get_troop_id,":my_troop",":my_agent"),
          (troop_get_slot,":my_class",":my_troop",slot_troop_class_type),
          (troop_get_slot,":my_rank",":my_troop",slot_troop_rank),
          
          (try_begin), # you get everything here.
            (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
            (assign,":my_rank",mm_rank_ranker),
          (try_end),
          
          (this_or_next|eq,":my_rank",mm_rank_ranker), #Only apply bonuses to rankers
          #Cavalry and skirmishers might get speed bonuses that apply to all ranks
          (this_or_next|eq,":my_class",multi_troop_class_mm_cavalry),
          (this_or_next|eq,":my_class",multi_troop_class_mm_artillery),#lets allow all the arty units to have the bonus #hotfix
          (eq,":my_class",multi_troop_class_mm_skirmisher),

          (agent_get_position,pos27,":my_agent"), #pos27 holds player position
          (agent_get_team,":my_team",":my_agent"),
          
          (set_fixed_point_multiplier,100),
          (store_mul,":max_search_range","$g_bonus_range",150),# to meters + 50%
          
          (try_begin),
            (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
            (assign,":max_search_range",125000), # i don't know search everywhere.
          (try_end),
          
          (assign,":affected_by_num_captains",0),
          (assign,":affected_by_num_flags",0),
          (assign,":affected_by_num_sergeants",0),
          (assign,":affected_by_num_musicians",0),
          (assign,":affected_by_num_generals",0),
          (try_for_agents,":cur_agent",pos27,":max_search_range"), 
            (agent_is_active,":cur_agent"),
            (agent_is_alive,":cur_agent"),
            (agent_is_human,":cur_agent"),
            #(neg|agent_is_non_player,":cur_agent"),
            (agent_get_team,":cur_team",":cur_agent"),
            (eq,":cur_team",":my_team"),
            
            (assign,":go_on",1),
            (try_begin),
              (eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
              (agent_get_group, ":agent_group", ":cur_agent"),
              (neq,":my_player",":agent_group"),
              
              (assign,":go_on",0),
            (try_end),
            (eq,":go_on",1),
            
            (agent_get_troop_id,":cur_troop",":cur_agent"),
            
            (troop_get_slot,":cur_agent_rank",":cur_troop",slot_troop_rank),
        
            (agent_get_position,pos4,":cur_agent"),
            (get_distance_between_positions_in_meters,":dist",pos4,pos27),
            (assign,":max_range","$g_bonus_range"),
						(troop_get_slot,":cur_agent_class",":cur_troop",slot_troop_class_type),
						(try_begin),
							(eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
							(assign,":max_range",125000), # i don't know search everywhere.
						(else_try),
						#	(try_begin), # for generals and cav, add moar.  cav fight more spread out, so extra range will help
							(eq,":cur_agent_class",multi_troop_class_mm_cavalry),
							(this_or_next|eq,":cur_agent_rank",mm_rank_officer),	
							(this_or_next|eq,":cur_agent_rank",mm_rank_sergeant),
							(eq,":cur_agent_rank",mm_rank_musician),					
							(val_mul,":max_range",12),
							(val_div,":max_range",10),

						(else_try),
							(eq,":cur_agent_rank",mm_rank_general), 

							(val_mul,":max_range",15),
							(val_div,":max_range",10),				  
							#(try_end),
							#(try_begin),
							#	(eq,":cur_agent_rank",mm_rank_general), #General's bonus have 50% longer range
							#	(val_mul,":max_range",15),
								#(val_div,":max_range",10),
							#(try_end),
						(try_end),
						#(try_begin),
						#	(eq, "$g_multiplayer_game_type", multiplayer_game_type_commander),
						#	(assign,":max_range",125000), # i don't know search everywhere.
						#(try_end),
				
            (le,":dist",":max_range"),
            
            #(troop_get_slot,":cur_agent_class",":cur_troop",slot_troop_class_type),
        
            (this_or_next|eq,":cur_agent_class",":my_class"), #Only affected by same class
            (eq,":cur_agent_rank",mm_rank_general),           #Or generals
            (try_begin),
              (eq,":cur_agent_rank",mm_rank_officer),
              (val_add,":affected_by_num_captains",1),
            (else_try),
              (eq,":cur_agent_rank",mm_rank_musician),
              (call_script,"script_cf_agent_is_playing_music",":cur_agent"),
              (val_add,":affected_by_num_musicians",1),
            (else_try),
              (eq,":cur_agent_rank",mm_rank_general),
              (val_add,":affected_by_num_generals",1),
            (else_try),
              (agent_get_wielded_item,":item_id",":cur_agent",0),
              (ge,":item_id",0),
              (item_slot_eq,":item_id",slot_item_multiplayer_item_class, multi_item_class_type_flag),
              (val_add,":affected_by_num_flags",1),
            (else_try),
              (eq,":cur_agent_rank",mm_rank_sergeant),
              (val_add,":affected_by_num_sergeants",1),
            (try_end),
          (try_end),
          
          (try_begin),
            (gt,":affected_by_num_captains",0),
            (try_begin),
              (this_or_next|eq,":my_class",multi_troop_class_mm_infantry),
              (eq,":my_class",multi_troop_class_mm_skirmisher),
              (eq,":my_rank",mm_rank_ranker),
              (assign,":show_accuracy",1),
            (else_try),
              (eq,":my_class",multi_troop_class_mm_cavalry),
							(agent_get_horse,":horse",":my_agent"),
							(gt,":horse",-1),
              #This bonus apply to non-rankers as well
              (assign,":show_speed",1),
            (else_try),
              (eq,":my_class",multi_troop_class_mm_artillery),
              #(eq,":my_rank",mm_rank_ranker),
              (assign,":show_use_speed",1),
            (try_end),
          (try_end),
          (try_begin),
            (this_or_next|gt,":affected_by_num_flags",0),
            (gt,":affected_by_num_sergeants",0),
            (try_begin),
              (this_or_next|eq,":my_class",multi_troop_class_mm_infantry),
              (eq,":my_class",multi_troop_class_mm_cavalry),
              (eq,":my_rank",mm_rank_ranker),
              (assign,":show_damage",1),
            (try_end),
            (try_begin),
              (eq,":my_class",multi_troop_class_mm_skirmisher),
              #This bonus apply to non-rankers as well
              (assign,":show_speed",1),
            (try_end),
          (try_end),
          (try_begin),
            (gt,":affected_by_num_musicians",0),
            (try_begin),
              (this_or_next|eq,":my_class",multi_troop_class_mm_infantry),
              (eq,":my_class",multi_troop_class_mm_skirmisher),
              (eq,":my_rank",mm_rank_ranker),
              (assign,":show_reload_speed",1),
            (else_try),
              (eq,":my_class",multi_troop_class_mm_cavalry),
              (eq,":my_rank",mm_rank_ranker),
              (assign,":show_damage",1),
            (try_end),
          (try_end),
          (try_begin),
            (gt,":affected_by_num_generals",0),
            (this_or_next|eq,":show_damage",1),
            (this_or_next|eq,":show_accuracy",1),
            (this_or_next|eq,":show_speed",1),
            (this_or_next|eq,":show_reload_speed",1),
            (eq,":show_use_speed",1),
            (assign,":show_general",1),
          (try_end),
        (try_end),
        
        (set_fixed_point_multiplier,1000),
        (position_set_y,pos5,650),
        (assign,":cur_x", 85),
        (assign,":x_adder", 65),
        
        (overlay_set_display, "$g_bonus_icons_overlay_damage", ":show_damage"),
        (try_begin),
          (eq, ":show_damage", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_damage", pos5),
          (val_add, ":cur_x", ":x_adder"),
        (try_end),
        (overlay_set_display, "$g_bonus_icons_overlay_accuracy", ":show_accuracy"),
        (try_begin),
          (eq, ":show_accuracy", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_accuracy", pos5),
          (val_add, ":cur_x", ":x_adder"),
        (try_end),
        (overlay_set_display, "$g_bonus_icons_overlay_speed", ":show_speed"),
        (try_begin),
          (eq, ":show_speed", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_speed", pos5),
          (val_add, ":cur_x", ":x_adder"),
        (try_end),
        (overlay_set_display, "$g_bonus_icons_overlay_reload_speed", ":show_reload_speed"),
        (try_begin),
          (eq, ":show_reload_speed", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_reload_speed", pos5),
          (val_add, ":cur_x", ":x_adder"),
        (try_end),
        (overlay_set_display, "$g_bonus_icons_overlay_use_speed", ":show_use_speed"),
        (try_begin),
          (eq, ":show_use_speed", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_use_speed", pos5),
          (val_add, ":cur_x", ":x_adder"),
        (try_end),
        (overlay_set_display, "$g_bonus_icons_overlay_general", ":show_general"),
        (try_begin),
          (eq, ":show_general", 1),
          (position_set_x, pos5, ":cur_x"),
          (overlay_set_position,"$g_bonus_icons_overlay_general", pos5),
          #(val_add, ":cur_x", ":x_adder"),
        (try_end),
        (set_fixed_point_multiplier,100),
        
        (store_mission_timer_a, "$g_bonus_icons_time_since_last_update"),
      (try_end),
      ]),

     ]),
     
  ("multiplayer_artillery_icons", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for showing artillery icons.
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, "$g_presentation_obj_arty_icon_take_ammo", "mesh_arty_icon_take_ammo"),
      (create_mesh_overlay, "$g_presentation_obj_arty_icon_put_ammo", "mesh_arty_icon_put_ammo"),
      (create_mesh_overlay, "$g_presentation_obj_arty_icon_ram", "mesh_arty_icon_ram"),
      (create_mesh_overlay, "$g_presentation_obj_arty_icon_move_up", "mesh_arty_icon_move_up"),
      (create_mesh_overlay, "$g_presentation_obj_arty_icon_take_control", "mesh_arty_icon_take_control"),

      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),

      (overlay_set_size, "$g_presentation_obj_arty_icon_take_ammo", pos1),
      (overlay_set_size, "$g_presentation_obj_arty_icon_put_ammo", pos1),
      (overlay_set_size, "$g_presentation_obj_arty_icon_ram", pos1),
      (overlay_set_size, "$g_presentation_obj_arty_icon_move_up", pos1),
      (overlay_set_size, "$g_presentation_obj_arty_icon_take_control", pos1),
      (overlay_set_display, "$g_presentation_obj_arty_icon_take_ammo", 0),
      (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
      (overlay_set_display, "$g_presentation_obj_arty_icon_ram", 0),
      (overlay_set_display, "$g_presentation_obj_arty_icon_move_up", 0),
      (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (set_fixed_point_multiplier, 1000),
      (try_begin),
        (call_script, "script_client_get_my_agent"),
        (assign,":my_agent",reg0),
        (agent_is_active,":my_agent"),
        (agent_is_alive,":my_agent"),
        (agent_get_troop_id,":troop_id",":my_agent"),
        (gt,":troop_id",-1),
        
        (troop_get_slot,":troop_class",":troop_id",slot_troop_class),
        
        (this_or_next|eq,":troop_class",multi_troop_class_mm_rocket),
        (eq,":troop_class",multi_troop_class_mm_artillery),
        
        (agent_get_position,pos17,":my_agent"), #pos17 hold agent position
        
        (try_begin), #For normal artillery
          (eq,":troop_class",multi_troop_class_mm_artillery),
      
          ### TAKE AMMO ###
          (try_begin),
            (assign,":continue",1),
            (try_for_range_backwards,":equipment_slot",ek_item_0,ek_head),
              (agent_get_item_slot, ":item_id", ":my_agent", ":equipment_slot"),
              (gt,":item_id",-1), # even have a item there?
              (is_between,":item_id","itm_cannon_cartridge_round","itm_rockets"), #has ammo already
              (assign,":continue",0), #don't point out the ammo box
            (try_end),
            (eq,":continue",1),
        
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_round_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_shell_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_canister_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_bomb_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_take_ammo", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_ammo", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_ammo", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_take_ammo", 0),
          (try_end),
            
          ### LOAD AMMO ###
          (try_begin),
            (assign,":continue",0),
            (try_for_range_backwards,":equipment_slot",ek_item_0,ek_head),
              (agent_get_item_slot, ":item_id", ":my_agent", ":equipment_slot"),
              (gt,":item_id",-1), # even have a item there?
              (is_between,":item_id","itm_cannon_cartridge_round","itm_rockets"), #has ammo
              (assign,":continue",1), #show where to put it
            (try_end),
            (eq,":continue",1),
            
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_load_cartridge_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_load_bomb_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_put_ammo", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
            (try_end),
          (else_try),
            (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
          (try_end),
           
          ### USE RAMROD ###
          (try_begin),
            (assign,":continue",0),
            (try_for_range_backwards,":equipment_slot",ek_item_0,ek_head),
              (agent_get_item_slot, ":item_id", ":my_agent", ":equipment_slot"),
              (gt,":item_id",-1), # even have a item there?
              (eq,":item_id","itm_ramrod"), #has a ramrod
              (assign,":continue",1), #show where to put it
            (try_end),
            (eq,":continue",1),
            
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_reload_button", somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_ram", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_ram", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_ram", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_ram", 0),
          (try_end),
              
          ### PUSH CANNON ###
          (try_begin),
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_12pdr_push_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_howitzer_push_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_fort_push_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_for_prop_instances, ":prop_no", "spr_mm_naval_push_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 50, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_move_up", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_move_up", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_move_up", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_move_up", 0),
          (try_end),
          
          ### TAKE CONTROL ###
          (try_begin),
            (agent_get_animation,":anim",":my_agent",0),
            (neq,":anim","anim_kneeling"), #Not using a cannon already
            
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_aim_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_take_control", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
          (try_end),
        (else_try), #For rocket artillery
          (eq,":troop_class",multi_troop_class_mm_rocket),
            
          ### LOAD AMMO ###
          (try_begin),
            (assign,":continue",0),
            (try_for_range_backwards,":equipment_slot",ek_item_0,ek_head),
              (agent_get_item_slot, ":item_id", ":my_agent", ":equipment_slot"),
              (gt,":item_id",-1), # even have a item there?
              (eq,"itm_rockets"), #has ammo
              (assign,":continue",1), #show where to put it
            (try_end),
            (eq,":continue",1),
            
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_load_rocket_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_put_ammo", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
          (try_end),
          
          ### TAKE CONTROL ###
          (try_begin),
            (agent_get_animation,":anim",":my_agent",0),
            (neq,":anim","anim_kneeling"), #Not using a cannon already
            
            (assign,":cur_closest_instance",-1),
            (assign,":min_distance",500), #in cm
            (try_for_prop_instances, ":prop_no", "spr_mm_aim_button",somt_temporary_object),
              (prop_instance_get_position, pos1, ":prop_no"),
              (get_distance_between_positions,":dist",pos1,pos17),
              (lt,":dist",":min_distance"),
              (assign,":min_distance",":dist"),
              (assign,":cur_closest_instance",":prop_no"),
            (try_end),
            (try_begin),
              (gt,":cur_closest_instance",-1),
              
              (prop_instance_get_position, pos1, ":cur_closest_instance"), #holds position of closest prop
              (position_move_z, pos1, 20, 1),
              (position_get_screen_projection, pos5, pos1),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
            
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_arty_icon_take_control", pos5),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
            (try_end),
          (else_try), 
            (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
          (try_end),
        (try_end),
      (else_try),
        (overlay_set_display, "$g_presentation_obj_arty_icon_take_ammo", 0),
        (overlay_set_display, "$g_presentation_obj_arty_icon_put_ammo", 0),
        (overlay_set_display, "$g_presentation_obj_arty_icon_ram", 0),
        (overlay_set_display, "$g_presentation_obj_arty_icon_move_up", 0),
        (overlay_set_display, "$g_presentation_obj_arty_icon_take_control", 0),
      (try_end),
      ]),
    ]),
       
       
  ("multiplayer_medic_icons", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for showing the location of a player.
    (ti_on_presentation_load, [

      # make 5 icons.. which we will use maximal.
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_1", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_2", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_3", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_4", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_5", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_6", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_7", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_8", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_9", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_10", "mesh_medic_icon_heal"),
      (create_mesh_overlay, "$g_presentation_obj_medic_icon_doc", "mesh_medic_icon_medic"),

      (set_fixed_point_multiplier, 1000),
      (position_set_x, pos1, 400),
      (position_set_y, pos1, 500),

      (overlay_set_size, "$g_presentation_obj_medic_icon_1", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_2", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_3", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_4", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_5", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_6", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_7", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_8", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_9", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_10", pos1),
      (overlay_set_size, "$g_presentation_obj_medic_icon_doc", pos1),
      (overlay_set_display, "$g_presentation_obj_medic_icon_1", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_2", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_3", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_4", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_5", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_6", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_7", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_8", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_9", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_10", 0),
      (overlay_set_display, "$g_presentation_obj_medic_icon_doc", 0),
      
      (assign,"$g_presentation_medic_timer", 0),
      (assign,"$g_presentation_medic_agent_found",-1),
      
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (set_fixed_point_multiplier, 1000),
      
      (assign,":cur_index",1),
      (assign,":has_medic_icon",0),
      
      (multiplayer_get_my_player,":my_player"),
      (try_begin),
        (player_is_active,":my_player"),
        (player_get_agent_id,":my_agent_id",":my_player"),
        (agent_is_active,":my_agent_id"),
        (agent_is_alive,":my_agent_id"),
        (agent_get_position,pos2,":my_agent_id"),
        (agent_get_team,":my_team",":my_agent_id"),
        
        (agent_get_troop_id,":troop_id",":my_agent_id"),
        (try_begin),
          (troop_slot_eq,":troop_id",slot_troop_class,multi_troop_class_mm_surgeon),  #if you're a doc
         
          (try_for_agents,":agent_id",pos2,10000),  # 10 meter searchrange.
            (lt,":cur_index",10),
            (neq,":my_agent_id",":agent_id"),
            (agent_is_active,":agent_id"),
            (agent_is_alive,":agent_id"),
            (agent_is_human,":agent_id"),
            (agent_get_team,":agent_team",":agent_id"),
            (eq,":agent_team",":my_team"),
            (store_agent_hit_points, ":health_percent", ":agent_id", 0), #get health
            (lt,":health_percent",100), #less than 100%
            (agent_get_slot, ":healed", ":agent_id", slot_agent_healed_perc),
            (lt,":healed",50),# only allow up to 50% healing
            
            (agent_get_position,pos1,":agent_id"),
            (position_move_z, pos1, 220, 1),
            (try_begin),
              (agent_get_horse, ":horse_agent", ":agent_id"),
              (agent_is_active,":horse_agent"),
              (agent_is_alive,":horse_agent"),
              (position_move_z, pos1, 100, 1),
            (try_end),
            (position_get_screen_projection, pos5, pos1),
            (position_get_x, ":x_pos", pos5),
            (position_get_y, ":y_pos", pos5),
            (val_add,":x_pos",-1),
            (position_move_x, pos5, -1, 1),
            #(position_set_y, pos5, ":y_pos"),
                
            (is_between, ":x_pos", -100, 1100),
            (is_between, ":y_pos", -100, 850),
            
            (try_begin),
              (eq,":cur_index",1),
              (overlay_set_position, "$g_presentation_obj_medic_icon_1", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_1", 1),
            (else_try),
              (eq,":cur_index",2),
              (overlay_set_position, "$g_presentation_obj_medic_icon_2", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_2", 1),
            (else_try),
              (eq,":cur_index",3),
              (overlay_set_position, "$g_presentation_obj_medic_icon_3", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_3", 1),
            (else_try),
              (eq,":cur_index",4),
              (overlay_set_position, "$g_presentation_obj_medic_icon_4", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_4", 1),
            (else_try),
              (eq,":cur_index",5),
              (overlay_set_position, "$g_presentation_obj_medic_icon_5", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_5", 1),
            (else_try),
              (eq,":cur_index",6),
              (overlay_set_position, "$g_presentation_obj_medic_icon_6", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_6", 1),
            (else_try),
              (eq,":cur_index",7),
              (overlay_set_position, "$g_presentation_obj_medic_icon_7", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_7", 1),
            (else_try),
              (eq,":cur_index",8),
              (overlay_set_position, "$g_presentation_obj_medic_icon_8", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_8", 1),
            (else_try),
              (eq,":cur_index",9),
              (overlay_set_position, "$g_presentation_obj_medic_icon_9", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_9", 1),
            (else_try),
              (eq,":cur_index",10),
              (overlay_set_position, "$g_presentation_obj_medic_icon_10", pos5),
              (overlay_set_display, "$g_presentation_obj_medic_icon_10", 1),
            (try_end),
            
            (val_add,":cur_index",1),
          (try_end),
        (try_end),
        
        # need heal yourself?
        (try_begin),
          (store_agent_hit_points, ":health_percent", ":my_agent_id", 0),
          (lt,":health_percent",100), #less than 100%
          (agent_get_slot, ":healed", ":my_agent_id", slot_agent_healed_perc),
          (lt,":healed",50),# only allow up to 50% healing
          
          (store_mission_timer_a,":cur_time"),
          (store_sub,":passed_time",":cur_time","$g_presentation_medic_timer"),
          
          (try_begin),
            (gt,":passed_time",1), # only update every second the new players.
            
            (assign,":found_one",0),
            (assign,":closest_dist",999999999),
            (try_for_agents,":agent_id",pos2,10000),  # 10 meter searchrange.
              (neq,":my_agent_id",":agent_id"),
              (agent_is_active,":agent_id"),
              (agent_is_alive,":agent_id"),
              (agent_is_human,":agent_id"),
              (agent_get_team,":agent_team",":agent_id"),
              (eq,":agent_team",":my_team"),
              
              (agent_get_troop_id,":troop_id",":agent_id"),
              (troop_slot_eq,":troop_id",slot_troop_class,multi_troop_class_mm_surgeon),  #if he is a doc
              
              (agent_get_position,pos1,":agent_id"),
              (get_distance_between_positions,":cur_dist",pos1,pos2),
              
              (lt,":cur_dist",":closest_dist"),
              
              (assign,":closest_dist",":cur_dist"),
              
              (assign,":found_one",1),
              
              (assign,"$g_presentation_medic_agent_found",":agent_id"),
            (try_end),
            (eq,":found_one",0),
            (assign,"$g_presentation_medic_agent_found",-1),
          (try_end),
          
          (gt,"$g_presentation_medic_agent_found",-1),
          
          (position_move_z, pos1, 220, 1),
          (try_begin),
            (agent_get_horse, ":horse_agent", ":agent_id"),
            (agent_is_active,":horse_agent"),
            (agent_is_alive,":horse_agent"),
            (position_move_z, pos1, 100, 1),
          (try_end),
          (position_get_screen_projection, pos5, pos1),
          (position_get_x, ":x_pos", pos5),
          (position_get_y, ":y_pos", pos5),
          (val_add,":x_pos",-1),
          (position_move_x, pos5, -1, 1),
          #(position_set_y, pos5, ":y_pos"),
              
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),
          
          (overlay_set_position, "$g_presentation_obj_medic_icon_doc", pos5),
          (overlay_set_display, "$g_presentation_obj_medic_icon_doc", 1),
          
          (assign,":has_medic_icon",1),
        (try_end),
      (try_end),
      
      (try_begin),
        (le,":cur_index",10),
        (overlay_set_display, "$g_presentation_obj_medic_icon_10", 0),
        (le,":cur_index",9),
        (overlay_set_display, "$g_presentation_obj_medic_icon_9", 0),
        (le,":cur_index",8),
        (overlay_set_display, "$g_presentation_obj_medic_icon_8", 0),
        (le,":cur_index",7),
        (overlay_set_display, "$g_presentation_obj_medic_icon_7", 0),
        (le,":cur_index",6),
        (overlay_set_display, "$g_presentation_obj_medic_icon_6", 0),
        (le,":cur_index",5),
        (overlay_set_display, "$g_presentation_obj_medic_icon_5", 0),
        (le,":cur_index",4),
        (overlay_set_display, "$g_presentation_obj_medic_icon_4", 0),
        (le,":cur_index",3),
        (overlay_set_display, "$g_presentation_obj_medic_icon_3", 0),
        (le,":cur_index",2),
        (overlay_set_display, "$g_presentation_obj_medic_icon_2", 0),
        (le,":cur_index",1),
        (overlay_set_display, "$g_presentation_obj_medic_icon_1", 0),
      (try_end),
      
      (try_begin),
        (eq,":has_medic_icon",0),
        (overlay_set_display, "$g_presentation_obj_medic_icon_doc", 0),
      (try_end),
      ]),
    ]),
     
       
       
  ("multiplayer_beacon_player", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for showing the location of a player.
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),

      (team_get_faction,":faction_1",0),
      (team_get_faction,":faction_2",1),
      
      (try_begin),
        (eq,":faction_1","fac_britain"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_sw"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_sw"),
      (else_try),  
        (eq,":faction_1","fac_france"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_vg"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_vg"),
      (else_try),  
        (eq,":faction_1","fac_prussia"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_kh"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_kh"),
      (else_try),  
        (eq,":faction_1","fac_russia"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_nd"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_nd"),
      (else_try),  
        (eq,":faction_1","fac_austria"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_rh"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_rh"),
      (else_try),  
        (eq,":faction_1","fac_rhine"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_1", "mesh_flag_project_sr"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_1", "mesh_flag_project_sr"),
      (try_end),
      (try_begin),
        (eq,":faction_2",":faction_1"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_rb"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_rb"),
      (else_try),  
        (eq,":faction_2","fac_britain"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_sw"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_sw"),
      (else_try),  
        (eq,":faction_2","fac_france"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_vg"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_vg"),
      (else_try),  
        (eq,":faction_2","fac_prussia"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_kh"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_kh"),
      (else_try),  
        (eq,":faction_2","fac_russia"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_nd"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_nd"),
      (else_try),  
        (eq,":faction_2","fac_austria"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_rh"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_rh"),
      (else_try),  
        (eq,":faction_2","fac_rhine"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_team_2", "mesh_flag_project_sr"),
        (create_mesh_overlay, "$g_presentation_obj_beacon_player_admin_2", "mesh_flag_project_sr"),
      (try_end),
      
      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),

      (overlay_set_size, "$g_presentation_obj_beacon_player_team_1", pos1),
      (overlay_set_size, "$g_presentation_obj_beacon_player_team_2", pos1),
      (overlay_set_size, "$g_presentation_obj_beacon_player_admin_1", pos1),
      (overlay_set_size, "$g_presentation_obj_beacon_player_admin_2", pos1),
      (overlay_set_display, "$g_presentation_obj_beacon_player_team_1", 0),
      (overlay_set_display, "$g_presentation_obj_beacon_player_team_2", 0),
      (overlay_set_display, "$g_presentation_obj_beacon_player_admin_1", 0),
      (overlay_set_display, "$g_presentation_obj_beacon_player_admin_2", 0),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (set_fixed_point_multiplier, 1000),
      
      (multiplayer_get_my_player,":my_player"),
      (try_begin),
        (player_is_active,"$g_beaconed_player_team_1"),
        (neq,"$g_beaconed_player_team_1",":my_player"),
        (player_get_agent_id,":agent_id","$g_beaconed_player_team_1"),
        (agent_is_active,":agent_id"),
        (agent_is_alive,":agent_id"),
        (agent_get_position,pos1,":agent_id"),
        (position_move_z, pos1, 220, 1),
        (position_get_screen_projection, pos5, pos1),
        (position_get_x, ":x_pos", pos5),
        (position_get_y, ":y_pos", pos5),
        (position_set_y, pos5, ":y_pos"),
            
        (is_between, ":x_pos", -100, 1100),
        (is_between, ":y_pos", -100, 850),
        
        (overlay_set_position, "$g_presentation_obj_beacon_player_team_1", pos5),
        (overlay_set_display, "$g_presentation_obj_beacon_player_team_1", 1),
      (else_try),
        (overlay_set_display, "$g_presentation_obj_beacon_player_team_1", 0),
      (try_end),
      (try_begin),
        (player_is_active,"$g_beaconed_player_team_2"),
        (neq,"$g_beaconed_player_team_2",":my_player"),
        (player_get_agent_id,":agent_id","$g_beaconed_player_team_2"),
        (agent_is_active,":agent_id"),
        (agent_is_alive,":agent_id"),
        (agent_get_position,pos1,":agent_id"),
        (position_move_z, pos1, 220, 1),
        (position_get_screen_projection, pos5, pos1),
        (position_get_x, ":x_pos", pos5),
        (position_get_y, ":y_pos", pos5),
        (position_set_y, pos5, ":y_pos"),
            
        (is_between, ":x_pos", -100, 1100),
        (is_between, ":y_pos", -100, 850),
        
        (overlay_set_position, "$g_presentation_obj_beacon_player_team_2", pos5),
        (overlay_set_display, "$g_presentation_obj_beacon_player_team_2", 1),
      (else_try),
        (overlay_set_display, "$g_presentation_obj_beacon_player_team_2", 0),
      (try_end),
      (try_begin),
        (player_is_active,"$g_beaconed_player_admin"),
        (neq,"$g_beaconed_player_admin",":my_player"),
        (player_get_agent_id,":agent_id","$g_beaconed_player_admin"),
        (agent_is_active,":agent_id"),
        (agent_is_alive,":agent_id"),
        (agent_get_team,":team",":agent_id"),
        (agent_get_position,pos1,":agent_id"),
        (position_move_z, pos1, 220, 1),
        (position_get_screen_projection, pos5, pos1),
        (position_get_x, ":x_pos", pos5),
        (position_get_y, ":y_pos", pos5),
        (position_set_y, pos5, ":y_pos"),
            
        (is_between, ":x_pos", -100, 1100),
        (is_between, ":y_pos", -100, 850),
        
        (try_begin),
          (eq,":team",0),
          (overlay_set_position, "$g_presentation_obj_beacon_player_admin_1", pos5),
          (overlay_set_display, "$g_presentation_obj_beacon_player_admin_1", 1),
          (overlay_set_display, "$g_presentation_obj_beacon_player_admin_2", 0),
        (else_try),
          (eq,":team",1),
          (overlay_set_position, "$g_presentation_obj_beacon_player_admin_2", pos5),
          (overlay_set_display, "$g_presentation_obj_beacon_player_admin_1", 0),
          (overlay_set_display, "$g_presentation_obj_beacon_player_admin_2", 1),
        (try_end),
      (else_try),
        (overlay_set_display, "$g_presentation_obj_beacon_player_admin_1", 0),
        (overlay_set_display, "$g_presentation_obj_beacon_player_admin_2", 0),
      (try_end),
      ]),
    ]),

  ("custom_order_menu", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (assign, "$g_custom_order_menu_active", 1),
      (assign, "$g_custom_order_menu_force_close", 0),
      (assign, "$g_custom_order_menu_screen_text", -1),
      (assign, "$g_custom_order_menu_screen_background_1", -1),
      (assign, "$g_custom_order_menu_screen_background_2", -1),
      (assign, "$g_custom_order_menu_screen_background_3", -1),
      (assign, "$g_custom_order_menu_screen_background_4", -1),
      (assign, "$g_custom_order_menu_screen_background_5", -1),
      (assign, "$g_custom_order_menu_screen_background_6", -1),
      (assign, "$g_custom_order_menu_screen_background_7", -1),
      (assign, "$g_custom_order_menu_screen_background_8", -1),
      (assign, "$g_custom_order_menu_screen_background_9", -1),
      (assign, "$g_custom_order_menu_screen_background_10", -1),
      (try_begin),
        (gt, reg62, 10),
        (assign, reg62, 10),
      (try_end),
      #int value that will be sent back to the server for the server to identify the type of menu
      (assign, "$g_custom_order_menu_custom_server_flag", reg61),
      #amount of buttons
      (assign, "$g_custom_order_menu_screen_button_count", reg62),
      (init_position, pos0),
      (assign, ":base_offset", 300),
      (assign, ":line_height", 22),

      (init_position, pos0),
      (position_set_y, pos0, ":base_offset"),
      (create_text_overlay, "$g_custom_order_menu_screen_text", s61),
      (overlay_set_color, "$g_custom_order_menu_screen_text", 0xFFFFFF),
      (overlay_set_position, "$g_custom_order_menu_screen_text", pos0),
      (overlay_set_alpha,"$g_custom_order_menu_screen_text", 0xFF),

      (try_for_range, ":j", 0, "$g_custom_order_menu_screen_button_count"),
        (store_add, ":i", ":j", 1),
        (init_position, pos0),
        (create_mesh_overlay, ":overlay_id", "mesh_custom_mp_ui_order_button"),
        (overlay_set_alpha, ":overlay_id", 0xFF),
        (store_sub, ":visual_position", "$g_custom_order_menu_screen_button_count", ":i"),
        #(val_sub, ":visual_position", 2),
        (store_mul, ":offset", ":line_height", ":visual_position"),
        (val_add, ":offset", ":base_offset"),
        (position_set_y, pos0, ":offset"),
        (overlay_set_position, ":overlay_id", pos0),

        (try_begin),
          (eq, ":i", 1),
          (assign, "$g_custom_order_menu_screen_background_1", ":overlay_id"),
        (else_try),
          (eq, ":i", 2),
          (assign, "$g_custom_order_menu_screen_background_2", ":overlay_id"),
        (else_try),
          (eq, ":i", 3),
          (assign, "$g_custom_order_menu_screen_background_3", ":overlay_id"),
        (else_try),
          (eq, ":i", 4),
          (assign, "$g_custom_order_menu_screen_background_4", ":overlay_id"),
        (else_try),
          (eq, ":i", 5),
          (assign, "$g_custom_order_menu_screen_background_5", ":overlay_id"),
        (else_try),
          (eq, ":i", 6),
          (assign, "$g_custom_order_menu_screen_background_6", ":overlay_id"),
        (else_try),
          (eq, ":i", 7),
          (assign, "$g_custom_order_menu_screen_background_7", ":overlay_id"),
        (else_try),
          (eq, ":i", 8),
          (assign, "$g_custom_order_menu_screen_background_8", ":overlay_id"),
        (else_try),
          (eq, ":i", 9),
          (assign, "$g_custom_order_menu_screen_background_9", ":overlay_id"),
        (else_try),
          (eq, ":i", 10),
          (assign, "$g_custom_order_menu_screen_background_10", ":overlay_id"),
        (try_end),
      (try_end),
      (presentation_set_duration, 999999),
      (omit_key_once, key_escape),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 0),
        (omit_key_once, key_1),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 1),
        (omit_key_once, key_2),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 2),
        (omit_key_once, key_3),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 3),
        (omit_key_once, key_4),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 4),
        (omit_key_once, key_5),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 5),
        (omit_key_once, key_6),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 6),
        (omit_key_once, key_7),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 7),
        (omit_key_once, key_8),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 8),
        (omit_key_once, key_9),
      (try_end),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 9),
        (omit_key_once, key_0),
      (try_end),
    ]),

    (ti_on_presentation_run, [
      (try_begin),
        #server sent close signal, let's immediately remove the menu
        (eq, "$g_custom_order_menu_force_close", 1),
        (clear_omitted_keys),
        (presentation_set_duration, 0),
        (assign, "$g_custom_order_menu_active", 0),
      (else_try),
      (eq, "$g_custom_order_menu_active", 1),
      (assign, ":key_pressed", -1),
      (try_begin),
        (gt, "$g_custom_order_menu_screen_button_count", 0),
        (key_clicked, key_1),
        (assign, ":key_pressed", custom_order_menu_key_1),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 1),
        (key_clicked, key_2),
        (assign, ":key_pressed", custom_order_menu_key_2),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 2),
        (key_clicked, key_3),
        (assign, ":key_pressed", custom_order_menu_key_3),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 3),
        (key_clicked, key_4),
        (assign, ":key_pressed", custom_order_menu_key_4),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 4),
        (key_clicked, key_5),
        (assign, ":key_pressed", custom_order_menu_key_5),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 5),
        (key_clicked, key_6),
        (assign, ":key_pressed", custom_order_menu_key_6),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 6),
        (key_clicked, key_7),
        (assign, ":key_pressed", custom_order_menu_key_7),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 7),
        (key_clicked, key_8),
        (assign, ":key_pressed", custom_order_menu_key_8),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 8),
        (key_clicked, key_9),
        (assign, ":key_pressed", custom_order_menu_key_9),
      (else_try),
        (gt, "$g_custom_order_menu_screen_button_count", 9),
        (key_clicked, key_0),
        (assign, ":key_pressed", custom_order_menu_key_0),
      (else_try),
        (key_clicked, key_escape), #Close
        (assign, ":key_pressed", custom_order_menu_close),
      (try_end),

      (neq, ":key_pressed", -1),
      (assign, "$g_custom_order_menu_active", 0),
      (try_for_range, ":j", 0, "$g_custom_order_menu_screen_button_count"),
        (store_add, ":i", ":j", 1),
        (try_begin),
          (eq, ":i", 1),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_1"),
        (else_try),
          (eq, ":i", 2),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_2"),
        (else_try),
          (eq, ":i", 3),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_3"),
        (else_try),
          (eq, ":i", 4),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_4"),
        (else_try),
          (eq, ":i", 5),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_5"),
        (else_try),
          (eq, ":i", 6),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_6"),
        (else_try),
          (eq, ":i", 7),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_7"),
        (else_try),
          (eq, ":i", 8),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_8"),
        (else_try),
          (eq, ":i", 9),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_9"),
        (else_try),
          (eq, ":i", 10),
          (assign, ":overlay_id", "$g_custom_order_menu_screen_background_10"),
        (try_end),
        (try_begin),
          (eq, ":key_pressed", ":i"),
          (overlay_animate_to_alpha, ":overlay_id", 1000, 0x00),
        (else_try),
          (overlay_animate_to_alpha, ":overlay_id", 100, 0x00),
        (try_end),
      (try_end),
      (overlay_animate_to_alpha, "$g_custom_order_menu_screen_text", 1000, 0x00),
      (multiplayer_send_3_int_to_server, multiplayer_event_send_player_action, player_action_custom_order_menu_interact, "$g_custom_order_menu_custom_server_flag", ":key_pressed"),
      (clear_omitted_keys),
      (presentation_set_duration, 1000),
    ]),
  ]),

  ("new_order_stuff", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      (assign,"$g_presentation_order_screen",0),
      (assign,"$g_presentation_order_last_command_at",0),

      (create_text_overlay,"$g_presentation_obj_order_screen_0","@F4 - Movement Orders^F5 - Formation Orders^F6 - Fire Orders"),
      (create_text_overlay,"$g_presentation_obj_order_screen_1","@F4 - Hold this position^F5 - Follow me^F6 - Charge^F7 - Advance^F8 - Halt^F9 - Fall back^F10 - Retreat^F11 - Slow march^F12 - Quick march"),
      (create_text_overlay,"$g_presentation_obj_order_screen_2","@F4 - Form line^F5 - Form column^F6 - Form square^F7 - Skirmish formation^F8 - Wheel left^F9 - Wheel right^F10 - Adjust facing"),
      (create_text_overlay,"$g_presentation_obj_order_screen_3","@F4 - Hold fire^F5 - Fire at will^F6 - Volley fire^F7 - Fire at position^F8 - Pick your targets"),
      (overlay_set_color,"$g_presentation_obj_order_screen_0",0xFF0000),
      (overlay_set_color,"$g_presentation_obj_order_screen_1",0xFF0000),
      (overlay_set_color,"$g_presentation_obj_order_screen_2",0xFF0000),
      (overlay_set_color,"$g_presentation_obj_order_screen_3",0xFF0000),
      (position_set_x,pos1,100),
      (position_set_y,pos1,500),
      (overlay_set_position,"$g_presentation_obj_order_screen_0",pos1),
      (overlay_set_position,"$g_presentation_obj_order_screen_1",pos1),
      (overlay_set_position,"$g_presentation_obj_order_screen_2",pos1),
      (overlay_set_position,"$g_presentation_obj_order_screen_3",pos1),
      (overlay_set_alpha,"$g_presentation_obj_order_screen_0", 0xFF),
      (overlay_set_alpha,"$g_presentation_obj_order_screen_1", 0x00),
      (overlay_set_alpha,"$g_presentation_obj_order_screen_2", 0x00),
      (overlay_set_alpha,"$g_presentation_obj_order_screen_3", 0x00),

      (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_run, [
      (store_trigger_param_1,":cur_time"),
      (store_sub,":time_since_last_command",":cur_time","$g_presentation_order_last_command_at"),
      (gt,":time_since_last_command",500), # 0.5 sec
      (assign,":terminate",0),
      (try_begin),
        (key_clicked,key_f4),
        (neq,"$g_presentation_order_screen",1),
        (try_begin),
          (eq,"$g_presentation_order_screen",0),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_0", 0x00),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_1", 0xFF),
          (assign,"$g_presentation_order_screen",1),
          (assign,"$g_presentation_order_last_command_at",":cur_time"),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_line,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",3),
          (call_script,"script_give_mm_order",mm_order_type_fire,mm_order_holdfire,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_is_down,key_f4),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (set_fixed_point_multiplier,1000),
          (get_player_agent_no,":player_agent"),
          (agent_get_look_position,pos23,":player_agent"),
          (assign,":end_cond",1),
          (position_move_z,pos23,180,1),
          (try_for_range,":unused",0,":end_cond"),
            (position_move_y,pos23,5,0),
            (position_get_distance_to_ground_level,":dist",pos23),
            (gt,":dist",10),
            (val_add,":end_cond",1),
            (gt,":end_cond",10000),
            (assign,":end_cond",0),
          (try_end),
          (prop_instance_set_position,"$g_hold_position_arrow_instance",pos23),
          (scene_prop_set_visibility,"$g_hold_position_arrow_instance",1),
          (set_fixed_point_multiplier,100),
        (try_end),
      (else_try),
        (eq,"$g_presentation_order_screen",1),
        (neg|key_is_down,key_f4),
        (scene_prop_get_visibility,":visibility","$g_hold_position_arrow_instance"),
        (eq,":visibility",1),
        (call_script,"script_give_mm_order",mm_order_type_move,mm_order_hold,0),
        (scene_prop_set_visibility,"$g_hold_position_arrow_instance",0),
        (assign,":terminate",1),
      (else_try),
        (key_clicked,key_f5),
        (try_begin),
          (eq,"$g_presentation_order_screen",0),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_0", 0x00),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_2", 0xFF),
          (assign,"$g_presentation_order_screen",2),
          (assign,"$g_presentation_order_last_command_at",":cur_time"),
        (else_try),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_follow,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_column,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",3),
          (call_script,"script_give_mm_order",mm_order_type_fire,mm_order_fireatwill,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f6),
        (try_begin),
          (eq,"$g_presentation_order_screen",0),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_0", 0x00),
          (overlay_set_alpha,"$g_presentation_obj_order_screen_3", 0xFF),
          (assign,"$g_presentation_order_screen",3),
          (assign,"$g_presentation_order_last_command_at",":cur_time"),
        (else_try),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_charge,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_square,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",3),
          (call_script,"script_give_mm_order",mm_order_type_fire,mm_order_volley,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f7),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_advance,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_skirmish,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",3),
          (call_script,"script_give_mm_order",mm_order_type_fire,mm_order_targetpos,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f8),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_halt,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_wheelleft,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",3),
          (call_script,"script_give_mm_order",mm_order_type_fire,mm_order_targetfree,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f9),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_fallback,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_wheelright,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f10),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_retreat,0),
          (assign,":terminate",1),
        (else_try),
          (eq,"$g_presentation_order_screen",2),
          (call_script,"script_give_mm_order",mm_order_type_formation,mm_order_adjust,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f11),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_slow,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (key_clicked,key_f12),
        (try_begin),
          (eq,"$g_presentation_order_screen",1),
          (call_script,"script_give_mm_order",mm_order_type_move,mm_order_quick,0),
          (assign,":terminate",1),
        (try_end),
      (else_try),
        (this_or_next|key_clicked,key_escape), #Close
        (key_clicked,key_f7),
        (assign,":terminate",1),
      (try_end),
      (try_begin),
        (eq,":terminate",1),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),


    ("singleplayer_progress_counter", prsntf_read_only|prsntf_manual_end_only, 0, [
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),
      #(assign, "$g_singleplayer_progress_counter_mode", 1), # modes 1 = counter 2 = progress
      (assign, "$g_singleplayer_progress_last_update", -1),
      ##(assign, "$g_singleplayer_progress_counter_min_value", 0),
      #(assign, "$g_singleplayer_progress_counter_max_value", 1),
      #(assign, "$g_singleplayer_progress_counter_cur_value", 0),
      #(assign, "$g_singleplayer_progress_counter_string_id", -1),
      (store_mission_timer_a, "$g_singleplayer_progress_counter_start_time"),
            
      (str_clear, s0),
      (create_text_overlay, "$g_singleplayer_progress_counter_overlay", s0, tf_left_align|tf_single_line|tf_with_outline),
      (overlay_set_color, "$g_singleplayer_progress_counter_overlay", 0xFFFFFF),
      (position_set_x, pos1, 20),
      (position_set_y, pos1, 590),
      (overlay_set_position, "$g_singleplayer_progress_counter_overlay", pos1),
      (position_set_x, pos1, 2000),
      (position_set_y, pos1, 2000),
      (overlay_set_size, "$g_singleplayer_progress_counter_overlay", pos1),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run,
     [(store_mission_timer_a, ":current_time"),
      (neq,":current_time","$g_singleplayer_progress_last_update"), # Update each second
      (assign,"$g_singleplayer_progress_last_update",":current_time"),
     
      (set_fixed_point_multiplier, 100),

      (try_begin),
        (eq,"$g_singleplayer_progress_counter_mode", 1), # counter
        (store_sub, ":seconds_past", ":current_time", "$g_singleplayer_progress_counter_start_time"),
        (store_sub, ":seconds_left", "$g_singleplayer_progress_counter_max_value", ":seconds_past"),
        (val_max, ":seconds_left", 0),
        (try_begin),
          (neq, "$g_singleplayer_progress_counter_cur_value", ":seconds_left"),
          (assign, "$g_singleplayer_progress_counter_cur_value", ":seconds_left"),
          (store_div, reg0, ":seconds_left", 60),
          (store_div, reg1, ":seconds_left", 10),
          (val_mod, reg1, 6),
          (assign, reg2, ":seconds_left"),
          (val_mod, reg2, 10),
          (str_store_string, s0, "str_reg0_dd_reg1reg2"),
          (overlay_set_text, "$g_singleplayer_progress_counter_overlay", s0),
          (position_set_x, pos1, 200),
          (position_set_y, pos1, 200),
          (overlay_set_size, "$g_singleplayer_progress_counter_overlay", pos1),
        (try_end),
      (else_try),
        (eq,"$g_singleplayer_progress_counter_mode", 2), # progress
        (gt,"$g_singleplayer_progress_counter_string_id", -1),
        (assign,reg0,"$g_singleplayer_progress_counter_cur_value"),
        (assign,reg1,"$g_singleplayer_progress_counter_max_value"),
        (str_store_string, s0, "$g_singleplayer_progress_counter_string_id"),
        #(str_store_string, s0, "@Destroyed {reg0} / {reg1}"),
        (overlay_set_text, "$g_singleplayer_progress_counter_overlay", s0),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, 100),
        (overlay_set_size, "$g_singleplayer_progress_counter_overlay", pos1),
      (else_try),
        (eq,"$g_singleplayer_progress_counter_mode", -1), # stop presentation
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),
    
   ("singleplayer_campain_map", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end
        
        
        (assign,":size_x",700),
        (assign,":size_y",850),
        (try_begin),
          (eq,"$g_finished_missions",0),
       #   (create_mesh_overlay, "$g_mission_icon_1", "mesh_french_flag_icon", tf_center_justify),
          (position_set_x, pos1, 447),
          (position_set_y, pos1, 377),
        (else_try),
          (ge,"$g_finished_missions",1),
       #   (create_mesh_overlay, "$g_mission_icon_1", "mesh_battle_icon"),
          (assign,":size_x",250),
          (assign,":size_y",250),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 417),
        (else_try),
          (assign,"$g_mission_icon_1",-1),
        (try_end),
        (try_begin),
          (gt,"$g_mission_icon_1",-1),
          
          (overlay_set_position, "$g_mission_icon_1", pos1),
          (position_set_x, pos1, ":size_x"),
          (position_set_y, pos1, ":size_y"),
          (overlay_set_size, "$g_mission_icon_1", pos1),
          
          # caption
          (create_text_overlay, "$g_mission_caption_1", "@Vienna", tf_center_justify),
          (overlay_set_color, "$g_mission_caption_1", 0x00000000),
          (position_set_x, pos1, 530),
          (position_set_y, pos1, 390),
          (overlay_set_position, "$g_mission_caption_1", pos1),
        (try_end),
        
        (assign,":size_x",700),
        (assign,":size_y",850),
        (try_begin),
          (eq,"$g_finished_missions",1),
       #   (create_mesh_overlay, "$g_mission_icon_2", "mesh_french_flag_icon", tf_center_justify),
          (position_set_x, pos1, 430),
          (position_set_y, pos1, 430),
        (else_try),
          (ge,"$g_finished_missions",2),
         # (create_mesh_overlay, "$g_mission_icon_2", "mesh_battle_icon"),
          (assign,":size_x",250),
          (assign,":size_y",250),
          (position_set_x, pos1, 500),
          (position_set_y, pos1, 490),
        (else_try),
          (assign,"$g_mission_icon_2",-1),
        (try_end),
        (try_begin),
          (gt,"$g_mission_icon_2",-1),
          
          (overlay_set_position, "$g_mission_icon_2", pos1),
          (position_set_x, pos1, ":size_x"),
          (position_set_y, pos1, ":size_y"),
          (overlay_set_size, "$g_mission_icon_2", pos1),
          
          # caption
          (create_text_overlay, "$g_mission_caption_1", "@Austerlitz", tf_center_justify),
          (overlay_set_color, "$g_mission_caption_1", 0x00000000),
          (position_set_x, pos1, 525),
          (position_set_y, pos1, 536),
          (overlay_set_position, "$g_mission_caption_1", pos1),
        (try_end),
        
        (assign,":size_x",700),
        (assign,":size_y",850),
        (try_begin),
          (eq,"$g_finished_missions",2),
        #  (create_mesh_overlay, "$g_mission_icon_3", "mesh_french_flag_icon", tf_center_justify),
          (position_set_x, pos1, 816),
          (position_set_y, pos1, 470),
        (else_try),
          (ge,"$g_finished_missions",3),
       #   (create_mesh_overlay, "$g_mission_icon_3", "mesh_battle_icon"),
          (position_set_x, pos1, 878),
          (position_set_y, pos1, 572),
          (assign,":size_x",250),
          (assign,":size_y",250),
        (else_try),
          (assign,"$g_mission_icon_3",-1),
        (try_end),
        (try_begin),
          (gt,"$g_mission_icon_3",-1),
          
          (overlay_set_position, "$g_mission_icon_3", pos1),
          (position_set_x, pos1, ":size_x"),
          (position_set_y, pos1, ":size_y"),
          (overlay_set_size, "$g_mission_icon_3", pos1),
          
          # caption
          (create_text_overlay, "$g_mission_caption_1", "@Drezden", tf_center_justify),
          (overlay_set_color, "$g_mission_caption_1", 0x00000000),
          (position_set_x, pos1, 900),
          (position_set_y, pos1, 582),
          (overlay_set_position, "$g_mission_caption_1", pos1),
        (try_end),
        
      #  (create_mesh_overlay, "$g_map_compass", "mesh_compass"),
        (position_set_x, pos1, 40),
        (position_set_y, pos1, 700),
        (overlay_set_position, "$g_map_compass", pos1),
        (position_set_x, pos1, 550),
        (position_set_y, pos1, 600),
        (overlay_set_size, "$g_map_compass", pos1),


        #(create_game_button_overlay, <destination>, <string_id>),
        (create_game_button_overlay,"$g_singleplayer_campain_map_quit","@Quit"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_campain_map_quit",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_campain_map_quit",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_campain_map_camp","@Go to the Camp"),
        (position_set_x,pos1,460),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_campain_map_camp",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_campain_map_camp",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_campain_map_continue","@Continue Campaign"),
        (position_set_x,pos1,850),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_campain_map_continue",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_campain_map_continue",pos1),

        

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_campain_map_continue"),
          #(assign,"$g_next_presentation","prsnt_singleplayer_memoir_screen"),
          
          (start_presentation, "prsnt_singleplayer_memoir_screen"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
          #(presentation_set_duration, 0),
          
          #(start_presentation, "prsnt_singleplayer_memoir_screen"),
        (else_try),
          (eq, ":object", "$g_singleplayer_campain_map_camp"),
          (start_presentation, "prsnt_singleplayer_camp_screen"),
          #(presentation_set_duration, 0),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_singleplayer_campain_map_quit"),
          (presentation_set_duration, 0),
          (jump_to_menu,"mnu_quit_dummy"),
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      
        #(store_trigger_param_1, ":cur_time"),
        # (gt, ":cur_time", 500),
        # (try_begin),
          # (this_or_next|key_clicked, key_space),
          # (this_or_next|key_clicked, key_enter),
          # (this_or_next|key_clicked, key_escape),
          # (this_or_next|key_clicked, key_back_space),
          # (this_or_next|key_clicked, key_left_mouse_button),
          # (key_clicked, key_right_mouse_button),
          # (try_begin),
            # (eq, "$g_game_before_quit_state", 0),
            # (val_add, "$g_game_before_quit_state", 1),
            # (create_mesh_overlay, reg0, "mesh_quit_adv_b"),
            # (position_set_x, pos1, -1),
            # (position_set_y, pos1, -1),
            # (overlay_set_position, reg0, pos1),
            # (position_set_x, pos1, 1002),
            # (position_set_y, pos1, 1002),
            # (overlay_set_size, reg0, pos1),
          # (else_try),
            # (presentation_set_duration, 0),
          # (try_end),
        # (try_end),
       ]),

     ]),
     
  ("singleplayer_camp_screen", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end
        
        # Create a container
        # (str_clear, s0),
        # (create_text_overlay, "$g_singleplayer_memoir_screen_container", s0, tf_scrollable_style_2),
        # (position_set_x, pos1, 0),
        # (position_set_y, pos1, 0),#90
        # (overlay_set_position, "$g_singleplayer_memoir_screen_container", pos1),
        # (position_set_x, pos1, 800),
        # (position_set_y, pos1, 690),#560
        # (overlay_set_area_size, "$g_singleplayer_memoir_screen_container", pos1),
        # (set_container_overlay, "$g_singleplayer_memoir_screen_container"),
        
       

        #(create_game_button_overlay, <destination>, <string_id>),
        (create_game_button_overlay,"$g_singleplayer_camp_screen_back","@Back"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_camp_screen_back",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_camp_screen_back",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_camp_screen_visit","@Visit the camp"),
        (position_set_x,pos1,350),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_camp_screen_visit",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_camp_screen_visit",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_camp_screen_companions","@Companions"),
        (position_set_x,pos1,600),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_camp_screen_companions",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_camp_screen_companions",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_camp_screen_merchants","@Merchants"),
        (position_set_x,pos1,850),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_camp_screen_merchants",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_camp_screen_merchants",pos1),

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_camp_screen_back"),
          (start_presentation, "prsnt_singleplayer_campain_map"),
        (else_try),
          (eq, ":object", "$g_singleplayer_camp_screen_visit"),
          (assign,"$g_started_camp","scn_sp_camp_austerlitz"),
          (jump_to_menu,"mnu_visit_camp_dummy"),
          (presentation_set_duration,0),
          
        (else_try),
          (eq, ":object", "$g_singleplayer_camp_screen_companions"),
          (start_presentation, "prsnt_singleplayer_companion_equipment_select"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_singleplayer_camp_screen_merchants"),
          
          (jump_to_menu,"mnu_town_trade"),
          (presentation_set_duration,0),
          
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      

       ]),

     ]),
     
  ("singleplayer_memoir_screen", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end
        
        # Create a container
        # (str_clear, s0),
        # (create_text_overlay, "$g_singleplayer_memoir_screen_container", s0, tf_scrollable_style_2),
        # (position_set_x, pos1, 0),
        # (position_set_y, pos1, 0),#90
        # (overlay_set_position, "$g_singleplayer_memoir_screen_container", pos1),
        # (position_set_x, pos1, 800),
        # (position_set_y, pos1, 690),#560
        # (overlay_set_area_size, "$g_singleplayer_memoir_screen_container", pos1),
        # (set_container_overlay, "$g_singleplayer_memoir_screen_container"),
        
        (store_add,":memoir_string_id","str_mission_briefing_1","$g_finished_missions"),
        (str_store_string,s0,":memoir_string_id"),
        
        (create_text_overlay, "$g_singleplayer_memoir_screen_text", s0, 0),
        (overlay_set_color, "$g_singleplayer_memoir_screen_text", 0x000000),
        (position_set_x, pos1, 246),
        (position_set_y, pos1, 168),
        (overlay_set_position, "$g_singleplayer_memoir_screen_text", pos1),
        (position_set_x, pos1, 700),
        (position_set_y, pos1, 900),
        (overlay_set_size, "$g_singleplayer_memoir_screen_text", pos1),
        
        
        # play the sound
        (store_add,":memoir_sound_id","snd_mission_narrator_1","$g_finished_missions"),
        (try_begin),
          (gt,":memoir_sound_id",-1),
          (play_sound,":memoir_sound_id",),
        (try_end),
        

        #(create_game_button_overlay, <destination>, <string_id>),
        (create_game_button_overlay,"$g_singleplayer_memoir_screen_back","@Back"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_memoir_screen_back",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_memoir_screen_back",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_memoir_screen_skip","@Skip"),
        (position_set_x,pos1,850),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_memoir_screen_skip",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_memoir_screen_skip",pos1),

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_memoir_screen_back"),
          (stop_all_sounds),
          (start_presentation, "prsnt_singleplayer_campain_map"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_singleplayer_memoir_screen_skip"),
          (stop_all_sounds),
          (start_presentation, "prsnt_singleplayer_companion_select"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      

       ]),

     ]),

   ("singleplayer_companion_select", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end
        
        # Create a container
        # (str_clear, s0),
        # (create_text_overlay, "$g_singleplayer_memoir_screen_container", s0, tf_scrollable_style_2),
        # (position_set_x, pos1, 0),
        # (position_set_y, pos1, 0),#90
        # (overlay_set_position, "$g_singleplayer_memoir_screen_container", pos1),
        # (position_set_x, pos1, 800),
        # (position_set_y, pos1, 690),#560
        # (overlay_set_area_size, "$g_singleplayer_memoir_screen_container", pos1),
        # (set_container_overlay, "$g_singleplayer_memoir_screen_container"),

        (str_store_string,s0,"@Available companions"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 50),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1700),
        (position_set_y, pos1, 1700),
        (overlay_set_size, reg0, pos1),
        
        (str_store_string,s0,"@Selected companions"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 510),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1700),
        (position_set_y, pos1, 1700),
        (overlay_set_size, reg0, pos1),
        
        (assign,":av_comp_x",30),
        (assign,":av_comp_y",120),
        (assign,":sel_comp_x",500),
        (assign,":sel_comp_y",120),
        (assign,":av_count",0),
        (assign,":sel_count",0),
        (try_for_range, ":cur_companion", companions_begin, companions_end),
          (troop_slot_eq, ":cur_companion", slot_troop_occupation, slto_player_companion),
          (store_mul,":troop_view",":cur_companion", 2), #with weapons
          (create_image_button_overlay_with_tableau_material, reg0, -1,"tableau_game_party_window",":troop_view"), 
          # Store the id in a slot
          (troop_set_slot,":cur_companion",slot_troop_button_id,reg0),
          (try_begin),
            (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (position_set_x, pos1, ":av_comp_x"),
            (position_set_y, pos1, ":av_comp_y"),
          (else_try),
            (position_set_x, pos1, ":sel_comp_x"),
            (position_set_y, pos1, ":sel_comp_y"),
          (try_end),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 350),
          (position_set_y, pos1, 350),
          (overlay_set_size, reg0, pos1),
          
          (str_store_troop_name, s7, ":cur_companion"),
          #(overlay_set_tooltip, reg0, s7),
          (create_button_overlay, reg0, s7),
          (troop_set_slot,":cur_companion",slot_troop_button_2_id,reg0),
          (overlay_set_color, reg0, 0x000000),
          (try_begin),
            (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (store_add,":text_x",":av_comp_x",70),
            (position_set_x, pos1, ":text_x"),
            (store_add,":text_y",":av_comp_y",35),
            (position_set_y, pos1, ":text_y"),
          (else_try),
            (store_add,":text_x",":sel_comp_x",70),
            (position_set_x, pos1, ":text_x"),
            (store_add,":text_y",":sel_comp_y",35),
            (position_set_y, pos1, ":text_y"),
          (try_end),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 900),
          (position_set_y, pos1, 900),
          (overlay_set_size, reg0, pos1),
          
          (try_begin),
            (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (val_add,":av_comp_y",100),         
            (val_add,":av_count",1),
            (try_begin),
              (eq,":av_count",5),
              
              (val_add,":av_comp_x",190),
              (val_sub,":av_comp_y",500),
            (try_end),
          (else_try),
            (val_add,":sel_comp_y",100),         
            (val_add,":sel_count",1),
            (try_begin),
              (eq,":sel_count",5),
              
              (val_add,":sel_comp_x",190),
              (val_sub,":sel_comp_y",500),
            (try_end),
          (try_end),
        (try_end),
        
        #(create_game_button_overlay, <destination>, <string_id>),
        (create_game_button_overlay,"$g_singleplayer_companion_select_back","@Back"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_companion_select_back",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_companion_select_back",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_companion_select_start","@Start Mission"),
        (position_set_x,pos1,850),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_companion_select_start",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_companion_select_start",pos1),

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_companion_select_back"),
          (start_presentation, "prsnt_singleplayer_memoir_screen"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        (else_try),
          (eq, ":object", "$g_singleplayer_companion_select_start"),
          #(start_presentation, "prsnt_singleplayer_mission_results"),
          
          (assign,"$g_last_finished_missions","$g_finished_missions"),
          (assign,"$g_last_finished_sub_missions","$g_finished_sub_missions"),
          
          (assign,"$g_started_mission",1),
          (jump_to_menu, "mnu_run_mission_dummy"),
          (presentation_set_duration,0),
          
          # (assign,"$g_finished_missions",1),
          # (assign,"$g_finished_sub_missions",0),
          # (assign,"$g_global_morale_modifier",10),
          # (try_begin),
            # (eq,"$g_finished_missions",0),
          # (else_try),
            # (eq,"$g_finished_missions",1), # Austerlitz

            # (jump_to_menu, "mnu_custom_battle_end"),
           
            # (presentation_set_duration,0),
          # (else_try),
            # (eq,"$g_finished_missions",2), # Drezden
            # (try_begin),
              # (eq,"$g_finished_sub_missions",0), # part 1
              
              # (modify_visitors_at_site,"scn_sp_dresden1"),
              # (reset_visitors, 0),
              # (set_player_troop, "trp_player"),
           
              # (set_visitor,0,"trp_player"),
             
              # (set_jump_mission,"mt_sp_campaign_dresden_1"),
              # (jump_to_scene,"scn_sp_dresden1"),
              # (change_screen_mission),
            ## (presentation_set_duration,0),
            # (else_try),
              # (eq,"$g_finished_sub_missions",1), # part 2
              
              # (modify_visitors_at_site,"scn_sp_dresden2"),
              # (reset_visitors, 0),
              # (set_player_troop, "trp_player"),
           
              # (set_visitor,0,"trp_player"),
             
              # (set_jump_mission,"mt_sp_campaign_dresden_2"),
              # (jump_to_scene,"scn_sp_dresden2"),
              # (change_screen_mission),
            # (try_end),
          #(try_end),         
        (else_try),
          (try_for_range, ":cur_companion", companions_begin, companions_end),
            (this_or_next|troop_slot_eq,":cur_companion",slot_troop_button_id,":object"),
            (troop_slot_eq,":cur_companion",slot_troop_button_2_id,":object"),
            (try_begin),
              (troop_slot_eq,":cur_companion",slot_troop_active_this_mission,1),
              (troop_set_slot,":cur_companion",slot_troop_active_this_mission,0),
            (else_try),
              (troop_set_slot,":cur_companion",slot_troop_active_this_mission,1),
            (try_end),
            (start_presentation, "prsnt_singleplayer_companion_select"),
            (try_begin),
              (eq,"$g_pres_started_from_mission",1),
              (presentation_set_duration,0),
            (try_end),
          (try_end),
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      

       ]),

     ]),
   
  ("singleplayer_companion_equipment_select", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end


        (str_store_string,s0,"@Choose a companion"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 50),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1700),
        (position_set_y, pos1, 1700),
        (overlay_set_size, reg0, pos1),
        
        # (str_store_string,s0,"@Selected companions"),
        # (create_text_overlay, reg0, s0, tf_with_outline),
        # (overlay_set_color, reg0, 0xFFFFFF),
        # (position_set_x, pos1, 510),
        # (position_set_y, pos1, 660),
        # (overlay_set_position, reg0, pos1),
        # (position_set_x, pos1, 1700),
        # (position_set_y, pos1, 1700),
        # (overlay_set_size, reg0, pos1),
        
        (assign,":av_comp_x",30),
        (assign,":av_comp_y",120),
        # (assign,":sel_comp_x",500),
        # (assign,":sel_comp_y",120),
        (assign,":av_count",0),
       # (assign,":sel_count",0),
        (try_for_range, ":cur_companion", companions_begin, companions_end),
          (troop_slot_eq, ":cur_companion", slot_troop_occupation, slto_player_companion),
          (store_mul,":troop_view",":cur_companion", 2), #with weapons
          (create_image_button_overlay_with_tableau_material, reg0, -1,"tableau_game_party_window",":troop_view"), 
          # Store the id in a slot
          (troop_set_slot,":cur_companion",slot_troop_button_id,reg0),
          #(try_begin),
          #  (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (position_set_x, pos1, ":av_comp_x"),
            (position_set_y, pos1, ":av_comp_y"),
          # (else_try),
            # (position_set_x, pos1, ":sel_comp_x"),
            # (position_set_y, pos1, ":sel_comp_y"),
          # (try_end),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 350),
          (position_set_y, pos1, 350),
          (overlay_set_size, reg0, pos1),
          
          (str_store_troop_name, s7, ":cur_companion"),
          #(overlay_set_tooltip, reg0, s7),
          (create_button_overlay, reg0, s7),
          (troop_set_slot,":cur_companion",slot_troop_button_2_id,reg0),
          (overlay_set_color, reg0, 0x000000),
          # (try_begin),
            # (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (store_add,":text_x",":av_comp_x",70),
            (position_set_x, pos1, ":text_x"),
            (store_add,":text_y",":av_comp_y",35),
            (position_set_y, pos1, ":text_y"),
          # (else_try),
            # (store_add,":text_x",":sel_comp_x",70),
            # (position_set_x, pos1, ":text_x"),
            # (store_add,":text_y",":sel_comp_y",35),
            # (position_set_y, pos1, ":text_y"),
          # (try_end),
          (overlay_set_position, reg0, pos1),
          (position_set_x, pos1, 900),
          (position_set_y, pos1, 900),
          (overlay_set_size, reg0, pos1),
          
          #(try_begin),
            # (troop_slot_eq, ":cur_companion", slot_troop_active_this_mission, 0),
            (val_add,":av_comp_y",100),         
            (val_add,":av_count",1),
            (try_begin),
              (eq,":av_count",5),
              
              (val_add,":av_comp_x",190),
              (val_sub,":av_comp_y",500),
            (else_try),
              (eq,":av_count",10),
              
              (val_add,":av_comp_x",190),
              (val_sub,":av_comp_y",500),
            (else_try),
              (eq,":av_count",15),
              
              (val_add,":av_comp_x",190),
              (val_sub,":av_comp_y",500),
            (try_end),
          # (else_try),
            # (val_add,":sel_comp_y",100),         
            # (val_add,":sel_count",1),
            # (try_begin),
              # (eq,":sel_count",5),
              
              # (val_add,":sel_comp_x",190),
              # (val_sub,":sel_comp_y",500),
            # (try_end),
          # (try_end),
        (try_end),
        
        #(create_game_button_overlay, <destination>, <string_id>),
        (create_game_button_overlay,"$g_singleplayer_companion_equipment_select_back","@Back"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_companion_equipment_select_back",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_companion_equipment_select_back",pos1),

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_companion_equipment_select_back"),
          (start_presentation, "prsnt_singleplayer_camp_screen"),
          (try_begin),
            (eq,"$g_pres_started_from_mission",1),
            (presentation_set_duration,0),
          (try_end),
        
        (else_try),
          (try_for_range, ":cur_companion", companions_begin, companions_end),
            (this_or_next|troop_slot_eq,":cur_companion",slot_troop_button_id,":object"),
            (troop_slot_eq,":cur_companion",slot_troop_button_2_id,":object"),
            (assign,"$g_started_companion",":cur_companion"),
            (jump_to_menu,"mnu_run_companion_dummy"),
            (presentation_set_duration,0),
            #(change_screen_equip_other, ":cur_companion"),
            # (try_begin),
              # (troop_slot_eq,":cur_companion",slot_troop_active_this_mission,1),
              # (troop_set_slot,":cur_companion",slot_troop_active_this_mission,0),
            # (else_try),
              # (troop_set_slot,":cur_companion",slot_troop_active_this_mission,1),
            # (try_end),
            # (start_presentation, "prsnt_singleplayer_companion_select"),
          (try_end),
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      

       ]),

     ]),   
     
  ("singleplayer_mission_results", 0, mesh_load_window,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),
        
        #Little Pos Helper begin
        (create_text_overlay, "$g_little_pos_helper", "@00,00"),
        (overlay_set_color, "$g_little_pos_helper", 0xFFFFFFFF),
        (init_position,pos22),
        (position_set_x, pos22, 10),
        (position_set_y, pos22, 700),
        (overlay_set_position, "$g_little_pos_helper", pos22),
        #Little Pos Helper end
        
        # Create a container
        # (str_clear, s0),
        # (create_text_overlay, "$g_singleplayer_memoir_screen_container", s0, tf_scrollable_style_2),
        # (position_set_x, pos1, 0),
        # (position_set_y, pos1, 0),#90
        # (overlay_set_position, "$g_singleplayer_memoir_screen_container", pos1),
        # (position_set_x, pos1, 800),
        # (position_set_y, pos1, 690),#560
        # (overlay_set_area_size, "$g_singleplayer_memoir_screen_container", pos1),
        # (set_container_overlay, "$g_singleplayer_memoir_screen_container"),
        
        (assign,":cur_y",680),
        
        (str_store_string,s0,"@Battle Results"),
        (create_text_overlay, reg0, s0, tf_center_justify|tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 475),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1800),
        (position_set_y, pos1, 1800),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",45),
        
        (str_store_string,s0,"@Count"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 420),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1500),
        (position_set_y, pos1, 1500),
        (overlay_set_size, reg0, pos1),
        
        (create_mesh_overlay, reg0, "mesh_white_plane", tf_with_outline),
        (overlay_set_color, reg0, 0x000000),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 522),
        (position_set_y, pos1, 442),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 100),
        (position_set_y, pos1, 9000),
        (overlay_set_size, reg0, pos1),
        
        (str_store_string,s0,"@Money"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 520),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1500),
        (position_set_y, pos1, 1500),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",45),

        (str_store_string,s0,"@Enemies killed:"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 250),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (assign,reg1,"$g_sp_enemies_killed"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 445),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (store_mul,reg1,"$g_sp_enemies_killed",10),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0x00FF3B),
        (position_set_x, pos1, 540),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",35),
        
        (str_store_string,s0,"@Personal kills:"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 250),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (assign,reg1,"$g_sp_personal_kills"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 445),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (store_mul,reg1,"$g_sp_personal_kills",10),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0x00FF3B),
        (position_set_x, pos1, 540),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",35),
        
        (str_store_string,s0,"@Allies lost:"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 250),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (assign,reg1,"$g_sp_allies_lost"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 445),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (store_mul,reg1,"$g_sp_allies_lost",5),
        (str_store_string,s0,"@-{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFF0000),
        (position_set_x, pos1, 530),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",35),
        
        (str_store_string,s0,"@Companions lost:"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 250),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (assign,reg1,"$g_sp_companions_lost"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 445),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (store_mul,reg1,"$g_sp_companions_lost",10),
        (str_store_string,s0,"@-{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFF0000),
        (position_set_x, pos1, 530),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (create_mesh_overlay, reg0, "mesh_white_plane", tf_with_outline),
        (overlay_set_color, reg0, 0x000000),
        (overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 260),
        (position_set_y, pos1, 478),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 17000),
        (position_set_y, pos1, 120),
        (overlay_set_size, reg0, pos1),
        
        (val_sub,":cur_y",45),

        (str_store_string,s0,"@Totals:"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 250),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (store_add,reg1,"$g_sp_enemies_killed","$g_sp_allies_lost"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0xFFFFFF),
        (position_set_x, pos1, 445),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        (assign,reg1,"$g_sp_money_gained"),
        (str_store_string,s0,"@{reg1}"),
        (create_text_overlay, reg0, s0, tf_with_outline),
        (overlay_set_color, reg0, 0x00FF3B),
        (position_set_x, pos1, 540),
        (position_set_y, pos1, ":cur_y"),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 1300),
        (position_set_y, pos1, 1300),
        (overlay_set_size, reg0, pos1),
        
        
        #
        
        #(create_game_button_overlay, <destination>, <string_id>),
        
        (create_game_button_overlay,"$g_singleplayer_mission_results_retry","@Retry"),
        (position_set_x,pos1,100),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_mission_results_retry",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_mission_results_retry",pos1),
        
        (create_game_button_overlay,"$g_singleplayer_mission_results_done","@Done"),
        (position_set_x,pos1,850),
        (position_set_y,pos1,30),
        (overlay_set_position,"$g_singleplayer_mission_results_done",pos1),
        (position_set_x,pos1,200),
        (position_set_y,pos1,55),
        (overlay_set_size,"$g_singleplayer_mission_results_done",pos1),

        (presentation_set_duration, 999999),
      ]),
     (ti_on_presentation_event_state_change,
      [
        (store_trigger_param_1, ":object"),
        #(store_trigger_param_2, ":value"),
       
        (try_begin),
          (eq, ":object", "$g_singleplayer_mission_results_retry"),
          
          (assign,"$g_finished_missions","$g_last_finished_missions"),
          (assign,"$g_finished_sub_missions","$g_last_finished_sub_missions"),
          
          (assign,"$g_started_mission",1),
          (jump_to_menu, "mnu_run_mission_dummy"),
          (presentation_set_duration,0),
          
        (else_try),
          (eq, ":object", "$g_singleplayer_mission_results_done"),
          
          (try_begin),
            (this_or_next|neq,"$g_finished_missions","$g_last_finished_missions"),
            (neq,"$g_finished_sub_missions","$g_last_finished_sub_missions"),
            (troop_add_gold, "trp_player", "$g_sp_money_gained"),
          (try_end),
          (start_presentation, "prsnt_singleplayer_campain_map"),
        (try_end),
      ]),
    (ti_on_presentation_run,
      [
      
      #Little Pos Helper begin
      (mouse_get_position, pos22),
      (position_get_x, reg21, pos22),
      (position_get_y, reg22, pos22),
      (overlay_set_text, "$g_little_pos_helper", "@{reg21},{reg22}"),
      #Little Pos Helper end
      

       ]),

     ]),

  ("singleplayer_cutscene_bars", prsntf_read_only|prsntf_manual_end_only, 0,
   [
    (ti_on_presentation_load,
      [
        (set_fixed_point_multiplier, 1000),
        (init_position,pos1),

        (assign,"$g_show_cutscene_bars",1),
        
        (create_mesh_overlay, reg0, "mesh_white_plane", tf_with_outline),
        (overlay_set_color, reg0, 0x000000),
        #(overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, 0),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 90000),
        (position_set_y, pos1, 4500),
        (overlay_set_size, reg0, pos1),
        
        (create_mesh_overlay, reg0, "mesh_white_plane", tf_with_outline),
        (overlay_set_color, reg0, 0x000000),
        #(overlay_set_alpha, reg0, 0xD0),
        (position_set_x, pos1, 0),
        (position_set_y, pos1, 660),
        (overlay_set_position, reg0, pos1),
        (position_set_x, pos1, 90000),
        (position_set_y, pos1, 4500),
        (overlay_set_size, reg0, pos1),

        (presentation_set_duration, 999999),
      ]),

    (ti_on_presentation_run,
      [
        (eq,"$g_show_cutscene_bars",0),
        (presentation_set_duration, 0),
      ]),

     ]),
     
  ("singleplayer_objective_projection_display", prsntf_read_only|prsntf_manual_end_only, 0, [ #this is for showing objective location display.
    (ti_on_presentation_load, [
      (set_fixed_point_multiplier, 1000),

      (create_mesh_overlay, "$g_presentation_obj_objective_projection_display_1", "mesh_target_plate"),
      (create_mesh_overlay, "$g_presentation_obj_objective_projection_display_2", "mesh_target_plate"),
      (create_mesh_overlay, "$g_presentation_obj_objective_projection_display_3", "mesh_target_plate"),
      (create_mesh_overlay, "$g_presentation_obj_objective_projection_display_4", "mesh_target_plate"),

      (position_set_x, pos1, 250),
      (position_set_y, pos1, 250),
      (position_set_x, pos2, 250),
      (position_set_y, pos2, 250),
      (position_set_x, pos3, 250),
      (position_set_y, pos3, 250),
      (position_set_x, pos4, 250),
      (position_set_y, pos4, 250),

      (overlay_set_size, "$g_presentation_obj_objective_projection_display_1", pos1),
      (overlay_set_size, "$g_presentation_obj_objective_projection_display_2", pos2),
      (overlay_set_size, "$g_presentation_obj_objective_projection_display_3", pos3),
      (overlay_set_size, "$g_presentation_obj_objective_projection_display_4", pos4),
      (overlay_set_display, "$g_presentation_obj_objective_projection_display_1", 0),
      (overlay_set_display, "$g_presentation_obj_objective_projection_display_2", 0),
      (overlay_set_display, "$g_presentation_obj_objective_projection_display_3", 0),
      (overlay_set_display, "$g_presentation_obj_objective_projection_display_4", 0),
      (presentation_set_duration, 999999),
      ]),
    (ti_on_presentation_run, [
      (try_begin),
        (ge, "$g_projection_state", 1),
        (set_fixed_point_multiplier, 1000),
        (prop_instance_get_position, pos1, "$g_objectives_locator_instance_1"), #holds position of objective prop
        (position_move_z, pos1, 250, 1),
      
        (position_get_screen_projection, pos5, pos1),
        (position_get_x, ":x_pos", pos5),
        (position_get_y, ":y_pos", pos5),
        (position_set_y, pos5, ":y_pos"),
        (try_begin),
          (is_between, ":x_pos", -100, 1100),
          (is_between, ":y_pos", -100, 850),

          (overlay_set_position, "$g_presentation_obj_objective_projection_display_1", pos5),
          (overlay_set_display, "$g_presentation_obj_objective_projection_display_1", 1),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_objective_projection_display_1", 0),
        (try_end),
        
        (try_begin),
          (ge, "$g_projection_state", 2),
          (set_fixed_point_multiplier, 1000),
          (prop_instance_get_position, pos2, "$g_objectives_locator_instance_2"), #holds position of objective prop
          (position_move_z, pos2, 250, 1),
      
          (position_get_screen_projection, pos5, pos2),
          (position_get_x, ":x_pos", pos5),
          (position_get_y, ":y_pos", pos5),
          (position_set_y, pos5, ":y_pos"),
          (try_begin),
            (is_between, ":x_pos", -100, 1100),
            (is_between, ":y_pos", -100, 850),

            (overlay_set_position, "$g_presentation_obj_objective_projection_display_2", pos5),
            (overlay_set_display, "$g_presentation_obj_objective_projection_display_2", 1),
          (else_try),
            (overlay_set_display, "$g_presentation_obj_objective_projection_display_2", 0),
          (try_end),
          
          (try_begin),
            (ge, "$g_projection_state", 3),
            (set_fixed_point_multiplier, 1000),
            (prop_instance_get_position, pos3, "$g_objectives_locator_instance_3"), #holds position of objective prop
            (position_move_z, pos3, 250, 1),
      
            (position_get_screen_projection, pos5, pos3),
            (position_get_x, ":x_pos", pos5),
            (position_get_y, ":y_pos", pos5),
            (position_set_y, pos5, ":y_pos"),
            (try_begin),
              (is_between, ":x_pos", -100, 1100),
              (is_between, ":y_pos", -100, 850),

              (overlay_set_position, "$g_presentation_obj_objective_projection_display_3", pos5),
              (overlay_set_display, "$g_presentation_obj_objective_projection_display_3", 1),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_objective_projection_display_3", 0),
            (try_end),
          
            (try_begin),
              (ge, "$g_projection_state", 4),
              (set_fixed_point_multiplier, 1000),
              (prop_instance_get_position, pos4, "$g_objectives_locator_instance_4"), #holds position of objective prop
              (position_move_z, pos4, 250, 1),
      
              (position_get_screen_projection, pos5, pos4),
              (position_get_x, ":x_pos", pos5),
              (position_get_y, ":y_pos", pos5),
              (position_set_y, pos5, ":y_pos"),
              (try_begin),
                (is_between, ":x_pos", -100, 1100),
                (is_between, ":y_pos", -100, 850),

                (overlay_set_position, "$g_presentation_obj_objective_projection_display_4", pos5),
                (overlay_set_display, "$g_presentation_obj_objective_projection_display_4", 1),
              (else_try),
                (overlay_set_display, "$g_presentation_obj_objective_projection_display_4", 0),
              (try_end),
            (else_try),
              (overlay_set_display, "$g_presentation_obj_objective_projection_display_4", 0),
            (try_end),
          (else_try),
            (overlay_set_display, "$g_presentation_obj_objective_projection_display_3", 0),
          (try_end),
        (else_try),
          (overlay_set_display, "$g_presentation_obj_objective_projection_display_2", 0),
        (try_end),
      (else_try),
        (presentation_set_duration, 0),
      (try_end),
      ]),
    ]),

  ]
